const [_Tinkr, _Mekanome] = [...$vararg]
const Tinkr = _Tinkr as unknown as tinkr
const Mekanome = _Mekanome as unknown as IMekanome
const meka = Tinkr.Util.Commands.New('meka')

/**
 * Registers a commant to be used under the "meka" namespace
 * @param prefix /meka {prefix}
 * @param callback The function to be called when the command is entered.
 * @param helpText Optional text to help describe the command.
 */
function Register(
  this: void,
  prefix: string,
  callback: (this: void) => void,
  helpText?: string
) {
  meka.Register(prefix, callback, helpText)
}

/**
 * Initializes core commands.
 */
function Init(this: void) {
  Register(
    'toggle',
    () => {
      if (Mekanome.enabled === false) {
        Mekanome.Print({ text: 'Started' })
        Mekanome.enabled = true
      } else {
        Mekanome.Print({ text: 'Stopped' })
        Mekanome.enabled = false
      }
    },
    'Toggles Mekanome.'
  )
}

const _CommandManager = {
  Register,
  Init
}

declare global {
  type CommandManager = typeof _CommandManager
}

Mekanome.CommandManager = _CommandManager

export default {}
