interface BaseCastable {
  variant: CastableVariant
  id: number
  binding: ActionButtons
}

interface GroundCastable extends BaseCastable {
  position: Vector3
  variant: 'ground'
}

interface TargetCastable extends BaseCastable {
  target: Mob
  variant: 'target'
}

interface SelfCastable extends BaseCastable {
  variant: 'self'
}

declare global {
  interface IMekanome {
    enabled: boolean
    CommandManager: CommandManager
    ActionManager: ActionManager
    EventManager: EventManager
    PlayerStateManager: PlayerStateManager
    MobManager: MobManager
    MobUtils: MobUtils
    VectorUtils: VectorUtils
    BindingsManager: BindingsManager
    SpellUtils: SpellUtils
    AuraManager: AuraManager
    AuraUtils: AuraUtils
    Cast: (this: void, castable: Castable) => void
    GetObject: (this: void, token: string) => WowGameObject | false
    Require<T>(this: void, file: string): T
    Error(this: void, text: string): void
    Print(
      this: void,
      args: {
        text: string
        prefix?: string
        level?: 'info' | 'warn' | 'error'
        color?: string
      }
    ): void
  }
  type CastableVariant = 'self' | 'target' | 'ground'
  type Castable = GroundCastable | TargetCastable | SelfCastable
}

export {}
