/* eslint-disable @typescript-eslint/no-duplicate-enum-values */
/* eslint-disable @typescript-eslint/ban-types */
/** @noSelfInFile **/

declare global {
  interface WowEventPayload {
    ACHIEVEMENT_EARNED: LuaMultiReturn<
      [achievementID: number, alreadyEarned: boolean | undefined]
    >

    ACHIEVEMENT_PLAYER_NAME: LuaMultiReturn<[achievementID: number]>

    ACHIEVEMENT_SEARCH_UPDATED: undefined

    CRITERIA_COMPLETE: LuaMultiReturn<[criteriaID: number]>

    CRITERIA_EARNED: LuaMultiReturn<[achievementID: number, description: string]>

    CRITERIA_UPDATE: undefined

    INSPECT_ACHIEVEMENT_READY: LuaMultiReturn<[guid: string]>

    RECEIVED_ACHIEVEMENT_LIST: undefined

    RECEIVED_ACHIEVEMENT_MEMBER_LIST: LuaMultiReturn<[achievementID: number]>

    TRACKED_ACHIEVEMENT_LIST_CHANGED: LuaMultiReturn<
      [achievementID: number | undefined, added: boolean | undefined]
    >

    TRACKED_ACHIEVEMENT_UPDATE: LuaMultiReturn<
      [
        achievementID: number,
        criteriaID: number | undefined,
        elapsed: number | undefined,
        duration: number | undefined
      ]
    >

    ACTION_RANGE_CHECK_UPDATE: LuaMultiReturn<
      [slot: number, isInRange: boolean, checksRange: boolean]
    >

    ACTION_USABLE_CHANGED: LuaMultiReturn<[changes: undefined[]]>

    ACTIONBAR_HIDEGRID: undefined

    ACTIONBAR_PAGE_CHANGED: undefined

    ACTIONBAR_SHOW_BOTTOMLEFT: undefined

    ACTIONBAR_SHOWGRID: undefined

    ACTIONBAR_SLOT_CHANGED: LuaMultiReturn<[slot: number]>

    ACTIONBAR_UPDATE_COOLDOWN: undefined

    ACTIONBAR_UPDATE_STATE: undefined

    ACTIONBAR_UPDATE_USABLE: undefined

    PET_BAR_UPDATE: undefined

    UPDATE_BONUS_ACTIONBAR: undefined

    UPDATE_EXTRA_ACTIONBAR: undefined

    UPDATE_MULTI_CAST_ACTIONBAR: undefined

    UPDATE_OVERRIDE_ACTIONBAR: undefined

    ADDON_LOADED: LuaMultiReturn<[addOnName: string, containsBindings: boolean]>

    ADDONS_UNLOADING: LuaMultiReturn<[closingClient: boolean]>

    SAVED_VARIABLES_TOO_LARGE: LuaMultiReturn<[addOnName: string]>

    AJ_DUNGEON_ACTION: LuaMultiReturn<[lfgDungeonID: number]>

    AJ_OPEN: undefined

    AJ_OPEN_COLLECTIONS_ACTION: undefined

    AJ_PVE_LFG_ACTION: undefined

    AJ_PVP_ACTION: LuaMultiReturn<[battleMasterListID: number]>

    AJ_PVP_LFG_ACTION: undefined

    AJ_PVP_RBG_ACTION: undefined

    AJ_PVP_SKIRMISH_ACTION: undefined

    AJ_QUEST_LOG_OPEN: LuaMultiReturn<[questID: number, uiMapID: number]>

    AJ_RAID_ACTION: LuaMultiReturn<[lfgDungeonID: number]>

    AJ_REFRESH_DISPLAY: LuaMultiReturn<[newAdventureNotice: boolean]>

    AJ_REWARD_DATA_RECEIVED: undefined

    ADVENTURE_MAP_CLOSE: undefined

    ADVENTURE_MAP_OPEN: LuaMultiReturn<[followerTypeID: number]>

    ADVENTURE_MAP_QUEST_UPDATE: LuaMultiReturn<[questID: number]>

    ADVENTURE_MAP_UPDATE_INSETS: undefined

    ADVENTURE_MAP_UPDATE_POIS: undefined

    ALLIED_RACE_CLOSE: undefined

    ALLIED_RACE_OPEN: LuaMultiReturn<[raceID: number]>

    ANIMA_DIVERSION_CLOSE: undefined

    ANIMA_DIVERSION_OPEN: LuaMultiReturn<[info: AnimaDiversionFrameInfo]>

    ANIMA_DIVERSION_TALENT_UPDATED: undefined

    AREA_POIS_UPDATED: undefined

    ARTIFACT_CLOSE: undefined

    ARTIFACT_ENDGAME_REFUND: LuaMultiReturn<
      [
        numRefundedPowers: number,
        refundedTier: string,
        bagOrSlotIndex: number,
        slotIndex: number | undefined
      ]
    >

    ARTIFACT_RELIC_FORGE_CLOSE: undefined

    ARTIFACT_RELIC_FORGE_PREVIEW_RELIC_CHANGED: undefined

    ARTIFACT_RELIC_FORGE_UPDATE: undefined

    ARTIFACT_RELIC_INFO_RECEIVED: undefined

    ARTIFACT_RESPEC_PROMPT: undefined

    ARTIFACT_TIER_CHANGED: LuaMultiReturn<
      [newTier: number, bagOrSlotIndex: number, slotIndex: number | undefined]
    >

    ARTIFACT_UPDATE: LuaMultiReturn<[newItem: boolean]>

    ARTIFACT_XP_UPDATE: undefined

    AUCTION_CANCELED: LuaMultiReturn<[auctionID: number]>

    AUCTION_HOUSE_AUCTION_CREATED: LuaMultiReturn<[auctionID: number]>

    AUCTION_HOUSE_AUCTIONS_EXPIRED: LuaMultiReturn<[auctionID: number]>

    AUCTION_HOUSE_BROWSE_FAILURE: undefined

    AUCTION_HOUSE_BROWSE_RESULTS_ADDED: LuaMultiReturn<[addedBrowseResults: undefined[]]>

    AUCTION_HOUSE_BROWSE_RESULTS_UPDATED: undefined

    AUCTION_HOUSE_CLOSED: undefined

    AUCTION_HOUSE_DISABLED: undefined

    AUCTION_HOUSE_FAVORITES_UPDATED: undefined

    AUCTION_HOUSE_ITEM_DELIVERY_DELAY_UPDATE: LuaMultiReturn<
      [purchasedItemDeliveryDelay: number, cancelledItemDeliveryDelay: number]
    >

    AUCTION_HOUSE_NEW_BID_RECEIVED: LuaMultiReturn<[auctionID: number]>

    AUCTION_HOUSE_NEW_RESULTS_RECEIVED: LuaMultiReturn<[itemKey: ItemKey | undefined]>

    AUCTION_HOUSE_POST_ERROR: undefined

    AUCTION_HOUSE_POST_WARNING: undefined

    AUCTION_HOUSE_PURCHASE_COMPLETED: LuaMultiReturn<[auctionID: number]>

    AUCTION_HOUSE_SCRIPT_DEPRECATED: undefined

    AUCTION_HOUSE_SHOW: undefined

    AUCTION_HOUSE_SHOW_COMMODITY_WON_NOTIFICATION: LuaMultiReturn<
      [commodityName: string, commodityQuantity: number]
    >

    AUCTION_HOUSE_SHOW_ERROR: LuaMultiReturn<[error: AuctionHouseError]>

    AUCTION_HOUSE_SHOW_FORMATTED_NOTIFICATION: LuaMultiReturn<
      [
        notification: AuctionHouseNotification,
        text: string,
        auctionID: number | undefined
      ]
    >

    AUCTION_HOUSE_SHOW_NOTIFICATION: LuaMultiReturn<
      [notification: AuctionHouseNotification]
    >

    AUCTION_HOUSE_THROTTLED_MESSAGE_DROPPED: undefined

    AUCTION_HOUSE_THROTTLED_MESSAGE_QUEUED: undefined

    AUCTION_HOUSE_THROTTLED_MESSAGE_RESPONSE_RECEIVED: undefined

    AUCTION_HOUSE_THROTTLED_MESSAGE_SENT: undefined

    AUCTION_HOUSE_THROTTLED_SYSTEM_READY: undefined

    AUCTION_MULTISELL_FAILURE: undefined

    AUCTION_MULTISELL_START: LuaMultiReturn<[numRepetitions: number]>

    AUCTION_MULTISELL_UPDATE: LuaMultiReturn<
      [createdCount: number, totalToCreate: number]
    >

    BID_ADDED: LuaMultiReturn<[bidID: number]>

    BIDS_UPDATED: undefined

    COMMODITY_PRICE_UNAVAILABLE: undefined

    COMMODITY_PRICE_UPDATED: LuaMultiReturn<
      [updatedUnitPrice: number, updatedTotalPrice: number]
    >

    COMMODITY_PURCHASE_FAILED: undefined

    COMMODITY_PURCHASE_SUCCEEDED: undefined

    COMMODITY_PURCHASED: LuaMultiReturn<[itemID: number, quantity: number]>

    COMMODITY_SEARCH_RESULTS_ADDED: LuaMultiReturn<[itemID: number]>

    COMMODITY_SEARCH_RESULTS_RECEIVED: undefined

    COMMODITY_SEARCH_RESULTS_UPDATED: LuaMultiReturn<[itemID: number]>

    EXTRA_BROWSE_INFO_RECEIVED: LuaMultiReturn<[itemID: number]>

    ITEM_KEY_ITEM_INFO_RECEIVED: LuaMultiReturn<[itemID: number]>

    ITEM_PURCHASED: LuaMultiReturn<[itemID: number]>

    ITEM_SEARCH_RESULTS_ADDED: LuaMultiReturn<[itemKey: ItemKey]>

    ITEM_SEARCH_RESULTS_UPDATED: LuaMultiReturn<
      [itemKey: ItemKey, newAuctionID: number | undefined]
    >

    OWNED_AUCTION_BIDDER_INFO_RECEIVED: LuaMultiReturn<
      [auctionID: number, bidderName: string]
    >

    OWNED_AUCTIONS_UPDATED: undefined

    REPLICATE_ITEM_LIST_UPDATE: undefined

    AZERITE_EMPOWERED_ITEM_EQUIPPED_STATUS_CHANGED: LuaMultiReturn<
      [isHeartEquipped: boolean]
    >

    AZERITE_EMPOWERED_ITEM_SELECTION_UPDATED: LuaMultiReturn<
      [azeriteEmpoweredItemLocation: ItemLocationMixin]
    >

    AZERITE_ESSENCE_ACTIVATED: LuaMultiReturn<
      [slot: AzeriteEssenceSlot, essenceID: number]
    >

    AZERITE_ESSENCE_ACTIVATION_FAILED: LuaMultiReturn<
      [slot: AzeriteEssenceSlot, essenceID: number]
    >

    AZERITE_ESSENCE_CHANGED: LuaMultiReturn<[essenceID: number, newRank: number]>

    AZERITE_ESSENCE_FORGE_CLOSE: undefined

    AZERITE_ESSENCE_FORGE_OPEN: undefined

    AZERITE_ESSENCE_MILESTONE_UNLOCKED: LuaMultiReturn<[milestoneID: number]>

    AZERITE_ESSENCE_UPDATE: undefined

    PENDING_AZERITE_ESSENCE_CHANGED: LuaMultiReturn<[essenceID: number | undefined]>

    AZERITE_ITEM_ENABLED_STATE_CHANGED: LuaMultiReturn<[enabled: boolean]>

    AZERITE_ITEM_EXPERIENCE_CHANGED: LuaMultiReturn<
      [
        azeriteItemLocation: ItemLocationMixin,
        oldExperienceAmount: number,
        newExperienceAmount: number
      ]
    >

    AZERITE_ITEM_POWER_LEVEL_CHANGED: LuaMultiReturn<
      [
        azeriteItemLocation: ItemLocationMixin,
        oldPowerLevel: number,
        newPowerLevel: number,
        unlockedEmpoweredItemsInfo: undefined[],
        azeriteItemID: number
      ]
    >

    BANK_BAG_SLOT_FLAGS_UPDATED: LuaMultiReturn<[slot: number]>

    BANK_TAB_SETTINGS_UPDATED: LuaMultiReturn<[bankType: BankType]>

    BANK_TABS_CHANGED: LuaMultiReturn<[bankType: BankType]>

    BANKFRAME_CLOSED: undefined

    BANKFRAME_OPENED: undefined

    PLAYER_ACCOUNT_BANK_TAB_SLOTS_CHANGED: LuaMultiReturn<[slot: number]>

    PLAYERBANKBAGSLOTS_CHANGED: undefined

    PLAYERBANKSLOTS_CHANGED: LuaMultiReturn<[slot: number]>

    PLAYERREAGENTBANKSLOTS_CHANGED: LuaMultiReturn<[slot: number]>

    REAGENTBANK_PURCHASED: undefined

    REAGENTBANK_UPDATE: undefined

    BARBER_SHOP_APPEARANCE_APPLIED: undefined

    BARBER_SHOP_CAMERA_VALUES_UPDATED: undefined

    BARBER_SHOP_CLOSE: undefined

    BARBER_SHOP_COST_UPDATE: undefined

    BARBER_SHOP_FORCE_CUSTOMIZATIONS_UPDATE: undefined

    BARBER_SHOP_OPEN: undefined

    BARBER_SHOP_RESULT: LuaMultiReturn<[success: boolean]>

    PET_BATTLE_ABILITY_CHANGED: LuaMultiReturn<
      [owner: number, petIndex: number, abilityID: number]
    >

    PET_BATTLE_ACTION_SELECTED: undefined

    PET_BATTLE_AURA_APPLIED: LuaMultiReturn<
      [owner: number, petIndex: number, auraInstanceID: number]
    >

    PET_BATTLE_AURA_CANCELED: LuaMultiReturn<
      [owner: number, petIndex: number, auraInstanceID: number]
    >

    PET_BATTLE_AURA_CHANGED: LuaMultiReturn<
      [owner: number, petIndex: number, auraInstanceID: number]
    >

    PET_BATTLE_CAPTURED: LuaMultiReturn<[owner: number, petIndex: number]>

    PET_BATTLE_CLOSE: undefined

    PET_BATTLE_FINAL_ROUND: LuaMultiReturn<[owner: number]>

    PET_BATTLE_HEALTH_CHANGED: LuaMultiReturn<
      [owner: number, petIndex: number, healthChange: number]
    >

    PET_BATTLE_LEVEL_CHANGED: LuaMultiReturn<
      [owner: number, petIndex: number, newLevel: number]
    >

    PET_BATTLE_MAX_HEALTH_CHANGED: LuaMultiReturn<
      [owner: number, petIndex: number, healthChange: number]
    >

    PET_BATTLE_OPENING_DONE: undefined

    PET_BATTLE_OPENING_START: undefined

    PET_BATTLE_OVER: undefined

    PET_BATTLE_OVERRIDE_ABILITY: LuaMultiReturn<[abilityIndex: number]>

    PET_BATTLE_PET_CHANGED: LuaMultiReturn<[owner: number]>

    PET_BATTLE_PET_ROUND_PLAYBACK_COMPLETE: LuaMultiReturn<[roundNumber: number]>

    PET_BATTLE_PET_ROUND_RESULTS: LuaMultiReturn<[roundNumber: number]>

    PET_BATTLE_PET_TYPE_CHANGED: LuaMultiReturn<
      [owner: number, petIndex: number, stateValue: number]
    >

    PET_BATTLE_PVP_DUEL_REQUEST_CANCEL: undefined

    PET_BATTLE_PVP_DUEL_REQUESTED: LuaMultiReturn<[fullName: string]>

    PET_BATTLE_QUEUE_PROPOSAL_ACCEPTED: undefined

    PET_BATTLE_QUEUE_PROPOSAL_DECLINED: undefined

    PET_BATTLE_QUEUE_PROPOSE_MATCH: undefined

    PET_BATTLE_QUEUE_STATUS: undefined

    PET_BATTLE_XP_CHANGED: LuaMultiReturn<
      [owner: number, petIndex: number, xpChange: number]
    >

    BEHAVIORAL_NOTIFICATION: LuaMultiReturn<[notificationType: string, dbId: string]>

    BLACK_MARKET_BID_RESULT: LuaMultiReturn<[marketID: number, resultCode: number]>

    BLACK_MARKET_CLOSE: undefined

    BLACK_MARKET_ITEM_UPDATE: undefined

    BLACK_MARKET_OPEN: undefined

    BLACK_MARKET_OUTBID: LuaMultiReturn<[marketID: number, itemID: number]>

    BLACK_MARKET_UNAVAILABLE: undefined

    BLACK_MARKET_WON: LuaMultiReturn<[marketID: number, itemID: number]>

    SIMPLE_BROWSER_WEB_ERROR: LuaMultiReturn<[errorCode: number]>

    SIMPLE_BROWSER_WEB_PROXY_FAILED: undefined

    SIMPLE_CHECKOUT_CLOSED: undefined

    CALENDAR_ACTION_PENDING: LuaMultiReturn<[pending: boolean]>

    CALENDAR_CLOSE_EVENT: undefined

    CALENDAR_EVENT_ALARM: LuaMultiReturn<[title: string, hour: number, minute: number]>

    CALENDAR_NEW_EVENT: LuaMultiReturn<[isCopy: boolean]>

    CALENDAR_OPEN_EVENT: LuaMultiReturn<[calendarType: string]>

    CALENDAR_UPDATE_ERROR: LuaMultiReturn<[errorReason: string]>

    CALENDAR_UPDATE_ERROR_WITH_COUNT: LuaMultiReturn<[errorReason: string, count: number]>

    CALENDAR_UPDATE_ERROR_WITH_PLAYER_NAME: LuaMultiReturn<
      [errorReason: string, playerName: string]
    >

    CALENDAR_UPDATE_EVENT: undefined

    CALENDAR_UPDATE_EVENT_LIST: undefined

    CALENDAR_UPDATE_GUILD_EVENTS: undefined

    CALENDAR_UPDATE_INVITE_LIST: LuaMultiReturn<[hasCompleteList: boolean | undefined]>

    CALENDAR_UPDATE_PENDING_INVITES: undefined

    CHALLENGE_MODE_COMPLETED: undefined

    CHALLENGE_MODE_DEATH_COUNT_UPDATED: undefined

    CHALLENGE_MODE_KEYSTONE_RECEPTABLE_OPEN: undefined

    CHALLENGE_MODE_KEYSTONE_SLOTTED: LuaMultiReturn<[keystoneID: number]>

    CHALLENGE_MODE_LEADERS_UPDATE: undefined

    CHALLENGE_MODE_MAPS_UPDATE: undefined

    CHALLENGE_MODE_MEMBER_INFO_UPDATED: undefined

    CHALLENGE_MODE_RESET: LuaMultiReturn<[mapID: number]>

    CHALLENGE_MODE_START: LuaMultiReturn<[mapID: number]>

    ALTERNATIVE_DEFAULT_LANGUAGE_CHANGED: undefined

    BN_CHAT_MSG_ADDON: LuaMultiReturn<
      [prefix: string, text: string, channel: string, senderID: number]
    >

    CAN_LOCAL_WHISPER_TARGET_RESPONSE: LuaMultiReturn<
      [whisperTarget: string, status: ChatWhisperTargetStatus]
    >

    CAN_PLAYER_SPEAK_LANGUAGE_CHANGED: LuaMultiReturn<
      [languageId: number, canSpeakLanguage: boolean]
    >

    CHANNEL_COUNT_UPDATE: LuaMultiReturn<[displayIndex: number, count: number]>

    CHANNEL_FLAGS_UPDATED: LuaMultiReturn<[displayIndex: number]>

    CHANNEL_INVITE_REQUEST: LuaMultiReturn<[channelID: string, name: string]>

    CHANNEL_LEFT: LuaMultiReturn<[chatChannelID: number, name: string]>

    CHANNEL_PASSWORD_REQUEST: LuaMultiReturn<[channelID: string]>

    CHANNEL_ROSTER_UPDATE: LuaMultiReturn<[displayIndex: number, count: number]>

    CHANNEL_UI_UPDATE: undefined

    CHAT_COMBAT_MSG_ARENA_POINTS_GAIN: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_ACHIEVEMENT: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_ADDON: LuaMultiReturn<
      [
        prefix: string,
        text: string,
        channel: string,
        sender: string,
        target: string,
        zoneChannelID: number,
        localID: number,
        name: string,
        instanceID: number
      ]
    >

    CHAT_MSG_ADDON_LOGGED: LuaMultiReturn<
      [
        prefix: string,
        text: string,
        channel: string,
        sender: string,
        target: string,
        zoneChannelID: number,
        localID: number,
        name: string,
        instanceID: number
      ]
    >

    CHAT_MSG_AFK: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BG_SYSTEM_ALLIANCE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BG_SYSTEM_HORDE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BG_SYSTEM_NEUTRAL: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN_INLINE_TOAST_ALERT: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN_INLINE_TOAST_BROADCAST: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN_INLINE_TOAST_BROADCAST_INFORM: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN_INLINE_TOAST_CONVERSATION: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN_WHISPER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN_WHISPER_INFORM: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_BN_WHISPER_PLAYER_OFFLINE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_CHANNEL: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_CHANNEL_JOIN: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_CHANNEL_LEAVE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_CHANNEL_LEAVE_PREVENTED: LuaMultiReturn<[channelName: string]>

    CHAT_MSG_CHANNEL_LIST: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_CHANNEL_NOTICE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_CHANNEL_NOTICE_USER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_COMBAT_FACTION_CHANGE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_COMBAT_HONOR_GAIN: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_COMBAT_MISC_INFO: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_COMBAT_XP_GAIN: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_COMMUNITIES_CHANNEL: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_CURRENCY: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_DND: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_EMOTE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_FILTERED: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_GUILD: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_GUILD_ACHIEVEMENT: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_GUILD_ITEM_LOOTED: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_IGNORED: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_INSTANCE_CHAT: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_INSTANCE_CHAT_LEADER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_LOOT: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_MONEY: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_MONSTER_EMOTE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_MONSTER_PARTY: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_MONSTER_SAY: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_MONSTER_WHISPER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_MONSTER_YELL: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_OFFICER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_OPENING: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_PARTY: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_PARTY_LEADER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_PET_BATTLE_COMBAT_LOG: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_PET_BATTLE_INFO: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_PET_INFO: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_PING: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_RAID: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_RAID_BOSS_EMOTE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_RAID_BOSS_WHISPER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_RAID_LEADER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_RAID_WARNING: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_RESTRICTED: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_SAY: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_SKILL: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_SYSTEM: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_TARGETICONS: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_TEXT_EMOTE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_TRADESKILLS: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_VOICE_TEXT: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_WHISPER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_WHISPER_INFORM: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_MSG_YELL: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        languageName: string,
        channelName: string,
        playerName2: string,
        specialFlags: string,
        zoneChannelID: number,
        channelIndex: number,
        channelBaseName: string,
        languageID: number,
        lineID: number,
        guid: string,
        bnSenderID: number,
        isMobile: boolean,
        isSubtitle: boolean,
        hideSenderInLetterbox: boolean,
        supressRaidIcons: boolean
      ]
    >

    CHAT_REGIONAL_SEND_FAILED: undefined

    CHAT_REGIONAL_STATUS_CHANGED: LuaMultiReturn<[isServiceAvailable: boolean]>

    CHAT_SERVER_DISCONNECTED: LuaMultiReturn<[isInitialMessage: boolean | undefined]>

    CHAT_SERVER_RECONNECTED: undefined

    CLEAR_BOSS_EMOTES: undefined

    DAILY_RESET_INSTANCE_WELCOME: LuaMultiReturn<[mapname: string, timeLeft: number]>

    INSTANCE_RESET_WARNING: LuaMultiReturn<[warningMessage: string, timeLeft: number]>

    LANGUAGE_LIST_CHANGED: undefined

    NOTIFY_CHAT_SUPPRESSED: undefined

    QUEST_BOSS_EMOTE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        displayTime: number,
        enableBossEmoteWarningSound: boolean
      ]
    >

    RAID_BOSS_EMOTE: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        displayTime: number,
        enableBossEmoteWarningSound: boolean
      ]
    >

    RAID_BOSS_WHISPER: LuaMultiReturn<
      [
        text: string,
        playerName: string,
        displayTime: number,
        enableBossEmoteWarningSound: boolean
      ]
    >

    RAID_INSTANCE_WELCOME: LuaMultiReturn<
      [mapname: string, timeLeft: number, locked: number, extended: number]
    >

    UPDATE_CHAT_COLOR: LuaMultiReturn<[name: string, r: number, g: number, b: number]>

    UPDATE_CHAT_COLOR_NAME_BY_CLASS: LuaMultiReturn<
      [name: string, colorNameByClass: boolean]
    >

    UPDATE_CHAT_WINDOWS: undefined

    UPDATE_FLOATING_CHAT_WINDOWS: undefined

    CINEMATIC_START: LuaMultiReturn<
      [canBeCancelled: boolean, forcedAspectRatio: CameraModeAspectRatio]
    >

    CINEMATIC_STOP: undefined

    HIDE_SUBTITLE: undefined

    PLAY_MOVIE: LuaMultiReturn<[movieID: number]>

    SHOW_SUBTITLE: LuaMultiReturn<[subtitle: string, sender: string | undefined]>

    STOP_MOVIE: undefined

    ACTIVE_COMBAT_CONFIG_CHANGED: LuaMultiReturn<[configID: number]>

    SELECTED_LOADOUT_CHANGED: undefined

    SPECIALIZATION_CHANGE_CAST_FAILED: undefined

    STARTER_BUILD_ACTIVATION_FAILED: undefined

    CLASS_TRIAL_TIMER_START: undefined

    CLASS_TRIAL_UPGRADE_COMPLETE: undefined

    CLICKBINDINGS_SET_HIGHLIGHTS_SHOWN: LuaMultiReturn<[showHighlights: boolean]>

    CLIENT_SCENE_CLOSED: undefined

    CLIENT_SCENE_OPENED: LuaMultiReturn<[sceneType: ClientSceneType]>

    AVATAR_LIST_UPDATED: LuaMultiReturn<[clubType: ClubType]>

    CLUB_ADDED: LuaMultiReturn<[clubId: string]>

    CLUB_ERROR: LuaMultiReturn<
      [action: ClubActionType, error: ClubErrorType, clubType: ClubType]
    >

    CLUB_INVITATION_ADDED_FOR_SELF: LuaMultiReturn<[invitation: ClubSelfInvitationInfo]>

    CLUB_INVITATION_REMOVED_FOR_SELF: LuaMultiReturn<[invitationId: string]>

    CLUB_INVITATIONS_RECEIVED_FOR_CLUB: LuaMultiReturn<[clubId: string]>

    CLUB_MEMBER_ADDED: LuaMultiReturn<[clubId: string, memberId: number]>

    CLUB_MEMBER_PRESENCE_UPDATED: LuaMultiReturn<
      [clubId: string, memberId: number, presence: ClubMemberPresence]
    >

    CLUB_MEMBER_REMOVED: LuaMultiReturn<[clubId: string, memberId: number]>

    CLUB_MEMBER_ROLE_UPDATED: LuaMultiReturn<
      [clubId: string, memberId: number, roleId: number]
    >

    CLUB_MEMBER_UPDATED: LuaMultiReturn<[clubId: string, memberId: number]>

    CLUB_MESSAGE_ADDED: LuaMultiReturn<
      [clubId: string, streamId: string, messageId: ClubMessageIdentifier]
    >

    CLUB_MESSAGE_HISTORY_RECEIVED: LuaMultiReturn<
      [
        clubId: string,
        streamId: string,
        downloadedRange: ClubMessageRange,
        contiguousRange: ClubMessageRange
      ]
    >

    CLUB_MESSAGE_UPDATED: LuaMultiReturn<
      [clubId: string, streamId: string, messageId: ClubMessageIdentifier]
    >

    CLUB_REMOVED: LuaMultiReturn<[clubId: string]>

    CLUB_REMOVED_MESSAGE: LuaMultiReturn<
      [clubName: string, clubRemovedReason: ClubRemovedReason]
    >

    CLUB_SELF_MEMBER_ROLE_UPDATED: LuaMultiReturn<[clubId: string, roleId: number]>

    CLUB_STREAM_ADDED: LuaMultiReturn<[clubId: string, streamId: string]>

    CLUB_STREAM_REMOVED: LuaMultiReturn<[clubId: string, streamId: string]>

    CLUB_STREAM_SUBSCRIBED: LuaMultiReturn<[clubId: string, streamId: string]>

    CLUB_STREAM_UNSUBSCRIBED: LuaMultiReturn<[clubId: string, streamId: string]>

    CLUB_STREAM_UPDATED: LuaMultiReturn<[clubId: string, streamId: string]>

    CLUB_STREAMS_LOADED: LuaMultiReturn<[clubId: string]>

    CLUB_TICKET_CREATED: LuaMultiReturn<[clubId: string, ticketInfo: ClubTicketInfo]>

    CLUB_TICKET_RECEIVED: LuaMultiReturn<[ticket: string]>

    CLUB_TICKETS_RECEIVED: LuaMultiReturn<[clubId: string]>

    CLUB_UPDATED: LuaMultiReturn<[clubId: string]>

    INITIAL_CLUBS_LOADED: undefined

    STREAM_VIEW_MARKER_UPDATED: LuaMultiReturn<
      [clubId: string, streamId: string, lastReadTime: number | undefined]
    >

    CLUB_FINDER_APPLICANT_INVITE_RECIEVED: LuaMultiReturn<[clubFinderGUIDs: string[]]>

    CLUB_FINDER_APPLICATIONS_UPDATED: LuaMultiReturn<
      [type: ClubFinderRequestType, clubFinderGUIDs: string[]]
    >

    CLUB_FINDER_CAN_WHISPER_APPLICANT: LuaMultiReturn<[applicant: string]>

    CLUB_FINDER_CLUB_LIST_RETURNED: LuaMultiReturn<[type: ClubFinderRequestType]>

    CLUB_FINDER_CLUB_REPORTED: LuaMultiReturn<
      [type: ClubFinderRequestType, clubFinderGUID: string]
    >

    CLUB_FINDER_COMMUNITY_OFFLINE_JOIN: LuaMultiReturn<[clubId: string]>

    CLUB_FINDER_ENABLED_OR_DISABLED: undefined

    CLUB_FINDER_GUILD_REALM_NAME_UPDATED: LuaMultiReturn<
      [clubFinderGUID: string, realmName: string]
    >

    CLUB_FINDER_LINKED_CLUB_RETURNED: LuaMultiReturn<[clubInfo: RecruitingClubInfo]>

    CLUB_FINDER_MEMBERSHIP_LIST_CHANGED: undefined

    CLUB_FINDER_PLAYER_PENDING_LIST_RECIEVED: LuaMultiReturn<
      [type: ClubFinderRequestType]
    >

    CLUB_FINDER_POST_UPDATED: LuaMultiReturn<[clubFinderGUIDs: string[]]>

    CLUB_FINDER_RECRUIT_LIST_CHANGED: undefined

    CLUB_FINDER_RECRUITMENT_POST_RETURNED: LuaMultiReturn<[type: ClubFinderRequestType]>

    CLUB_FINDER_RECRUITS_UPDATED: LuaMultiReturn<[type: ClubFinderRequestType]>

    COMBAT_LOG_EVENT: undefined

    COMBAT_LOG_EVENT_UNFILTERED: undefined

    COMBAT_TEXT_UPDATE: LuaMultiReturn<[combatTextType: string]>

    COMMENTATOR_ENTER_WORLD: undefined

    COMMENTATOR_HISTORY_FLUSHED: undefined

    COMMENTATOR_IMMEDIATE_FOV_UPDATE: LuaMultiReturn<[fov: number]>

    COMMENTATOR_MAP_UPDATE: undefined

    COMMENTATOR_PLAYER_NAME_OVERRIDE_UPDATE: LuaMultiReturn<
      [nameToOverride: string, overrideName: string | undefined]
    >

    COMMENTATOR_PLAYER_UPDATE: undefined

    COMMENTATOR_RESET_SETTINGS: undefined

    COMMENTATOR_TEAM_NAME_UPDATE: LuaMultiReturn<[teamName: string]>

    COMMENTATOR_TEAMS_SWAPPED: LuaMultiReturn<[swapped: boolean]>

    COMPACT_UNIT_FRAME_PROFILES_LOADED: undefined

    CONSOLE_CLEAR: undefined

    CONSOLE_COLORS_CHANGED: undefined

    CONSOLE_FONT_SIZE_CHANGED: undefined

    CONSOLE_LOG: LuaMultiReturn<[message: string]>

    CONSOLE_MESSAGE: LuaMultiReturn<[message: string, colorType: number]>

    CVAR_UPDATE: LuaMultiReturn<[eventName: string, value: string]>

    GLUE_CONSOLE_LOG: LuaMultiReturn<[message: string]>

    TOGGLE_CONSOLE: LuaMultiReturn<[showConsole: boolean | undefined]>

    BAG_CLOSED: LuaMultiReturn<[bagID: BagIndex]>

    BAG_CONTAINER_UPDATE: undefined

    BAG_NEW_ITEMS_UPDATED: undefined

    BAG_OPEN: LuaMultiReturn<[bagID: number]>

    BAG_OVERFLOW_WITH_FULL_INVENTORY: undefined

    BAG_SLOT_FLAGS_UPDATED: LuaMultiReturn<[slot: number]>

    BAG_UPDATE: LuaMultiReturn<[bagID: BagIndex]>

    BAG_UPDATE_COOLDOWN: undefined

    BAG_UPDATE_DELAYED: undefined

    EQUIP_BIND_REFUNDABLE_CONFIRM: LuaMultiReturn<
      [slot: number, itemLocation: ItemLocationMixin]
    >

    EQUIP_BIND_TRADEABLE_CONFIRM: LuaMultiReturn<
      [slot: number, itemLocation: ItemLocationMixin]
    >

    EXPAND_BAG_BAR_CHANGED: LuaMultiReturn<[expandBagBar: boolean]>

    INVENTORY_SEARCH_UPDATE: undefined

    ITEM_LOCK_CHANGED: LuaMultiReturn<
      [bagOrSlotIndex: BagIndex, slotIndex: number | undefined]
    >

    ITEM_LOCKED: LuaMultiReturn<[bagOrSlotIndex: BagIndex, slotIndex: number | undefined]>

    ITEM_UNLOCKED: LuaMultiReturn<
      [bagOrSlotIndex: BagIndex, slotIndex: number | undefined]
    >

    USE_COMBINED_BAGS_CHANGED: LuaMultiReturn<[useCombinedBags: boolean]>

    CONTENT_TRACKING_IS_ENABLED_UPDATE: LuaMultiReturn<[isEnabled: boolean]>

    CONTENT_TRACKING_LIST_UPDATE: undefined

    CONTENT_TRACKING_UPDATE: LuaMultiReturn<
      [type: ContentTrackingType, id: number, isTracked: boolean]
    >

    TRACKABLE_INFO_UPDATE: LuaMultiReturn<[type: ContentTrackingType, id: number]>

    TRACKING_TARGET_INFO_UPDATE: LuaMultiReturn<
      [targetType: ContentTrackingTargetType, targetID: number]
    >

    CONTRIBUTION_CHANGED: LuaMultiReturn<
      [
        state: ContributionState,
        result: ContributionResult,
        name: string,
        contributionID: number
      ]
    >

    CONTRIBUTION_COLLECTOR_PENDING: LuaMultiReturn<
      [contributionID: number, isPending: boolean, result: number]
    >

    CONTRIBUTION_COLLECTOR_UPDATE: undefined

    CONTRIBUTION_COLLECTOR_UPDATE_SINGLE: LuaMultiReturn<[contributionID: number]>

    COVENANT_CALLINGS_UPDATED: LuaMultiReturn<[callings: undefined[]]>

    COVENANT_PREVIEW_CLOSE: undefined

    COVENANT_PREVIEW_OPEN: LuaMultiReturn<[previewInfo: CovenantPreviewInfo]>

    COVENANT_RENOWN_CATCH_UP_STATE_UPDATE: undefined

    COVENANT_SANCTUM_RENOWN_LEVEL_CHANGED: LuaMultiReturn<
      [newRenownLevel: number, oldRenownLevel: number]
    >

    COVENANT_CHOSEN: LuaMultiReturn<[covenantID: number]>

    CRAFTING_HOUSE_DISABLED: undefined

    CRAFTINGORDERS_CAN_REQUEST: undefined

    CRAFTINGORDERS_CLAIM_ORDER_RESPONSE: LuaMultiReturn<
      [result: CraftingOrderResult, orderID: number]
    >

    CRAFTINGORDERS_CLAIMED_ORDER_ADDED: undefined

    CRAFTINGORDERS_CLAIMED_ORDER_REMOVED: undefined

    CRAFTINGORDERS_CLAIMED_ORDER_UPDATED: LuaMultiReturn<[orderID: number]>

    CRAFTINGORDERS_CRAFT_ORDER_RESPONSE: LuaMultiReturn<
      [result: CraftingOrderResult, orderID: number]
    >

    CRAFTINGORDERS_CUSTOMER_FAVORITES_CHANGED: undefined

    CRAFTINGORDERS_CUSTOMER_OPTIONS_PARSED: undefined

    CRAFTINGORDERS_DISPLAY_CRAFTER_FULFILLED_MSG: LuaMultiReturn<
      [
        orderTypeString: string,
        itemNameString: string,
        playerNameString: string,
        tipAmount: number,
        quantityCrafted: number
      ]
    >

    CRAFTINGORDERS_FULFILL_ORDER_RESPONSE: LuaMultiReturn<
      [result: CraftingOrderResult, orderID: number]
    >

    CRAFTINGORDERS_HIDE_CRAFTER: undefined

    CRAFTINGORDERS_HIDE_CUSTOMER: undefined

    CRAFTINGORDERS_ORDER_CANCEL_RESPONSE: LuaMultiReturn<[result: CraftingOrderResult]>

    CRAFTINGORDERS_ORDER_PLACEMENT_RESPONSE: LuaMultiReturn<[result: CraftingOrderResult]>

    CRAFTINGORDERS_REJECT_ORDER_RESPONSE: LuaMultiReturn<
      [result: CraftingOrderResult, orderID: number]
    >

    CRAFTINGORDERS_RELEASE_ORDER_RESPONSE: LuaMultiReturn<
      [result: CraftingOrderResult, orderID: number]
    >

    CRAFTINGORDERS_SHOW_CRAFTER: undefined

    CRAFTINGORDERS_SHOW_CUSTOMER: undefined

    CRAFTINGORDERS_UNEXPECTED_ERROR: undefined

    CRAFTINGORDERS_UPDATE_CUSTOMER_NAME: LuaMultiReturn<
      [customerName: string, orderID: number]
    >

    CRAFTINGORDERS_UPDATE_ORDER_COUNT: LuaMultiReturn<
      [orderType: CraftingOrderType, numOrders: number]
    >

    CRAFTINGORDERS_UPDATE_PERSONAL_ORDER_COUNTS: undefined

    ACCOUNT_CHARACTER_CURRENCY_DATA_RECEIVED: undefined

    ACCOUNT_MONEY: undefined

    CURRENCY_DISPLAY_UPDATE: LuaMultiReturn<
      [
        currencyType: number | undefined,
        quantity: number | undefined,
        quantityChange: number | undefined,
        quantityGainSource: number | undefined,
        destroyReason: number | undefined
      ]
    >

    CURRENCY_TRANSFER_FAILED: undefined

    CURRENCY_TRANSFER_LOG_UPDATE: undefined

    PLAYER_MONEY: undefined

    BATTLE_PET_CURSOR_CLEAR: undefined

    CURSOR_CHANGED: LuaMultiReturn<
      [
        isDefault: boolean,
        newCursorType: UICursorType,
        oldCursorType: UICursorType,
        oldCursorVirtualID: number
      ]
    >

    MOUNT_CURSOR_CLEAR: undefined

    WORLD_CURSOR_TOOLTIP_UPDATE: LuaMultiReturn<[anchorType: WorldCursorAnchorType]>

    HARDCORE_DEATHS: LuaMultiReturn<[memberName: string]>

    AREA_SPIRIT_HEALER_IN_RANGE: undefined

    AREA_SPIRIT_HEALER_OUT_OF_RANGE: undefined

    CEMETERY_PREFERENCE_UPDATED: undefined

    CONFIRM_XP_LOSS: undefined

    CORPSE_IN_INSTANCE: undefined

    CORPSE_IN_RANGE: undefined

    CORPSE_OUT_OF_RANGE: undefined

    PLAYER_ALIVE: undefined

    PLAYER_DEAD: undefined

    PLAYER_SKINNED: LuaMultiReturn<[hasFreeRepop: number]>

    PLAYER_UNGHOST: undefined

    REQUEST_CEMETERY_LIST_RESPONSE: LuaMultiReturn<[isGossipTriggered: boolean]>

    RESURRECT_REQUEST: LuaMultiReturn<[inviter: string]>

    SELF_RES_SPELL_CHANGED: undefined

    ACTIVE_DELVE_DATA_UPDATE: undefined

    DELVES_ACCOUNT_DATA_ELEMENT_CHANGED: undefined

    SHOW_DELVES_COMPANION_CONFIGURATION_UI: undefined

    SHOW_DELVES_DISPLAY_UI: undefined

    WALK_IN_DATA_UPDATE: undefined

    LEARNED_SPELL_IN_TAB: LuaMultiReturn<
      [spellID: number, skillInfoIndex: number, isGuildPerkSpell: boolean]
    >

    DUEL_FINISHED: undefined

    DUEL_INBOUNDS: undefined

    DUEL_OUTOFBOUNDS: undefined

    DUEL_REQUESTED: LuaMultiReturn<[playerName: string]>

    DUEL_TO_THE_DEATH_REQUESTED: LuaMultiReturn<[playerName: string]>

    EDIT_MODE_LAYOUTS_UPDATED: LuaMultiReturn<
      [layoutInfo: EditModeLayouts, reconcileLayouts: boolean]
    >

    BOSS_KILL: LuaMultiReturn<[encounterID: number, encounterName: string]>

    DISABLE_LOW_LEVEL_RAID: undefined

    ENABLE_LOW_LEVEL_RAID: undefined

    ENCOUNTER_END: LuaMultiReturn<
      [
        encounterID: number,
        encounterName: string,
        difficultyID: number,
        groupSize: number,
        success: number
      ]
    >

    ENCOUNTER_START: LuaMultiReturn<
      [
        encounterID: number,
        encounterName: string,
        difficultyID: number,
        groupSize: number
      ]
    >

    INSTANCE_LOCK_START: undefined

    INSTANCE_LOCK_STOP: undefined

    INSTANCE_LOCK_WARNING: undefined

    RAID_TARGET_UPDATE: undefined

    UPDATE_INSTANCE_INFO: undefined

    EJ_DIFFICULTY_UPDATE: LuaMultiReturn<[difficultyID: number]>

    EJ_LOOT_DATA_RECIEVED: LuaMultiReturn<[itemID: number | undefined]>

    EQUIPMENT_SETS_CHANGED: undefined

    EQUIPMENT_SWAP_FINISHED: LuaMultiReturn<[result: boolean, setID: number | undefined]>

    EQUIPMENT_SWAP_PENDING: undefined

    TRANSMOG_OUTFITS_CHANGED: undefined

    SETTINGS_LOADED: undefined

    MAX_EXPANSION_LEVEL_UPDATED: undefined

    MIN_EXPANSION_LEVEL_UPDATED: undefined

    SHOW_SUBSCRIPTION_INTERSTITIAL: LuaMultiReturn<[type: SubscriptionInterstitialType]>

    FOG_OF_WAR_UPDATED: undefined

    BATTLETAG_INVITE_SHOW: LuaMultiReturn<[name: string]>

    BN_BLOCK_FAILED_TOO_MANY: LuaMultiReturn<[blockType: string]>

    BN_BLOCK_LIST_UPDATED: undefined

    BN_CHAT_WHISPER_UNDELIVERABLE: LuaMultiReturn<[senderID: number]>

    BN_CONNECTED: LuaMultiReturn<[suppressNotification: boolean]>

    BN_CUSTOM_MESSAGE_CHANGED: LuaMultiReturn<[id: number | undefined]>

    BN_CUSTOM_MESSAGE_LOADED: undefined

    BN_DISCONNECTED: LuaMultiReturn<[result: boolean, suppressNotification: boolean]>

    BN_FRIEND_ACCOUNT_OFFLINE: LuaMultiReturn<[friendId: number, isCompanionApp: boolean]>

    BN_FRIEND_ACCOUNT_ONLINE: LuaMultiReturn<[friendId: number, isCompanionApp: boolean]>

    BN_FRIEND_INFO_CHANGED: LuaMultiReturn<[friendIndex: number | undefined]>

    BN_FRIEND_INVITE_ADDED: LuaMultiReturn<[accountID: number]>

    BN_FRIEND_INVITE_LIST_INITIALIZED: LuaMultiReturn<[listSize: number]>

    BN_FRIEND_INVITE_REMOVED: undefined

    BN_FRIEND_LIST_SIZE_CHANGED: LuaMultiReturn<[accountID: number | undefined]>

    BN_INFO_CHANGED: undefined

    BN_REQUEST_FOF_SUCCEEDED: undefined

    FRIENDLIST_UPDATE: undefined

    IGNORELIST_UPDATE: undefined

    MUTELIST_UPDATE: undefined

    NEW_MATCHMAKING_PARTY_INVITE: undefined

    REJECTED_MATCHMAKING_PARTY_INVITE: LuaMultiReturn<[name: string]>

    WHO_LIST_UPDATE: undefined

    GM_PLAYER_INFO: LuaMultiReturn<[name: string, info: string]>

    ITEM_RESTORATION_BUTTON_STATUS: undefined

    PETITION_CLOSED: undefined

    PETITION_SHOW: undefined

    PLAYER_REPORT_SUBMITTED: LuaMultiReturn<[invitedByGUID: string]>

    QUICK_TICKET_SYSTEM_STATUS: undefined

    QUICK_TICKET_THROTTLE_CHANGED: undefined

    UPDATE_WEB_TICKET: LuaMultiReturn<
      [
        hasTicket: boolean,
        numTickets: number | undefined,
        ticketStatus: number | undefined,
        caseIndex: number | undefined,
        waitTimeMinutes: number | undefined,
        waitMessage: string | undefined
      ]
    >

    GAME_ENVIRONMENT_SWITCHED: LuaMultiReturn<[gameEnvironment: GameEnvironment]>

    GAME_PAD_ACTIVE_CHANGED: LuaMultiReturn<[isActive: boolean]>

    GAME_PAD_CONFIGS_CHANGED: undefined

    GAME_PAD_CONNECTED: undefined

    GAME_PAD_DISCONNECTED: undefined

    GAME_PAD_POWER_CHANGED: LuaMultiReturn<[powerLevel: GamePadPowerLevel]>

    GARRISON_ARCHITECT_CLOSED: undefined

    GARRISON_ARCHITECT_OPENED: LuaMultiReturn<[followerTypeID: number]>

    GARRISON_BUILDING_ACTIVATABLE: LuaMultiReturn<
      [buildingName: string, garrisonType: number]
    >

    GARRISON_BUILDING_ACTIVATED: LuaMultiReturn<
      [garrisonPlotInstanceID: number, garrisonBuildingID: number]
    >

    GARRISON_BUILDING_ERROR: undefined

    GARRISON_BUILDING_LIST_UPDATE: LuaMultiReturn<[categoryID: number]>

    GARRISON_BUILDING_PLACED: LuaMultiReturn<
      [garrisonPlotInstanceID: number, newPlacement: boolean]
    >

    GARRISON_BUILDING_REMOVED: LuaMultiReturn<
      [garrPlotInstanceID: number, garrBuildingID: number]
    >

    GARRISON_BUILDING_UPDATE: LuaMultiReturn<
      [garrisonBuildingID: number, garrPlotInstanceID: number | undefined]
    >

    GARRISON_FOLLOWER_ADDED: LuaMultiReturn<
      [
        followerDbID: number,
        followerName: string,
        followerClassName: string,
        followerLevel: number,
        followerQuality: number,
        isUpgraded: boolean,
        textureKit: string,
        followerTypeID: number
      ]
    >

    GARRISON_FOLLOWER_CATEGORIES_UPDATED: undefined

    GARRISON_FOLLOWER_DURABILITY_CHANGED: LuaMultiReturn<
      [garrFollowerTypeID: number, followerDbID: number, followerDurability: number]
    >

    GARRISON_FOLLOWER_HEALED: LuaMultiReturn<[followerID: number]>

    GARRISON_FOLLOWER_LIST_UPDATE: LuaMultiReturn<[followerTypeID: number]>

    GARRISON_FOLLOWER_REMOVED: LuaMultiReturn<[followerTypeID: number]>

    GARRISON_FOLLOWER_UPGRADED: LuaMultiReturn<[followerDbID: number]>

    GARRISON_FOLLOWER_XP_CHANGED: LuaMultiReturn<
      [
        garrFollowerTypeID: number,
        followerDbID: number,
        xpChange: number,
        oldFollowerXp: number,
        oldFollowerLevel: number,
        oldFollowerQuality: number
      ]
    >

    GARRISON_HIDE_LANDING_PAGE: undefined

    GARRISON_INVASION_AVAILABLE: undefined

    GARRISON_INVASION_UNAVAILABLE: undefined

    GARRISON_LANDINGPAGE_SHIPMENTS: undefined

    GARRISON_MISSION_AREA_BONUS_ADDED: LuaMultiReturn<
      [garrisonMissonBonusAbilityID: number]
    >

    GARRISON_MISSION_BONUS_ROLL_COMPLETE: LuaMultiReturn<
      [missionID: number, success: boolean]
    >

    GARRISON_MISSION_COMPLETE_RESPONSE: LuaMultiReturn<
      [
        missionID: number,
        canComplete: boolean,
        success: boolean,
        bonusRollSuccess: boolean,
        followerDeaths: undefined[],
        autoCombatResult: AutoCombatResult | undefined
      ]
    >

    GARRISON_MISSION_FINISHED: LuaMultiReturn<[followerTypeID: number, missionID: number]>

    GARRISON_MISSION_LIST_UPDATE: LuaMultiReturn<[garrFollowerTypeID: number]>

    GARRISON_MISSION_NPC_CLOSED: undefined

    GARRISON_MISSION_NPC_OPENED: LuaMultiReturn<[followerTypeID: number]>

    GARRISON_MISSION_REWARD_INFO: LuaMultiReturn<
      [missionID: number, followerDbID: number]
    >

    GARRISON_MISSION_STARTED: LuaMultiReturn<
      [garrFollowerTypeID: number, missionID: number]
    >

    GARRISON_MONUMENT_CLOSE_UI: undefined

    GARRISON_MONUMENT_LIST_LOADED: LuaMultiReturn<[success: boolean]>

    GARRISON_MONUMENT_REPLACED: LuaMultiReturn<[success: boolean]>

    GARRISON_MONUMENT_SELECTED_TROPHY_ID_LOADED: LuaMultiReturn<[success: boolean]>

    GARRISON_MONUMENT_SHOW_UI: undefined

    GARRISON_RANDOM_MISSION_ADDED: LuaMultiReturn<
      [followerTypeID: number, missionID: number]
    >

    GARRISON_RECALL_PORTAL_LAST_USED_TIME: LuaMultiReturn<
      [success: boolean, recallPortalLastUsedTime: number]
    >

    GARRISON_RECALL_PORTAL_USED: LuaMultiReturn<[success: boolean]>

    GARRISON_RECRUIT_FOLLOWER_RESULT: undefined

    GARRISON_RECRUITMENT_FOLLOWERS_GENERATED: undefined

    GARRISON_RECRUITMENT_NPC_CLOSED: undefined

    GARRISON_RECRUITMENT_NPC_OPENED: LuaMultiReturn<[followerTypeID: number]>

    GARRISON_RECRUITMENT_READY: undefined

    GARRISON_SHIPMENT_RECEIVED: undefined

    GARRISON_SHIPYARD_NPC_CLOSED: undefined

    GARRISON_SHIPYARD_NPC_OPENED: LuaMultiReturn<[followerTypeID: number]>

    GARRISON_SHOW_LANDING_PAGE: undefined

    GARRISON_SPEC_GROUP_UPDATED: LuaMultiReturn<[garrTypeID: number, specID: number]>

    GARRISON_SPEC_GROUPS_CLEARED: LuaMultiReturn<[garrTypeID: number]>

    GARRISON_TALENT_COMPLETE: LuaMultiReturn<[garrTypeID: number, doAlert: boolean]>

    GARRISON_TALENT_EVENT_UPDATE: LuaMultiReturn<[eventType: number, eventID: number]>

    GARRISON_TALENT_NPC_CLOSED: undefined

    GARRISON_TALENT_NPC_OPENED: LuaMultiReturn<
      [garrisonTypeID: number, garrisonTalentTreeID: number]
    >

    GARRISON_TALENT_RESEARCH_STARTED: LuaMultiReturn<
      [garrTypeID: number, garrisonTalentTreeID: number, garrTalentID: number]
    >

    GARRISON_TALENT_UNLOCKS_RESULT: undefined

    GARRISON_TALENT_UPDATE: LuaMultiReturn<[garrTypeID: number]>

    GARRISON_TRADESKILL_NPC_CLOSED: undefined

    GARRISON_UPDATE: undefined

    GARRISON_UPGRADEABLE_RESULT: LuaMultiReturn<[garrisonUpgradeable: boolean]>

    GARRISON_USE_PARTY_GARRISON_CHANGED: undefined

    SHIPMENT_CRAFTER_CLOSED: undefined

    SHIPMENT_CRAFTER_INFO: LuaMultiReturn<
      [
        success: number,
        shipmentCount: number,
        maxShipments: number,
        ownedShipments: number,
        plotInstanceID: number
      ]
    >

    SHIPMENT_CRAFTER_OPENED: LuaMultiReturn<[charShipmentContainerID: number]>

    SHIPMENT_CRAFTER_REAGENT_UPDATE: undefined

    SHIPMENT_UPDATE: LuaMultiReturn<
      [shipmentStarted: boolean | undefined, hasAttachedFollower: boolean | undefined]
    >

    ACTIVATE_GLYPH: LuaMultiReturn<[spellID: number]>

    CANCEL_GLYPH_CAST: undefined

    USE_GLYPH: LuaMultiReturn<[spellID: number]>

    DYNAMIC_GOSSIP_POI_UPDATED: undefined

    GOSSIP_CLOSED: LuaMultiReturn<[interactionIsContinuing: boolean]>

    GOSSIP_CONFIRM: LuaMultiReturn<[gossipID: number, text: string, cost: number]>

    GOSSIP_CONFIRM_CANCEL: undefined

    GOSSIP_ENTER_CODE: LuaMultiReturn<[gossipID: number]>

    GOSSIP_OPTIONS_REFRESHED: undefined

    GOSSIP_SHOW: LuaMultiReturn<[uiTextureKit: string | undefined]>

    GUILDBANK_ITEM_LOCK_CHANGED: undefined

    GUILDBANK_TEXT_CHANGED: LuaMultiReturn<[guildBankTab: number]>

    GUILDBANK_UPDATE_MONEY: undefined

    GUILDBANK_UPDATE_TABS: undefined

    GUILDBANK_UPDATE_TEXT: LuaMultiReturn<[guildBankTab: number]>

    GUILDBANK_UPDATE_WITHDRAWMONEY: undefined

    GUILDBANKBAGSLOTS_CHANGED: undefined

    GUILDBANKFRAME_CLOSED: undefined

    GUILDBANKFRAME_OPENED: undefined

    GUILDBANKLOG_UPDATE: undefined

    CLOSE_TABARD_FRAME: undefined

    DISABLE_DECLINE_GUILD_INVITE: undefined

    ENABLE_DECLINE_GUILD_INVITE: undefined

    GUILD_CHALLENGE_COMPLETED: LuaMultiReturn<
      [challengeType: number, currentCount: number, maxCount: number, goldAwarded: number]
    >

    GUILD_CHALLENGE_UPDATED: undefined

    GUILD_EVENT_LOG_UPDATE: undefined

    GUILD_INVITE_CANCEL: undefined

    GUILD_INVITE_REQUEST: LuaMultiReturn<
      [
        inviter: string,
        guildName: string,
        guildAchievementPoints: number,
        oldGuildName: string,
        isNewGuild: boolean | undefined,
        tabardInfo: GuildTabardInfo | undefined
      ]
    >

    GUILD_MOTD: LuaMultiReturn<[motdText: string]>

    GUILD_NEWS_UPDATE: undefined

    GUILD_PARTY_STATE_UPDATED: LuaMultiReturn<[inGuildParty: boolean]>

    GUILD_RANKS_UPDATE: undefined

    GUILD_RECIPE_KNOWN_BY_MEMBERS: undefined

    GUILD_REGISTRAR_CLOSED: undefined

    GUILD_REGISTRAR_SHOW: undefined

    GUILD_RENAME_REQUIRED: LuaMultiReturn<[flagSet: boolean]>

    GUILD_REWARDS_LIST: undefined

    GUILD_ROSTER_UPDATE: LuaMultiReturn<[canRequestRosterUpdate: boolean]>

    GUILD_TRADESKILL_UPDATE: undefined

    GUILDTABARD_UPDATE: undefined

    OPEN_TABARD_FRAME: undefined

    PLAYER_GUILD_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    REQUIRED_GUILD_RENAME_RESULT: LuaMultiReturn<[success: boolean]>

    TABARD_CANSAVE_CHANGED: undefined

    TABARD_SAVE_PENDING: undefined

    HEIRLOOM_UPGRADE_TARGETING_CHANGED: LuaMultiReturn<
      [pendingHeirloomUpgradeSpellcast: boolean]
    >

    HEIRLOOMS_UPDATED: LuaMultiReturn<
      [
        itemID: number | undefined,
        updateReason: string | undefined,
        hideUntilLearned: boolean | undefined
      ]
    >

    IMMERSIVE_INTERACTION_BEGIN: undefined

    IMMERSIVE_INTERACTION_END: undefined

    NAVIGATION_FRAME_CREATED: LuaMultiReturn<[region: unknown]>

    NAVIGATION_FRAME_DESTROYED: undefined

    INSTANCE_ENCOUNTER_ADD_TIMER: LuaMultiReturn<[timeRemaining: number]>

    INSTANCE_ENCOUNTER_ENGAGE_UNIT: undefined

    INSTANCE_ENCOUNTER_OBJECTIVE_COMPLETE: LuaMultiReturn<[objectiveID: number]>

    INSTANCE_ENCOUNTER_OBJECTIVE_START: LuaMultiReturn<
      [objectiveID: number, objectiveProgress: number]
    >

    INSTANCE_ENCOUNTER_OBJECTIVE_UPDATE: LuaMultiReturn<
      [objectiveID: number, objectiveProgress: number]
    >

    ISLAND_AZERITE_GAIN: LuaMultiReturn<
      [
        amount: number,
        gainedByPlayer: boolean,
        factionIndex: number,
        gainedBy: string,
        gainedFrom: string
      ]
    >

    ISLANDS_QUEUE_CLOSE: undefined

    ISLANDS_QUEUE_OPEN: undefined

    ACTION_WILL_BIND_ITEM: undefined

    BIND_ENCHANT: undefined

    CHARACTER_ITEM_FIXUP_NOTIFICATION: LuaMultiReturn<[fixupVersion: number]>

    CONFIRM_BEFORE_USE: undefined

    CONVERT_TO_BIND_TO_ACCOUNT_CONFIRM: undefined

    DELETE_ITEM_CONFIRM: LuaMultiReturn<
      [itemName: string, qualityID: number, bonding: number, questWarn: number]
    >

    END_BOUND_TRADEABLE: LuaMultiReturn<[reason: string]>

    GET_ITEM_INFO_RECEIVED: LuaMultiReturn<[itemID: number, success: boolean]>

    ITEM_CHANGED: LuaMultiReturn<[previousHyperlink: string, newHyperlink: string]>

    ITEM_CONVERSION_DATA_READY: LuaMultiReturn<[itemGUID: string]>

    ITEM_COUNT_CHANGED: LuaMultiReturn<[itemID: number]>

    ITEM_DATA_LOAD_RESULT: LuaMultiReturn<[itemID: number, success: boolean]>

    MERCHANT_CONFIRM_TRADE_TIMER_REMOVAL: LuaMultiReturn<[itemLink: string]>

    REPLACE_ENCHANT: LuaMultiReturn<[existingStr: string, replacementStr: string]>

    REPLACE_TRADESKILL_ENCHANT: LuaMultiReturn<[existing: string, replacement: string]>

    TRADE_REPLACE_ENCHANT: LuaMultiReturn<[existing: string, replacement: string]>

    USE_BIND_CONFIRM: undefined

    USE_NO_REFUND_CONFIRM: undefined

    WEAPON_ENCHANT_CHANGED: undefined

    ITEM_INTERACTION_CHARGE_INFO_UPDATED: undefined

    ITEM_INTERACTION_ITEM_SELECTION_UPDATED: LuaMultiReturn<
      [itemLocation: ItemLocationMixin | undefined]
    >

    SOCKET_INFO_ACCEPT: undefined

    SOCKET_INFO_BIND_CONFIRM: undefined

    SOCKET_INFO_CLOSE: undefined

    SOCKET_INFO_FAILURE: undefined

    SOCKET_INFO_REFUNDABLE_CONFIRM: undefined

    SOCKET_INFO_SUCCESS: undefined

    SOCKET_INFO_UPDATE: undefined

    ITEM_TEXT_BEGIN: undefined

    ITEM_TEXT_CLOSED: undefined

    ITEM_TEXT_READY: undefined

    ITEM_TEXT_TRANSLATION: LuaMultiReturn<[delay: number]>

    ITEM_UPGRADE_FAILED: undefined

    ITEM_UPGRADE_MASTER_SET_ITEM: undefined

    MODIFIER_STATE_CHANGED: LuaMultiReturn<[key: string, down: number]>

    UPDATE_BINDINGS: undefined

    KNOWLEDGE_BASE_ARTICLE_LOAD_FAILURE: undefined

    KNOWLEDGE_BASE_ARTICLE_LOAD_SUCCESS: undefined

    KNOWLEDGE_BASE_QUERY_LOAD_FAILURE: undefined

    KNOWLEDGE_BASE_QUERY_LOAD_SUCCESS: undefined

    KNOWLEDGE_BASE_SERVER_MESSAGE: undefined

    KNOWLEDGE_BASE_SETUP_LOAD_FAILURE: undefined

    KNOWLEDGE_BASE_SETUP_LOAD_SUCCESS: undefined

    KNOWLEDGE_BASE_SYSTEM_MOTD_UPDATED: undefined

    ISLAND_COMPLETED: LuaMultiReturn<[mapID: number, winner: number]>

    LFG_BOOT_PROPOSAL_UPDATE: undefined

    LFG_COMPLETION_REWARD: undefined

    LFG_ENABLED_STATE_CHANGED: undefined

    LFG_INVALID_ERROR_MESSAGE: LuaMultiReturn<
      [reason: number, subReason1: number, subReason2: number]
    >

    LFG_LOCK_INFO_RECEIVED: undefined

    LFG_OFFER_CONTINUE: LuaMultiReturn<
      [name: string, lfgDungeonsID: number, typeID: number]
    >

    LFG_OPEN_FROM_GOSSIP: LuaMultiReturn<[dungeonID: number]>

    LFG_PROPOSAL_DONE: undefined

    LFG_PROPOSAL_FAILED: undefined

    LFG_PROPOSAL_SHOW: undefined

    LFG_PROPOSAL_SUCCEEDED: undefined

    LFG_PROPOSAL_UPDATE: undefined

    LFG_QUEUE_STATUS_UPDATE: undefined

    LFG_READY_CHECK_DECLINED: LuaMultiReturn<[name: string]>

    LFG_READY_CHECK_HIDE: undefined

    LFG_READY_CHECK_PLAYER_IS_READY: LuaMultiReturn<[name: string]>

    LFG_READY_CHECK_SHOW: LuaMultiReturn<[isRequeue: boolean]>

    LFG_READY_CHECK_UPDATE: undefined

    LFG_ROLE_CHECK_DECLINED: undefined

    LFG_ROLE_CHECK_HIDE: undefined

    LFG_ROLE_CHECK_ROLE_CHOSEN: LuaMultiReturn<
      [name: string, isTank: boolean, isHealer: boolean, isDamage: boolean]
    >

    LFG_ROLE_CHECK_SHOW: LuaMultiReturn<[isRequeue: boolean]>

    LFG_ROLE_CHECK_UPDATE: undefined

    LFG_ROLE_UPDATE: undefined

    LFG_UPDATE: undefined

    LFG_UPDATE_RANDOM_INFO: undefined

    SHOW_LFG_EXPAND_SEARCH_PROMPT: undefined

    UPDATE_LFG_LIST: undefined

    WARFRONT_COMPLETED: LuaMultiReturn<[mapID: number, winner: number]>

    LFG_GROUP_DELISTED_LEADERSHIP_CHANGE: LuaMultiReturn<
      [listingName: string, automaticDelistTimeRemaining: number]
    >

    LFG_LIST_ACTIVE_ENTRY_UPDATE: LuaMultiReturn<[created: boolean | undefined]>

    LFG_LIST_APPLICANT_LIST_UPDATED: LuaMultiReturn<
      [newPendingEntry: boolean | undefined, newPendingEntryWithData: boolean | undefined]
    >

    LFG_LIST_APPLICANT_UPDATED: LuaMultiReturn<[applicantID: number]>

    LFG_LIST_APPLICATION_STATUS_UPDATED: LuaMultiReturn<
      [searchResultID: number, newStatus: string, oldStatus: string, groupName: string]
    >

    LFG_LIST_AVAILABILITY_UPDATE: undefined

    LFG_LIST_ENTRY_CREATION_FAILED: undefined

    LFG_LIST_ENTRY_EXPIRED_TIMEOUT: undefined

    LFG_LIST_ENTRY_EXPIRED_TOO_MANY_PLAYERS: undefined

    LFG_LIST_JOINED_GROUP: LuaMultiReturn<[searchResultID: number, groupName: string]>

    LFG_LIST_SEARCH_FAILED: LuaMultiReturn<[reason: string | undefined]>

    LFG_LIST_SEARCH_RESULT_UPDATED: LuaMultiReturn<[searchResultID: number]>

    LFG_LIST_SEARCH_RESULTS_RECEIVED: undefined

    NEW_RUNEFORGE_POWER_ADDED: LuaMultiReturn<[powerID: number]>

    RUNEFORGE_LEGENDARY_CRAFTING_CLOSED: undefined

    RUNEFORGE_LEGENDARY_CRAFTING_OPENED: LuaMultiReturn<[isUpgrade: boolean]>

    RUNEFORGE_POWER_INFO_UPDATED: LuaMultiReturn<[powerID: number]>

    LOADING_SCREEN_DISABLED: undefined

    LOADING_SCREEN_ENABLED: undefined

    AZERITE_EMPOWERED_ITEM_LOOTED: LuaMultiReturn<[itemLink: string]>

    BONUS_ROLL_ACTIVATE: undefined

    BONUS_ROLL_DEACTIVATE: undefined

    BONUS_ROLL_FAILED: undefined

    BONUS_ROLL_RESULT: LuaMultiReturn<
      [
        typeIdentifier: string,
        itemLink: string,
        quantity: number,
        specID: number,
        sex: number,
        personalLootToast: boolean,
        currencyID: number | undefined,
        isSecondaryResult: boolean,
        corrupted: boolean
      ]
    >

    BONUS_ROLL_STARTED: undefined

    CANCEL_ALL_LOOT_ROLLS: undefined

    CANCEL_LOOT_ROLL: LuaMultiReturn<[rollID: number]>

    CONFIRM_DISENCHANT_ROLL: LuaMultiReturn<[rollID: number, rollType: number]>

    CONFIRM_LOOT_ROLL: LuaMultiReturn<
      [rollID: number, rollType: number, confirmReason: string]
    >

    ENCOUNTER_LOOT_RECEIVED: LuaMultiReturn<
      [
        encounterID: number,
        itemID: number,
        itemLink: string,
        quantity: number,
        itemName: string,
        fileName: string
      ]
    >

    GARRISON_MISSION_BONUS_ROLL_LOOT: LuaMultiReturn<[itemID: number, quantity: number]>

    ITEM_PUSH: LuaMultiReturn<[bagSlot: number, iconFileID: number]>

    LOOT_BIND_CONFIRM: LuaMultiReturn<[lootSlot: number]>

    LOOT_CLOSED: undefined

    LOOT_ITEM_AVAILABLE: LuaMultiReturn<[itemTooltip: string, lootHandle: number]>

    LOOT_ITEM_ROLL_WON: LuaMultiReturn<
      [
        itemLink: string,
        rollQuantity: number,
        rollType: number,
        roll: number,
        upgraded: boolean
      ]
    >

    LOOT_OPENED: LuaMultiReturn<[autoLoot: boolean, isFromItem: boolean]>

    LOOT_READY: LuaMultiReturn<[autoloot: boolean]>

    LOOT_ROLLS_COMPLETE: LuaMultiReturn<[lootHandle: number]>

    LOOT_SLOT_CHANGED: LuaMultiReturn<[lootSlot: number]>

    LOOT_SLOT_CLEARED: LuaMultiReturn<[lootSlot: number]>

    MAIN_SPEC_NEED_ROLL: LuaMultiReturn<
      [rollID: number, roll: number, isWinning: boolean]
    >

    OPEN_MASTER_LOOT_LIST: undefined

    PET_BATTLE_LOOT_RECEIVED: LuaMultiReturn<
      [typeIdentifier: string, itemLink: string, quantity: number]
    >

    PLAYER_LOOT_SPEC_UPDATED: undefined

    QUEST_CURRENCY_LOOT_RECEIVED: LuaMultiReturn<
      [questID: number, currencyId: number, quantity: number]
    >

    QUEST_LOOT_RECEIVED: LuaMultiReturn<
      [questID: number, itemLink: string, quantity: number]
    >

    SHOW_LOOT_TOAST: LuaMultiReturn<
      [
        typeIdentifier: string,
        itemLink: string,
        quantity: number,
        specID: number,
        sex: number,
        personalLootToast: boolean,
        toastMethod: number,
        lessAwesome: boolean,
        upgraded: boolean,
        corrupted: boolean
      ]
    >

    SHOW_LOOT_TOAST_LEGENDARY_LOOTED: LuaMultiReturn<[itemLink: string]>

    SHOW_LOOT_TOAST_UPGRADE: LuaMultiReturn<
      [
        itemLink: string,
        quantity: number,
        specID: number,
        sex: number,
        baseQuality: number,
        personalLootToast: boolean,
        lessAwesome: boolean
      ]
    >

    SHOW_PVP_FACTION_LOOT_TOAST: LuaMultiReturn<
      [
        typeIdentifier: string,
        itemLink: string,
        quantity: number,
        specID: number,
        sex: number,
        personalLootToast: boolean,
        lessAwesome: boolean
      ]
    >

    SHOW_RATED_PVP_REWARD_TOAST: LuaMultiReturn<
      [
        typeIdentifier: string,
        itemLink: string,
        quantity: number,
        specID: number,
        sex: number,
        personalLootToast: boolean,
        lessAwesome: boolean
      ]
    >

    START_LOOT_ROLL: LuaMultiReturn<
      [rollID: number, rollTime: number, lootHandle: number | undefined]
    >

    TRIAL_CAP_REACHED_MONEY: undefined

    UPDATE_MASTER_LOOT_LIST: undefined

    LOOT_HISTORY_CLEAR_HISTORY: undefined

    LOOT_HISTORY_GO_TO_ENCOUNTER: LuaMultiReturn<[encounterID: number]>

    LOOT_HISTORY_ONE_HUNDRED_ROLL: LuaMultiReturn<
      [encounterID: number, lootListID: number]
    >

    LOOT_HISTORY_UPDATE_DROP: LuaMultiReturn<[encounterID: number, lootListID: number]>

    LOOT_HISTORY_UPDATE_ENCOUNTER: LuaMultiReturn<[encounterID: number]>

    LOOT_JOURNAL_ITEM_UPDATE: undefined

    LORE_TEXT_UPDATED_CAMPAIGN: LuaMultiReturn<
      [campaignID: number, textEntries: undefined[]]
    >

    LOSS_OF_CONTROL_ADDED: LuaMultiReturn<[unitTarget: UnitToken, effectIndex: number]>

    LOSS_OF_CONTROL_COMMENTATOR_ADDED: LuaMultiReturn<
      [victim: string, effectIndex: number]
    >

    LOSS_OF_CONTROL_COMMENTATOR_UPDATE: LuaMultiReturn<[victim: string]>

    LOSS_OF_CONTROL_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_CONTROL_GAINED: undefined

    PLAYER_CONTROL_LOST: undefined

    CLOSE_INBOX_ITEM: LuaMultiReturn<[mailIndex: number]>

    MAIL_CLOSED: undefined

    MAIL_FAILED: LuaMultiReturn<[itemID: number | undefined]>

    MAIL_INBOX_UPDATE: undefined

    MAIL_LOCK_SEND_ITEMS: LuaMultiReturn<[attachSlot: number, itemLink: string]>

    MAIL_SEND_INFO_UPDATE: undefined

    MAIL_SEND_SUCCESS: undefined

    MAIL_SHOW: undefined

    MAIL_SUCCESS: LuaMultiReturn<[itemID: number | undefined]>

    MAIL_UNLOCK_SEND_ITEMS: undefined

    SEND_MAIL_COD_CHANGED: undefined

    SEND_MAIL_MONEY_CHANGED: undefined

    UPDATE_PENDING_MAIL: undefined

    MAJOR_FACTION_INTERACTION_ENDED: undefined

    MAJOR_FACTION_INTERACTION_STARTED: undefined

    MAJOR_FACTION_RENOWN_LEVEL_CHANGED: LuaMultiReturn<
      [majorFactionID: number, newRenownLevel: number, oldRenownLevel: number]
    >

    MAJOR_FACTION_UNLOCKED: LuaMultiReturn<[majorFactionID: number]>

    NEW_WMO_CHUNK: undefined

    PLAYER_MAP_CHANGED: LuaMultiReturn<[oldMapID: number, newMapID: number]>

    USER_WAYPOINT_UPDATED: undefined

    WORLD_MAP_OPEN: LuaMultiReturn<[uiMapID: number]>

    ZONE_CHANGED: undefined

    ZONE_CHANGED_INDOORS: undefined

    ZONE_CHANGED_NEW_AREA: undefined

    MAP_EXPLORATION_UPDATED: undefined

    MERCHANT_CLOSED: undefined

    MERCHANT_FILTER_ITEM_UPDATE: LuaMultiReturn<[itemID: number]>

    MERCHANT_SHOW: undefined

    MERCHANT_UPDATE: undefined

    MINIMAP_PING: LuaMultiReturn<[unitTarget: UnitToken, y: number, x: number]>

    MINIMAP_UPDATE_TRACKING: undefined

    MINIMAP_UPDATE_ZOOM: undefined

    MOUNT_EQUIPMENT_APPLY_RESULT: LuaMultiReturn<[success: boolean]>

    MOUNT_JOURNAL_SEARCH_UPDATED: undefined

    MOUNT_JOURNAL_USABILITY_CHANGED: undefined

    NEW_MOUNT_ADDED: LuaMultiReturn<[mountID: number]>

    MYTHIC_PLUS_CURRENT_AFFIX_UPDATE: undefined

    MYTHIC_PLUS_NEW_WEEKLY_RECORD: LuaMultiReturn<
      [mapChallengeModeID: number, completionMilliseconds: number, level: number]
    >

    FORBIDDEN_NAME_PLATE_CREATED: LuaMultiReturn<[namePlateFrame: NamePlateFrame]>

    FORBIDDEN_NAME_PLATE_UNIT_ADDED: LuaMultiReturn<[unitToken: string]>

    FORBIDDEN_NAME_PLATE_UNIT_REMOVED: LuaMultiReturn<[unitToken: string]>

    NAME_PLATE_CREATED: LuaMultiReturn<[namePlateFrame: NamePlateFrame]>

    NAME_PLATE_UNIT_ADDED: LuaMultiReturn<[unitToken: string]>

    NAME_PLATE_UNIT_REMOVED: LuaMultiReturn<[unitToken: string]>

    AVOIDANCE_UPDATE: undefined

    CHARACTER_POINTS_CHANGED: LuaMultiReturn<[change: number]>

    CHARACTER_UPGRADE_SPELL_TIER_SET: LuaMultiReturn<[tierIndex: number]>

    COMBAT_RATING_UPDATE: undefined

    DISABLE_XP_GAIN: undefined

    ENABLE_XP_GAIN: undefined

    EQUIP_BIND_CONFIRM: LuaMultiReturn<[slot: number, itemLocation: ItemLocationMixin]>

    INSPECT_HONOR_UPDATE: undefined

    INSPECT_READY: LuaMultiReturn<[inspecteeGUID: string]>

    LIFESTEAL_UPDATE: undefined

    MASTERY_UPDATE: undefined

    PET_SPELL_POWER_UPDATE: undefined

    PLAYER_AVG_ITEM_LEVEL_UPDATE: undefined

    PLAYER_EQUIPMENT_CHANGED: LuaMultiReturn<[equipmentSlot: number, hasCurrent: boolean]>

    PROFESSION_EQUIPMENT_CHANGED: LuaMultiReturn<[skillLineID: number, isTool: boolean]>

    PVP_POWER_UPDATE: undefined

    SPEED_UPDATE: undefined

    SPELL_POWER_CHANGED: undefined

    STURDINESS_UPDATE: undefined

    UPDATE_FACTION: undefined

    UPDATE_INVENTORY_ALERTS: undefined

    UPDATE_INVENTORY_DURABILITY: undefined

    WEAPON_SLOT_CHANGED: undefined

    BNET_REQUEST_INVITE_CONFIRMATION: LuaMultiReturn<
      [
        gameAccountID: number,
        questSessionActive: boolean,
        tank: boolean,
        healer: boolean,
        dps: boolean
      ]
    >

    CONVERT_TO_RAID_CONFIRMATION: undefined

    ENTERED_DIFFERENT_INSTANCE_FROM_PARTY: undefined

    GROUP_FORMED: LuaMultiReturn<[category: number, partyGUID: string]>

    GROUP_INVITE_CONFIRMATION: undefined

    GROUP_JOINED: LuaMultiReturn<[category: number, partyGUID: string]>

    GROUP_LEFT: LuaMultiReturn<[category: number, partyGUID: string]>

    GROUP_ROSTER_UPDATE: undefined

    INSTANCE_BOOT_START: undefined

    INSTANCE_BOOT_STOP: undefined

    INSTANCE_GROUP_SIZE_CHANGED: undefined

    INVITE_TO_PARTY_CONFIRMATION: LuaMultiReturn<
      [targetName: string, willConvertToRaid: boolean, questSessionActive: boolean]
    >

    INVITE_TRAVEL_PASS_CONFIRMATION: LuaMultiReturn<
      [
        targetName: string,
        targetGUID: string,
        willConvertToRaid: boolean,
        questSessionActive: boolean
      ]
    >

    LEAVE_PARTY_CONFIRMATION: undefined

    PARTY_INVITE_CANCEL: undefined

    PARTY_INVITE_REQUEST: LuaMultiReturn<
      [
        name: string,
        isTank: boolean,
        isHealer: boolean,
        isDamage: boolean,
        isNativeRealm: boolean,
        allowMultipleRoles: boolean,
        inviterGUID: string,
        questSessionActive: boolean
      ]
    >

    PARTY_LEADER_CHANGED: undefined

    PARTY_LFG_RESTRICTED: undefined

    PARTY_LOOT_METHOD_CHANGED: undefined

    PARTY_MEMBER_DISABLE: LuaMultiReturn<[unitTarget: UnitToken]>

    PARTY_MEMBER_ENABLE: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_DIFFICULTY_CHANGED: undefined

    PLAYER_ROLES_ASSIGNED: undefined

    RAID_ROSTER_UPDATE: undefined

    READY_CHECK: LuaMultiReturn<[initiatorName: string, readyCheckTimeLeft: number]>

    READY_CHECK_CONFIRM: LuaMultiReturn<[unitTarget: UnitToken, isReady: boolean]>

    READY_CHECK_FINISHED: LuaMultiReturn<[preempted: boolean]>

    REQUEST_INVITE_CONFIRMATION: LuaMultiReturn<
      [
        targetName: string,
        partyLevelLink: number,
        questSessionActive: boolean,
        tank: boolean | undefined,
        healer: boolean | undefined,
        dps: boolean | undefined
      ]
    >

    ROLE_CHANGED_INFORM: LuaMultiReturn<
      [changedName: string, fromName: string, oldRole: string, newRole: string]
    >

    ROLE_POLL_BEGIN: LuaMultiReturn<[fromName: string]>

    VOTE_KICK_REASON_NEEDED: LuaMultiReturn<[name: string, resultGUID: string]>

    SHOW_PARTY_POSE_UI: LuaMultiReturn<[mapID: number, won: boolean]>

    PERKS_ACTIVITIES_TRACKED_LIST_CHANGED: LuaMultiReturn<
      [perksActivityID: number, added: boolean]
    >

    PERKS_ACTIVITIES_TRACKED_UPDATED: undefined

    PERKS_ACTIVITIES_UPDATED: undefined

    PERKS_ACTIVITY_COMPLETED: LuaMultiReturn<[perksActivityID: number]>

    CHEST_REWARDS_UPDATED_FROM_SERVER: undefined

    PERKS_PROGRAM_ADD_PENDING_SHOP_ITEM: LuaMultiReturn<[vendorItemID: number]>

    PERKS_PROGRAM_CLOSE: undefined

    PERKS_PROGRAM_CURRENCY_AWARDED: LuaMultiReturn<[value: number]>

    PERKS_PROGRAM_CURRENCY_REFRESH: LuaMultiReturn<[oldValue: number, newValue: number]>

    PERKS_PROGRAM_DATA_REFRESH: undefined

    PERKS_PROGRAM_DATA_SPECIFIC_ITEM_REFRESH: LuaMultiReturn<[vendorItemID: number]>

    PERKS_PROGRAM_DISABLED: undefined

    PERKS_PROGRAM_OPEN: undefined

    PERKS_PROGRAM_PURCHASE_SUCCESS: LuaMultiReturn<[vendorItemID: number]>

    PERKS_PROGRAM_REFUND_SUCCESS: LuaMultiReturn<[vendorItemID: number]>

    PERKS_PROGRAM_REMOVE_PENDING_SHOP_ITEM: LuaMultiReturn<[vendorItemID: number]>

    PERKS_PROGRAM_RESULT_ERROR: undefined

    PERKS_PROGRAM_SET_FROZEN_ITEM: LuaMultiReturn<[vendorItemID: number]>

    PET_ATTACK_START: undefined

    PET_ATTACK_STOP: undefined

    PET_BAR_HIDEGRID: undefined

    PET_BAR_SHOWGRID: undefined

    PET_BAR_UPDATE_COOLDOWN: undefined

    PET_DISMISS_START: LuaMultiReturn<[delay: number]>

    PET_FORCE_NAME_DECLENSION: LuaMultiReturn<
      [
        name: string,
        petNumber: number | undefined,
        declinedName1: string | undefined,
        declinedName2: string | undefined,
        declinedName3: string | undefined,
        declinedName4: string | undefined,
        declinedName5: string | undefined
      ]
    >

    PET_UI_CLOSE: undefined

    RAISED_AS_GHOUL: undefined

    UPDATE_POSSESS_BAR: undefined

    UPDATE_VEHICLE_ACTIONBAR: undefined

    BATTLEPET_FORCE_NAME_DECLENSION: LuaMultiReturn<[name: string, battlePetGUID: string]>

    COMPANION_LEARNED: undefined

    COMPANION_UNLEARNED: undefined

    COMPANION_UPDATE: LuaMultiReturn<[companionType: string | undefined]>

    NEW_PET_ADDED: LuaMultiReturn<[battlePetGUID: string]>

    PET_JOURNAL_AUTO_SLOTTED_PET: LuaMultiReturn<
      [slotIndex: number, battlePetGUID: string]
    >

    PET_JOURNAL_CAGE_FAILED: undefined

    PET_JOURNAL_LIST_UPDATE: undefined

    PET_JOURNAL_NEW_BATTLE_SLOT: undefined

    PET_JOURNAL_PET_DELETED: LuaMultiReturn<[battlePetGUID: string]>

    PET_JOURNAL_PET_RESTORED: LuaMultiReturn<[battlePetGUID: string]>

    PET_JOURNAL_PET_REVOKED: LuaMultiReturn<[battlePetGUID: string]>

    PET_JOURNAL_PETS_HEALED: undefined

    PET_JOURNAL_TRAP_LEVEL_SET: LuaMultiReturn<[trapLevel: number]>

    UPDATE_SUMMONPETS_ACTION: undefined

    PING_SYSTEM_ERROR: LuaMultiReturn<[error: string]>

    PLAYER_CHOICE_CLOSE: undefined

    PLAYER_CHOICE_UPDATE: undefined

    PLAYER_INTERACTION_MANAGER_FRAME_HIDE: LuaMultiReturn<[type: PlayerInteractionType]>

    PLAYER_INTERACTION_MANAGER_FRAME_SHOW: LuaMultiReturn<[type: PlayerInteractionType]>

    MENTORSHIP_STATUS_CHANGED: undefined

    NEWCOMER_GRADUATION: undefined

    SKILL_LINE_SPECS_RANKS_CHANGED: undefined

    SKILL_LINE_SPECS_UNLOCKED: LuaMultiReturn<[skillLineID: number, tradeSkillID: number]>

    ARENA_OPPONENT_UPDATE: LuaMultiReturn<[unitToken: string, updateReason: string]>

    ARENA_PREP_OPPONENT_SPECIALIZATIONS: undefined

    ARENA_SEASON_WORLD_STATE: undefined

    BATTLEFIELD_AUTO_QUEUE: undefined

    BATTLEFIELD_AUTO_QUEUE_EJECT: undefined

    BATTLEFIELD_QUEUE_TIMEOUT: undefined

    BATTLEFIELDS_CLOSED: undefined

    BATTLEFIELDS_SHOW: LuaMultiReturn<
      [isArena: boolean | undefined, battleMasterListID: number | undefined]
    >

    BATTLEGROUND_OBJECTIVES_UPDATE: undefined

    BATTLEGROUND_POINTS_UPDATE: undefined

    GDF_SIM_COMPLETE: undefined

    HONOR_LEVEL_UPDATE: LuaMultiReturn<[isHigherLevel: boolean]>

    NOTIFY_PVP_AFK_RESULT: LuaMultiReturn<
      [offender: string, numBlackMarksOnOffender: number, numPlayersIHaveReported: number]
    >

    PLAYER_ENTERING_BATTLEGROUND: undefined

    PLAYER_JOINED_PVP_MATCH: undefined

    POST_MATCH_CURRENCY_REWARD_UPDATE: LuaMultiReturn<
      [reward: PVPPostMatchCurrencyReward]
    >

    POST_MATCH_ITEM_REWARD_UPDATE: undefined

    PVP_BRAWL_INFO_UPDATED: undefined

    PVP_MATCH_ACTIVE: undefined

    PVP_MATCH_COMPLETE: LuaMultiReturn<[winner: number, duration: number]>

    PVP_MATCH_INACTIVE: undefined

    PVP_MATCH_STATE_CHANGED: undefined

    PVP_RATED_STATS_UPDATE: undefined

    PVP_REWARDS_UPDATE: undefined

    PVP_ROLE_POPUP_HIDE: LuaMultiReturn<[readyCheckInfo: PvpReadyCheckInfo | undefined]>

    PVP_ROLE_POPUP_SHOW: LuaMultiReturn<[readyCheckInfo: PvpReadyCheckInfo]>

    PVP_ROLE_UPDATE: undefined

    PVP_SPECIAL_EVENT_INFO_UPDATED: undefined

    PVP_TYPES_ENABLED: LuaMultiReturn<
      [
        wargameBattlegrounds: boolean,
        ratedBattlegrounds: boolean,
        ratedArenas: boolean,
        ratedSoloShuffle: boolean,
        ratedBGBlitz: boolean
      ]
    >

    PVP_VEHICLE_INFO_UPDATED: undefined

    PVP_WORLDSTATE_UPDATE: undefined

    PVPQUEUE_ANYWHERE_SHOW: undefined

    PVPQUEUE_ANYWHERE_UPDATE_AVAILABLE: undefined

    UPDATE_ACTIVE_BATTLEFIELD: undefined

    UPDATE_BATTLEFIELD_SCORE: undefined

    UPDATE_BATTLEFIELD_STATUS: LuaMultiReturn<[battleFieldIndex: number]>

    WAR_MODE_STATUS_UPDATE: LuaMultiReturn<[warModeEnabled: boolean]>

    WARGAME_INVITE_SENT: undefined

    WARGAME_REQUEST_RESPONSE: LuaMultiReturn<
      [responderGUID: string, responderName: string | undefined, accepted: boolean]
    >

    WARGAME_REQUESTED: LuaMultiReturn<
      [
        opposingPartyMemberName: string,
        battlegroundName: string,
        timeoutSeconds: number,
        tournamentRules: boolean
      ]
    >

    WORLD_PVP_QUEUE: undefined

    QUEST_ACCEPTED: LuaMultiReturn<[questId: number]>

    QUEST_AUTOCOMPLETE: LuaMultiReturn<[questId: number]>

    QUEST_COMPLETE: undefined

    QUEST_DATA_LOAD_RESULT: LuaMultiReturn<[questID: number, success: boolean]>

    QUEST_DETAIL: LuaMultiReturn<[questStartItemID: number | undefined]>

    QUEST_LOG_CRITERIA_UPDATE: LuaMultiReturn<
      [
        questID: number,
        specificTreeID: number,
        description: string,
        numFulfilled: number,
        numRequired: number
      ]
    >

    QUEST_LOG_UPDATE: undefined

    QUEST_POI_UPDATE: undefined

    QUEST_REMOVED: LuaMultiReturn<[questID: number, wasReplayQuest: boolean]>

    QUEST_TURNED_IN: LuaMultiReturn<
      [questID: number, xpReward: number, moneyReward: number]
    >

    QUEST_WATCH_LIST_CHANGED: LuaMultiReturn<
      [questID: number | undefined, added: boolean | undefined]
    >

    QUEST_WATCH_UPDATE: LuaMultiReturn<[questID: number]>

    QUESTLINE_UPDATE: LuaMultiReturn<[requestRequired: boolean]>

    TASK_PROGRESS_UPDATE: undefined

    TREASURE_PICKER_CACHE_FLUSH: undefined

    WAYPOINT_UPDATE: undefined

    WORLD_QUEST_COMPLETED_BY_SPELL: LuaMultiReturn<[questID: number]>

    QUEST_ACCEPT_CONFIRM: LuaMultiReturn<[name: string, questTitle: string]>

    QUEST_FINISHED: undefined

    QUEST_GREETING: undefined

    QUEST_ITEM_UPDATE: undefined

    QUEST_PROGRESS: undefined

    QUEST_SESSION_CREATED: undefined

    QUEST_SESSION_DESTROYED: undefined

    QUEST_SESSION_ENABLED_STATE_CHANGED: LuaMultiReturn<[enabled: boolean]>

    QUEST_SESSION_JOINED: undefined

    QUEST_SESSION_LEFT: undefined

    QUEST_SESSION_MEMBER_CONFIRM: undefined

    QUEST_SESSION_MEMBER_START_RESPONSE: LuaMultiReturn<[guid: string, response: boolean]>

    QUEST_SESSION_NOTIFICATION: LuaMultiReturn<[result: QuestSessionResult, guid: string]>

    RAF_INFO_UPDATED: LuaMultiReturn<[info: RafInfo]>

    RAF_RECRUITING_ENABLED_STATUS: LuaMultiReturn<[enabled: boolean]>

    RAF_REWARD_CLAIM_FAILED: undefined

    RAF_SYSTEM_ENABLED_STATUS: LuaMultiReturn<[enabled: boolean]>

    RAF_SYSTEM_INFO_UPDATED: LuaMultiReturn<[systemInfo: RafSystemInfo]>

    REPORT_PLAYER_RESULT: LuaMultiReturn<[success: boolean, reportType: ReportType]>

    ARCHAEOLOGY_CLOSED: undefined

    ARCHAEOLOGY_FIND_COMPLETE: LuaMultiReturn<
      [numFindsCompleted: number, totalFinds: number, researchBranchID: number]
    >

    ARCHAEOLOGY_SURVEY_CAST: LuaMultiReturn<
      [
        numFindsCompleted: number,
        totalFinds: number,
        researchBranchID: number,
        successfulFind: number
      ]
    >

    ARCHAEOLOGY_TOGGLE: undefined

    ARTIFACT_DIGSITE_COMPLETE: LuaMultiReturn<[researchBranchID: number]>

    RESEARCH_ARTIFACT_COMPLETE: LuaMultiReturn<[name: string]>

    RESEARCH_ARTIFACT_DIG_SITE_UPDATED: undefined

    RESEARCH_ARTIFACT_UPDATE: undefined

    ADDON_ACTION_BLOCKED: LuaMultiReturn<[isTainted: string, function: string]>

    ADDON_ACTION_FORBIDDEN: LuaMultiReturn<[isTainted: string, function: string]>

    MACRO_ACTION_BLOCKED: LuaMultiReturn<[function: string]>

    MACRO_ACTION_FORBIDDEN: LuaMultiReturn<[function: string]>

    RETURNING_PLAYER_PROMPT: undefined

    JAILERS_TOWER_LEVEL_UPDATE: LuaMultiReturn<[level: number, type: JailersTowerType]>

    SCENARIO_BONUS_OBJECTIVE_COMPLETE: LuaMultiReturn<[bonusObjectiveID: number]>

    SCENARIO_BONUS_VISIBILITY_UPDATE: undefined

    SCENARIO_COMPLETED: LuaMultiReturn<
      [questID: number | undefined, xp: number | undefined, money: number | undefined]
    >

    SCENARIO_CRITERIA_SHOW_STATE_UPDATE: LuaMultiReturn<[show: boolean]>

    SCENARIO_CRITERIA_UPDATE: LuaMultiReturn<[criteriaID: number]>

    SCENARIO_POI_UPDATE: undefined

    SCENARIO_SPELL_UPDATE: undefined

    SCENARIO_UPDATE: LuaMultiReturn<[newStep: boolean | undefined]>

    SCRAPPING_MACHINE_ITEM_ADDED: LuaMultiReturn<[index: number]>

    SCRAPPING_MACHINE_ITEM_REMOVED: LuaMultiReturn<[index: number]>

    SCRAPPING_MACHINE_PENDING_ITEM_CHANGED: undefined

    SCRAPPING_MACHINE_SCRAPPING_FINISHED: undefined

    LUA_WARNING: LuaMultiReturn<[warnType: number, warningText: string]>

    SCRIPTED_ANIMATIONS_UPDATE: undefined

    SECURE_TRANSFER_CANCEL: undefined

    SECURE_TRANSFER_CONFIRM_SEND_MAIL: undefined

    SECURE_TRANSFER_CONFIRM_TRADE_ACCEPT: undefined

    CONFIG_COMMIT_FAILED: LuaMultiReturn<[configID: number]>

    TRAIT_COND_INFO_CHANGED: LuaMultiReturn<[condID: number]>

    TRAIT_CONFIG_CREATED: LuaMultiReturn<[configInfo: TraitConfigInfo]>

    TRAIT_CONFIG_DELETED: LuaMultiReturn<[configID: number]>

    TRAIT_CONFIG_LIST_UPDATED: undefined

    TRAIT_CONFIG_UPDATED: LuaMultiReturn<[configID: number]>

    TRAIT_NODE_CHANGED: LuaMultiReturn<[nodeID: number]>

    TRAIT_NODE_CHANGED_PARTIAL: LuaMultiReturn<[ID: number, info: TraitNodeInfoPartial]>

    TRAIT_NODE_ENTRY_UPDATED: LuaMultiReturn<[nodeEntryID: number]>

    TRAIT_SUB_TREE_CHANGED: LuaMultiReturn<[subTreeID: number]>

    TRAIT_SYSTEM_INTERACTION_STARTED: LuaMultiReturn<[treeID: number]>

    TRAIT_SYSTEM_NPC_CLOSED: undefined

    TRAIT_TREE_CHANGED: LuaMultiReturn<[treeID: number]>

    TRAIT_TREE_CURRENCY_INFO_UPDATED: LuaMultiReturn<[treeID: number]>

    SKILL_LINES_CHANGED: undefined

    SOCIAL_ITEM_RECEIVED: undefined

    TWITTER_LINK_RESULT: LuaMultiReturn<
      [isLinked: boolean, screenName: string, error: string]
    >

    TWITTER_POST_RESULT: LuaMultiReturn<[result: number]>

    TWITTER_STATUS_UPDATE: LuaMultiReturn<
      [isTwitterEnabled: boolean, isLinked: boolean, screenName: string]
    >

    SOCIAL_QUEUE_CONFIG_UPDATED: undefined

    SOCIAL_QUEUE_UPDATE: LuaMultiReturn<
      [groupGUID: string, numAddedItems: number | undefined]
    >

    ALERT_REGIONAL_CHAT_DISABLED: undefined

    CHAT_DISABLED_CHANGE_FAILED: LuaMultiReturn<[disabled: boolean]>

    CHAT_DISABLED_CHANGED: LuaMultiReturn<[disabled: boolean]>

    SOULBIND_ACTIVATED: LuaMultiReturn<[soulbindID: number]>

    SOULBIND_CONDUIT_COLLECTION_CLEARED: undefined

    SOULBIND_CONDUIT_COLLECTION_REMOVED: LuaMultiReturn<[conduitID: number]>

    SOULBIND_CONDUIT_COLLECTION_UPDATED: LuaMultiReturn<
      [collectionData: ConduitCollectionData]
    >

    SOULBIND_CONDUIT_INSTALLED: LuaMultiReturn<
      [nodeID: number, data: SoulbindConduitData]
    >

    SOULBIND_CONDUIT_UNINSTALLED: LuaMultiReturn<
      [nodeID: number, data: SoulbindConduitData]
    >

    SOULBIND_FORGE_INTERACTION_ENDED: undefined

    SOULBIND_FORGE_INTERACTION_STARTED: undefined

    SOULBIND_NODE_LEARNED: LuaMultiReturn<[nodeID: number]>

    SOULBIND_NODE_UNLEARNED: LuaMultiReturn<[nodeID: number]>

    SOULBIND_NODE_UPDATED: LuaMultiReturn<[nodeID: number]>

    SOULBIND_PATH_CHANGED: undefined

    SOULBIND_PENDING_CONDUIT_CHANGED: LuaMultiReturn<[nodeID: number, conduitID: number]>

    SOUND_DEVICE_UPDATE: undefined

    SOUNDKIT_FINISHED: LuaMultiReturn<[soundHandle: number]>

    ACTIVE_TALENT_GROUP_CHANGED: LuaMultiReturn<[curr: number, prev: number]>

    CONFIRM_TALENT_WIPE: LuaMultiReturn<[cost: number, respecType: number]>

    PET_SPECIALIZATION_CHANGED: undefined

    PLAYER_LEARN_PVP_TALENT_FAILED: undefined

    PLAYER_LEARN_TALENT_FAILED: undefined

    PLAYER_PVP_TALENT_UPDATE: undefined

    PLAYER_TALENT_UPDATE: undefined

    SPEC_INVOLUNTARILY_CHANGED: LuaMultiReturn<[isPet: boolean]>

    TALENTS_INVOLUNTARILY_RESET: LuaMultiReturn<[isPetTalents: boolean]>

    SPELL_ACTIVATION_OVERLAY_GLOW_HIDE: LuaMultiReturn<[spellID: number]>

    SPELL_ACTIVATION_OVERLAY_GLOW_SHOW: LuaMultiReturn<[spellID: number]>

    SPELL_ACTIVATION_OVERLAY_HIDE: LuaMultiReturn<[spellID: number | undefined]>

    SPELL_ACTIVATION_OVERLAY_SHOW: LuaMultiReturn<
      [
        spellID: number,
        overlayFileDataID: number,
        locationName: string,
        scale: number,
        r: number,
        g: number,
        b: number
      ]
    >

    CURRENT_SPELL_CAST_CHANGED: LuaMultiReturn<[cancelledCast: boolean]>

    LEARNED_SPELL_IN_SKILL_LINE: LuaMultiReturn<
      [spellID: number, skillLineIndex: number, isGuildPerkSpell: boolean]
    >

    MAX_SPELL_START_RECOVERY_OFFSET_CHANGED: LuaMultiReturn<
      [clampedNewQueueWindowMs: number]
    >

    PLAYER_TOTEM_UPDATE: LuaMultiReturn<[totemSlot: number]>

    SPELL_FLYOUT_UPDATE: LuaMultiReturn<
      [
        flyoutID: number | undefined,
        spellID: number | undefined,
        isLearned: boolean | undefined
      ]
    >

    SPELL_PUSHED_TO_ACTIONBAR: LuaMultiReturn<
      [spellID: number, slot: number, page: number]
    >

    SPELL_UPDATE_CHARGES: undefined

    SPELL_UPDATE_COOLDOWN: undefined

    SPELL_UPDATE_ICON: undefined

    SPELL_UPDATE_USABLE: undefined

    SPELLS_CHANGED: undefined

    START_AUTOREPEAT_SPELL: undefined

    STOP_AUTOREPEAT_SPELL: undefined

    UNIT_SPELLCAST_SENT: LuaMultiReturn<
      [unit: string, target: string, castGUID: string, spellID: number]
    >

    UPDATE_SHAPESHIFT_COOLDOWN: undefined

    UPDATE_SHAPESHIFT_FORM: undefined

    UPDATE_SHAPESHIFT_FORMS: undefined

    UPDATE_SHAPESHIFT_USABLE: undefined

    ENCHANT_SPELL_COMPLETED: LuaMultiReturn<
      [successful: boolean, enchantedItem: ItemLocationMixin | undefined]
    >

    ENCHANT_SPELL_SELECTED: undefined

    SPELL_DATA_LOAD_RESULT: LuaMultiReturn<[spellID: number, success: boolean]>

    SPELL_TEXT_UPDATE: LuaMultiReturn<[spellID: number]>

    UPDATE_SPELL_TARGET_ITEM_CONTEXT: undefined

    OPEN_SPLASH_SCREEN: LuaMultiReturn<[info: SplashScreenInfo | undefined]>

    PET_INFO_UPDATE: undefined

    PET_STABLE_CLOSED: undefined

    PET_STABLE_FAVORITES_UPDATED: undefined

    PET_STABLE_SHOW: undefined

    PET_STABLE_UPDATE: undefined

    SUPER_TRACKING_CHANGED: undefined

    CAPTUREFRAMES_FAILED: undefined

    CAPTUREFRAMES_SUCCEEDED: undefined

    DISABLE_TAXI_BENCHMARK: undefined

    ENABLE_TAXI_BENCHMARK: undefined

    FIRST_FRAME_RENDERED: undefined

    GENERIC_ERROR: LuaMultiReturn<[errorMessage: string]>

    GLOBAL_MOUSE_DOWN: LuaMultiReturn<[button: string]>

    GLOBAL_MOUSE_UP: LuaMultiReturn<[button: string]>

    INITIAL_HOTFIXES_APPLIED: undefined

    LOC_RESULT: LuaMultiReturn<[result: string]>

    LOGOUT_CANCEL: undefined

    PLAYER_CAMPING: undefined

    PLAYER_ENTERING_WORLD: LuaMultiReturn<
      [isInitialLogin: boolean, isReloadingUi: boolean]
    >

    PLAYER_LEAVING_WORLD: undefined

    PLAYER_LOGIN: undefined

    PLAYER_LOGOUT: undefined

    PLAYER_QUITING: undefined

    SEARCH_DB_LOADED: undefined

    STREAMING_ICON: LuaMultiReturn<[streamingStatus: number]>

    SYSMSG: LuaMultiReturn<[string: string, r: number, g: number, b: number]>

    TIME_PLAYED_MSG: LuaMultiReturn<
      [totalTimePlayed: number, timePlayedThisLevel: number]
    >

    UI_ERROR_MESSAGE: LuaMultiReturn<[errorType: number, message: string]>

    UI_ERROR_POPUP: LuaMultiReturn<[errorType: number, message: string]>

    UI_INFO_MESSAGE: LuaMultiReturn<[errorType: number, message: string]>

    VARIABLES_LOADED: undefined

    WOW_MOUSE_NOT_FOUND: undefined

    TALKINGHEAD_CLOSE: undefined

    TALKINGHEAD_REQUESTED: undefined

    TAXI_NODE_STATUS_CHANGED: undefined

    TAXIMAP_CLOSED: undefined

    TAXIMAP_OPENED: LuaMultiReturn<[system: number]>

    REMIX_END_OF_EVENT: undefined

    HIDE_HYPERLINK_TOOLTIP: undefined

    SHOW_HYPERLINK_TOOLTIP: LuaMultiReturn<[hyperlink: string]>

    TOOLTIP_DATA_UPDATE: LuaMultiReturn<[dataInstanceID: number | undefined]>

    NEW_TOY_ADDED: LuaMultiReturn<[itemID: number]>

    TOYS_UPDATED: LuaMultiReturn<
      [
        itemID: number | undefined,
        isNew: boolean | undefined,
        hasFanfare: boolean | undefined
      ]
    >

    PLAYER_TRADE_CURRENCY: undefined

    PLAYER_TRADE_MONEY: undefined

    TRADE_ACCEPT_UPDATE: LuaMultiReturn<[playerAccepted: number, targetAccepted: number]>

    TRADE_CLOSED: undefined

    TRADE_CURRENCY_CHANGED: undefined

    TRADE_MONEY_CHANGED: undefined

    TRADE_PLAYER_ITEM_CHANGED: LuaMultiReturn<[tradeSlotIndex: number]>

    TRADE_POTENTIAL_BIND_ENCHANT: LuaMultiReturn<[canBecomeBoundForTrade: boolean]>

    TRADE_POTENTIAL_REMOVE_TRANSMOG: LuaMultiReturn<
      [itemLink: string, tradeSlotIndex: number]
    >

    TRADE_REQUEST: LuaMultiReturn<[name: string]>

    TRADE_REQUEST_CANCEL: undefined

    TRADE_SHOW: undefined

    TRADE_TARGET_ITEM_CHANGED: LuaMultiReturn<[tradeSlotIndex: number]>

    TRADE_UPDATE: undefined

    CRAFTING_DETAILS_UPDATE: undefined

    NEW_RECIPE_LEARNED: LuaMultiReturn<
      [
        recipeID: number,
        recipeLevel: number | undefined,
        baseRecipeID: number | undefined
      ]
    >

    OBLITERUM_FORGE_PENDING_ITEM_CHANGED: undefined

    OPEN_RECIPE_RESPONSE: LuaMultiReturn<
      [recipeID: number, skillLineID: number, expansionSkillLineID: number]
    >

    TRACKED_RECIPE_UPDATE: LuaMultiReturn<[recipeID: number, tracked: boolean]>

    TRADE_SKILL_CLOSE: undefined

    TRADE_SKILL_CRAFT_BEGIN: LuaMultiReturn<[recipeSpellID: number]>

    TRADE_SKILL_CRAFTING_REAGENT_BONUS_TEXT_UPDATED: LuaMultiReturn<[itemID: number]>

    TRADE_SKILL_CURRENCY_REWARD_RESULT: LuaMultiReturn<[data: CraftingCurrencyResultData]>

    TRADE_SKILL_DATA_SOURCE_CHANGED: undefined

    TRADE_SKILL_DATA_SOURCE_CHANGING: undefined

    TRADE_SKILL_DETAILS_UPDATE: undefined

    TRADE_SKILL_FAVORITES_CHANGED: LuaMultiReturn<
      [isFavorite: boolean, recipeSpellID: number]
    >

    TRADE_SKILL_ITEM_CRAFTED_RESULT: LuaMultiReturn<[data: CraftingItemResultData]>

    TRADE_SKILL_ITEM_UPDATE: LuaMultiReturn<[itemGUID: string]>

    TRADE_SKILL_LIST_UPDATE: undefined

    TRADE_SKILL_NAME_UPDATE: undefined

    TRADE_SKILL_SHOW: undefined

    UPDATE_TRADESKILL_CAST_STOPPED: LuaMultiReturn<[isScrapping: boolean]>

    TRAINER_CLOSED: undefined

    TRAINER_DESCRIPTION_UPDATE: undefined

    TRAINER_SERVICE_INFO_NAME_UPDATE: undefined

    TRAINER_SHOW: undefined

    TRAINER_UPDATE: undefined

    TRANSMOG_COLLECTION_CAMERA_UPDATE: undefined

    TRANSMOG_COLLECTION_ITEM_FAVORITE_UPDATE: LuaMultiReturn<
      [itemAppearanceID: number, isFavorite: boolean]
    >

    TRANSMOG_COLLECTION_ITEM_UPDATE: undefined

    TRANSMOG_COLLECTION_SOURCE_ADDED: LuaMultiReturn<[itemModifiedAppearanceID: number]>

    TRANSMOG_COLLECTION_SOURCE_REMOVED: LuaMultiReturn<[itemModifiedAppearanceID: number]>

    TRANSMOG_COLLECTION_UPDATED: LuaMultiReturn<
      [
        collectionIndex: number | undefined,
        modID: number | undefined,
        itemAppearanceID: number | undefined,
        reason: string | undefined
      ]
    >

    TRANSMOG_COSMETIC_COLLECTION_SOURCE_ADDED: LuaMultiReturn<
      [itemModifiedAppearanceID: number]
    >

    TRANSMOG_SEARCH_UPDATED: LuaMultiReturn<
      [searchType: TransmogSearchType, collectionType: TransmogCollectionType | undefined]
    >

    TRANSMOG_SETS_UPDATE_FAVORITE: undefined

    TRANSMOG_SOURCE_COLLECTABILITY_UPDATE: LuaMultiReturn<
      [itemModifiedAppearanceID: number, collectable: boolean]
    >

    TRANSMOGRIFY_CLOSE: undefined

    TRANSMOGRIFY_ITEM_UPDATE: undefined

    TRANSMOGRIFY_OPEN: undefined

    TRANSMOGRIFY_SUCCESS: LuaMultiReturn<[transmogLocation: TransmogLocationMixin]>

    TRANSMOGRIFY_UPDATE: LuaMultiReturn<
      [transmogLocation: TransmogLocationMixin | undefined, action: string | undefined]
    >

    LEAVING_TUTORIAL_AREA: undefined

    NPE_TUTORIAL_UPDATE: undefined

    TUTORIAL_HIGHLIGHT_SPELL: LuaMultiReturn<
      [spellID: number, tutorialGlobalStringTag: string]
    >

    TUTORIAL_TRIGGER: LuaMultiReturn<[tutorialIndex: number, forceShow: boolean]>

    TUTORIAL_UNHIGHLIGHT_SPELL: undefined

    DISPLAY_EVENT_TOAST_LINK: LuaMultiReturn<[link: string]>

    DISPLAY_EVENT_TOASTS: undefined

    FRAME_MANAGER_UPDATE_ALL: undefined

    FRAME_MANAGER_UPDATE_FRAME: LuaMultiReturn<[type: UIFrameType, show: boolean]>

    GENERIC_WIDGET_DISPLAY_SHOW: LuaMultiReturn<[info: GenericWidgetDisplayFrameInfo]>

    UPDATE_MACROS: undefined

    NOTCHED_DISPLAY_MODE_CHANGED: undefined

    UI_SCALE_CHANGED: undefined

    UI_MODEL_SCENE_INFO_UPDATED: undefined

    SYSTEM_VISIBILITY_CHANGED: undefined

    UPDATE_ALL_UI_WIDGETS: undefined

    UPDATE_UI_WIDGET: LuaMultiReturn<[widgetInfo: UIWidgetInfo]>

    UNIT_AURA: LuaMultiReturn<[unitTarget: UnitToken, updateInfo: UnitAuraUpdateInfo]>

    ACTIVE_PLAYER_SPECIALIZATION_CHANGED: undefined

    ARENA_COOLDOWNS_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    ARENA_CROWD_CONTROL_SPELL_UPDATE: LuaMultiReturn<
      [unitTarget: UnitToken, spellID: number]
    >

    AUTOFOLLOW_BEGIN: LuaMultiReturn<[name: string]>

    AUTOFOLLOW_END: undefined

    CANCEL_SUMMON: undefined

    COMBO_TARGET_CHANGED: undefined

    CONFIRM_BINDER: LuaMultiReturn<[areaName: string]>

    CONFIRM_SUMMON: LuaMultiReturn<
      [summonReason: number, skippingStartExperience: boolean]
    >

    ECLIPSE_DIRECTION_CHANGE: LuaMultiReturn<[direction: string]>

    HEARTHSTONE_BOUND: undefined

    HONOR_XP_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    INCOMING_RESURRECT_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    INCOMING_SUMMON_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    KNOWN_TITLES_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    LOCALPLAYER_PET_RENAMED: undefined

    MIRROR_TIMER_PAUSE: LuaMultiReturn<[timerName: string, paused: number]>

    MIRROR_TIMER_START: LuaMultiReturn<
      [
        timerName: string,
        value: number,
        maxValue: number,
        scale: number,
        paused: number,
        timerLabel: string
      ]
    >

    MIRROR_TIMER_STOP: LuaMultiReturn<[timerName: string]>

    NEUTRAL_FACTION_SELECT_RESULT: LuaMultiReturn<[success: boolean]>

    OBJECT_ENTERED_AOI: LuaMultiReturn<[guid: string]>

    OBJECT_LEFT_AOI: LuaMultiReturn<[guid: string]>

    PET_BAR_UPDATE_USABLE: undefined

    PET_UI_UPDATE: undefined

    PLAYER_CAN_GLIDE_CHANGED: LuaMultiReturn<[canGlide: boolean]>

    PLAYER_DAMAGE_DONE_MODS: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_ENTER_COMBAT: undefined

    PLAYER_FARSIGHT_FOCUS_CHANGED: undefined

    PLAYER_FLAGS_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_FOCUS_CHANGED: undefined

    PLAYER_IMPULSE_APPLIED: undefined

    PLAYER_IS_GLIDING_CHANGED: LuaMultiReturn<[isGliding: boolean]>

    PLAYER_LEAVE_COMBAT: undefined

    PLAYER_LEVEL_CHANGED: LuaMultiReturn<
      [oldLevel: number, newLevel: number, real: boolean]
    >

    PLAYER_LEVEL_UP: LuaMultiReturn<
      [
        level: number,
        healthDelta: number,
        powerDelta: number,
        numNewTalents: number,
        numNewPvpTalentSlots: number,
        strengthDelta: number,
        agilityDelta: number,
        staminaDelta: number,
        intellectDelta: number
      ]
    >

    PLAYER_MOUNT_DISPLAY_CHANGED: undefined

    PLAYER_PVP_KILLS_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_PVP_RANK_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_REGEN_DISABLED: undefined

    PLAYER_REGEN_ENABLED: undefined

    PLAYER_SOFT_ENEMY_CHANGED: undefined

    PLAYER_SOFT_FRIEND_CHANGED: undefined

    PLAYER_SOFT_INTERACT_CHANGED: LuaMultiReturn<[oldTarget: string, newTarget: string]>

    PLAYER_SOFT_TARGET_INTERACTION: undefined

    PLAYER_SPECIALIZATION_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_STARTED_LOOKING: undefined

    PLAYER_STARTED_MOVING: undefined

    PLAYER_STARTED_TURNING: undefined

    PLAYER_STOPPED_LOOKING: undefined

    PLAYER_STOPPED_MOVING: undefined

    PLAYER_STOPPED_TURNING: undefined

    PLAYER_TARGET_CHANGED: undefined

    PLAYER_TRIAL_XP_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    PLAYER_UPDATE_RESTING: undefined

    PLAYER_XP_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    PORTRAITS_UPDATED: undefined

    PROVING_GROUNDS_SCORE_UPDATE: LuaMultiReturn<[points: number]>

    PVP_TIMER_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    RUNE_POWER_UPDATE: LuaMultiReturn<[runeIndex: number, added: boolean | undefined]>

    RUNE_TYPE_UPDATE: LuaMultiReturn<[runeIndex: number]>

    SHOW_FACTION_SELECT_UI: undefined

    SPELL_CONFIRMATION_PROMPT: LuaMultiReturn<
      [
        spellID: number,
        effectValue: number,
        message: string,
        duration: number,
        currencyTypesID: number,
        currencyCost: number,
        currentDifficulty: number
      ]
    >

    SPELL_CONFIRMATION_TIMEOUT: LuaMultiReturn<[spellID: number, effectValue: number]>

    UNIT_ABSORB_AMOUNT_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_AREA_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_ATTACK: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_ATTACK_POWER: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_ATTACK_SPEED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_CHEAT_TOGGLE_EVENT: undefined

    UNIT_CLASSIFICATION_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_COMBAT: LuaMultiReturn<
      [
        unitTarget: UnitToken,
        event: string,
        flagText: string,
        amount: number,
        schoolMask: number
      ]
    >

    UNIT_CONNECTION: LuaMultiReturn<[unitTarget: UnitToken, isConnected: boolean]>

    UNIT_CTR_OPTIONS: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_DAMAGE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_DEFENSE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_DISPLAYPOWER: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_DISTANCE_CHECK_UPDATE: LuaMultiReturn<
      [unitTarget: UnitToken, isInDistance: boolean]
    >

    UNIT_FACTION: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_FLAGS: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_FORM_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_HEAL_ABSORB_AMOUNT_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_HEAL_PREDICTION: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_HEALTH: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_IN_RANGE_UPDATE: LuaMultiReturn<[unitTarget: UnitToken, isInRange: boolean]>

    UNIT_INVENTORY_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_LEVEL: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_MANA: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_MAX_HEALTH_MODIFIERS_CHANGED: LuaMultiReturn<
      [unitTarget: UnitToken, percentMaxHealthAdjusted: number]
    >

    UNIT_MAXHEALTH: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_MAXPOWER: LuaMultiReturn<[unitTarget: UnitToken, powerType: string]>

    UNIT_MODEL_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_NAME_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_OTHER_PARTY_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_PET: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_PET_EXPERIENCE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_PHASE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_PORTRAIT_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_POWER_BAR_HIDE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_POWER_BAR_SHOW: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_POWER_BAR_TIMER_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_POWER_FREQUENT: LuaMultiReturn<[unitTarget: UnitToken, powerType: string]>

    UNIT_POWER_POINT_CHARGE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_POWER_UPDATE: LuaMultiReturn<[unitTarget: UnitToken, powerType: string]>

    UNIT_QUEST_LOG_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_RANGED_ATTACK_POWER: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_RANGEDDAMAGE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_RESISTANCES: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_SPELL_HASTE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_SPELLCAST_CHANNEL_START: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_CHANNEL_STOP: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_CHANNEL_UPDATE: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_DELAYED: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_EMPOWER_START: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_EMPOWER_STOP: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number, complete: boolean]
    >

    UNIT_SPELLCAST_EMPOWER_UPDATE: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_FAILED: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_FAILED_QUIET: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_INTERRUPTED: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_INTERRUPTIBLE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_SPELLCAST_NOT_INTERRUPTIBLE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_SPELLCAST_RETICLE_CLEAR: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_RETICLE_TARGET: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_START: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_STOP: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_SPELLCAST_SUCCEEDED: LuaMultiReturn<
      [unitTarget: UnitToken, castGUID: string, spellID: number]
    >

    UNIT_STATS: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_TARGET: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_TARGETABLE_CHANGED: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_THREAT_LIST_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_THREAT_SITUATION_UPDATE: LuaMultiReturn<[unitTarget: UnitToken]>

    UPDATE_EXHAUSTION: undefined

    UPDATE_MOUSEOVER_UNIT: undefined

    UPDATE_STEALTH: undefined

    VEHICLE_ANGLE_UPDATE: LuaMultiReturn<[normalizedPitch: number, radians: number]>

    PLAYER_GAINS_VEHICLE_DATA: LuaMultiReturn<
      [unitTarget: UnitToken, vehicleUIIndicatorID: number]
    >

    PLAYER_LOSES_VEHICLE_DATA: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_ENTERED_VEHICLE: LuaMultiReturn<
      [
        unitTarget: UnitToken,
        showVehicleFrame: boolean,
        isControlSeat: boolean,
        vehicleUIIndicatorID: number,
        vehicleGUID: string,
        mayChooseExit: boolean,
        hasPitch: boolean
      ]
    >

    UNIT_ENTERING_VEHICLE: LuaMultiReturn<
      [
        unitTarget: UnitToken,
        showVehicleFrame: boolean,
        isControlSeat: boolean,
        vehicleUIIndicatorID: number,
        vehicleGUID: string,
        mayChooseExit: boolean,
        hasPitch: boolean
      ]
    >

    UNIT_EXITED_VEHICLE: LuaMultiReturn<[unitTarget: UnitToken]>

    UNIT_EXITING_VEHICLE: LuaMultiReturn<[unitTarget: UnitToken]>

    VEHICLE_ANGLE_SHOW: LuaMultiReturn<[shouldShow: number | undefined]>

    VEHICLE_PASSENGERS_CHANGED: undefined

    VEHICLE_POWER_SHOW: LuaMultiReturn<[shouldShow: number | undefined]>

    VEHICLE_UPDATE: undefined

    ADAPTER_LIST_CHANGED: undefined

    DISPLAY_SIZE_CHANGED: undefined

    GLUE_SCREENSHOT_FAILED: undefined

    GLUE_SCREENSHOT_STARTED: undefined

    GLUE_SCREENSHOT_SUCCEEDED: undefined

    GX_RESTARTED: undefined

    SCREENSHOT_FAILED: undefined

    SCREENSHOT_STARTED: undefined

    SCREENSHOT_SUCCEEDED: undefined

    VIGNETTE_MINIMAP_UPDATED: LuaMultiReturn<[vignetteGUID: string, onMinimap: boolean]>

    VIGNETTES_UPDATED: undefined

    VOICE_CHAT_ACTIVE_INPUT_DEVICE_UPDATED: undefined

    VOICE_CHAT_ACTIVE_OUTPUT_DEVICE_UPDATED: undefined

    VOICE_CHAT_AUDIO_CAPTURE_ENERGY: LuaMultiReturn<[isSpeaking: boolean, energy: number]>

    VOICE_CHAT_AUDIO_CAPTURE_STARTED: undefined

    VOICE_CHAT_AUDIO_CAPTURE_STOPPED: undefined

    VOICE_CHAT_CHANNEL_ACTIVATED: LuaMultiReturn<[channelID: number]>

    VOICE_CHAT_CHANNEL_DEACTIVATED: LuaMultiReturn<[channelID: number]>

    VOICE_CHAT_CHANNEL_DISPLAY_NAME_CHANGED: LuaMultiReturn<
      [channelID: number, channelDisplayName: string]
    >

    VOICE_CHAT_CHANNEL_JOINED: LuaMultiReturn<
      [
        status: VoiceChatStatusCode,
        channelID: number,
        channelType: ChatChannelType,
        clubId: string | undefined,
        streamId: string | undefined
      ]
    >

    VOICE_CHAT_CHANNEL_MEMBER_ACTIVE_STATE_CHANGED: LuaMultiReturn<
      [memberID: number, channelID: number, isActive: boolean]
    >

    VOICE_CHAT_CHANNEL_MEMBER_ADDED: LuaMultiReturn<[memberID: number, channelID: number]>

    VOICE_CHAT_CHANNEL_MEMBER_ENERGY_CHANGED: LuaMultiReturn<
      [memberID: number, channelID: number, speakingEnergy: number]
    >

    VOICE_CHAT_CHANNEL_MEMBER_GUID_UPDATED: LuaMultiReturn<
      [memberID: number, channelID: number]
    >

    VOICE_CHAT_CHANNEL_MEMBER_MUTE_FOR_ALL_CHANGED: LuaMultiReturn<
      [memberID: number, channelID: number, isMutedForAll: boolean]
    >

    VOICE_CHAT_CHANNEL_MEMBER_MUTE_FOR_ME_CHANGED: LuaMultiReturn<
      [memberID: number, channelID: number, isMutedForMe: boolean]
    >

    VOICE_CHAT_CHANNEL_MEMBER_REMOVED: LuaMultiReturn<
      [memberID: number, channelID: number]
    >

    VOICE_CHAT_CHANNEL_MEMBER_SILENCED_CHANGED: LuaMultiReturn<
      [memberID: number, channelID: number, isSilenced: boolean]
    >

    VOICE_CHAT_CHANNEL_MEMBER_SPEAKING_STATE_CHANGED: LuaMultiReturn<
      [memberID: number, channelID: number, isSpeaking: boolean]
    >

    VOICE_CHAT_CHANNEL_MEMBER_STT_MESSAGE: LuaMultiReturn<
      [memberID: number, channelID: number, message: string, language: string]
    >

    VOICE_CHAT_CHANNEL_MEMBER_VOLUME_CHANGED: LuaMultiReturn<
      [memberID: number, channelID: number, volume: number]
    >

    VOICE_CHAT_CHANNEL_MUTE_STATE_CHANGED: LuaMultiReturn<
      [channelID: number, isMuted: boolean]
    >

    VOICE_CHAT_CHANNEL_PTT_CHANGED: LuaMultiReturn<
      [channelID: number, pushToTalkSetting: string]
    >

    VOICE_CHAT_CHANNEL_REMOVED: LuaMultiReturn<[channelID: number]>

    VOICE_CHAT_CHANNEL_TRANSCRIBING_CHANGED: LuaMultiReturn<
      [channelID: number, isTranscribing: boolean]
    >

    VOICE_CHAT_CHANNEL_TRANSMIT_CHANGED: LuaMultiReturn<
      [channelID: number, isTransmitting: boolean]
    >

    VOICE_CHAT_CHANNEL_VOLUME_CHANGED: LuaMultiReturn<[channelID: number, volume: number]>

    VOICE_CHAT_COMMUNICATION_MODE_CHANGED: LuaMultiReturn<
      [communicationMode: CommunicationMode]
    >

    VOICE_CHAT_CONNECTION_SUCCESS: undefined

    VOICE_CHAT_DEAFENED_CHANGED: LuaMultiReturn<[isDeafened: boolean]>

    VOICE_CHAT_ERROR: LuaMultiReturn<
      [platformCode: number, statusCode: VoiceChatStatusCode]
    >

    VOICE_CHAT_INPUT_DEVICES_UPDATED: undefined

    VOICE_CHAT_LOGIN: LuaMultiReturn<[status: VoiceChatStatusCode]>

    VOICE_CHAT_LOGOUT: LuaMultiReturn<[status: VoiceChatStatusCode]>

    VOICE_CHAT_MUTED_CHANGED: LuaMultiReturn<[isMuted: boolean]>

    VOICE_CHAT_OUTPUT_DEVICES_UPDATED: undefined

    VOICE_CHAT_PENDING_CHANNEL_JOIN_STATE: LuaMultiReturn<
      [
        channelType: ChatChannelType,
        clubId: string | undefined,
        streamId: string | undefined,
        pendingJoin: boolean
      ]
    >

    VOICE_CHAT_PTT_BUTTON_PRESSED_STATE_CHANGED: LuaMultiReturn<[isPressed: boolean]>

    VOICE_CHAT_SILENCED_CHANGED: LuaMultiReturn<[isSilenced: boolean]>

    VOICE_CHAT_SPEAK_FOR_ME_ACTIVE_STATUS_UPDATED: undefined

    VOICE_CHAT_SPEAK_FOR_ME_FEATURE_STATUS_UPDATED: undefined

    VOICE_CHAT_TTS_PLAYBACK_FAILED: LuaMultiReturn<
      [status: VoiceTtsStatusCode, utteranceID: number, destination: VoiceTtsDestination]
    >

    VOICE_CHAT_TTS_PLAYBACK_FINISHED: LuaMultiReturn<
      [numConsumers: number, utteranceID: number, destination: VoiceTtsDestination]
    >

    VOICE_CHAT_TTS_PLAYBACK_STARTED: LuaMultiReturn<
      [
        numConsumers: number,
        utteranceID: number,
        durationMS: number,
        destination: VoiceTtsDestination
      ]
    >

    VOICE_CHAT_TTS_SPEAK_TEXT_UPDATE: LuaMultiReturn<
      [status: VoiceTtsStatusCode, utteranceID: number]
    >

    VOICE_CHAT_TTS_VOICES_UPDATE: undefined

    VOICE_CHAT_VAD_SETTINGS_UPDATED: undefined

    VOID_DEPOSIT_WARNING: LuaMultiReturn<[slot: number, link: string]>

    VOID_STORAGE_CONTENTS_UPDATE: undefined

    VOID_STORAGE_DEPOSIT_UPDATE: LuaMultiReturn<[slot: number]>

    VOID_STORAGE_UPDATE: undefined

    VOID_TRANSFER_DONE: undefined

    VOID_TRANSFER_SUCCESS: undefined

    WEEKLY_REWARDS_ITEM_CHANGED: undefined

    WEEKLY_REWARDS_UPDATE: undefined

    WORLD_LOOT_OBJECT_INFO_UPDATED: LuaMultiReturn<[guid: string]>

    WORLD_LOOT_OBJECT_SWAP_INVENTORY_TYPE_UPDATED: undefined

    CANCEL_PLAYER_COUNTDOWN: LuaMultiReturn<
      [initiatedBy: string, informChat: boolean, initiatedByName: string | undefined]
    >

    START_PLAYER_COUNTDOWN: LuaMultiReturn<
      [
        initiatedBy: string,
        timeRemaining: number,
        totalTime: number,
        informChat: boolean,
        initiatedByName: string | undefined
      ]
    >

    START_TIMER: LuaMultiReturn<
      [timerType: StartTimerType, timeRemaining: number, totalTime: number]
    >

    STOP_TIMER_OF_TYPE: LuaMultiReturn<[timerType: StartTimerType]>

    WORLD_STATE_TIMER_START: LuaMultiReturn<[timerID: number]>

    WORLD_STATE_TIMER_STOP: LuaMultiReturn<[timerID: number]>

    ENTITLEMENT_DELIVERED: LuaMultiReturn<
      [
        entitlementType: WoWEntitlementType,
        textureID: number,
        name: string,
        payloadID: number | undefined,
        showFancyToast: boolean
      ]
    >

    RAF_ENTITLEMENT_DELIVERED: LuaMultiReturn<
      [
        entitlementType: WoWEntitlementType,
        textureID: number,
        name: string,
        payloadID: number | undefined,
        showFancyToast: boolean,
        rafVersion: RecruitAFriendRewardsVersion
      ]
    >

    TOKEN_AUCTION_SOLD: undefined

    TOKEN_BUY_CONFIRM_REQUIRED: undefined

    TOKEN_BUY_RESULT: LuaMultiReturn<[result: number]>

    TOKEN_CAN_VETERAN_BUY_UPDATE: LuaMultiReturn<[result: number]>

    TOKEN_DISTRIBUTIONS_UPDATED: LuaMultiReturn<[result: number]>

    TOKEN_MARKET_PRICE_UPDATED: LuaMultiReturn<[result: number]>

    TOKEN_REDEEM_BALANCE_UPDATED: undefined

    TOKEN_REDEEM_CONFIRM_REQUIRED: LuaMultiReturn<[choiceType: number]>

    TOKEN_REDEEM_FRAME_SHOW: undefined

    TOKEN_REDEEM_GAME_TIME_UPDATED: undefined

    TOKEN_REDEEM_RESULT: LuaMultiReturn<[result: number, choiceType: number]>

    TOKEN_SELL_CONFIRM_REQUIRED: undefined

    TOKEN_SELL_CONFIRMED: undefined

    TOKEN_SELL_RESULT: LuaMultiReturn<[result: number]>

    TOKEN_STATUS_CHANGED: undefined
  }

  type WoWEventKey = keyof WowEventPayload
}

export {}
