/* eslint-disable @typescript-eslint/no-duplicate-enum-values */
/* eslint-disable @typescript-eslint/ban-types */
/** @noSelfInFile **/

declare global {
  interface Blob {
    DrawAll(): void

    DrawBlob(questID: number, draw: boolean): void

    DrawNone(): void

    EnableMerging(enable: boolean): void

    EnableSmoothing(enable: boolean): void

    GetMapID(): number

    SetBorderAlpha(alpha: number): void

    SetBorderScalar(scalar: number): void

    SetBorderTexture(asset: string): void

    SetFillAlpha(alpha: number): void

    SetFillTexture(asset: string): void

    SetMapID(uiMapID: number): void

    SetMergeThreshold(threshold: number): void

    SetNumSplinePoints(numSplinePoints: number): void
  }

  interface CharacterModelBase {
    ApplySpellVisualKit(spellVisualKitID: number, oneShot: boolean): void

    CanSetUnit(unit: UnitToken): void

    FreezeAnimation(anim: number, variation: number, frame: number): void

    GetDisplayInfo(): number

    GetDoBlend(): boolean

    GetKeepModelOnHide(): boolean

    HasAnimation(anim: number): boolean

    PlayAnimKit(animKit: number, loop: boolean): void

    RefreshCamera(): void

    RefreshUnit(): void

    SetAnimation(anim: number, variation: number | undefined): void

    SetBarberShopAlternateForm(): void

    SetCamDistanceScale(scale: number): void

    SetCreature(creatureID: number, displayID: number): void

    SetDisplayInfo(displayID: number, mountDisplayID: number | undefined): void

    SetDoBlend(doBlend: boolean): void

    SetItem(
      itemID: number,
      appearanceModID: number | undefined,
      itemVisualID: number | undefined
    ): void

    SetItemAppearance(
      itemAppearanceID: number,
      itemVisualID: number | undefined,
      itemSubclass: ItemWeaponSubclass | undefined
    ): void

    SetKeepModelOnHide(keepModelOnHide: boolean): void

    SetPortraitZoom(zoom: number): void

    SetRotation(radians: number, animate: boolean): void

    SetUnit(unit: UnitToken, blend: boolean, useNativeForm: boolean | undefined): boolean

    StopAnimKit(): void

    ZeroCachedCenterXY(): void
  }

  interface CinematicModel {
    EquipItem(itemID: number): void

    InitializeCamera(scaleFactor: number): void

    InitializePanCamera(scaleFactor: number): void

    RefreshCamera(): void

    SetAnimOffset(offset: number): void

    SetCameraPosition(positionX: number, positionY: number, positionZ: number): void

    SetCameraTarget(positionX: number, positionY: number, positionZ: number): void

    SetCreatureData(creatureID: number): void

    SetFacingLeft(isFacingLeft: boolean): void

    SetFadeTimes(fadeInSeconds: number, fadeOutSeconds: number): void

    SetHeightFactor(factor: number): void

    SetJumpInfo(jumpLength: number, jumpHeight: number): void

    SetPanDistance(scale: number): void

    SetSpellVisualKit(visualKitID: number): void

    SetTargetDistance(scale: number): void

    StartPan(
      panType: number,
      durationSeconds: number,
      doFade: boolean,
      visKitID: number,
      startPositionScale: number,
      speedMultiplier: number
    ): void

    StopPan(): void

    UnequipItems(): void
  }

  interface Cooldown {
    Clear(): void

    GetCooldownDisplayDuration(): number

    GetCooldownDuration(): number

    GetCooldownTimes(): LuaMultiReturn<[start: number, duration: number]>

    GetDrawBling(): boolean

    GetDrawEdge(): boolean

    GetDrawSwipe(): boolean

    GetEdgeScale(): number

    GetReverse(): boolean

    GetRotation(): number

    IsPaused(): boolean

    Pause(): void

    Resume(): void

    SetBlingTexture(
      texture: string,
      colorR: number,
      colorG: number,
      colorB: number,
      colorA: number
    ): void

    SetCooldown(start: number, duration: number, modRate: number): void

    SetCooldownDuration(duration: number, modRate: number): void

    SetCooldownUNIX(start: number, duration: number, modRate: number): void

    SetCountdownAbbrevThreshold(seconds: number): void

    SetCountdownFont(fontName: string): void

    SetDrawBling(drawBling: boolean): void

    SetDrawEdge(drawEdge: boolean): void

    SetDrawSwipe(drawSwipe: boolean): void

    SetEdgeScale(scale: number): void

    SetEdgeTexture(
      texture: string,
      colorR: number,
      colorG: number,
      colorB: number,
      colorA: number
    ): void

    SetHideCountdownNumbers(hideNumbers: boolean): void

    SetReverse(reverse: boolean): void

    SetRotation(rotationRadians: number): void

    SetSwipeColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetSwipeTexture(
      texture: string,
      colorR: number,
      colorG: number,
      colorB: number,
      colorA: number
    ): void

    SetTexCoordRange(low: Vector2DMixin, high: Vector2DMixin): void

    SetUseCircularEdge(useCircularEdge: boolean): void
  }

  interface DressUpModel {
    Dress(): void

    GetAutoDress(): boolean

    GetItemTransmogInfo(inventorySlot: number): ItemTransmogInfo

    GetItemTransmogInfoList(): ItemTransmogInfo[]

    GetObeyHideInTransmogFlag(): boolean

    GetSheathed(): boolean

    GetUseTransmogChoices(): boolean

    GetUseTransmogSkin(): boolean

    IsGeoReady(): boolean

    IsSlotAllowed(slot: number): boolean

    IsSlotVisible(slot: number): boolean

    SetAutoDress(enabled: boolean): void

    SetItemTransmogInfo(
      itemTransmogInfo: ItemTransmogInfo,
      inventorySlot: number | undefined,
      ignoreChildItems: boolean
    ): ItemTryOnReason

    SetObeyHideInTransmogFlag(enabled: boolean): void

    SetSheathed(sheathed: boolean, hideWeapons: boolean): void

    SetUseTransmogChoices(enabled: boolean): void

    SetUseTransmogSkin(enabled: boolean): void

    TryOn(
      linkOrItemModifiedAppearanceID: string | number,
      handSlotName: string | undefined,
      spellEnchantID: number | undefined
    ): ItemTryOnReason | undefined

    Undress(): void

    UndressSlot(inventorySlot: number): void
  }

  interface FogOfWarFrame {
    GetFogOfWarBackgroundAtlas(): string

    GetFogOfWarBackgroundTexture(): string | undefined

    GetFogOfWarMaskAtlas(): string

    GetFogOfWarMaskTexture(): string | undefined

    GetMaskScalar(): number

    GetUiMapID(): number

    SetFogOfWarBackgroundAtlas(atlas: string): void

    SetFogOfWarBackgroundTexture(
      asset: string,
      horizontalTile: boolean,
      verticalTile: boolean
    ): void

    SetFogOfWarMaskAtlas(atlas: string): void

    SetFogOfWarMaskTexture(asset: string): void

    SetMaskScalar(scalar: number): void

    SetUiMapID(uiMapID: number): void
  }

  interface ModelSceneActorBase {
    ClearModel(): void

    GetActiveBoundingBox(): LuaMultiReturn<
      [boxBottom: Vector3DMixin, boxTop: Vector3DMixin]
    >

    GetAlpha(): number

    GetAnimation(): number

    GetAnimationBlendOperation(): ModelBlendOperation

    GetAnimationVariation(): number

    GetDesaturation(): number

    GetMaxBoundingBox(): LuaMultiReturn<[boxBottom: Vector3DMixin, boxTop: Vector3DMixin]>

    GetModelFileID(): number

    GetModelPath(): string

    GetModelUnitGUID(): string

    GetParticleOverrideScale(): number | undefined

    GetPitch(): number

    GetPosition(): LuaMultiReturn<
      [positionX: number, positionY: number, positionZ: number]
    >

    GetRoll(): number

    GetScale(): number

    GetSpellVisualKit(): number

    GetYaw(): number

    Hide(): void

    IsLoaded(): boolean

    IsShown(): boolean

    IsUsingCenterForOrigin(): LuaMultiReturn<[x: boolean, y: boolean, z: boolean]>

    IsVisible(): boolean

    PlayAnimationKit(animationKit: number, isLooping: boolean): void

    SetAlpha(alpha: number): void

    SetAnimation(
      animation: number,
      variation: number | undefined,
      animSpeed: number,
      animOffsetSeconds: number
    ): void

    SetAnimationBlendOperation(blendOp: ModelBlendOperation): void

    SetDesaturation(strength: number): void

    SetModelByCreatureDisplayID(
      creatureDisplayID: number,
      useActivePlayerCustomizations: boolean
    ): boolean

    SetModelByFileID(asset: string, useMips: boolean): boolean

    SetModelByPath(asset: string, useMips: boolean): boolean

    SetModelByUnit(
      unit: UnitToken,
      sheatheWeapons: boolean,
      autoDress: boolean,
      hideWeapons: boolean,
      usePlayerNativeForm: boolean,
      holdBowString: boolean
    ): boolean

    SetParticleOverrideScale(scale: number | undefined): void

    SetPitch(pitch: number): void

    SetPosition(positionX: number, positionY: number, positionZ: number): void

    SetRoll(roll: number): void

    SetScale(scale: number): void

    SetShown(show: boolean): void

    SetSpellVisualKit(spellVisualKitID: number, oneShot: boolean): void

    SetUseCenterForOrigin(x: boolean, y: boolean, z: boolean): void

    SetYaw(yaw: number): void

    Show(): void

    StopAnimationKit(): void
  }

  interface ModelSceneActor {
    AttachToMount(
      rider: ModelSceneActor,
      animation: number,
      spellKitVisualID: number | undefined
    ): boolean

    CalculateMountScale(rider: ModelSceneActor): number

    Dress(): void

    DressPlayerSlot(invSlot: number): void

    GetAutoDress(): boolean

    GetItemTransmogInfo(inventorySlots: number): ItemTransmogInfo | undefined

    GetItemTransmogInfoList(): ItemTransmogInfo[]

    GetObeyHideInTransmogFlag(): boolean

    GetPaused(): LuaMultiReturn<[paused: boolean, globalPaused: boolean]>

    GetSheathed(): boolean

    GetUseTransmogChoices(): boolean

    GetUseTransmogSkin(): boolean

    IsGeoReady(): boolean

    IsSlotAllowed(inventorySlots: number): boolean

    IsSlotVisible(inventorySlots: number): boolean

    ReleaseFrontEndCharacterDisplays(): boolean

    ResetNextHandSlot(): void

    SetAutoDress(autoDress: boolean): void

    SetFrontEndLobbyModelFromDefaultCharacterDisplay(characterIndex: number): boolean

    SetItemTransmogInfo(
      transmogInfo: ItemTransmogInfo,
      inventorySlots: number | undefined,
      ignoreChildItems: boolean
    ): ItemTryOnReason

    SetModelByHyperlink(link: string): boolean

    SetObeyHideInTransmogFlag(obey: boolean): void

    SetPaused(paused: boolean, affectsGlobalPause: boolean): void

    SetPlayerModelFromGlues(
      characterIndex: number | undefined,
      sheatheWeapons: boolean,
      autoDress: boolean,
      hideWeapons: boolean,
      usePlayerNativeForm: boolean
    ): boolean

    SetSheathed(sheathed: boolean, hidden: boolean): void

    SetUseTransmogChoices(use: boolean): void

    SetUseTransmogSkin(use: boolean): void

    TryOn(
      itemLinkOrItemModifiedAppearanceID: string,
      handSlotName: string | undefined,
      spellEnchantmentID: number
    ): ItemTryOnReason | undefined

    Undress(includeWeapons: boolean): void

    UndressSlot(inventorySlots: number): void
  }

  interface ModelScene {
    ClearFog(): void

    CreateActor(name: string, template: string): void

    GetActorAtIndex(index: number): void

    GetCameraFarClip(): number

    GetCameraFieldOfView(): number

    GetCameraForward(): LuaMultiReturn<
      [forwardX: number, forwardY: number, forwardZ: number]
    >

    GetCameraNearClip(): number

    GetCameraPosition(): LuaMultiReturn<
      [positionX: number, positionY: number, positionZ: number]
    >

    GetCameraRight(): LuaMultiReturn<[rightX: number, rightY: number, rightZ: number]>

    GetCameraUp(): LuaMultiReturn<[upX: number, upY: number, upZ: number]>

    GetDrawLayer(): LuaMultiReturn<[layer: DrawLayer, sublevel: number]>

    GetFogColor(): LuaMultiReturn<[colorR: number, colorG: number, colorB: number]>

    GetFogFar(): number

    GetFogNear(): number

    GetLightAmbientColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number]
    >

    GetLightDiffuseColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number]
    >

    GetLightDirection(): LuaMultiReturn<
      [directionX: number, directionY: number, directionZ: number]
    >

    GetLightPosition(): LuaMultiReturn<
      [positionX: number, positionY: number, positionZ: number]
    >

    GetLightType(): ModelLightType | undefined

    GetNumActors(): number

    GetViewInsets(): [number, number, number, number]

    GetViewTranslation(): LuaMultiReturn<[translationX: number, translationY: number]>

    IsLightVisible(): boolean

    Project3DPointTo2D(
      pointX: number,
      pointY: number,
      pointZ: number
    ): LuaMultiReturn<[point2DX: number, point2DY: number, depth: number]>

    SetCameraFarClip(farClip: number): void

    SetCameraFieldOfView(fov: number): void

    SetCameraNearClip(nearClip: number): void

    SetCameraOrientationByAxisVectors(
      forwardX: number,
      forwardY: number,
      forwardZ: number,
      rightX: number,
      rightY: number,
      rightZ: number,
      upX: number,
      upY: number,
      upZ: number
    ): void

    SetCameraOrientationByYawPitchRoll(yaw: number, pitch: number, roll: number): void

    SetCameraPosition(positionX: number, positionY: number, positionZ: number): void

    SetDesaturation(strength: number): void

    SetDrawLayer(layer: DrawLayer): void

    SetFogColor(colorR: number, colorG: number, colorB: number): void

    SetFogFar(far: number): void

    SetFogNear(near: number): void

    SetLightAmbientColor(colorR: number, colorG: number, colorB: number): void

    SetLightDiffuseColor(colorR: number, colorG: number, colorB: number): void

    SetLightDirection(directionX: number, directionY: number, directionZ: number): void

    SetLightPosition(positionX: number, positionY: number, positionZ: number): void

    SetLightType(lightType: ModelLightType): void

    SetLightVisible(visible: boolean): void

    SetPaused(paused: boolean, affectsGlobalPause: boolean): void

    SetViewInsets(insets: [number, number, number, number]): void

    SetViewTranslation(translationX: number, translationY: number): void

    TakeActor(): void
  }

  interface QuestPOI {
    GetNumTooltips(): number

    GetTooltipIndex(index: number): number

    UpdateMouseOverTooltip(
      x: number,
      y: number
    ): LuaMultiReturn<[questID: number | undefined, numObjectives: number | undefined]>
  }

  interface ScenarioPOI {
    GetScenarioTooltipText(): string | undefined

    UpdateMouseOverTooltip(x: number, y: number): boolean
  }

  interface Checkout {
    CancelOpenCheckout(): void

    ClearFocus(): void

    CloseCheckout(): void

    CopyExternalLink(): void

    OpenCheckout(checkoutID: number): boolean

    OpenExternalLink(): void

    SetFocus(): void

    SetZoom(zoomLevel: number): void
  }

  interface TabardModelBase {
    CanSaveTabardNow(): boolean

    CycleVariation(variationIndex: number, delta: number): void

    GetLowerEmblemTexture(texture: Texture): void

    GetUpperEmblemTexture(texture: Texture): void

    InitializeTabardColors(): void

    IsGuildTabard(): boolean

    Save(): void
  }

  interface TabardModel {
    GetLowerBackgroundFileName(): number

    GetLowerEmblemFile(): number

    GetUpperBackgroundFileName(): number

    GetUpperEmblemFile(): number
  }

  interface UnitPositionFrame {
    AddUnit(
      unitTokenString: string,
      asset: string,
      width: number | undefined,
      height: number | undefined,
      r: number | undefined,
      g: number | undefined,
      b: number | undefined,
      a: number | undefined,
      sublayer: number | undefined,
      showFacing: boolean | undefined
    ): void

    ClearUnits(): void

    FinalizeUnits(): void

    GetMouseOverUnits(): string

    GetPlayerPingScale(): number

    GetUiMapID(): number

    SetPlayerPingScale(scale: number): void

    SetPlayerPingTexture(
      textureType: PingTextureType,
      asset: string,
      width: number,
      height: number
    ): void

    SetUiMapID(mapID: number): void

    SetUnitColor(
      unit: string,
      colorR: number,
      colorG: number,
      colorB: number,
      colorA: number
    ): void

    StartPlayerPing(duration: number, fadeDuration: number): void

    StopPlayerPing(): void
  }

  interface Minimap {
    GetPingPosition(): LuaMultiReturn<[positionX: number, positionY: number]>

    GetZoom(): number

    GetZoomLevels(): number

    PingLocation(locationX: number, locationY: number): void

    SetArchBlobInsideAlpha(alpha: number): void

    SetArchBlobInsideTexture(asset: string): void

    SetArchBlobOutsideAlpha(alpha: number): void

    SetArchBlobOutsideTexture(asset: string): void

    SetArchBlobRingAlpha(alpha: number): void

    SetArchBlobRingScalar(scalar: number): void

    SetArchBlobRingTexture(asset: string): void

    SetBlipTexture(asset: string): void

    SetCorpsePOIArrowTexture(asset: string): void

    SetIconTexture(asset: string): void

    SetMaskTexture(asset: string): void

    SetPOIArrowTexture(asset: string): void

    SetPlayerTexture(asset: string): void

    SetQuestBlobInsideAlpha(alpha: number): void

    SetQuestBlobInsideTexture(asset: string): void

    SetQuestBlobOutsideAlpha(alpha: number): void

    SetQuestBlobOutsideTexture(asset: string): void

    SetQuestBlobRingAlpha(alpha: number): void

    SetQuestBlobRingScalar(scalar: number): void

    SetQuestBlobRingTexture(asset: string): void

    SetStaticPOIArrowTexture(asset: string): void

    SetTaskBlobInsideAlpha(alpha: number): void

    SetTaskBlobInsideTexture(asset: string): void

    SetTaskBlobOutsideAlpha(alpha: number): void

    SetTaskBlobOutsideTexture(asset: string): void

    SetTaskBlobRingAlpha(alpha: number): void

    SetTaskBlobRingScalar(scalar: number): void

    SetTaskBlobRingTexture(asset: string): void

    SetZoom(zoomFactor: number): void

    UpdateBlips(): void
  }

  interface Animation {
    GetDuration(): number

    GetElapsed(): number

    GetEndDelay(): number

    GetOrder(): number

    GetProgress(): number

    GetRegionParent(): ScriptObject

    GetScript(scriptTypeName: string, bindingType: number | undefined): () => void

    GetSmoothProgress(): number

    GetSmoothing(): string

    GetStartDelay(): number

    GetTarget(): ScriptObject

    HasScript(scriptName: string): boolean

    HookScript(
      scriptTypeName: string,
      script: () => void,
      bindingType: number | undefined
    ): void

    IsDelaying(): boolean

    IsDone(): boolean

    IsPaused(): boolean

    IsPlaying(): boolean

    IsStopped(): boolean

    Pause(): void

    Play(): void

    Restart(): void

    SetChildKey(childKey: string): boolean

    SetDuration(durationSec: number, recomputeGroupDuration: boolean): void

    SetEndDelay(delaySec: number, recomputeGroupDuration: boolean): void

    SetOrder(newOrder: number): void

    SetParent(parent: AnimationGroup, order: number | undefined): void

    SetPlaying(play: boolean): void

    SetScript(scriptTypeName: string, script: (() => void) | undefined): void

    SetSmoothProgress(durationSec: number): void

    SetSmoothing(weights: string): void

    SetStartDelay(delaySec: number, recomputeGroupDuration: boolean): void

    SetTarget(target: ScriptObject): boolean

    SetTargetKey(key: string): boolean

    SetTargetName(name: string): boolean

    SetTargetParent(): boolean

    Stop(): void
  }

  interface Alpha {
    GetFromAlpha(): number

    GetToAlpha(): number

    SetFromAlpha(normalizedAlpha: number): void

    SetToAlpha(normalizedAlpha: number): void
  }

  interface FlipBook {
    GetFlipBookColumns(): number

    GetFlipBookFrameHeight(): number

    GetFlipBookFrameWidth(): number

    GetFlipBookFrames(): number

    GetFlipBookRows(): number

    SetFlipBookColumns(columns: number): void

    SetFlipBookFrameHeight(height: number): void

    SetFlipBookFrameWidth(width: number): void

    SetFlipBookFrames(frames: number): void

    SetFlipBookRows(rows: number): void
  }

  interface AnimationGroup {
    CreateAnimation(
      animationType: string | undefined,
      name: string | undefined,
      templateName: string | undefined
    ): Animation

    Finish(): void

    GetAnimationSpeedMultiplier(): number

    GetAnimations(): ScriptObject

    GetDuration(): number

    GetElapsed(): number

    GetLoopState(): string

    GetLooping(): LoopType

    GetProgress(): number

    GetScript(scriptTypeName: string, bindingType: number | undefined): () => void

    HasScript(scriptName: string): boolean

    HookScript(
      scriptTypeName: string,
      script: () => void,
      bindingType: number | undefined
    ): void

    IsDone(): boolean

    IsPaused(): boolean

    IsPendingFinish(): boolean

    IsPlaying(): boolean

    IsReverse(): boolean

    IsSetToFinalAlpha(): boolean

    Pause(): void

    Play(reverse: boolean, offset: number): void

    RemoveAnimations(): void

    Restart(reverse: boolean, offset: number): void

    SetAnimationSpeedMultiplier(animationSpeedMultiplier: number): void

    SetLooping(loopType: LoopType): void

    SetPlaying(play: boolean): void

    SetScript(scriptTypeName: string, script: (() => void) | undefined): void

    SetToFinalAlpha(setToFinalAlpha: boolean): void

    Stop(): void
  }

  interface Path {
    CreateControlPoint(
      name: string | undefined,
      templateName: string | undefined,
      order: number | undefined
    ): unknown

    GetControlPoints(): ScriptObject

    GetCurveType(): string

    GetMaxControlPointOrder(): number

    SetCurveType(curveType: string): void
  }

  interface Rotation {
    GetDegrees(): number

    GetOrigin(): LuaMultiReturn<[point: string, originX: number, originY: number]>

    GetRadians(): number

    SetDegrees(angle: number): void

    SetOrigin(point: string, originX: number, originY: number): void

    SetRadians(angle: number): void
  }

  interface Scale {
    GetOrigin(): LuaMultiReturn<[point: string, originX: number, originY: number]>

    GetScale(): LuaMultiReturn<[scaleX: number, scaleY: number]>

    GetScaleFrom(): LuaMultiReturn<[scaleX: number, scaleY: number]>

    GetScaleTo(): LuaMultiReturn<[scaleX: number, scaleY: number]>

    SetOrigin(point: string, originX: number, originY: number): void

    SetScale(scaleX: number, scaleY: number): void

    SetScaleFrom(scaleX: number, scaleY: number): void

    SetScaleTo(scaleX: number, scaleY: number): void
  }

  interface TextureCoordTranslation {
    GetOffset(): LuaMultiReturn<[offsetU: number, offsetV: number]>

    SetOffset(offsetU: number, offsetV: number): void
  }

  interface Translation {
    GetOffset(): LuaMultiReturn<[offsetX: number, offsetY: number]>

    SetOffset(offsetX: number, offsetY: number): void
  }

  interface VertexColor {
    GetEndColor(): ColorMixin

    GetStartColor(): ColorMixin

    SetEndColor(color: ColorMixin): void

    SetStartColor(color: ColorMixin): void
  }

  interface AnimatableObject {
    CreateAnimationGroup(
      name: string | undefined,
      templateName: string | undefined
    ): AnimationGroup

    GetAnimationGroups(): ScriptObject

    StopAnimating(): void
  }

  interface Browser {
    ClearFocus(): void

    CopyExternalLink(): void

    DeleteCookies(): void

    NavigateBack(): void

    NavigateForward(): void

    NavigateHome(urlType: string): void

    NavigateReload(): void

    NavigateStop(): void

    NavigateTo(url: string): void

    OpenExternalLink(): void

    OpenTicket(index: number): void

    SetFocus(): void

    SetZoom(zoom: number): void
  }

  interface Button {
    ClearDisabledTexture(): void

    ClearHighlightTexture(): void

    ClearNormalTexture(): void

    ClearPushedTexture(): void

    Click(button: string, isDown: boolean): void

    Disable(): void

    Enable(): void

    GetButtonState(): SimpleButtonStateToken

    GetDisabledFontObject(): FontInfo

    GetDisabledTexture(): Texture

    GetFontString(): FontString

    GetHighlightFontObject(): FontInfo

    GetHighlightTexture(): Texture

    GetMotionScriptsWhileDisabled(): boolean

    GetNormalFontObject(): FontInfo

    GetNormalTexture(): Texture

    GetPushedTextOffset(): LuaMultiReturn<[offsetX: number, offsetY: number]>

    GetPushedTexture(): Texture

    GetText(): string

    GetTextHeight(): number

    GetTextWidth(): number

    IsEnabled(): boolean

    RegisterForClicks(unpackedPrimitiveType: number): void

    RegisterForMouse(unpackedPrimitiveType: number): void

    SetButtonState(buttonState: SimpleButtonStateToken, lock: boolean): void

    SetDisabledAtlas(atlas: string): void

    SetDisabledFontObject(font: FontInfo): void

    SetDisabledTexture(asset: string): void

    SetEnabled(enabled: boolean): void

    SetFontString(fontString: FontString): void

    SetFormattedText(text: string): void

    SetHighlightAtlas(atlas: string, blendMode: BlendMode | undefined): void

    SetHighlightFontObject(font: FontInfo): void

    SetHighlightTexture(asset: string, blendMode: BlendMode | undefined): void

    SetMotionScriptsWhileDisabled(motionScriptsWhileDisabled: boolean): void

    SetNormalAtlas(atlas: string): void

    SetNormalFontObject(font: FontInfo): void

    SetNormalTexture(asset: string): void

    SetPushedAtlas(atlas: string): void

    SetPushedTextOffset(offsetX: number, offsetY: number): void

    SetPushedTexture(asset: string): void

    SetText(text: string): void
  }

  interface Checkbox {
    GetChecked(): boolean

    GetCheckedTexture(): Texture

    GetDisabledCheckedTexture(): Texture

    SetChecked(checked: boolean): void

    SetCheckedTexture(asset: string): void

    SetDisabledCheckedTexture(asset: string): void
  }

  interface ColorSelect {
    ClearColorWheelTexture(): void

    GetColorAlpha(): number

    GetColorAlphaTexture(): Texture

    GetColorAlphaThumbTexture(): Texture

    GetColorHSV(): LuaMultiReturn<[hsvX: number, hsvY: number, hsvZ: number]>

    GetColorRGB(): LuaMultiReturn<[rgbR: number, rgbG: number, rgbB: number]>

    GetColorValueTexture(): Texture

    GetColorValueThumbTexture(): Texture

    GetColorWheelTexture(): Texture

    GetColorWheelThumbTexture(): Texture

    SetColorAlpha(alpha: number): void

    SetColorAlphaTexture(texture: Texture): void

    SetColorAlphaThumbTexture(texture: string): void

    SetColorHSV(hsvX: number, hsvY: number, hsvZ: number): void

    SetColorRGB(rgbR: number, rgbG: number, rgbB: number): void

    SetColorValueTexture(texture: Texture): void

    SetColorValueThumbTexture(texture: string): void

    SetColorWheelTexture(texture: Texture): void

    SetColorWheelThumbTexture(texture: string): void
  }

  interface ControlPoint {
    GetOffset(): LuaMultiReturn<[offsetX: number, offsetY: number]>

    GetOrder(): number

    SetOffset(offsetX: number, offsetY: number): void

    SetOrder(order: number): void

    SetParent(parent: ScriptObject, order: number | undefined): void
  }

  interface EditBox {
    AddHistoryLine(text: string): void

    ClearFocus(): void

    ClearHighlightText(): void

    ClearHistory(): void

    Disable(): void

    Enable(): void

    GetAltArrowKeyMode(): boolean

    GetBlinkSpeed(): number

    GetCursorPosition(): number

    GetDisplayText(): string

    GetFont(): LuaMultiReturn<[name: string, fontHeight: number, flags: FontFlags[]]>

    GetFontObject(): FontInfo

    GetHighlightColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetHistoryLines(): number

    GetIndentedWordWrap(): boolean

    GetInputLanguage(): string

    GetJustifyH(): string

    GetJustifyV(): number

    GetMaxBytes(): number

    GetMaxLetters(): number

    GetNumLetters(): number

    GetNumber(): number | undefined

    GetShadowColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetShadowOffset(): LuaMultiReturn<[offsetX: number, offsetY: number]>

    GetSpacing(): number

    GetText(): string

    GetTextColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetTextInsets(): LuaMultiReturn<
      [left: number, right: number, top: number, bottom: number]
    >

    GetUTF8CursorPosition(): number

    GetVisibleTextByteLimit(): number

    HasFocus(): boolean

    HasText(): boolean

    HighlightText(start: number, stop: number): void

    Insert(text: string): void

    IsAlphabeticOnly(): boolean

    IsAutoFocus(): boolean

    IsCountInvisibleLetters(): boolean

    IsEnabled(): boolean

    IsInIMECompositionMode(): boolean

    IsMultiLine(): boolean

    IsNumeric(): boolean

    IsNumericFullRange(): boolean

    IsPassword(): boolean

    IsSecureText(): boolean

    ResetInputMode(): void

    SetAlphabeticOnly(enabled: boolean): void

    SetAltArrowKeyMode(altMode: boolean): void

    SetAutoFocus(autoFocus: boolean): void

    SetBlinkSpeed(cursorBlinkSpeedSec: number): void

    SetCountInvisibleLetters(countInvisibleLetters: boolean): void

    SetCursorPosition(cursorPosition: number): void

    SetEnabled(enabled: boolean): void

    SetFocus(): void

    SetFont(fontFile: string, height: number, flags: FontFlags[]): boolean

    SetFontObject(font: FontInfo): void

    SetHighlightColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetHistoryLines(numHistoryLines: number): void

    SetIndentedWordWrap(isIndented: boolean): void

    SetJustifyH(justifyH: string): void

    SetJustifyV(justifyV: number): void

    SetMaxBytes(maxBytes: number): void

    SetMaxLetters(maxLetters: number): void

    SetMultiLine(multiline: boolean): void

    SetNumber(number: number): void

    SetNumeric(isNumeric: boolean): void

    SetNumericFullRange(isNumeric: boolean): void

    SetPassword(isPassword: boolean): void

    SetSecureText(isSecure: boolean): void

    SetSecurityDisablePaste(): void

    SetSecurityDisableSetText(): void

    SetShadowColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetShadowOffset(offsetX: number, offsetY: number): void

    SetSpacing(fontHeight: number): void

    SetText(text: string): void

    SetTextColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetTextInsets(left: number, right: number, top: number, bottom: number): void

    SetVisibleTextByteLimit(maxVisibleBytes: number): void

    ToggleInputLanguage(): void
  }

  interface Font {
    CopyFontObject(sourceFont: FontInfo): void

    GetAlpha(): number

    GetFont(): LuaMultiReturn<[fontFile: string, height: number, flags: FontFlags[]]>

    GetFontObject(): FontInfo

    GetIndentedWordWrap(): boolean

    GetJustifyH(): string

    GetJustifyV(): number

    GetShadowColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetShadowOffset(): LuaMultiReturn<[offsetX: number, offsetY: number]>

    GetSpacing(): number

    GetTextColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    SetAlpha(alpha: number): void

    SetFont(fontFile: string, height: number, flags: FontFlags[]): void

    SetFontObject(font: FontInfo): void

    SetIndentedWordWrap(wordWrap: boolean): void

    SetJustifyH(justifyH: string): void

    SetJustifyV(justifyV: number): void

    SetShadowColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetShadowOffset(offsetX: number, offsetY: number): void

    SetSpacing(spacing: number): void

    SetTextColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void
  }

  interface FontString {
    CalculateScreenAreaFromCharacterSpan(
      leftIndex: number,
      rightIndex: number
    ): undefined[] | undefined

    CanNonSpaceWrap(): boolean

    CanWordWrap(): boolean

    FindCharacterIndexAtCoordinate(
      x: number,
      y: number
    ): LuaMultiReturn<[characterIndex: number, inside: boolean]>

    GetFieldSize(): number

    GetFont(): LuaMultiReturn<
      [fontFile: string | undefined, fontHeight: number, flags: FontFlags[]]
    >

    GetFontObject(): FontInfo

    GetIndentedWordWrap(): boolean

    GetJustifyH(): string

    GetJustifyV(): number

    GetLineHeight(): number

    GetMaxLines(): number

    GetNumLines(): number

    GetRotation(): number

    GetShadowColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetShadowOffset(): LuaMultiReturn<[offsetX: number, offsetY: number]>

    GetSpacing(): number

    GetStringHeight(): number

    GetStringWidth(): number

    GetText(): string

    GetTextColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetTextScale(): number

    GetUnboundedStringWidth(): number

    GetWrappedWidth(): number

    IsTruncated(): boolean

    SetAlphaGradient(start: number, length: number): boolean

    SetFixedColor(fixedColor: boolean): void

    SetFont(fontFile: string, fontHeight: number, flags: FontFlags[]): void

    SetFontObject(font: FontInfo): void

    SetFormattedText(text: string): void

    SetIndentedWordWrap(wrap: boolean): void

    SetJustifyH(justifyH: string): void

    SetJustifyV(justifyV: number): void

    SetMaxLines(maxLines: number): void

    SetNonSpaceWrap(wrap: boolean): void

    SetRotation(radians: number): void

    SetShadowColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetShadowOffset(offsetX: number, offsetY: number): void

    SetSpacing(spacing: number): void

    SetText(text: string): void

    SetTextColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetTextHeight(height: number): void

    SetTextScale(textScale: number): void

    SetTextToFit(text: string): void

    SetWordWrap(wrap: boolean): void
  }

  interface FrameScriptObject {
    GetName(): string

    GetObjectType(): string

    IsForbidden(): boolean

    IsObjectType(objectType: string): boolean

    SetForbidden(): void
  }

  interface HTML {
    GetContentHeight(): number

    GetFont(
      textType: unknown
    ): LuaMultiReturn<[fontFile: string, height: number, flags: FontFlags[]]>

    GetFontObject(textType: unknown): FontInfo

    GetHyperlinkFormat(): string

    GetIndentedWordWrap(textType: unknown): boolean

    GetJustifyH(textType: unknown): string

    GetJustifyV(textType: unknown): number

    GetShadowColor(
      textType: unknown
    ): LuaMultiReturn<[colorR: number, colorG: number, colorB: number, colorA: number]>

    GetShadowOffset(textType: unknown): LuaMultiReturn<[offsetX: number, offsetY: number]>

    GetSpacing(textType: unknown): number

    GetTextColor(
      textType: unknown
    ): LuaMultiReturn<[colorR: number, colorG: number, colorB: number, colorA: number]>

    GetTextData(): undefined[]

    SetFont(textType: unknown, fontFile: string, height: number, flags: FontFlags[]): void

    SetFontObject(textType: unknown, font: FontInfo): void

    SetHyperlinkFormat(format: string): void

    SetIndentedWordWrap(textType: unknown, wordWrap: boolean): void

    SetJustifyH(textType: unknown, justifyH: string): void

    SetJustifyV(textType: unknown, justifyV: number): void

    SetShadowColor(
      textType: unknown,
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetShadowOffset(textType: unknown, offsetX: number, offsetY: number): void

    SetSpacing(textType: unknown, spacing: number): void

    SetText(text: string, ignoreMarkup: boolean): void

    SetTextColor(
      textType: unknown,
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void
  }

  interface Line {
    ClearAllPoints(): void

    GetEndPoint(): LuaMultiReturn<
      [relativePoint: string, relativeTo: unknown, offsetX: number, offsetY: number]
    >

    GetHitRectThickness(): number

    GetStartPoint(): LuaMultiReturn<
      [relativePoint: string, relativeTo: unknown, offsetX: number, offsetY: number]
    >

    GetThickness(): number

    SetEndPoint(
      relativePoint: string,
      relativeTo: unknown,
      offsetX: number,
      offsetY: number
    ): void

    SetHitRectThickness(thickness: number): void

    SetStartPoint(
      relativePoint: string,
      relativeTo: unknown,
      offsetX: number,
      offsetY: number
    ): void

    SetThickness(thickness: number): void
  }

  interface MapScene {
    GetMaxCharacterSlotCount(): number

    GetModelDrawLayer(): LuaMultiReturn<[layer: DrawLayer, sublayer: number]>

    GetViewInsets(): LuaMultiReturn<
      [left: number, right: number, top: number, bottom: number]
    >

    SetModelDrawLayer(layer: DrawLayer): void

    SetViewInsets(left: number, right: number, top: number, bottom: number): void
  }

  interface MessageFrame {
    AddMessage(
      text: string,
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined,
      messageID: number | undefined
    ): void

    Clear(): void

    GetFadeDuration(): number

    GetFadePower(): number

    GetFading(): boolean

    GetFont(): LuaMultiReturn<[fontFile: string, height: number, flags: FontFlags[]]>

    GetFontObject(): FontInfo

    GetFontStringByID(messageID: number): FontString

    GetIndentedWordWrap(): boolean

    GetInsertMode(): InsertMode

    GetJustifyH(): string

    GetJustifyV(): number

    GetShadowColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetShadowOffset(): LuaMultiReturn<[offsetX: number, offsetY: number]>

    GetSpacing(): number

    GetTextColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetTimeVisible(): number

    HasMessageByID(messageID: number): boolean

    ResetMessageFadeByID(messageID: number): void

    SetFadeDuration(fadeDurationSeconds: number): void

    SetFadePower(fadePower: number): void

    SetFading(fading: boolean): void

    SetFont(fontFile: string, height: number, flags: FontFlags[]): void

    SetFontObject(font: FontInfo): void

    SetIndentedWordWrap(wordWrap: boolean): void

    SetInsertMode(mode: InsertMode): void

    SetJustifyH(justifyH: string): void

    SetJustifyV(justifyV: number): void

    SetShadowColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetShadowOffset(offsetX: number, offsetY: number): void

    SetSpacing(spacing: number): void

    SetTextColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetTimeVisible(timeVisibleSeconds: number): void
  }

  interface Model {
    AdvanceTime(): void

    ClearFog(): void

    ClearModel(): void

    ClearTransform(): void

    GetCameraDistance(): number

    GetCameraFacing(): number

    GetCameraPosition(): LuaMultiReturn<
      [positionX: number, positionY: number, positionZ: number]
    >

    GetCameraRoll(): number

    GetCameraTarget(): LuaMultiReturn<[targetX: number, targetY: number, targetZ: number]>

    GetDesaturation(): number

    GetFacing(): number

    GetFogColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetFogFar(): number

    GetFogNear(): number

    GetLight(): LuaMultiReturn<[enabled: boolean, light: ModelLight]>

    GetModelAlpha(): number

    GetModelDrawLayer(): LuaMultiReturn<[layer: DrawLayer, sublayer: number]>

    GetModelFileID(): number

    GetModelScale(): number

    GetPaused(): boolean

    GetPitch(): number

    GetPosition(): LuaMultiReturn<
      [positionX: number, positionY: number, positionZ: number]
    >

    GetRoll(): number

    GetShadowEffect(): number

    GetViewInsets(): LuaMultiReturn<
      [left: number, right: number, top: number, bottom: number]
    >

    GetViewTranslation(): LuaMultiReturn<[x: number, y: number]>

    GetWorldScale(): number

    HasAttachmentPoints(): boolean

    HasCustomCamera(): boolean

    IsUsingModelCenterToTransform(): boolean

    MakeCurrentCameraCustom(): void

    ReplaceIconTexture(asset: string): void

    SetCamera(cameraIndex: number): void

    SetCameraDistance(distance: number): void

    SetCameraFacing(radians: number): void

    SetCameraPosition(positionX: number, positionY: number, positionZ: number): void

    SetCameraRoll(radians: number): void

    SetCameraTarget(targetX: number, targetY: number, targetZ: number): void

    SetCustomCamera(cameraIndex: number): void

    SetDesaturation(strength: number): void

    SetFacing(facing: number): void

    SetFogColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetFogFar(fogFar: number): void

    SetFogNear(fogNear: number): void

    SetGlow(glow: number): void

    SetLight(enabled: boolean, light: ModelLight): void

    SetModel(asset: number, noMip: boolean): void

    SetModelAlpha(alpha: number): void

    SetModelDrawLayer(layer: DrawLayer): void

    SetModelScale(scale: number): void

    SetParticlesEnabled(enabled: boolean): void

    SetPaused(paused: boolean): void

    SetPitch(pitch: number): void

    SetPosition(positionX: number, positionY: number, positionZ: number): void

    SetRoll(roll: number): void

    SetSequence(sequence: number): void

    SetSequenceTime(sequence: number, timeOffset: number): void

    SetShadowEffect(strength: number): void

    SetTransform(
      translation: Vector3DMixin | undefined,
      rotation: Vector3DMixin | undefined,
      scale: number | undefined
    ): void

    SetViewInsets(left: number, right: number, top: number, bottom: number): void

    SetViewTranslation(x: number, y: number): void

    TransformCameraSpaceToModelSpace(cameraPosition: Vector3DMixin): Vector3DMixin

    UseModelCenterToTransform(useCenter: boolean): void
  }

  interface ModelFFX {
    AddCharacterLight(index: number | undefined, light: ModelLight): void

    AddLight(index: number | undefined, light: ModelLight): void

    AddPetLight(index: number | undefined, light: ModelLight): void

    ResetLights(): void
  }

  interface Movie {
    EnableSubtitles(enable: boolean): void

    StartMovie(
      movieID: number,
      looping: boolean
    ): LuaMultiReturn<[success: boolean, returnCode: number]>

    StartMovieByName(
      movieName: string,
      looping: boolean,
      resolution: number
    ): LuaMultiReturn<[success: boolean, returnCode: number]>

    StopMovie(): void
  }

  interface ScriptObject {
    ClearParentKey(): void

    GetDebugName(preferParentKey: boolean): string

    GetParent(): ScriptObject

    GetParentKey(): string

    SetParentKey(parentKey: string, clearOtherKeys: boolean): void
  }

  interface OffScreen {
    ApplySnapshot(texture: Texture, snapshotID: number): boolean

    Flush(): void

    GetMaxSnapshots(): number

    IsSnapshotValid(snapshotID: number): boolean

    SetMaxSnapshots(maxSnapshots: number): void

    TakeSnapshot(): number | undefined

    TestPrintToFile(snapshotID: number, filename: string): boolean

    UsesNPOT(): boolean | undefined
  }

  interface Region {
    GetAlpha(): number

    GetDrawLayer(): LuaMultiReturn<[layer: DrawLayer, sublayer: number]>

    GetEffectiveScale(): number

    GetScale(): number

    GetVertexColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    IsIgnoringParentAlpha(): boolean

    IsIgnoringParentScale(): boolean

    IsObjectLoaded(): boolean

    SetAlpha(alpha: number): void

    SetDrawLayer(layer: DrawLayer, sublevel: number): void

    SetIgnoreParentAlpha(ignore: boolean): void

    SetIgnoreParentScale(ignore: boolean): void

    SetScale(scale: number): void

    SetVertexColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void
  }

  interface ScriptRegion {
    CanChangeProtectedState(): boolean

    CollapsesLayout(): boolean

    EnableMouse(enable: boolean): void

    EnableMouseMotion(enable: boolean): void

    EnableMouseWheel(enable: boolean): void

    GetBottom(): number

    GetCenter(): LuaMultiReturn<[x: number, y: number]>

    GetHeight(ignoreRect: boolean): number

    GetLeft(): number

    GetRect(): LuaMultiReturn<
      [left: number, bottom: number, width: number, height: number]
    >

    GetRight(): number

    GetScaledRect(): LuaMultiReturn<
      [left: number, bottom: number, width: number, height: number]
    >

    GetScript(scriptTypeName: string, bindingType: number | undefined): () => void

    GetSize(ignoreRect: boolean): LuaMultiReturn<[width: number, height: number]>

    GetSourceLocation(): string

    GetTop(): number

    GetWidth(ignoreRect: boolean): number

    HasScript(scriptName: string): boolean

    Hide(): void

    HookScript(
      scriptTypeName: string,
      script: () => void,
      bindingType: number | undefined
    ): void

    IsAnchoringRestricted(): boolean

    IsCollapsed(): boolean

    IsDragging(): boolean

    IsMouseClickEnabled(): boolean

    IsMouseEnabled(): boolean

    IsMouseMotionEnabled(): boolean

    IsMouseMotionFocus(): boolean

    IsMouseOver(
      offsetTop: number,
      offsetBottom: number,
      offsetLeft: number,
      offsetRight: number
    ): boolean

    IsMouseWheelEnabled(): boolean

    IsProtected(): LuaMultiReturn<[isProtected: boolean, isProtectedExplicitly: boolean]>

    IsRectValid(): boolean

    IsShown(): boolean

    IsVisible(): boolean

    SetCollapsesLayout(collapsesLayout: boolean): void

    SetMouseClickEnabled(enabled: boolean): void

    SetMouseMotionEnabled(enabled: boolean): void

    SetParent(parent: unknown | undefined): void

    SetPassThroughButtons(unpackedPrimitiveType: number): void

    SetPropagateMouseClicks(propagate: boolean): void

    SetPropagateMouseMotion(propagate: boolean): void

    SetShown(show: boolean): void

    Show(): void
  }

  interface ScriptRegionResizing {
    AdjustPointsOffset(x: number, y: number): void

    ClearAllPoints(): void

    ClearPoint(point: string): void

    ClearPointsOffset(): void

    GetNumPoints(): number

    GetPoint(
      anchorIndex: number,
      resolveCollapsed: boolean
    ): LuaMultiReturn<
      [
        point: string,
        relativeTo: unknown,
        relativePoint: string,
        offsetX: number,
        offsetY: number
      ]
    >

    GetPointByName(
      point: string,
      resolveCollapsed: boolean
    ): LuaMultiReturn<
      [
        point: string,
        relativeTo: unknown,
        relativePoint: string,
        offsetX: number,
        offsetY: number
      ]
    >

    SetAllPoints(relativeTo: unknown, doResize: boolean): void

    SetHeight(height: number): void

    SetPoint(
      point: string,
      relativeTo: unknown,
      relativePoint: string,
      offsetX: number,
      offsetY: number
    ): void

    SetSize(x: number, y: number): void

    SetWidth(width: number): void
  }

  interface ScrollFrame {
    GetHorizontalScroll(): number

    GetHorizontalScrollRange(): number

    GetScrollChild(): unknown

    GetVerticalScroll(): number

    GetVerticalScrollRange(): number

    SetHorizontalScroll(offset: number): void

    SetScrollChild(scrollChild: unknown): void

    SetVerticalScroll(offset: number): void

    UpdateScrollChildRect(): void
  }

  interface Slider {
    Disable(): void

    Enable(): void

    GetMinMaxValues(): LuaMultiReturn<[minValue: number, maxValue: number]>

    GetObeyStepOnDrag(): boolean

    GetOrientation(): Orientation

    GetStepsPerPage(): number

    GetThumbTexture(): Texture

    GetValue(): number

    GetValueStep(): number

    IsDraggingThumb(): boolean

    IsEnabled(): boolean

    SetEnabled(enabled: boolean): void

    SetMinMaxValues(minValue: number, maxValue: number): void

    SetObeyStepOnDrag(obeyStepOnDrag: boolean): void

    SetOrientation(orientation: Orientation): void

    SetStepsPerPage(stepsPerPage: number): void

    SetThumbTexture(asset: string): void

    SetValue(value: number, treatAsMouseEvent: boolean): void

    SetValueStep(valueStep: number): void
  }

  interface StatusBar {
    GetFillStyle(): StatusBarFillStyle

    GetMinMaxValues(): LuaMultiReturn<[minValue: number, maxValue: number]>

    GetOrientation(): Orientation

    GetReverseFill(): boolean

    GetRotatesTexture(): boolean

    GetStatusBarColor(): LuaMultiReturn<
      [colorR: number, colorG: number, colorB: number, colorA: number]
    >

    GetStatusBarDesaturation(): number

    GetStatusBarTexture(): Texture

    GetValue(): number

    IsStatusBarDesaturated(): boolean

    SetColorFill(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetFillStyle(fillStyle: StatusBarFillStyle): void

    SetMinMaxValues(minValue: number, maxValue: number): void

    SetOrientation(orientation: Orientation): void

    SetReverseFill(isReverseFill: boolean): void

    SetRotatesTexture(rotatesTexture: boolean): void

    SetStatusBarColor(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetStatusBarDesaturated(desaturated: boolean): void

    SetStatusBarDesaturation(desaturation: number): void

    SetStatusBarTexture(asset: string): void

    SetValue(value: number): void
  }

  interface Texture {
    AddMaskTexture(mask: ScriptObject): void

    GetMaskTexture(index: number): ScriptObject

    GetNumMaskTextures(): number

    RemoveMaskTexture(mask: ScriptObject): void
  }

  interface TextureBase {
    ClearTextureSlice(): void

    GetAtlas(): string

    GetBlendMode(): BlendMode

    GetDesaturation(): number

    GetHorizTile(): boolean

    GetRotation(): LuaMultiReturn<
      [radians: number, normalizedRotationPoint: Vector2DMixin]
    >

    GetTexCoord(): LuaMultiReturn<[x: number, y: number]>

    GetTexelSnappingBias(): number

    GetTexture(): string | undefined

    GetTextureFileID(): number

    GetTextureFilePath(): string | undefined

    GetTextureSliceMargins(): LuaMultiReturn<
      [left: number, top: number, right: number, bottom: number]
    >

    GetTextureSliceMode(): UITextureSliceMode

    GetVertTile(): boolean

    GetVertexOffset(
      vertexIndex: number
    ): LuaMultiReturn<[offsetX: number, offsetY: number]>

    IsBlockingLoadRequested(): boolean

    IsDesaturated(): boolean

    IsSnappingToPixelGrid(): boolean

    SetAtlas(
      atlas: string,
      useAtlasSize: boolean,
      filterMode: FilterMode | undefined,
      resetTexCoords: boolean | undefined
    ): void

    SetBlendMode(blendMode: BlendMode): void

    SetBlockingLoadsRequested(blocking: boolean): void

    SetColorTexture(
      colorR: number,
      colorG: number,
      colorB: number,
      a: number | undefined
    ): void

    SetDesaturated(desaturated: boolean): void

    SetDesaturation(desaturation: number): void

    SetGradient(
      orientation: Orientation,
      minColor: ColorMixin,
      maxColor: ColorMixin
    ): void

    SetHorizTile(tiling: boolean): void

    SetMask(file: string): void

    SetRotation(radians: number, normalizedRotationPoint: Vector2DMixin | undefined): void

    SetSnapToPixelGrid(snap: boolean): void

    SetTexCoord(left: number, right: number, bottom: number, top: number): void

    SetTexelSnappingBias(bias: number): void

    SetTexture(
      textureAsset: string | undefined,
      wrapModeHorizontal: string | undefined,
      wrapModeVertical: string | undefined,
      filterMode: string | undefined
    ): boolean

    SetTextureSliceMargins(left: number, top: number, right: number, bottom: number): void

    SetTextureSliceMode(sliceMode: UITextureSliceMode): void

    SetVertTile(tiling: boolean): void

    SetVertexOffset(vertexIndex: number, offsetX: number, offsetY: number): void
  }
}

export {}
