/* eslint-disable @typescript-eslint/no-duplicate-enum-values */
/* eslint-disable @typescript-eslint/ban-types */
/** @noSelfInFile **/

declare global {
  interface ActionUsableState {
    slot: number
    usable: boolean
    noMana: boolean
  }

  interface AddOnInfo {
    name: string
    title: string
    notes: string
    loadable: boolean
    reason: string
    security: string
    updateAvailable: boolean
  }

  interface AddOnLoadableInfo {
    loadable: boolean
    reason: string
  }

  interface AlliedRaceInfo {
    raceID: number
    maleModelID: number
    femaleModelID: number
    achievementIds: number[]
    maleName: string
    femaleName: string
    description: string
    raceFileString: string
    crestAtlas: string
    modelBackgroundAtlas: string
    bannerColor: ColorMixin
  }

  interface AlliedRaceRacialAbility {
    description: string
    name: string
    icon: number
  }

  interface AnimaDiversionCostInfo {
    currencyID: number
    quantity: number
  }

  interface AnimaDiversionFrameInfo {
    textureKit: string
    title: string
    mapID: number
  }

  interface AnimaDiversionNodeInfo {
    talentID: number
    name: string
    description: string
    costs: undefined[]
    currencyID: number
    icon: number
    normalizedPosition: Vector2DMixin
    state: AnimaDiversionNodeState
  }

  interface AppearanceSourceInfo {
    visualID: number
    sourceID: number
    isCollected: boolean
    itemID: number
    itemModID: number
    invType: number
    categoryID: TransmogCollectionType
    playerCanCollect: boolean
    isValidSourceForPlayer: boolean
    inventorySlot: number | undefined
    sourceType: number | undefined
    name: string | undefined
    quality: number | undefined
    useError: string | undefined
    useErrorType: TransmogUseErrorType | undefined
    meetsTransmogPlayerCondition: boolean | undefined
    isHideVisual: boolean | undefined
  }

  interface ArdenwealdGardenData {
    active: number
    ready: number
    remainingSeconds: number
  }

  interface AreaPOIInfo {
    areaPoiID: number
    position: Vector2DMixin
    name: string
    description: string | undefined
    linkedUiMapID: number | undefined
    textureIndex: number | undefined
    tooltipWidgetSet: number | undefined
    iconWidgetSet: number | undefined
    atlasName: string | undefined
    uiTextureKit: string | undefined
    shouldGlow: boolean
    factionID: number | undefined
    isPrimaryMapForPOI: boolean
    isAlwaysOnFlightmap: boolean
    addPaddingAboveTooltipWidgets: boolean | undefined
    highlightWorldQuestsOnHover: boolean
    highlightVignettesOnHover: boolean
    isCurrentEvent: boolean
  }

  interface ArtifactAppearanceInfo {
    artifactAppearanceID: number
    appearanceName: string
    displayIndex: number
    unlocked: boolean
    failureDescription: string | undefined
    uiCameraID: number
    altHandCameraID: number | undefined
    swatchColor: ColorMixin
    modelOpacity: number
    modelSaturation: number
    obtainable: boolean
  }

  interface ArtifactAppearanceSetInfo {
    artifactAppearanceSetID: number
    appearanceSetName: string
    appearanceSetDescription: string
    numAppearances: number
  }

  interface ArtifactArtInfo {
    textureKit: string
    titleName: string
    titleColor: ColorMixin
    barConnectedColor: ColorMixin
    barDisconnectedColor: ColorMixin
    uiModelSceneID: number
    spellVisualKitID: number
  }

  interface ArtifactInfo {
    itemID: number
    altItemID: number | undefined
    name: string
    icon: number
    xp: number
    pointsSpent: number
    quality: number
    artifactAppearanceID: number
    appearanceModID: number
    itemAppearanceID: number | undefined
    altItemAppearanceID: number | undefined
    altOnTop: boolean
    tier: string
  }

  interface ArtifactMetaPowerInfo {
    spellID: number
    powerCost: number
    currentRank: number
  }

  interface ArtifactPowerInfo {
    spellID: number
    cost: number
    currentRank: number
    maxRank: number
    bonusRanks: number
    numMaxRankBonusFromTier: number
    prereqsMet: boolean
    isStart: boolean
    isGoldMedal: boolean
    isFinal: boolean
    tier: number
    position: Vector2DMixin
    offset: Vector2DMixin | undefined
    linearIndex: number | undefined
  }

  interface ArtifactRelicInfo {
    name: string
    icon: number
    slotTypeName: string
    link: string
  }

  interface AuctionHouseBrowseQuery {
    searchString: string
    sorts: undefined[]
    minLevel: number | undefined
    maxLevel: number | undefined
    filters: undefined[] | undefined
    itemClassFilters: undefined[] | undefined
  }

  interface AuctionHouseFilterGroup {
    category: AuctionHouseFilterCategory
    filters: undefined[]
  }

  interface AuctionHouseItemClassFilter {
    classID: number
    subClassID: number | undefined
    inventoryType: InventoryType | undefined
  }

  interface AuctionHouseSortType {
    sortOrder: AuctionHouseSortOrder
    reverseSort: boolean
  }

  interface AuctionInfo {
    itemKey: ItemKey
    itemLink: string | undefined
    minBid: number | undefined
    bidAmount: number | undefined
    buyoutAmount: number | undefined
    bidder: string | undefined
  }

  interface BidInfo {
    auctionID: number
    itemKey: ItemKey
    itemLink: string | undefined
    timeLeft: AuctionHouseTimeLeftBand
    minBid: number | undefined
    bidAmount: number | undefined
    buyoutAmount: number | undefined
    bidder: string | undefined
  }

  interface BrowseResultInfo {
    itemKey: ItemKey
    appearanceLink: string | undefined
    totalQuantity: number
    minPrice: number
    containsOwnerItem: boolean
  }

  interface CommoditySearchResultInfo {
    itemID: number
    quantity: number
    unitPrice: number
    auctionID: number
    owners: string[]
    totalNumberOfOwners: number
    timeLeftSeconds: number | undefined
    numOwnerItems: number
    containsOwnerItem: boolean
    containsAccountItem: boolean
  }

  interface ItemKey {
    itemID: number
    itemLevel: number
    itemSuffix: number
    battlePetSpeciesID: number
  }

  interface ItemKeyInfo {
    itemID: number
    battlePetSpeciesID: number
    itemName: string
    battlePetLink: string | undefined
    appearanceLink: string | undefined
    quality: ItemQuality
    iconFileID: number
    isPet: boolean
    isCommodity: boolean
    isEquipment: boolean
  }

  interface ItemSearchResultInfo {
    itemKey: ItemKey
    owners: string[]
    totalNumberOfOwners: number
    timeLeft: AuctionHouseTimeLeftBand
    auctionID: number
    quantity: number
    itemLink: string | undefined
    containsOwnerItem: boolean
    containsAccountItem: boolean
    containsSocketedItem: boolean
    bidder: string | undefined
    minBid: number | undefined
    bidAmount: number | undefined
    buyoutAmount: number | undefined
    timeLeftSeconds: number | undefined
  }

  interface OwnedAuctionInfo {
    auctionID: number
    itemKey: ItemKey
    itemLink: string | undefined
    status: AuctionStatus
    quantity: number
    timeLeftSeconds: number | undefined
    timeLeft: AuctionHouseTimeLeftBand | undefined
    bidAmount: number | undefined
    buyoutAmount: number | undefined
    bidder: string | undefined
  }

  interface ReplicateItemInfo {
    name: string | undefined
    texture: number | undefined
    count: number
    qualityID: number
    usable: boolean | undefined
    level: number
    levelType: string | undefined
    minBid: number
    minIncrement: number
    buyoutPrice: number
    bidAmount: number
    highBidder: string | undefined
    bidderFullName: string | undefined
    owner: string | undefined
    ownerFullName: string | undefined
    saleStatus: number
    itemID: number
    hasAllInfo: boolean | undefined
  }

  interface AzeriteEmpoweredItemPowerInfo {
    azeritePowerID: number
    spellID: number
  }

  interface AzeriteEmpoweredItemPowerText {
    name: string
    description: string
  }

  interface AzeriteEmpoweredItemTierInfo {
    azeritePowerIDs: number[]
    unlockLevel: number
  }

  interface AzeriteSpecInfo {
    classID: number
    specID: number
  }

  interface AzeriteEssenceInfo {
    ID: number
    name: string
    rank: number
    unlocked: boolean
    valid: boolean
    icon: number
  }

  interface AzeriteMilestoneInfo {
    ID: number
    requiredLevel: number
    canUnlock: boolean
    unlocked: boolean
    rank: number | undefined
    slot: AzeriteEssenceSlot | undefined
  }

  interface UnlockedAzeriteEmpoweredItems {
    unlockedItem: ItemLocationMixin
    tierIndex: number
  }

  interface BankTabData {
    ID: number
    bankType: BankType
    name: string
    icon: number
    depositFlags: BagSlotFlags
  }

  interface BNetAccountInfo {
    bnetAccountID: number
    accountName: string
    battleTag: string
    isFriend: boolean
    isBattleTagFriend: boolean
    lastOnlineTime: number
    isAFK: boolean
    isDND: boolean
    isFavorite: boolean
    appearOffline: boolean
    customMessage: string
    customMessageTime: number
    note: string
    rafLinkType: RafLinkType
    gameAccountInfo: BNetGameAccountInfo
  }

  interface BNetGameAccountInfo {
    gameAccountID: number
    clientProgram: string
    isOnline: boolean
    isGameBusy: boolean
    isGameAFK: boolean
    wowProjectID: number | undefined
    characterName: string | undefined
    realmName: string | undefined
    realmDisplayName: string | undefined
    realmID: number | undefined
    factionName: string | undefined
    raceName: string | undefined
    className: string | undefined
    areaName: string | undefined
    characterLevel: number | undefined
    richPresence: string | undefined
    playerGuid: string | undefined
    isWowMobile: boolean
    canSummon: boolean
    hasFocus: boolean
    regionID: number
    isInCurrentRegion: boolean
    timerunningSeasonID: number | undefined
  }

  interface BountyInfo {
    questID: number
    factionID: number
    icon: number
    numObjectives: number
    turninRequirementText: string | undefined
  }

  interface CVarInfo {
    value: string
    defaultValue: string
    isStoredServerAccount: boolean
    isStoredServerCharacter: boolean
    isLockedFromUser: boolean
    isSecure: boolean
    isReadOnly: boolean
  }

  interface CalendarDayEvent {
    eventID: string
    title: string
    isCustomTitle: boolean
    startTime: CalendarTime
    endTime: CalendarTime
    calendarType: string
    sequenceType: string
    eventType: CalendarEventType
    iconTexture: number | undefined
    modStatus: string
    inviteStatus: CalendarStatus
    invitedBy: string
    difficulty: number
    inviteType: CalendarInviteType
    sequenceIndex: number
    numSequenceDays: number
    difficultyName: string
    dontDisplayBanner: boolean
    dontDisplayEnd: boolean
    clubID: string
    isLocked: boolean
  }

  interface CalendarEventIndexInfo {
    offsetMonths: number
    monthDay: number
    eventIndex: number
  }

  interface CalendarEventInfo {
    title: string
    description: string
    creator: string | undefined
    eventType: CalendarEventType
    repeatOption: CalendarEventRepeatOptions
    maxSize: number
    textureIndex: number | undefined
    time: CalendarTime
    lockoutTime: CalendarTime
    isLocked: boolean
    isAutoApprove: boolean
    hasPendingInvite: boolean
    inviteStatus: CalendarStatus | undefined
    inviteType: CalendarInviteType | undefined
    calendarType: string
    communityName: string | undefined
  }

  interface CalendarEventInviteInfo {
    name: string | undefined
    level: number
    className: string | undefined
    classFilename: string | undefined
    inviteStatus: CalendarStatus | undefined
    modStatus: string | undefined
    inviteIsMine: boolean
    type: CalendarInviteType
    notes: string
    classID: number | undefined
    guid: string
  }

  interface CalendarEventStatusOption {
    status: CalendarStatus
    statusString: string
  }

  interface CalendarEventTextureInfo {
    title: string
    iconTexture: number
    expansionLevel: number
    difficultyId: number | undefined
    mapId: number | undefined
    isLfr: boolean | undefined
  }

  interface CalendarEventTypeDisplayInfo {
    displayString: string
    eventType: CalendarEventType
  }

  interface CalendarGuildEventInfo {
    eventID: string
    year: number
    month: number
    monthDay: number
    weekday: number
    hour: number
    minute: number
    eventType: CalendarEventType
    title: string
    calendarType: string
    texture: number
    inviteStatus: CalendarStatus
    clubID: string
  }

  interface CalendarGuildFilterInfo {
    minLevel: number
    maxLevel: number
    rank: number
  }

  interface CalendarHolidayInfo {
    name: string
    description: string
    texture: number
    startTime: CalendarTime | undefined
    endTime: CalendarTime | undefined
  }

  interface CalendarMonthInfo {
    month: number
    year: number
    numDays: number
    firstWeekday: number
  }

  interface CalendarRaidInfo {
    name: string
    calendarType: string
    raidID: number
    time: CalendarTime
    difficulty: number
    difficultyName: string | undefined
  }

  interface ChallengeModeCompletionMemberInfo {
    memberGUID: string
    name: string
  }

  interface ChallengeModeGuildAttemptMember {
    name: string
    classFileName: string
  }

  interface ChallengeModeGuildTopAttempt {
    name: string
    classFileName: string
    keystoneLevel: number
    mapChallengeModeID: number
    isYou: boolean
    members: undefined[]
  }

  interface CharCustomizationCategory {
    id: number
    orderIndex: number
    name: string
    icon: string
    selectedIcon: string
    undressModel: boolean
    subcategory: boolean
    cameraZoomLevel: number
    cameraDistanceOffset: number
    spellShapeshiftFormID: number | undefined
    chrModelID: number | undefined
    options: undefined[]
    hasNewChoices: boolean
    needsNativeFormCategory: boolean
  }

  interface CharCustomizationChoice {
    id: number
    name: string
    ineligibleChoice: boolean
    isNew: boolean
    swatchColor1: ColorMixin | undefined
    swatchColor2: ColorMixin | undefined
    soundKit: number | undefined
    isLocked: boolean
    lockedText: string | undefined
  }

  interface CharCustomizationOption {
    id: number
    name: string
    orderIndex: number
    optionType: ChrCustomizationOptionType
    choices: undefined[]
    currentChoiceIndex: number | undefined
    hasNewChoices: boolean
    isSound: boolean
  }

  interface ChatChannelInfo {
    name: string
    shortcut: string
    localID: number
    instanceID: number
    zoneChannelID: number
    channelType: PermanentChatChannelType
  }

  interface AddonMessageParams {
    prefix: string
    message: string
    chatType: string | undefined
    target: string | undefined
  }

  interface ChromieTimeExpansionInfo {
    id: number
    name: string
    description: string
    mapAtlas: string
    previewAtlas: string
    completed: boolean
    alreadyOn: boolean
    recommended: boolean
    sortPriority: number
  }

  interface ImportLoadoutEntryInfo {
    nodeID: number
    ranksGranted: number
    ranksPurchased: number
    selectionEntryID: number
  }

  interface ClickBindingInfo {
    type: ClickBindingType
    actionID: number
    button: string
    modifiers: number
  }

  interface ClubInfo {
    clubId: string
    name: string
    shortName: string | undefined
    description: string
    broadcast: string
    clubType: ClubType
    avatarId: number
    memberCount: number | undefined
    favoriteTimeStamp: number | undefined
    joinTime: number | undefined
    socialQueueingEnabled: boolean | undefined
    crossFaction: boolean | undefined
  }

  interface ClubInvitationCandidateInfo {
    memberId: number
    name: string
    priority: number
    status: ClubInvitationCandidateStatus
  }

  interface ClubInvitationInfo {
    invitationId: string
    isMyInvitation: boolean
    invitee: ClubMemberInfo
  }

  interface ClubLimits {
    maximumNumberOfStreams: number
  }

  interface ClubMemberInfo {
    isSelf: boolean
    memberId: number
    name: string | undefined
    role: ClubRoleIdentifier | undefined
    presence: ClubMemberPresence
    clubType: ClubType | undefined
    guid: string | undefined
    bnetAccountId: number | undefined
    memberNote: string | undefined
    officerNote: string | undefined
    classID: number | undefined
    race: number | undefined
    level: number | undefined
    zone: string | undefined
    achievementPoints: number | undefined
    profession1ID: number | undefined
    profession1Rank: number | undefined
    profession1Name: string | undefined
    profession2ID: number | undefined
    profession2Rank: number | undefined
    profession2Name: string | undefined
    lastOnlineYear: number | undefined
    lastOnlineMonth: number | undefined
    lastOnlineDay: number | undefined
    lastOnlineHour: number | undefined
    guildRank: string | undefined
    guildRankOrder: number | undefined
    isRemoteChat: boolean | undefined
    overallDungeonScore: number | undefined
    faction: PvPFaction | undefined
    timerunningSeasonID: number | undefined
  }

  interface ClubMessageIdentifier {
    epoch: number
    position: number
  }

  interface ClubMessageInfo {
    messageId: ClubMessageIdentifier
    content: string
    author: ClubMemberInfo
    destroyer: ClubMemberInfo | undefined
    destroyed: boolean
    edited: boolean
  }

  interface ClubMessageRange {
    oldestMessageId: ClubMessageIdentifier
    newestMessageId: ClubMessageIdentifier
  }

  interface ClubPrivilegeInfo {
    canDestroy: boolean
    canSetAttribute: boolean
    canSetName: boolean
    canSetDescription: boolean
    canSetAvatar: boolean
    canSetBroadcast: boolean
    canSetPrivacyLevel: boolean
    canSetOwnMemberAttribute: boolean
    canSetOtherMemberAttribute: boolean
    canSetOwnMemberNote: boolean
    canSetOtherMemberNote: boolean
    canSetOwnVoiceState: boolean
    canSetOwnPresenceLevel: boolean
    canUseVoice: boolean
    canVoiceMuteMemberForAll: boolean
    canGetInvitation: boolean
    canSendInvitation: boolean
    canSendGuestInvitation: boolean
    canRevokeOwnInvitation: boolean
    canRevokeOtherInvitation: boolean
    canGetBan: boolean
    canGetSuggestion: boolean
    canSuggestMember: boolean
    canGetTicket: boolean
    canCreateTicket: boolean
    canDestroyTicket: boolean
    canAddBan: boolean
    canRemoveBan: boolean
    canCreateStream: boolean
    canDestroyStream: boolean
    canSetStreamPosition: boolean
    canSetStreamAttribute: boolean
    canSetStreamName: boolean
    canSetStreamSubject: boolean
    canSetStreamAccess: boolean
    canSetStreamVoiceLevel: boolean
    canCreateMessage: boolean
    canDestroyOwnMessage: boolean
    canDestroyOtherMessage: boolean
    canEditOwnMessage: boolean
    canPinMessage: boolean
    kickableRoleIds: number[]
  }

  interface ClubRoleInfo {
    roleId: number
    name: string
    required: boolean
    unique: boolean
  }

  interface ClubSelfInvitationInfo {
    invitationId: string
    club: ClubInfo
    inviter: ClubMemberInfo
    leaders: undefined[]
  }

  interface ClubStreamInfo {
    streamId: string
    name: string
    subject: string
    leadersAndModeratorsOnly: boolean
    streamType: ClubStreamType
    creationTime: number
  }

  interface ClubStreamNotificationSetting {
    streamId: string
    filter: ClubStreamNotificationFilter
  }

  interface ClubTicketInfo {
    ticketId: string
    allowedRedeemCount: number
    currentRedeemCount: number
    creationTime: number
    expirationTime: number
    defaultStreamId: string | undefined
    creator: ClubMemberInfo
  }

  interface ClubFinderApplicantInfo {
    clubFinderGUID: string
    playerGUID: string
    closed: number
    name: string
    message: string
    level: number
    classID: number
    ilvl: number
    specIds: number[]
    requestStatus: PlayerClubRequestStatus
    lookupSuccess: boolean
    lastUpdatedTime: number
    faction: number
  }

  interface ClubSettingsInfo {
    playStyleDungeon: boolean
    playStyleRaids: boolean
    playStylePvp: boolean
    playStyleRP: boolean
    playStyleSocial: boolean
    roleTank: boolean
    roleHealer: boolean
    roleDps: boolean
    sizeSmall: boolean
    sizeMedium: boolean
    sizeLarge: boolean
    maxLevelOnly: boolean
    enableListing: boolean
    sortRelevance: boolean
    sortMembers: boolean
    sortNewest: boolean
    autoAccept: boolean
    crossFaction: boolean
  }

  interface RecruitingClubInfo {
    clubFinderGUID: string
    numActiveMembers: number
    name: string
    comment: string
    guildLeader: string
    isGuild: boolean
    emblemInfo: number
    tabardInfo: GuildTabardInfo | undefined
    recruitingSpecIds: number[]
    recruitmentFlags: number
    localeSet: boolean
    recruitmentLocale: number
    minILvl: number
    cached: number
    cacheRequested: number
    lastPosterGUID: string
    clubId: string
    lastUpdatedTime: number
    isCrossFaction: boolean
    realmName: string | undefined
  }

  interface CommentatorHistory {
    series: undefined[]
    teamDirectory: undefined[]
    overrideNameDirectory: undefined[]
  }

  interface CommentatorOverrideNameEntry {
    originalName: string
    newName: string
  }

  interface CommentatorPlayerData {
    unitToken: string
    name: string
    faction: number
    specialization: number
    damageDone: number
    damageTaken: number
    healingDone: number
    healingTaken: number
    kills: number
    deaths: number
    soloShuffleRoundWins: number
    soloShuffleRoundLosses: number
  }

  interface CommentatorSeries {
    teams: undefined[]
  }

  interface CommentatorSeriesTeam {
    name: string
    score: number
  }

  interface CommentatorTeamDirectoryEntry {
    playerName: string
    teamName: string
  }

  interface CommentatorTrackedItemCooldown {
    spellID: number
    category: TrackedSpellCategory
  }

  interface CommentatorUnitData {
    healthMax: number
    health: number
    absorbTotal: number
    isDeadOrGhost: boolean
    isFeignDeath: boolean
    powerTypeToken: string
    power: number
    powerMax: number
  }

  interface NameOverrideEntry {
    originalName: string
    overrideName: string
  }

  interface ConsoleCommandInfo {
    command: string
    help: string
    category: ConsoleCategory
    commandType: ConsoleCommandType
    scriptContents: string
    scriptParameters: string
  }

  interface ConsoleScriptCollectionData {
    ID: number
    name: string
  }

  interface ConsoleScriptCollectionElementData {
    collectionID: number | undefined
    consoleScriptID: number | undefined
  }

  interface ConsoleScriptData {
    ID: number
    name: string
    help: string
    script: string
    params: string
    isLuaScript: boolean
  }

  interface ConsoleScriptParameter {
    name: string
    description: string
  }

  interface ContainerItemInfo {
    iconFileID: number
    stackCount: number
    isLocked: boolean
    quality: ItemQuality | undefined
    isReadable: boolean
    hasLoot: boolean
    hyperlink: string
    isFiltered: boolean
    hasNoValue: boolean
    itemID: number
    isBound: boolean
    itemName: string
  }

  interface ItemPurchaseCurrency {
    iconFileID: number | undefined
    currencyCount: number
    name: string
  }

  interface ItemPurchaseInfo {
    money: number
    itemCount: number
    refundSeconds: number
    currencyCount: number
    hasEnchants: boolean
  }

  interface ItemPurchaseItem {
    iconFileID: number | undefined
    itemCount: number
    hyperlink: string
  }

  interface ItemQuestInfo {
    isQuestItem: boolean
    questID: number | undefined
    isActive: boolean
  }

  interface ContentTrackingMapInfo {
    x: number
    y: number
    trackableType: ContentTrackingType
    trackableID: number
    targetType: ContentTrackingTargetType
    targetID: number
    waypointText: string
  }

  interface EncounterTrackingInfo {
    encounterName: string
    journalEncounterID: number | undefined
    journalInstanceID: number | undefined
    instanceName: string
    subText: string | undefined
    difficultyID: number | undefined
    lfgDungeonID: number | undefined
    groupFinderActivityID: number | undefined
  }

  interface VendorTrackingInfo {
    creatureName: string
    zoneName: string | undefined
    currencyType: number | undefined
    cost: number | undefined
  }

  interface ContributionAppearance {
    stateName: string
    stateColor: ColorMixin
    tooltipLine: string
    tooltipUseTimeRemaining: boolean
    statusBarAtlas: string
    borderAtlas: string
    bannerAtlas: string
  }

  interface ContributionMapInfo {
    areaPoiID: number
    position: Vector2DMixin
    name: string
    atlasName: string
    collectorCreatureID: number
  }

  interface CovenantAbilityInfo {
    spellID: number
    type: CovenantAbilityType
  }

  interface CovenantFeatureInfo {
    name: string
    description: string
    texture: number
  }

  interface CovenantPreviewInfo {
    textureKit: string
    transmogSetID: number
    mountID: number
    covenantName: string
    covenantZone: string
    description: string
    covenantCrest: string
    covenantAbilities: undefined[]
    fromPlayerChoice: boolean
    covenantSoulbinds: undefined[]
    featureInfo: CovenantFeatureInfo
  }

  interface CovenantSoulbindInfo {
    spellID: number
    uiTextureKit: string
    name: string
    description: string
    sortOrder: number
  }

  interface CovenantSanctumFeatureInfo {
    garrTalentTreeID: number
    featureType: number
    uiOrder: number
  }

  interface CovenantSanctumRenownLevelInfo {
    level: number
    locked: boolean
    isMilestone: boolean
    isCapstone: boolean
  }

  interface CovenantSanctumRenownRewardInfo {
    uiOrder: number
    itemID: number | undefined
    spellID: number | undefined
    mountID: number | undefined
    transmogID: number | undefined
    transmogSetID: number | undefined
    titleMaskID: number | undefined
    garrFollowerID: number | undefined
    transmogIllusionSourceID: number | undefined
    icon: number | undefined
    name: string | undefined
    description: string | undefined
    toastDescription: string | undefined
  }

  interface CovenantData {
    ID: number
    textureKit: string
    celebrationSoundKit: number
    animaChannelSelectSoundKit: number
    animaChannelActiveSoundKit: number
    animaGemsFullSoundKit: number
    animaNewGemSoundKit: number
    animaReinforceSelectSoundKit: number
    upgradeTabSelectSoundKitID: number
    reservoirFullSoundKitID: number
    beginResearchSoundKitID: number
    renownFanfareSoundKitID: number
    name: string
    soulbindIDs: number[]
  }

  interface CraftingOrderRequestInfo {
    orderType: CraftingOrderType
    selectedSkillLineAbility: number | undefined
    searchFavorites: boolean
    initialNonPublicSearch: boolean
    primarySort: CraftingOrderSortInfo
    secondarySort: CraftingOrderSortInfo
    forCrafter: boolean
    offset: number
    callback: CraftingOrderRequestCallback
    profession: Profession | undefined
  }

  interface CraftingOrderRequestMyOrdersInfo {
    primarySort: CraftingOrderSortInfo
    secondarySort: CraftingOrderSortInfo
    offset: number
    callback: CraftingOrderRequestMyOrdersCallback
  }

  interface CraftingOrderBucketInfo {
    itemID: number
    spellID: number
    skillLineAbilityID: number
    tipAmountAvg: number
    tipAmountMax: number
    numAvailable: number
  }

  interface CraftingOrderClaimsRemainingInfo {
    claimsRemaining: number
    secondsToRecharge: number | undefined
  }

  interface CraftingOrderCustomerCategory {
    categoryName: string
    categoryID: number
    uiSortOrder: number
    primaryCategorySortOrder: number | undefined
    secondaryCategorySortOrder: number | undefined
    type: CraftingOrderCustomerCategoryType
  }

  interface CraftingOrderCustomerCategoryFilters {
    primaryCategoryID: number | undefined
    secondaryCategoryID: number | undefined
    tertiaryCategoryID: number | undefined
  }

  interface CraftingOrderCustomerOptionInfo {
    skillLineAbilityID: number
    professionID: number
    skillUpSkillLineID: number
    spellID: number
    itemID: number
    itemName: string
    primaryCategoryID: number
    iLvlMin: number
    iLvlMax: number | undefined
    canUse: boolean
    bindOnPickup: boolean
    qualityIlvlBonuses: number[] | undefined
    craftingQualityIDs: number[] | undefined
    quality: ItemQuality | undefined
    slots: number | undefined
    level: number | undefined
    skill: number | undefined
    secondaryCategoryID: number | undefined
    tertiaryCategoryID: number | undefined
    expansionID: number | undefined
  }

  interface CraftingOrderCustomerSearchParams {
    categoryFilters: CraftingOrderCustomerCategoryFilters
    searchText: string | undefined
    minLevel: number
    maxLevel: number
    uncollectedOnly: boolean
    usableOnly: boolean
    upgradesOnly: boolean
    currentExpansionOnly: boolean
    includePoor: boolean
    includeCommon: boolean
    includeUncommon: boolean
    includeRare: boolean
    includeEpic: boolean
    includeLegendary: boolean
    includeArtifact: boolean
    isFavoritesSearch: boolean
  }

  interface CraftingOrderCustomerSearchResults {
    options: undefined[]
    extraColumnType: AuctionHouseExtraColumn | undefined
  }

  interface CraftingOrderInfo {
    orderID: number
    itemID: number
    spellID: number
    skillLineAbilityID: number
    orderType: CraftingOrderType
    orderState: CraftingOrderState
    expirationTime: number
    claimEndTime: number
    minQuality: number
    tipAmount: number
    consortiumCut: number
    isRecraft: boolean
    isFulfillable: boolean
    reagentState: CraftingOrderReagentsType
    customerGuid: string | undefined
    customerName: string | undefined
    crafterGuid: string | undefined
    crafterName: string | undefined
    npcCustomerCreatureID: number | undefined
    customerNotes: string
    reagents: undefined[]
    outputItemHyperlink: string | undefined
    outputItemGUID: string | undefined
    recraftItemHyperlink: string | undefined
    npcOrderRewards: undefined[]
    npcCraftingOrderSetID: number
    npcTreasureID: number
  }

  interface CraftingOrderMailInfo {
    reason: RcoCloseReason
    recipeName: string
    commissionPaid: number | undefined
    crafterNote: string | undefined
    crafterGUID: string | undefined
    crafterName: string | undefined
    customerGUID: string | undefined
    customerName: string | undefined
  }

  interface CraftingOrderPersonalOrdersInfo {
    profession: Profession
    numPersonalOrders: number
    professionName: string
  }

  interface CraftingOrderReagentInfo {
    reagent: CraftingReagentInfo
    slotIndex: number
    source: CraftingOrderReagentSource
    isBasicReagent: boolean
  }

  interface CraftingOrderRewardInfo {
    itemLink: string | undefined
    currencyType: number | undefined
    count: number
  }

  interface CraftingOrderSortInfo {
    sortType: CraftingOrderSortType
    reversed: boolean
  }

  interface NewCraftingOrderInfo {
    skillLineAbilityID: number
    orderType: CraftingOrderType
    orderDuration: CraftingOrderDuration
    tipAmount: number
    customerNotes: string
    reagentItems: undefined[]
    craftingReagentItems: undefined[]
    minCraftingQualityID: number | undefined
    orderTarget: string | undefined
    recraftItem: string | undefined
  }

  interface ClassInfo {
    className: string
    classFile: string
    classID: number
  }

  interface FactionInfo {
    name: string
    groupTag: string
  }

  interface RaceInfo {
    raceName: string
    clientFileString: string
    raceID: number
  }

  interface BackpackCurrencyInfo {
    name: string
    quantity: number
    iconFileID: number
    currencyTypesID: number
  }

  interface CharacterCurrencyData {
    characterGUID: string
    characterName: string
    currencyID: number
    quantity: number
  }

  interface CurrencyDisplayInfo {
    name: string
    description: string
    icon: number
    quality: number
    displayAmount: number
    actualAmount: number
  }

  interface CurrencyInfo {
    name: string
    description: string
    currencyID: number
    isHeader: boolean
    isHeaderExpanded: boolean
    currencyListDepth: number
    isTypeUnused: boolean
    isShowInBackpack: boolean
    quantity: number
    trackedQuantity: number
    iconFileID: number
    maxQuantity: number
    canEarnPerWeek: boolean
    quantityEarnedThisWeek: number
    isTradeable: boolean
    quality: ItemQuality
    maxWeeklyQuantity: number
    totalEarned: number
    discovered: boolean
    useTotalEarnedForMaxQty: boolean
    isAccountWide: boolean
    isAccountTransferable: boolean
    transferPercentage: number | undefined
    rechargingCycleDurationMS: number
    rechargingAmountPerCycle: number
  }

  interface CurrencyTransferTransaction {
    sourceCharacterGUID: string
    sourceCharacterName: string
    destinationCharacterGUID: string
    destinationCharacterName: string
    currencyType: number
    quantityTransferred: number
    totalQuantityConsumed: number
    timestamp: number
  }

  interface GraveyardMapInfo {
    areaPoiID: number
    position: Vector2DMixin
    name: string
    textureIndex: number
    graveyardID: number
    isGraveyardSelectable: boolean
  }

  interface SelfResurrectOption {
    name: string
    optionType: SelfResurrectOptionType
    id: number
    canUse: boolean
    isLimited: boolean
    priority: number
  }

  interface EditModeAnchorInfo {
    point: string
    relativeTo: string
    relativePoint: string
    offsetX: number
    offsetY: number
  }

  interface EditModeLayoutInfo {
    layoutName: string
    layoutType: EditModeLayoutType
    systems: undefined[]
  }

  interface EditModeLayouts {
    layouts: undefined[]
    activeLayout: number
  }

  interface EditModeSettingInfo {
    setting: number
    value: number
  }

  interface EditModeSystemInfo {
    system: EditModeSystem
    systemIndex: number | undefined
    anchorInfo: EditModeAnchorInfo
    anchorInfo2: EditModeAnchorInfo | undefined
    settings: undefined[]
    isInDefaultPosition: boolean
  }

  interface DungeonEntranceMapInfo {
    areaPoiID: number
    position: Vector2DMixin
    name: string
    description: string
    atlasName: string
    journalInstanceID: number
  }

  interface EncounterJournalItemInfo {
    itemID: number
    encounterID: number | undefined
    name: string | undefined
    itemQuality: string | undefined
    filterType: ItemSlotFilterType | undefined
    icon: number | undefined
    slot: string | undefined
    armorType: string | undefined
    link: string | undefined
    handError: boolean | undefined
    weaponTypeError: boolean | undefined
    displayAsPerPlayerLoot: boolean | undefined
    displayAsVeryRare: boolean | undefined
    displayAsExtremelyRare: boolean | undefined
    displaySeasonID: number | undefined
  }

  interface EncounterJournalMapEncounterInfo {
    encounterID: number
    mapX: number
    mapY: number
  }

  interface EncounterJournalSectionInfo {
    spellID: number
    title: string
    description: string | undefined
    headerType: number
    abilityIcon: number
    creatureDisplayID: number
    uiModelSceneID: number
    siblingSectionID: number | undefined
    firstChildSectionID: number | undefined
    filteredByDifficulty: boolean
    link: string
    startsOpen: boolean
  }

  interface ExpansionDisplayInfo {
    logo: number
    banner: string
    features: undefined[]
    highResBackgroundID: number
    lowResBackgroundID: number
  }

  interface ExpansionDisplayInfoFeature {
    icon: number
    text: string
  }

  interface FogOfWarInfo {
    fogOfWarID: number
    backgroundAtlas: string
    maskAtlas: string
    maskScalar: number
  }

  interface FontScriptInfo {
    color: ColorMixin
    height: number
    outline: string
    shadow: FontScriptShadowInfo | undefined
  }

  interface FontScriptShadowInfo {
    color: ColorMixin
    x: number
    y: number
  }

  interface FriendInfo {
    connected: boolean
    name: string
    className: string | undefined
    area: string | undefined
    notes: string | undefined
    guid: string
    level: number
    dnd: boolean
    afk: boolean
    rafLinkType: RafLinkType
    mobile: boolean
  }

  interface WhoInfo {
    fullName: string
    fullGuildName: string
    level: number
    raceStr: string
    classStr: string
    area: string
    filename: string | undefined
    gender: number
    timerunningSeasonID: number | undefined
  }

  interface GamePadAxisConfig {
    axis: string
    shift: number | undefined
    scale: number | undefined
    deadzone: number | undefined
    buttonThreshold: number | undefined
    buttonPos: string | undefined
    buttonNeg: string | undefined
    comment: string | undefined
  }

  interface GamePadConfig {
    comment: string | undefined
    name: string | undefined
    configID: GamePadConfigID
    labelStyle: string | undefined
    rawButtonMappings: undefined[]
    rawAxisMappings: undefined[]
    axisConfigs: undefined[]
    stickConfigs: undefined[]
  }

  interface GamePadConfigID {
    vendorID: number | undefined
    productID: number | undefined
  }

  interface GamePadMappedState {
    name: string
    labelStyle: string
    buttonCount: number
    axisCount: number
    stickCount: number
    buttons: boolean[]
    axes: number[]
    sticks: undefined[]
  }

  interface GamePadRawAxisMapping {
    rawIndex: number
    axis: string | undefined
    comment: string | undefined
  }

  interface GamePadRawButtonMapping {
    rawIndex: number
    button: string | undefined
    axis: string | undefined
    axisValue: number | undefined
    comment: string | undefined
  }

  interface GamePadRawState {
    name: string
    vendorID: number
    productID: number
    rawButtonCount: number
    rawAxisCount: number
    rawButtons: boolean[]
    rawAxes: number[]
  }

  interface GamePadStick {
    x: number
    y: number
    len: number
  }

  interface GamePadStickConfig {
    stick: string
    axisX: string | undefined
    axisY: string | undefined
    deadzone: number | undefined
    deadzoneX: number | undefined
    deadzoneY: number | undefined
    comment: string | undefined
  }

  interface AutoCombatDamageClassString {
    damageClassValue: number
    locString: string
  }

  interface AutoCombatResult {
    winner: boolean
    combatLog: undefined[]
  }

  interface AutoCombatSpellInfo {
    autoCombatSpellID: number
    name: string
    description: string
    cooldown: number
    duration: number
    schoolMask: number
    previewMask: number
    icon: number
    spellTutorialFlag: number
    hasThornsEffect: boolean
  }

  interface AutoCombatTroopInfo {
    name: string
    followerID: number
    garrFollowerID: number
    followerTypeID: number
    displayIDs: undefined[]
    level: number
    quality: number
    levelXP: number
    maxXP: number
    height: number
    scale: number
    displayScale: number | undefined
    displayHeight: number | undefined
    classSpec: number | undefined
    className: string | undefined
    flavorText: string | undefined
    classAtlas: string
    portraitIconID: number
    textureKit: string
    isTroop: boolean
    raceID: number
    health: number
    maxHealth: number
    role: number
    isAutoTroop: boolean
    isSoulbind: boolean
    isCollected: boolean
    autoCombatStats: FollowerAutoCombatStatsInfo
  }

  interface AutoMissionCombatEventInfo {
    boardIndex: number
    oldHealth: number
    newHealth: number
    maxHealth: number
    points: number | undefined
  }

  interface AutoMissionEnvironmentEffect {
    name: string
    autoCombatSpellInfo: AutoCombatSpellInfo
  }

  interface AutoMissionEvent {
    type: number
    spellID: number
    schoolMask: number
    effectIndex: number
    casterBoardIndex: number
    auraType: number
    targetInfo: undefined[]
  }

  interface AutoMissionRound {
    events: undefined[]
  }

  interface AutoMissionTargetingInfo {
    targetIndex: number
    previewType: number
    spellID: number
    effectIndex: number
  }

  interface FollowerAutoCombatStatsInfo {
    currentHealth: number
    maxHealth: number
    attack: number
    healingTimestamp: number
    healCost: number
    minutesHealingRemaining: number
  }

  interface FollowerDisplayID {
    id: number
    followerPageScale: number
    showWeapon: boolean
  }

  interface FollowerMissionCompleteInfo {
    name: string
    displayIDs: undefined[]
    level: number
    quality: number
    currentXP: number
    maxXP: number
    height: number
    scale: number
    movementType: number | undefined
    impactDelay: number | undefined
    castID: number | undefined
    castSoundID: number | undefined
    impactID: number | undefined
    impactSoundID: number | undefined
    targetImpactID: number | undefined
    targetImpactSoundID: number | undefined
    className: string | undefined
    classAtlas: string
    portraitIconID: number
    textureKit: string
    isTroop: boolean
    boardIndex: number
    health: number
    maxHealth: number
    role: number
  }

  interface GarrisonAbilityCounterInfo {
    id: number
    icon: number
    name: string
    factor: number
    description: string
  }

  interface GarrisonAbilityInfo {
    id: number
    name: string
    description: string
    icon: number
    isTrait: boolean
    isSpecialization: boolean
    temporary: boolean
    category: string | undefined
    counters: undefined[]
    isEmptySlot: boolean
  }

  interface GarrisonEnemyEncounterInfo {
    name: string
    displayID: number
    portraitFileDataID: number
    textureKit: string
    scale: number
    height: number
    mechanics: undefined[]
    autoCombatSpells: undefined[]
    autoCombatAutoAttack: AutoCombatSpellInfo | undefined
    role: number
    health: number
    maxHealth: number
    attack: number
    boardIndex: number
    isElite: boolean
  }

  interface GarrisonFollowerDeathInfo {
    followerID: number
    state: number
  }

  interface GarrisonMechanicInfo {
    mechanicTypeID: number
    icon: number
    name: string
    factor: number
    description: string
    ability: GarrisonAbilityInfo | undefined
  }

  interface GarrisonPlotInstanceMapInfo {
    buildingPlotInstanceID: number
    position: Vector2DMixin
    name: string
    atlasName: string
  }

  interface MissionDeploymentInfo {
    location: string
    xp: number
    environment: string | undefined
    environmentDesc: string | undefined
    environmentTexture: number
    locTextureKit: string
    isExhausting: boolean
    enemies: undefined[]
  }

  interface MissionEncounterIconInfo {
    portraitFileDataID: number
    missionScalar: number
    isElite: boolean
    isRare: boolean
  }

  interface GarrisonAbilityEffect {
    name: string
    description: string
    icon: number
    factor: number
  }

  interface GarrisonFollowerAbilityInfo {
    id: number
    name: string
    description: string
    icon: number
    isTrait: boolean
    isSpecialization: boolean
    temporary: boolean
    category: string | undefined
    counters: undefined[]
    isEmptySlot: boolean
  }

  interface GarrisonTalentCurrencyCostInfo {
    currencyType: number
    currencyQuantity: number
  }

  interface GarrisonTalentInfo {
    id: number
    ability: GarrisonFollowerAbilityInfo
    name: string
    icon: number
    tier: number
    uiOrder: number
    type: number
    prerequisiteTalentID: number | undefined
    selected: boolean
    researched: boolean
    ignoreTalent: boolean
    researchDuration: number
    startTime: number
    timeRemaining: number
    researchGoldCost: number
    researchCurrencyCosts: undefined[]
    talentAvailability: GarrisonTalentAvailability
    talentRank: number
    talentMaxRank: number
    isBeingResearched: boolean
    description: string
    perkSpellID: number
    researchDescription: string | undefined
    playerConditionReason: string | undefined
    socketInfo: GarrisonTalentSocketInfo
    treeID: number
  }

  interface GarrisonTalentSocketInfo {
    socketType: number
    socketSubtype: number
    misc0: number
    misc1: number
  }

  interface GarrisonTalentTreeInfo {
    treeID: number
    title: string
    textureKit: string
    talents: undefined[]
    isClassAgnostic: boolean
    isThemed: boolean
    featureType: number
    featureSubtype: number
  }

  interface FriendshipReputationInfo {
    friendshipFactionID: number
    standing: number
    maxRep: number
    name: string | undefined
    text: string
    texture: number
    reaction: string
    reactionThreshold: number
    nextThreshold: number | undefined
    reversedColor: boolean
    overrideColor: number | undefined
  }

  interface FriendshipReputationRankInfo {
    currentLevel: number
    maxLevel: number
  }

  interface GossipOptionRewardInfo {
    id: number
    quantity: number
    rewardType: GossipOptionRewardType
  }

  interface GossipOptionUIInfo {
    gossipOptionID: number | undefined
    name: string
    icon: number
    rewards: undefined[]
    status: GossipOptionStatus
    spellID: number | undefined
    flags: number
    overrideIconID: number | undefined
    selectOptionWhenOnlyOption: boolean
    orderIndex: number
    failureDescription: string | undefined
  }

  interface GossipOptionUIWidgetSetAndType {
    widgetType: number
    uiWidgetSetID: number
  }

  interface GossipPoiInfo {
    name: string
    textureIndex: number
    position: Vector2DMixin
    inBattleMap: boolean
  }

  interface GossipQuestUIInfo {
    title: string
    questLevel: number
    isTrivial: boolean
    frequency: number | undefined
    repeatable: boolean | undefined
    isComplete: boolean | undefined
    isLegendary: boolean
    isIgnored: boolean
    questID: number
    isImportant: boolean
    isMeta: boolean
  }

  interface GuildNewsInfo {
    isSticky: boolean
    isHeader: boolean
    newsType: number
    whoText: string | undefined
    whatText: string | undefined
    newsDataID: number
    data: number[]
    weekday: number
    day: number
    month: number
    year: number
    guildMembersPresent: number
  }

  interface GuildTabardInfo {
    backgroundColor: ColorMixin
    borderColor: ColorMixin
    emblemColor: ColorMixin
    emblemFileID: number
    emblemStyle: number
  }

  interface DifficultyInfo {
    name: string
    instanceType: string
    isHeroic: boolean
    isChallengeMode: boolean
    displayHeroic: boolean
    displayMythic: boolean
    toggleDifficultyID: number | undefined
    isLFR: boolean
    minPlayers: number | undefined
    maxPlayers: number | undefined
  }

  interface DungeonEncounterInfo {
    encounterName: string
    texture: string
    isKilled: boolean
    ineligible: boolean
  }

  interface InstanceInfo {
    name: string
    instanceType: string
    difficultyID: number
    difficultyName: string
    maxPlayers: number
    dynamicDifficulty: number
    isDynamic: boolean | undefined
    instanceID: number
    instanceGroupSize: number
    lfgDungeonID: number | undefined
  }

  interface InvasionMapInfo {
    invasionID: number
    name: string
    position: Vector2DMixin
    atlasName: string
    rewardQuestID: number | undefined
  }

  interface IslandsQueueDifficultyInfo {
    difficultyId: number
    previewRewardQuestId: number
  }

  interface ItemInfoResult {
    itemName: string
    itemLink: string
    itemQuality: ItemQuality
    itemLevel: number
    itemMinLevel: number
    itemType: string
    itemSubType: string
    itemStackCount: number
    itemEquipLoc: string
    itemTexture: number
    sellPrice: number
    classID: number
    subclassID: number
    bindType: number
    expansionID: number
    setID: number | undefined
    isCraftingReagent: boolean
  }

  interface ConversionCurrencyCost {
    currencyID: number
    amount: number
  }

  interface ItemInteractionChargeInfo {
    newChargeAmount: number
    rechargeRate: number
    timeToNextCharge: number
  }

  interface ItemInteractionFrameInfo {
    textureKit: string
    openSoundKitID: number
    closeSoundKitID: number
    titleText: string
    tutorialText: string
    buttonText: string
    interactionType: UIItemInteractionType
    flags: number
    description: string | undefined
    buttonTooltip: string | undefined
    confirmationDescription: string | undefined
    slotTooltip: string | undefined
    cost: number | undefined
    currencyTypeId: number | undefined
    dropInSlotSoundKitId: number | undefined
  }

  interface ItemUpgradeCostDiscountInfo {
    isDiscounted: boolean
    discountHighWatermark: number
    isPartialTwoHandDiscount: boolean
    isAccountWideDiscount: boolean
    doesCurrentCharacterMeetHighWatermark: boolean
  }

  interface ItemUpgradeCurrencyCost {
    cost: number
    currencyID: number
    discountInfo: ItemUpgradeCostDiscountInfo
  }

  interface ItemUpgradeItemCost {
    cost: number
    itemID: number
    discountInfo: ItemUpgradeCostDiscountInfo
  }

  interface ItemUpgradeItemInfo {
    iconID: number
    name: string
    itemUpgradeable: boolean
    displayQuality: number
    highWatermarkSlot: number
    currUpgrade: number
    maxUpgrade: number
    minItemLevel: number
    maxItemLevel: number
    upgradeLevelInfos: undefined[]
    customUpgradeString: string | undefined
    upgradeCostTypesForSeason: undefined[]
  }

  interface ItemUpgradeLevelInfo {
    upgradeLevel: number
    displayQuality: number
    itemLevelIncrement: number
    levelStats: undefined[]
    currencyCostsToUpgrade: undefined[]
    itemCostsToUpgrade: undefined[]
    failureMessage: string | undefined
  }

  interface ItemUpgradeSeasonalCostType {
    itemID: number | undefined
    currencyID: number | undefined
    orderIndex: number
    sourceString: string | undefined
  }

  interface ItemUpgradeStat {
    displayString: string
    statValue: number
    active: boolean
  }

  interface LFGDungeonInfo {
    name: string
    iconID: number
    link: string | undefined
  }

  interface LFGLockInfo {
    lfgID: number
    reason: number
    hideEntry: boolean
  }

  interface AdvancedFilterOptions {
    needsTank: boolean
    needsHealer: boolean
    needsDamage: boolean
    needsMyClass: boolean
    hasTank: boolean
    hasHealer: boolean
    activities: number[]
    minimumRating: number
    difficultyNormal: boolean
    difficultyHeroic: boolean
    difficultyMythic: boolean
    difficultyMythicPlus: boolean
  }

  interface BestDungeonScoreMapInfo {
    mapScore: number
    mapName: string
    bestRunLevel: number
    finishedSuccess: boolean
    bestRunDurationMs: number
    bestLevelIncrement: number
  }

  interface GroupFinderActivityInfo {
    fullName: string
    shortName: string
    categoryID: number
    groupFinderActivityGroupID: number
    ilvlSuggestion: number
    filters: number
    minLevel: number
    maxNumPlayers: number
    displayType: LFGListDisplayType
    orderIndex: number
    useHonorLevel: boolean
    showQuickJoinToast: boolean
    isMythicPlusActivity: boolean
    isRatedPvpActivity: boolean
    isCurrentRaidActivity: boolean
    isPvpActivity: boolean
    isMythicActivity: boolean
    allowCrossFaction: boolean
    isHeroicActivity: boolean
    isNormalActivity: boolean
    useDungeonRoleExpectations: boolean
  }

  interface LfgApplicantData {
    applicantID: number
    applicationStatus: string
    pendingApplicationStatus: string | undefined
    numMembers: number
    isNew: boolean
    comment: string
    displayOrderID: number
  }

  interface LfgCategoryData {
    name: string
    searchPromptOverride: string | undefined
    separateRecommended: boolean
    autoChooseActivity: boolean
    preferCurrentArea: boolean
    showPlaystyleDropdown: boolean
    allowCrossFaction: boolean
  }

  interface LfgEntryData {
    activityID: number
    requiredItemLevel: number
    requiredHonorLevel: number
    name: string
    comment: string
    voiceChat: string
    duration: number
    autoAccept: boolean
    privateGroup: boolean
    questID: number | undefined
    requiredDungeonScore: number | undefined
    requiredPvpRating: number | undefined
    playstyle: LFGEntryPlaystyle | undefined
    isCrossFactionListing: boolean
  }

  interface LfgSearchResultData {
    searchResultID: number
    activityID: number
    leaderName: string | undefined
    name: string
    comment: string
    voiceChat: string
    requiredItemLevel: number
    requiredHonorLevel: number
    hasSelf: boolean
    numMembers: number
    numBNetFriends: number
    numCharFriends: number
    numGuildMates: number
    isDelisted: boolean
    autoAccept: boolean
    isWarMode: boolean
    age: number
    questID: number | undefined
    leaderOverallDungeonScore: number | undefined
    leaderDungeonScoreInfo: BestDungeonScoreMapInfo | undefined
    leaderBestDungeonScoreInfo: BestDungeonScoreMapInfo | undefined
    leaderPvpRatingInfo: PvpRatingInfo | undefined
    requiredDungeonScore: number | undefined
    requiredPvpRating: number | undefined
    playstyle: LFGEntryPlaystyle | undefined
    crossFactionListing: boolean | undefined
    leaderFactionGroup: number
    partyGUID: string
  }

  interface PvpRatingInfo {
    bracket: number
    rating: number
    activityName: string
    tier: number
  }

  interface WowLocale {
    enUS: boolean
    koKR: boolean
    frFR: boolean
    deDE: boolean
    zhCN: boolean
    zhTW: boolean
    esES: boolean
    esMX: boolean
    ruRU: boolean
    ptBR: boolean
    itIT: boolean
  }

  interface CurrencyCost {
    currencyID: number
    amount: number
  }

  interface RuneforgeItemPreviewInfo {
    itemGUID: string
    itemLevel: number
    itemName: string
  }

  interface RuneforgeLegendaryComponentInfo {
    powerID: number
    modifiers: number[]
  }

  interface RuneforgeLegendaryCraftDescription {
    baseItem: ItemLocationMixin
    runeforgePowerID: number
    modifiers: number[]
  }

  interface RuneforgePower {
    runeforgePowerID: number
    state: RuneforgePowerState
    name: string
    descriptionSpellID: number
    description: string
    source: string | undefined
    iconFileID: number
    specName: string | undefined
    matchesSpec: boolean
    matchesCovenant: boolean
    covenantID: number | undefined
    slots: string[]
  }

  interface LocaleInfo {
    localeId: number
    localeName: string
  }

  interface EncounterLootDropInfo {
    lootListID: number
    itemHyperlink: string
    playerRollState: EncounterLootDropRollState
    currentLeader: EncounterLootDropRollInfo | undefined
    isTied: boolean
    winner: EncounterLootDropRollInfo | undefined
    allPassed: boolean
    rollInfos: undefined[]
    startTime: number
    duration: number
  }

  interface EncounterLootDropRollInfo {
    playerName: string
    playerGUID: string
    playerClass: string
    isSelf: boolean
    state: EncounterLootDropRollState
    isWinner: boolean
    roll: number | undefined
  }

  interface EncounterLootDrops {
    encounterID: number
    drops: undefined[]
  }

  interface EncounterLootInfo {
    encounterName: string
    encounterID: number
    startTime: number
    duration: number
  }

  interface LootJournalItemInfo {
    itemID: number
    icon: number
    invType: number
  }

  interface LootJournalItemSetInfo {
    setID: number
    itemLevel: number
    name: string
  }

  interface LoreTextEntry {
    text: string
    isHeader: boolean
  }

  interface LossOfControlData {
    locType: string
    spellID: number
    displayText: string
    iconTexture: number
    startTime: number | undefined
    timeRemaining: number | undefined
    duration: number | undefined
    lockoutSchool: number
    priority: number
    displayType: number
    auraInstanceID: number | undefined
  }

  interface MajorFactionData {
    name: string
    factionID: number
    expansionID: number
    bountySetID: number
    isUnlocked: boolean
    unlockDescription: string | undefined
    uiPriority: number
    renownLevel: number
    renownReputationEarned: number
    renownLevelThreshold: number
    textureKit: string
    celebrationSoundKit: number
    renownFanfareSoundKitID: number
  }

  interface MajorFactionRenownInfo {
    renownLevel: number
    renownReputationEarned: number
    renownLevelThreshold: number
  }

  interface MajorFactionRenownLevelInfo {
    factionID: number
    level: number
    locked: boolean
    isMilestone: boolean
    isCapstone: boolean
  }

  interface MajorFactionRenownRewardInfo {
    renownRewardID: number
    uiOrder: number
    isAccountUnlock: boolean
    itemID: number | undefined
    spellID: number | undefined
    mountID: number | undefined
    transmogID: number | undefined
    transmogSetID: number | undefined
    titleMaskID: number | undefined
    transmogIllusionSourceID: number | undefined
    icon: number | undefined
    name: string | undefined
    description: string | undefined
    toastDescription: string | undefined
  }

  interface MapBannerInfo {
    areaPoiID: number
    name: string
    atlasName: string
    uiTextureKit: string | undefined
  }

  interface MapLinkInfo {
    areaPoiID: number
    position: Vector2DMixin
    name: string
    atlasName: string
    linkedUiMapID: number
  }

  interface UiMapDetails {
    mapID: number
    name: string
    mapType: UIMapType
    parentMapID: number
    flags: UIMapFlag
  }

  interface UiMapGroupMemberInfo {
    mapID: number
    relativeHeightIndex: number
    name: string
  }

  interface UiMapHighlightInfo {
    fileDataID: number
    atlasID: string
    texturePercentageX: number
    texturePercentageY: number
    textureX: number
    textureY: number
    scrollChildX: number
    scrollChildY: number
  }

  interface UiMapLayerInfo {
    layerWidth: number
    layerHeight: number
    tileWidth: number
    tileHeight: number
    minScale: number
    maxScale: number
    additionalZoomSteps: number
  }

  interface UiMapExplorationHitRect {
    top: number
    bottom: number
    left: number
    right: number
  }

  interface UiMapExplorationInfo {
    textureWidth: number
    textureHeight: number
    offsetX: number
    offsetY: number
    isShownByMouseOver: boolean
    isDrawOnTopLayer: boolean
    fileDataIDs: number[]
    hitRect: UiMapExplorationHitRect
  }

  interface MinimapScriptTrackingFilter {
    spellID: number | undefined
    filterID: MinimapTrackingFilter | undefined
  }

  interface MinimapScriptTrackingInfo {
    name: string
    texture: number
    active: boolean
    type: string
    subType: number
    spellID: number | undefined
  }

  interface MirrorTimerInfo {
    name: string
    startValue: number
    maxValue: number
    scale: number
    paused: number
    label: string
    spellID: number
  }

  interface MountCreatureDisplayInfo {
    creatureDisplayID: number
    isVisible: boolean
  }

  interface MountInfo {
    name: string
    spellID: number
    icon: number
    isActive: boolean
    isUsable: boolean
    sourceType: number
    isFavorite: boolean
    isFactionSpecific: boolean
    faction: number | undefined
    shouldHideOnChar: boolean
    isCollected: boolean
    mountID: number
    isSteadyFlight: boolean
  }

  interface MountInfoExtra {
    creatureDisplayInfoID: number | undefined
    description: string
    source: string
    isSelfMount: boolean
    mountTypeID: number
    uiModelSceneID: number
    animID: number
    spellVisualKitID: number
    disablePlayerMountPreview: boolean
  }

  interface MapSeasonBestInfo {
    durationSec: number
    level: number
    completionDate: MythicPlusDate
    affixIDs: number[]
    members: undefined[]
    dungeonScore: number
  }

  interface MythicPlusDate {
    year: number
    month: number
    day: number
    hour: number
    minute: number
  }

  interface MythicPlusKeystoneAffix {
    id: number
    seasonID: number
  }

  interface MythicPlusMember {
    name: string | undefined
    specID: number
    classID: number
  }

  interface MythicPlusRunInfo {
    mapChallengeModeID: number
    level: number
    thisWeek: boolean
    completed: boolean
    runScore: number
  }

  interface MythicPlusAffixScoreInfo {
    name: string
    score: number
    level: number
    durationSec: number
    overTime: boolean
  }

  interface MythicPlusRatingLinkInfo {
    mapChallengeModeID: number
    level: number
    completedInTime: number
    dungeonScore: number
    name: string
  }

  interface InspectGuildInfo {
    achievementPoints: number
    numMembers: number
    guildName: string
    realmName: string
  }

  interface InspectPVPData {
    rating: number
    gamesWon: number
    gamesPlayed: number
    roundsWon: number
    roundsPlayed: number
  }

  interface PartyPoseInfo {
    partyPoseID: number
    mapID: number
    widgetSetID: number | undefined
    victoryModelSceneID: number
    defeatModelSceneID: number
    victorySoundKitID: number
    defeatSoundKitID: number
    uiTextureKit: string | undefined
    titleText: string | undefined
    extraButtonText: string | undefined
    flags: PartyPoseFlags
  }

  interface PerksActivitiesInfo {
    activePerksMonth: number
    displayMonthName: string
    secondsRemaining: number
    activities: undefined[]
    thresholds: undefined[]
  }

  interface PerksActivitiesPending {
    pendingIDs: number[]
  }

  interface PerksActivitiesTracked {
    trackedIDs: number[]
  }

  interface PerksActivityCondition {
    isMet: boolean
    text: string
    uiPriority: number
  }

  interface PerksActivityCriteria {
    criteriaID: number
    requiredValue: number
  }

  interface PerksActivityInfo {
    ID: number
    activityName: string
    description: string
    thresholdContributionAmount: number
    completed: boolean
    inProgress: boolean
    tracked: boolean
    supersedes: number
    uiPriority: number
    areAllConditionsMet: boolean
    conditions: undefined[]
    eventName: string | undefined
    eventStartTime: number | undefined
    eventEndTime: number | undefined
    requirementsList: undefined[]
    criteriaList: undefined[]
    tagNames: string[]
  }

  interface PerksActivityRequirement {
    completed: boolean
    requirementText: string
  }

  interface PerksActivityTags {
    tagName: string[]
  }

  interface PerksActivityThresholdInfo {
    thresholdOrderIndex: number
    currencyAwardAmount: number
    requiredContributionAmount: number
    pendingReward: boolean
    itemReward: number | undefined
  }

  interface ModelSceneActorData {
    actorID: number | undefined
    scriptTag: string | undefined
    posX: number | undefined
    posY: number | undefined
    posZ: number | undefined
    yaw: number | undefined
    pitch: number | undefined
    roll: number | undefined
    normalizedScale: number | undefined
  }

  interface ModelSceneCameraData {
    cameraID: number | undefined
    scriptTag: string | undefined
    targetX: number | undefined
    targetY: number | undefined
    targetZ: number | undefined
    yaw: number | undefined
    pitch: number | undefined
    roll: number | undefined
    defaultZoom: number | undefined
    zoomMin: number | undefined
    zoomMax: number | undefined
  }

  interface PerksProgramItemDisplayInfo {
    overrideModelSceneID: number | undefined
    creatureDisplayInfoID: number | undefined
    mainHandItemModifiedAppearanceID: number | undefined
    offHandItemModifiedAppearanceID: number | undefined
  }

  interface PerksProgramPendingChestRewards {
    rewardTypeID: number
    perksVendorItemID: number | undefined
    rewardAmount: number
    monthRewarded: string | undefined
    activityMonthID: number
    thresholdOrderIndex: number
  }

  interface PerksVendorCategoryInfo {
    ID: number
    displayName: string
    defaultUIModelSceneID: number
  }

  interface PerksVendorItemInfo {
    name: string
    perksVendorCategoryID: number
    description: string
    timeRemaining: number
    purchased: boolean
    refundable: boolean
    subItemsLoaded: boolean
    isPurchasePending: boolean
    doesNotExpire: boolean
    price: number
    perksVendorItemID: number
    itemID: number
    iconTexture: string
    mountID: number
    mountTypeName: string
    speciesID: number
    transmogSetID: number
    itemModifiedAppearanceID: number
    subItems: undefined[]
    uiGroupInfo: PerksVendorItemUIGroupInfo | undefined
  }

  interface PerksVendorItemUIGroupInfo {
    ID: number
    name: string
    priority: number
  }

  interface PerksVendorSubItemInfo {
    name: string
    itemID: number
    itemAppearanceID: number
    invType: string
    quality: ItemQuality
  }

  interface PetTamerMapInfo {
    areaPoiID: number
    position: Vector2DMixin
    name: string
    atlasName: string | undefined
    textureIndex: number | undefined
  }

  interface PetAbilityLevelInfo {
    abilityID: number
    level: number
  }

  interface PetJournalPetInfo {
    speciesID: number
    customName: string | undefined
    petLevel: number
    xp: number
    maxXP: number
    displayID: number
    isFavorite: boolean
    icon: number
    petType: number
    creatureID: number
    name: string | undefined
    sourceText: string
    description: string
    isWild: boolean
    canBattle: boolean
    tradable: boolean
    unique: boolean
    obtainable: boolean
  }

  interface ContextualWorldPingResult {
    contextualPingType: PingSubjectType | undefined
    result: PingResult
  }

  interface PingCooldownInfo {
    startTimeMs: number
    endTimeMs: number
  }

  interface PingTypeInfo {
    orderIndex: number
    type: PingSubjectType
    uiTextureKitID: string
  }

  interface PlayerChoiceInfo {
    objectGUID: string
    choiceID: number
    questionText: string
    pendingChoiceText: string
    uiTextureKit: string
    hideWarboardHeader: boolean
    keepOpenAfterChoice: boolean
    options: undefined[]
    soundKitID: number | undefined
    closeUISoundKitID: number | undefined
  }

  interface PlayerChoiceOptionButtonInfo {
    id: number
    text: string
    disabled: boolean
    confirmation: string | undefined
    tooltip: string | undefined
    rewardQuestID: number | undefined
    soundKitID: number | undefined
  }

  interface PlayerChoiceOptionInfo {
    id: number
    description: string
    header: string
    choiceArtID: number
    desaturatedArt: boolean
    disabledOption: boolean
    hasRewards: boolean
    rewardInfo: PlayerChoiceOptionRewardInfo
    uiTextureKit: string
    maxStacks: number
    buttons: undefined[]
    widgetSetID: number | undefined
    spellID: number | undefined
    rarity: PlayerChoiceRarity | undefined
    rarityColor: ColorMixin | undefined
    typeArtID: number | undefined
    headerIconAtlasElement: string | undefined
    subHeader: string | undefined
    consolidateWidgets: boolean
  }

  interface PlayerChoiceOptionRewardInfo {
    currencyRewards: undefined[]
    itemRewards: undefined[]
    repRewards: undefined[]
  }

  interface PlayerChoiceRewardCurrencyInfo {
    currencyId: number
    name: string
    currencyTexture: number
    quantity: number
    isCurrencyContainer: boolean
  }

  interface PlayerChoiceRewardItemInfo {
    itemId: number
    name: string
    quantity: number
  }

  interface PlayerChoiceRewardReputationInfo {
    factionId: number
    quantity: number
  }

  interface MythicPlusRatingMapSummary {
    challengeModeID: number
    mapScore: number
    bestRunLevel: number
    bestRunDurationMS: number
    finishedSuccess: boolean
  }

  interface MythicPlusRatingSummary {
    currentSeasonScore: number
    runs: undefined[]
  }

  interface CharacterAlternateFormData {
    raceID: number
    name: string
    fileName: string
    createScreenIconAtlas: string
  }

  interface PlayerInfoCharacterData {
    name: string
    fileName: string
    alternateFormRaceData: CharacterAlternateFormData | undefined
    createScreenIconAtlas: string
    sex: number
  }

  interface ProfTabHighlight {
    description: string
  }

  interface ProfTabInfo {
    rootNodeID: number
    name: string
    description: string
    rootIconID: number
    highlights: undefined[]
  }

  interface SpecPerkInfo {
    perkID: number
    isMajorPerk: boolean
  }

  interface SpecializationCurrencyInfo {
    numAvailable: number
    currencyName: string
  }

  interface SpecializationTabInfo {
    enabled: boolean
    errorReason: string
  }

  interface BattlefieldCurrencyReward {
    id: number
    quantity: number
  }

  interface BattlefieldItemReward {
    id: number
    name: string
    texture: number
    quantity: number
  }

  interface BattlefieldRewards {
    honor: number
    experience: number
    itemRewards: undefined[] | undefined
    currencyRewards: undefined[] | undefined
    roleShortageBonus: RoleShortageReward | undefined
  }

  interface BattlefieldVehicleInfo {
    x: number
    y: number
    name: string
    isOccupied: boolean
    atlas: string
    textureWidth: number
    textureHeight: number
    facing: number
    isPlayer: boolean
    isAlive: boolean
    shouldDrawBelowPlayerBlips: boolean
  }

  interface BattlemasterListInfo {
    name: string
    instanceType: number
    minPlayers: number
    maxPlayers: number
    icon: number
    longDescription: string
    shortDescription: string
  }

  interface HonorRewardInfo {
    honorLevelName: string
    badgeFileDataID: number
    achievementRewardedID: number
  }

  interface LevelUpBattlegroundInfo {
    id: number
    icon: number
    name: string
    isEpic: boolean
  }

  interface MatchPVPStatColumn {
    pvpStatID: number
    columnHeaderID: number
    orderIndex: number
    name: string
    tooltipTitle: string
    tooltip: string
  }

  interface PvpBrawlInfo {
    brawlID: number
    name: string
    shortDescription: string
    longDescription: string
    canQueue: boolean
    minLevel: number
    maxLevel: number
    groupsAllowed: boolean
    timeLeftUntilNextChange: number | undefined
    brawlType: BrawlType
    mapNames: string[]
    includesAllArenas: boolean
    minItemLevel: number
  }

  interface PVPPersonalRatedInfo {
    personalRating: number
    bestSeasonRating: number
    bestWeeklyRating: number
    seasonPlayed: number
    seasonWon: number
    weeklyPlayed: number
    weeklyWon: number
    lastWeeksBestRating: number
    hasWonBracketToday: boolean
    tier: number
    ranking: number | undefined
    roundsSeasonPlayed: number
    roundsSeasonWon: number
    roundsWeeklyPlayed: number
    roundsWeeklyWon: number
  }

  interface PVPPostMatchCurrencyReward {
    currencyType: number
    quantityChanged: number
  }

  interface PVPPostMatchItemReward {
    type: string
    link: string
    quantity: number
    specID: number
    sex: number
    isUpgraded: boolean
  }

  interface PvpReadyCheckInfo {
    roles: undefined[]
    numPlayersAccepted: number
    numPlayersDeclined: number
    totalNumPlayers: number
  }

  interface PvpRoleQueueInfo {
    role: string
    totalRole: number
    totalAccepted: number
    totalDeclined: number
  }

  interface PvpScalingData {
    scalingDataID: number
    specializationID: number
    name: string
    value: number
  }

  interface PVPScoreInfo {
    name: string
    guid: string
    killingBlows: number
    honorableKills: number
    deaths: number
    honorGained: number
    faction: number
    raceName: string
    className: string
    classToken: string
    damageDone: number
    healingDone: number
    rating: number
    ratingChange: number
    prematchMMR: number
    mmrChange: number
    postmatchMMR: number
    talentSpec: string
    honorLevel: number
    roleAssigned: number
    stats: undefined[]
  }

  interface PVPStatInfo {
    pvpStatID: number
    pvpStatValue: number
    orderIndex: number
    name: string
    tooltip: string
    iconName: string
  }

  interface PVPTeamInfo {
    name: string
    size: number
    rating: number
    ratingNew: number
    ratingMMR: number
  }

  interface PvpTierInfo {
    name: string
    descendRating: number
    ascendRating: number
    descendTier: number
    ascendTier: number
    pvpTierEnum: number
    tierIconID: number
  }

  interface RandomBGInfo {
    canQueue: boolean
    bgID: number
    hasRandomWinToday: boolean
    minLevel: number
    maxLevel: number
  }

  interface RatedBGBlitzSpecStats {
    weeklyMostPlayedSpecID: number
    weeklyMostPlayedSpecGames: number
    seasonMostPlayedSpecID: number
    seasonMostPlayedSpecGames: number
  }

  interface RatedMatchDeserterPenalty {
    personalRatingChange: number
    queuePenaltySpellID: number
    queuePenaltyDuration: number
  }

  interface RatedSoloShuffleSpecStats {
    weeklyMostPlayedSpecID: number
    weeklyMostPlayedSpecRounds: number
    seasonMostPlayedSpecID: number
    seasonMostPlayedSpecRounds: number
  }

  interface RoleShortageReward {
    validRoles: string[]
    rewardSpellID: number
    rewardItemID: number
  }

  interface QuestLineInfo {
    questLineName: string
    questName: string
    questLineID: number
    questID: number
    x: number
    y: number
    isHidden: boolean
    isLegendary: boolean
    isLocalStory: boolean
    isDaily: boolean
    isCampaign: boolean
    isImportant: boolean
    isAccountCompleted: boolean
    isCombatAllyQuest: boolean
    isMeta: boolean
    inProgress: boolean
    isQuestStart: boolean
    floorLocation: QuestLineFloorLocation
  }

  interface QuestInfo {
    title: string
    questLogIndex: number
    questID: number
    campaignID: number | undefined
    level: number
    difficultyLevel: number
    suggestedGroup: number
    frequency: QuestFrequency | undefined
    isHeader: boolean
    useMinimalHeader: boolean
    sortAsNormalQuest: boolean
    isCollapsed: boolean
    startEvent: boolean
    isTask: boolean
    isBounty: boolean
    isStory: boolean
    isScaling: boolean
    isOnMap: boolean
    hasLocalPOI: boolean
    isHidden: boolean
    isAutoComplete: boolean
    overridesSortOrder: boolean
    readyForTranslation: boolean
    isInternalOnly: boolean
    isAbandonOnDisable: boolean
    headerSortKey: number | undefined
    questClassification: QuestClassification
  }

  interface QuestObjectiveInfo {
    text: string
    type: string
    finished: boolean
    numFulfilled: number
    numRequired: number
  }

  interface QuestOnMapInfo {
    questID: number
    x: number
    y: number
    type: number
    isMapIndicatorQuest: boolean
  }

  interface QuestTagInfo {
    tagName: string
    tagID: number
    worldQuestType: number | undefined
    quality: WorldQuestQuality | undefined
    tradeskillLineID: number | undefined
    isElite: boolean | undefined
    displayExpiration: boolean | undefined
  }

  interface QuestTheme {
    background: string
    seal: string
    signature: string
    poiIcon: string
  }

  interface QuestRequiredCurrencyInfo {
    texture: number
    name: string
    currencyID: number
    quality: number
    requiredAmount: number
  }

  interface QuestRewardCurrencyInfo {
    texture: number
    name: string
    currencyID: number
    quality: number
    baseRewardAmount: number
    bonusRewardAmount: number
    totalRewardAmount: number
    questRewardContextFlags: QuestRewardContextFlags | undefined
  }

  interface QuestRewardReputationInfo {
    factionID: number
    rewardAmount: number
  }

  interface QuestRewardSpellInfo {
    texture: number
    name: string
    garrFollowerID: number | undefined
    isTradeskill: boolean
    isSpellLearned: boolean
    hideSpellLearnText: boolean
    isBoostSpell: boolean
    genericUnlock: boolean
    type: QuestCompleteSpellType
  }

  interface QuestSessionPlayerDetails {
    name: string
    guid: string
  }

  interface TaskPOIData {
    questId: number
    x: number
    y: number
    inProgress: boolean
    numObjectives: number
    mapID: number
    isQuestStart: boolean
    isDaily: boolean
    isCombatAllyQuest: boolean
    isMeta: boolean
    childDepth: number | undefined
  }

  interface QueueSpecificInfo {
    queueType: string
    lfgIDs: number[] | undefined
    lfgListID: number | undefined
    activityID: number | undefined
    battlefieldType: string | undefined
    listID: number | undefined
    mapName: string | undefined
    rated: boolean | undefined
    isBrawl: boolean | undefined
    teamSize: number | undefined
  }

  interface RafAppearanceInfo {
    appearanceID: number
  }

  interface RafAppearanceSetInfo {
    setID: number
    setName: string
    appearanceIDs: number[]
  }

  interface RafIllusionInfo {
    spellItemEnchantmentID: number
  }

  interface RafInfo {
    versions: undefined[]
    recruitmentInfo: RafRecruitmentinfo | undefined
    recruits: undefined[]
    claimInProgress: boolean
  }

  interface RafMonthCount {
    lifetimeMonths: number
    spentMonths: number
    availableMonths: number
  }

  interface RafMountInfo {
    spellID: number
    mountID: number
  }

  interface RafPetInfo {
    creatureID: number
    speciesID: number
    displayID: number
    speciesName: string
    description: string
  }

  interface RafRecruit {
    bnetAccountID: number
    wowAccountGUID: string
    battleTag: string
    monthsRemaining: number
    subStatus: RafRecruitSubStatus
    acceptanceID: string
    versionRecruited: RecruitAFriendRewardsVersion
    activities: undefined[]
  }

  interface RafRecruitActivity {
    activityID: number
    rewardQuestID: number
    state: RafRecruitActivityState
  }

  interface RafRecruitmentinfo {
    recruitmentCode: string
    recruitmentURL: string
    expireTime: number
    remainingTimeSeconds: number
    totalUses: number
    remainingUses: number
    sourceRealm: string
    sourceFaction: string
  }

  interface RafReward {
    rewardID: number
    rafVersion: RecruitAFriendRewardsVersion
    itemID: number
    rewardType: RafRewardType
    petInfo: RafPetInfo | undefined
    mountInfo: RafMountInfo | undefined
    appearanceInfo: RafAppearanceInfo | undefined
    titleInfo: RafTitleInfo | undefined
    appearanceSetInfo: RafAppearanceSetInfo | undefined
    illusionInfo: RafIllusionInfo | undefined
    canClaim: boolean
    claimed: boolean
    canAfford: boolean
    repeatable: boolean
    repeatableClaimCount: number
    monthsRequired: number
    monthCost: number
    availableInMonths: number
    iconID: number
  }

  interface RafSystemInfo {
    maxRecruits: number
    maxRecruitMonths: number
    maxRecruitmentUses: number
    daysInCycle: number
  }

  interface RafTitleInfo {
    titleMaskID: number
  }

  interface RafVersionInfo {
    rafVersion: RecruitAFriendRewardsVersion
    monthCount: RafMonthCount
    rewards: undefined[]
    nextReward: RafReward | undefined
    numAffordableRewards: number
    numRecruits: number
  }

  interface FactionData {
    factionID: number
    name: string
    description: string
    reaction: number
    currentReactionThreshold: number
    nextReactionThreshold: number
    currentStanding: number
    atWarWith: boolean
    canToggleAtWar: boolean
    isChild: boolean
    isHeader: boolean
    isHeaderWithRep: boolean
    isCollapsed: boolean
    isWatched: boolean
    hasBonusRepGain: boolean
    canSetInactive: boolean
    isAccountWide: boolean
  }

  interface DigSiteMapInfo {
    researchSiteID: number
    position: Vector2DMixin
    name: string
    poiBlobID: number
    textureIndex: number
  }

  interface ScenarioCriteriaInfo {
    description: string
    criteriaType: number
    completed: boolean
    quantity: number
    totalQuantity: number
    flags: number
    assetID: number
    criteriaID: number
    duration: number
    elapsed: number
    failed: boolean
    isWeightedProgress: boolean
    isFormatted: boolean
  }

  interface ScenarioInformation {
    name: string
    currentStage: number
    numStages: number
    flags: number
    isComplete: boolean
    xp: number
    money: number
    type: number
    area: string
    uiTextureKit: string
    scenarioID: number
  }

  interface ScenarioStepInfo {
    title: string
    description: string
    numCriteria: number
    stepFailed: boolean
    isBonusStep: boolean
    isForCurrentStepOnly: boolean
    shouldShowBonusObjective: boolean
    spells: undefined[]
    weightedProgress: number | undefined
    rewardQuestID: number
    widgetSetID: number | undefined
    stepID: number
  }

  interface ScenarioStepSpellInfo {
    spellID: number
    name: string
    icon: number
  }

  interface ScriptedAnimationEffect {
    id: number
    visual: number
    visualScale: number
    duration: number
    trajectory: ScriptedAnimationTrajectory
    yawRadians: number
    pitchRadians: number
    rollRadians: number
    offsetX: number
    offsetY: number
    offsetZ: number
    animation: number
    animationSpeed: number
    alpha: number
    useTargetAsSource: boolean
    startBehavior: ScriptedAnimationBehavior | undefined
    startSoundKitID: number | undefined
    finishEffectID: number | undefined
    finishBehavior: ScriptedAnimationBehavior | undefined
    finishSoundKitID: number | undefined
    startAlphaFade: number | undefined
    startAlphaFadeDuration: number | undefined
    endAlphaFade: number | undefined
    endAlphaFadeDuration: number | undefined
    animationStartOffset: number | undefined
    loopingSoundKitID: number | undefined
    particleOverrideScale: number | undefined
  }

  interface ModelLight {
    omnidirectional: boolean
    point: Vector3DMixin
    ambientIntensity: number
    ambientColor: ColorMixin | undefined
    diffuseIntensity: number
    diffuseColor: ColorMixin | undefined
  }

  interface TraitCondInfo {
    condID: number
    ranksGranted: number | undefined
    isAlwaysMet: boolean
    isMet: boolean
    isGate: boolean
    questID: number | undefined
    achievementID: number | undefined
    specSetID: number | undefined
    playerLevel: number | undefined
    traitCurrencyID: number | undefined
    spentAmountRequired: number | undefined
    tooltipFormat: string | undefined
    traitCondAccountElementID: number | undefined
  }

  interface TraitConfigInfo {
    ID: number
    type: TraitConfigType
    name: string
    treeIDs: number[]
    usesSharedActionBars: boolean
  }

  interface TraitCurrencyCost {
    ID: number
    amount: number
  }

  interface TraitDefinitionInfo {
    spellID: number | undefined
    overrideName: string | undefined
    overrideSubtext: string | undefined
    overrideDescription: string | undefined
    overrideIcon: number | undefined
    overriddenSpellID: number | undefined
    subType: TraitDefinitionSubType | undefined
  }

  interface TraitEntryInfo {
    definitionID: number | undefined
    subTreeID: number | undefined
    type: TraitNodeEntryType
    maxRanks: number
    isAvailable: boolean
    conditionIDs: number[]
  }

  interface TraitEntryRankInfo {
    entryID: number
    rank: number
  }

  interface TraitGateInfo {
    topLeftNodeID: number
    conditionID: number
  }

  interface TraitNodeInfo {
    ID: number
    posX: number
    posY: number
    flags: number
    entryIDs: number[]
    entryIDsWithCommittedRanks: number[]
    canPurchaseRank: boolean
    canRefundRank: boolean
    isAvailable: boolean
    isVisible: boolean
    isDisplayError: boolean
    ranksPurchased: number
    activeRank: number
    currentRank: number
    activeEntry: TraitEntryRankInfo | undefined
    nextEntry: TraitEntryRankInfo | undefined
    maxRanks: number
    type: TraitNodeType
    visibleEdges: undefined[]
    meetsEdgeRequirements: boolean
    groupIDs: number[]
    conditionIDs: number[]
    isCascadeRepurchasable: boolean
    cascadeRepurchaseEntryID: number | undefined
    subTreeID: number | undefined
    subTreeActive: boolean | undefined
  }

  interface TraitNodeInfoPartial {
    canPurchaseRank: boolean | undefined
    canRefundRank: boolean | undefined
    isAvailable: boolean | undefined
    isVisible: boolean | undefined
    ranksPurchased: number | undefined
    activeRank: number | undefined
    currentRank: number | undefined
    meetsEdgeRequirements: boolean | undefined
    isCascadeRepurchasable: boolean | undefined
    activeEntryID: number | undefined
    subTreeActive: boolean | undefined
  }

  interface TraitOutEdgeInfo {
    targetNode: number
    type: number
    visualStyle: number
    isActive: boolean
  }

  interface TraitSubTreeInfo {
    ID: number
    name: string | undefined
    description: string | undefined
    iconElementID: string | undefined
    traitCurrencyID: number | undefined
    isActive: boolean
    subTreeSelectionNodeIDs: number[]
    posX: number
    posY: number
  }

  interface TraitTreeInfo {
    ID: number
    gates: undefined[]
    hideSingleRankNumbers: boolean
  }

  interface TreeCurrencyInfo {
    traitCurrencyID: number
    quantity: number
    maxQuantity: number | undefined
    spent: number
  }

  interface HTMLContentNode {
    text: string
    type: unknown
    align: string
  }

  interface SocialQueueConfig {
    TOASTS_DISABLED: boolean
    TOAST_DURATION: number
    DELAY_DURATION: number
    QUEUE_MULTIPLIER: number
    PLAYER_MULTIPLIER: number
    PLAYER_FRIEND_VALUE: number
    PLAYER_GUILD_VALUE: number
    THROTTLE_INITIAL_THRESHOLD: number
    THROTTLE_DECAY_TIME: number
    THROTTLE_PRIORITY_SPIKE: number
    THROTTLE_MIN_THRESHOLD: number
    THROTTLE_PVP_PRIORITY_NORMAL: number
    THROTTLE_PVP_PRIORITY_LOW: number
    THROTTLE_PVP_HONOR_THRESHOLD: number
    THROTTLE_LFGLIST_PRIORITY_DEFAULT: number
    THROTTLE_LFGLIST_PRIORITY_ABOVE: number
    THROTTLE_LFGLIST_PRIORITY_BELOW: number
    THROTTLE_LFGLIST_ILVL_SCALING_ABOVE: number
    THROTTLE_LFGLIST_ILVL_SCALING_BELOW: number
    THROTTLE_RF_PRIORITY_ABOVE: number
    THROTTLE_RF_ILVL_SCALING_ABOVE: number
    THROTTLE_DF_MAX_ITEM_LEVEL: number
    THROTTLE_DF_BEST_PRIORITY: number
  }

  interface SocialQueueGroupInfo {
    canJoin: boolean
    numQueues: number
    needTank: boolean
    needHealer: boolean
    needDamage: boolean
    isSoloQueueParty: boolean
    questSessionActive: boolean
    leaderGUID: string
  }

  interface SocialQueueGroupQueueInfo {
    clientID: number
    eligible: boolean
    needTank: boolean
    needHealer: boolean
    needDamage: boolean
    isAutoAccept: boolean
    queueData: QueueSpecificInfo
  }

  interface SocialQueuePlayerInfo {
    guid: string
    clubId: string | undefined
  }

  interface ConduitCollectionData {
    conduitID: number
    conduitRank: number
    conduitItemLevel: number
    conduitType: SoulbindConduitType
    conduitSpecSetID: number
    conduitSpecIDs: number[]
    conduitSpecName: string | undefined
    covenantID: number | undefined
    conduitItemID: number
  }

  interface SoulbindConduitData {
    conduitID: number
    conduitRank: number
  }

  interface SoulbindData {
    ID: number
    covenantID: number
    name: string
    description: string
    textureKit: string
    unlocked: boolean
    cvarIndex: number
    tree: SoulbindTree
    modelSceneData: SoulbindModelSceneData
    activationSoundKitID: number
    playerConditionReason: string | undefined
  }

  interface SoulbindModelSceneData {
    creatureDisplayInfoID: number
    modelSceneActorID: number
  }

  interface SoulbindNode {
    ID: number
    row: number
    column: number
    icon: number
    spellID: number
    playerConditionReason: string | undefined
    conduitID: number
    conduitRank: number
    state: SoulbindNodeState
    conduitType: SoulbindConduitType | undefined
    parentNodeIDs: number[]
    failureRenownRequirement: number | undefined
    socketEnhanced: boolean | undefined
  }

  interface SoulbindTree {
    editable: boolean
    nodes: undefined[]
  }

  interface PvpTalentInfo {
    talentID: number
    name: string
    icon: number
    selected: boolean
    available: boolean
    spellID: number
    unlocked: boolean
    known: boolean
    grantedByAura: boolean
    dependenciesUnmet: boolean
    dependenciesUnmetReason: string | undefined
  }

  interface PvpTalentSlotInfo {
    enabled: boolean
    level: number
    selectedTalentID: number | undefined
    availableTalentIDs: number[]
  }

  interface SpecializationInfoResult {
    id: number
    name: string
    description: string
    icon: number
    role: string
    recommended: boolean
    allowedForBoost: boolean
    masterySpell1: number | undefined
    masterySpell2: number | undefined
  }

  interface SpellBookItemInfo {
    actionID: number
    spellID: number | undefined
    itemType: SpellBookItemType
    name: string
    subName: string
    iconID: number
    isPassive: boolean
    isOffSpec: boolean
    skillLineIndex: number | undefined
  }

  interface SpellBookSkillLineInfo {
    name: string
    iconID: number
    itemIndexOffset: number
    numSpellBookItems: number
    isGuild: boolean
    shouldHide: boolean
    specID: number | undefined
    offSpecID: number | undefined
  }

  interface DeadlyDebuffInfo {
    criticalTimeRemainingMs: number | undefined
    criticalStacks: number | undefined
    priority: number
    warningText: string
    soundKitID: number | undefined
  }

  interface SpellInfo {
    name: string
    iconID: number
    originalIconID: number
    castTime: number
    minRange: number
    maxRange: number
    spellID: number
  }

  interface SpellChargeInfo {
    currentCharges: number
    maxCharges: number
    cooldownStartTime: number
    cooldownDuration: number
    chargeModRate: number
  }

  interface SpellCooldownInfo {
    startTime: number
    duration: number
    isEnabled: boolean
    modRate: number
  }

  interface SpellPowerCostInfo {
    type: PowerType
    name: string
    cost: number
    minCost: number
    costPercent: number
    costPerSec: number
    requiredAuraID: number
    hasRequiredAura: boolean
  }

  interface SplashScreenInfo {
    textureKit: string
    minDisplayCharLevel: number
    minQuestDisplayLevel: number
    soundKitID: number
    allianceQuestID: number | undefined
    hordeQuestID: number | undefined
    header: string
    topLeftFeatureTitle: string
    topLeftFeatureDesc: string
    bottomLeftFeatureTitle: string
    bottomLeftFeatureDesc: string
    rightFeatureTitle: string
    rightFeatureDesc: string
    shouldShowQuest: boolean
    screenType: SplashScreenType
    gameMenuRequest: boolean
  }

  interface PetInfo {
    slotID: number
    icon: number
    name: string
    level: number
    familyName: string
    specialization: string
    type: string
    abilities: number[]
    displayID: number
    isFavorite: boolean
    isExotic: boolean
    uiModelSceneID: number
    petNumber: number
    creatureID: number
  }

  interface MapTaxiNodeInfo {
    nodeID: number
    position: Vector2DMixin
    name: string
    atlasName: string
    faction: FlightPathFaction
    textureKit: string
    isUndiscovered: boolean
  }

  interface TaxiNodeInfo {
    nodeID: number
    position: Vector2DMixin
    name: string
    state: FlightPathState
    slotIndex: number
    textureKit: string
    useSpecialIcon: boolean
    specialIconCostString: string | undefined
    isMapLayerTransition: boolean
  }

  interface AtlasInfo {
    width: number
    height: number
    rawSize: Vector2DMixin
    leftTexCoord: number
    rightTexCoord: number
    topTexCoord: number
    bottomTexCoord: number
    tilesHorizontally: boolean
    tilesVertically: boolean
    file: number | undefined
    filename: string | undefined
    sliceData: UITextureSliceData | undefined
  }

  interface CalendarTime {
    monthDay: number
    month: number
    weekday: number
    year: number
    hour: number
    minute: number
  }

  interface TooltipItemComparisonInfo {
    method: TooltipComparisonMethod
    item: TooltipComparisonItem
    additionalItems: TooltipComparisonItem[]
  }

  interface TooltipComparisonLine {
    text: string
    color: ColorMixin
  }

  interface TooltipDataArg {
    field: string
    stringVal: string | undefined
    intVal: number | undefined
    floatVal: number | undefined
    boolVal: boolean | undefined
    colorVal: ColorMixin | undefined
    guidVal: string | undefined
  }

  interface TotemInfoScript {
    haveTotem: boolean
    totemName: string
    startTime: number
    duration: number
    icon: number
  }

  interface CraftingCurrencyResultData {
    currencyID: number
    quantity: number
    operationID: number
    firstCraftReward: boolean
    showCurrencyText: boolean
  }

  interface CraftingItemResultData {
    resourcesReturned: undefined[] | undefined
    craftingQuality: number | undefined
    qualityProgress: number
    itemID: number
    itemGUID: string
    quantity: number
    hyperlink: string
    isCrit: boolean
    critBonusSkill: number
    recraftable: boolean
    bonusCraft: boolean
    multicraft: number
    operationID: number
    firstCraftReward: boolean
    isEnchant: boolean
    hasIngenuityProc: boolean
    concentrationCurrencyID: number
    concentrationSpent: number
    ingenuityRefund: number
  }

  interface CraftingItemSlotModification {
    dataSlotIndex: number
    itemID: number
  }

  interface CraftingOperationBonusStatInfo {
    bonusStatName: string
    bonusStatValue: number
    ratingDescription: string
    ratingPct: number
    bonusRatingPct: number
  }

  interface CraftingOperationInfo {
    recipeID: number
    baseDifficulty: number
    bonusDifficulty: number
    baseSkill: number
    bonusSkill: number
    isQualityCraft: boolean
    quality: number
    craftingQuality: number
    craftingQualityID: number
    craftingDataID: number
    lowerSkillThreshold: number
    upperSkillTreshold: number
    guaranteedCraftingQualityID: number
    bonusStats: undefined[]
    concentrationCurrencyID: number
    concentrationCost: number
    ingenuityRefund: number
  }

  interface CraftingReagent {
    itemID: number | undefined
    currencyID: number | undefined
  }

  interface CraftingReagentInfo {
    itemID: number
    dataSlotIndex: number
    quantity: number
  }

  interface CraftingReagentSlotInfo {
    mcrSlotID: number
    requiredSkillRank: number
    slotText: string | undefined
  }

  interface CraftingReagentSlotSchematic {
    reagents: undefined[]
    reagentType: CraftingReagentType
    quantityRequired: number
    slotInfo: CraftingReagentSlotInfo | undefined
    dataSlotType: TradeskillSlotDataType
    dataSlotIndex: number
    slotIndex: number
    orderSource: CraftingOrderReagentSource | undefined
    required: boolean
  }

  interface CraftingRecipeOutputInfo {
    icon: number
    hyperlink: string | undefined
    itemID: number | undefined
  }

  interface CraftingRecipeRequirement {
    name: string
    met: boolean
    type: RecipeRequirementType
  }

  interface CraftingRecipeSchematic {
    recipeID: number
    icon: number
    quantityMin: number
    quantityMax: number
    name: string
    recipeType: TradeskillRecipeType
    productQuality: number | undefined
    outputItemID: number | undefined
    reagentSlotSchematics: undefined[]
    isRecraft: boolean
    hasCraftingOperationInfo: boolean
  }

  interface CraftingRecipeSkillLineInfo {
    professionSkillLineID: number
    expansionSkillLineID: number
  }

  interface CraftingResourceReturnInfo {
    itemID: number
    quantity: number
  }

  interface CraftingTargetItem {
    itemID: number
    itemGUID: string
    hyperlink: string | undefined
    quantity: number
  }

  interface GatheringOperationBonusStatInfo {
    bonusStatName: string
    bonusStatValue: number
    ratingDescription: string
    ratingPct: number
    bonusRatingPct: number
  }

  interface GatheringOperationInfo {
    spellID: number
    maxDifficulty: number
    baseSkill: number
    bonusSkill: number
    bonusStats: undefined[]
  }

  interface ProfessionInfo {
    profession: Profession | undefined
    professionID: number
    sourceCounter: number
    professionName: string
    expansionName: string
    skillLevel: number
    maxSkillLevel: number
    skillModifier: number
    isPrimaryProfession: boolean
    parentProfessionID: number | undefined
    parentProfessionName: string | undefined
  }

  interface RegularReagentInfo {
    itemID: number
    quantity: number
  }

  interface TradeSkillRecipeInfo {
    categoryID: number
    name: string
    relativeDifficulty: TradeskillRelativeDifficulty | undefined
    maxTrivialLevel: number
    itemLevel: number
    alternateVerb: string | undefined
    numSkillUps: number
    canSkillUp: boolean
    firstCraft: boolean
    sourceType: number | undefined
    learned: boolean
    disabled: boolean
    favorite: boolean
    supportsQualities: boolean
    craftable: boolean
    disabledReason: string | undefined
    recipeID: number
    skillLineAbilityID: number
    previousRecipeID: number | undefined
    nextRecipeID: number | undefined
    icon: number | undefined
    hyperlink: string | undefined
    currentRecipeExperience: number | undefined
    nextLevelRecipeExperience: number | undefined
    unlockedRecipeLevel: number | undefined
    earnedExperience: number | undefined
    supportsCraftingStats: boolean
    hasSingleItemOutput: boolean
    qualityItemIDs: number[] | undefined
    qualityIlvlBonuses: number[] | undefined
    alwaysUsesLowestQuality: boolean
    maxQuality: number | undefined
    qualityIDs: number[] | undefined
    canCreateMultiple: boolean
    abilityVerb: string | undefined
    abilityAllVerb: string | undefined
    isRecraft: boolean
    isDummyRecipe: boolean
    isGatheringRecipe: boolean
    isEnchantingRecipe: boolean
    isSalvageRecipe: boolean
  }

  interface TransmogApplyWarningInfo {
    itemLink: string
    text: string
  }

  interface TransmogSetItemInfo {
    itemID: number
    itemModifiedAppearanceID: number
    invSlot: number
    invType: string
  }

  interface TransmogSlotInfo {
    isTransmogrified: boolean
    hasPending: boolean
    isPendingCollected: boolean
    canTransmogrify: boolean
    cannotTransmogrifyReason: number
    hasUndo: boolean
    isHideVisual: boolean
    texture: number | undefined
  }

  interface TransmogSlotVisualInfo {
    baseSourceID: number
    baseVisualID: number
    appliedSourceID: number
    appliedVisualID: number
    pendingSourceID: number
    pendingVisualID: number
    hasUndo: boolean
    isHideVisual: boolean
    itemSubclass: number
  }

  interface TransmogAppearanceInfoBySourceData {
    appearanceID: number
    appearanceIsCollected: boolean
    sourceIsCollected: boolean
    sourceIsCollectedPermanent: boolean
    sourceIsCollectedConditional: boolean
    meetsTransmogPlayerCondition: boolean
    appearanceHasAnyNonLevelRequirements: boolean
    appearanceMeetsNonLevelRequirements: boolean
    appearanceIsUsable: boolean
    appearanceNumSources: number
    sourceIsKnown: boolean
    canDisplayOnPlayer: boolean
    isAnySourceValidForPlayer: boolean
  }

  interface TransmogAppearanceJournalEncounterInfo {
    instance: string
    instanceType: number
    tiers: string[]
    encounter: string
    difficulties: string[]
  }

  interface TransmogAppearanceSourceInfoData {
    category: TransmogCollectionType
    itemAppearanceID: number
    canHaveIllusion: boolean
    icon: number
    isCollected: boolean
    itemLink: string
    transmoglink: string
    sourceType: number | undefined
    itemSubClass: number
  }

  interface TransmogCategoryAppearanceInfo {
    visualID: number
    isCollected: boolean
    isFavorite: boolean
    isHideVisual: boolean
    canDisplayOnPlayer: boolean
    uiOrder: number
    exclusions: number
    restrictedSlotID: number | undefined
    isUsable: boolean
    hasRequiredHoliday: boolean
    hasActiveRequiredHoliday: boolean
    alwaysShowItem: boolean | undefined
  }

  interface TransmogCategoryInfo {
    name: string
    isWeapon: boolean
    canHaveIllusions: boolean
    canMainHand: boolean
    canOffHand: boolean
  }

  interface TransmogIllusionInfo {
    visualID: number
    sourceID: number
    icon: number
    isCollected: boolean
    isUsable: boolean
    isHideVisual: boolean
  }

  interface TransmogOutfitInfo {
    name: string
    icon: number
  }

  interface TransmogSetInfo {
    setID: number
    name: string
    baseSetID: number | undefined
    description: string | undefined
    label: string | undefined
    expansionID: number
    patchID: number
    uiOrder: number
    classMask: number
    hiddenUntilCollected: boolean
    requiredFaction: string | undefined
    collected: boolean
    favorite: boolean
    limitedTimeSet: boolean
    validForCharacter: boolean
  }

  interface TransmogSetPrimaryAppearanceInfo {
    appearanceID: number
    collected: boolean
  }

  interface DBColorExport {
    baseTag: string
    color: ColorMixin
  }

  interface EventToastInfo {
    eventToastID: number
    title: string
    subtitle: string
    instructionText: string
    iconFileID: number
    subIcon: string | undefined
    link: string
    qualityString: string | undefined
    quality: number | undefined
    eventType: EventToastEventType
    displayType: EventToastDisplayType
    uiTextureKit: string
    sortOrder: number
    time: number | undefined
    uiWidgetSetID: number | undefined
    extraUiWidgetSetID: number | undefined
    titleTooltip: string | undefined
    subtitleTooltip: string | undefined
    titleTooltipUiWidgetSetID: number | undefined
    subtitleTooltipUiWidgetSetID: number | undefined
    hideDefaultAtlas: boolean | undefined
    showSoundKitID: number | undefined
    hideSoundKitID: number | undefined
    colorTint: ColorMixin | undefined
    flags: number
  }

  interface GenericWidgetDisplayFrameInfo {
    uiWidgetSetID: number | undefined
    uiTextureKit: string | undefined
    title: string | undefined
    frameWidth: number
    frameHeight: number
    extraButtonText: string | undefined
    closeButtonText: string | undefined
  }

  interface UIModelSceneActorDisplayInfo {
    animation: number
    animationVariation: number
    animSpeed: number
    animationKitID: number | undefined
    spellVisualKitID: number | undefined
    alpha: number
    scale: number
  }

  interface UIModelSceneActorInfo {
    modelActorID: number
    scriptTag: string
    position: Vector3DMixin
    yaw: number
    pitch: number
    roll: number
    normalizeScaleAggressiveness: number | undefined
    useCenterForOriginX: boolean
    useCenterForOriginY: boolean
    useCenterForOriginZ: boolean
    modelActorDisplayID: number | undefined
  }

  interface UIModelSceneCameraInfo {
    modelSceneCameraID: number
    scriptTag: string
    cameraType: string
    target: Vector3DMixin
    yaw: number
    pitch: number
    roll: number
    zoomDistance: number
    minZoomDistance: number
    maxZoomDistance: number
    zoomedTargetOffset: Vector3DMixin
    zoomedYawOffset: number
    zoomedPitchOffset: number
    zoomedRollOffset: number
    flags: ModelSceneSetting
  }

  interface ModifiedInstanceInfo {
    lfrItemLevel: number | undefined
    normalItemLevel: number | undefined
    heroicItemLevel: number | undefined
    mythicItemLevel: number | undefined
    uiTextureKit: string
    description: string
  }

  interface AnchorBinding {
    point: string
    relativeTo: unknown
    relativePoint: string
    offsetX: number
    offsetY: number
  }

  interface uiBoundsRect {
    left: number
    bottom: number
    width: number
    height: number
  }

  interface UITextureSliceData {
    marginLeft: number
    marginTop: number
    marginRight: number
    marginBottom: number
    sliceMode: UITextureSliceMode
  }

  interface BulletTextListWidgetVisualizationInfo {
    shownState: WidgetShownState
    enabledState: WidgetEnabledState
    lines: string[]
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface CaptureBarWidgetVisualizationInfo {
    shownState: WidgetShownState
    barValue: number
    barMinValue: number
    barMaxValue: number
    neutralZoneSize: number
    neutralZoneCenter: number
    tooltip: string
    glowAnimType: WidgetGlowAnimType
    fillDirectionType: CaptureBarWidgetFillDirectionType
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface CaptureZoneVisualizationInfo {
    shownState: WidgetShownState
    mode: ZoneControlMode
    leadingEdgeType: ZoneControlLeadingEdgeType
    dangerFlashType: ZoneControlDangerFlashType
    zoneInfo: ZoneEntry
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface DiscreteProgressStepsVisualizationInfo {
    shownState: WidgetShownState
    tooltip: string
    progressMin: number
    progressMax: number
    progressVal: number
    numSteps: number
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface DoubleIconAndTextWidgetVisualizationInfo {
    shownState: WidgetShownState
    label: string
    leftText: string
    leftTooltip: string
    rightText: string
    rightTooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface DoubleStateIconRowVisualizationInfo {
    shownState: WidgetShownState
    leftIcons: undefined[]
    rightIcons: undefined[]
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface DoubleStatusBarWidgetVisualizationInfo {
    shownState: WidgetShownState
    leftBarMin: number
    leftBarMax: number
    leftBarValue: number
    leftBarTooltip: string
    rightBarMin: number
    rightBarMax: number
    rightBarValue: number
    rightBarTooltip: string
    barValueTextType: StatusBarValueTextType
    text: string
    leftBarTooltipLoc: UIWidgetTooltipLocation
    rightBarTooltipLoc: UIWidgetTooltipLocation
    fillMotionType: UIWidgetMotionType
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface FillUpFramesWidgetVisualizationInfo {
    shownState: WidgetShownState
    fillMin: number
    fillMax: number
    fillValue: number
    numTotalFrames: number
    numFullFrames: number
    pulseFillingFrame: boolean
    tooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface HorizontalCurrenciesWidgetVisualizationInfo {
    shownState: WidgetShownState
    currencies: undefined[]
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface IconAndTextWidgetVisualizationInfo {
    state: IconAndTextWidgetState
    text: string
    tooltip: string
    dynamicTooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface IconTextAndBackgroundWidgetVisualizationInfo {
    shownState: WidgetShownState
    text: string
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface IconTextAndCurrenciesWidgetVisualizationInfo {
    shownState: WidgetShownState
    enabledState: WidgetEnabledState
    descriptionShownState: WidgetShownState
    descriptionEnabledState: WidgetEnabledState
    text: string
    description: string
    currencies: undefined[]
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface ItemDisplayVisualizationInfo {
    shownState: WidgetShownState
    tooltipLoc: UIWidgetTooltipLocation
    itemInfo: UIWidgetItemInfo
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface MapPinAnimationWidgetVisualizationInfo {
    shownState: WidgetShownState
    animType: MapPinAnimationType
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface ScenarioHeaderCurrenciesAndBackgroundWidgetVisualizationInfo {
    shownState: WidgetShownState
    currencies: undefined[]
    headerText: string
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface ScenarioHeaderDelvesWidgetVisualizationInfo {
    shownState: WidgetShownState
    headerText: string
    tooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    tierText: string
    tierTooltipSpellID: number | undefined
    currencies: undefined[]
    spells: undefined[]
    rewardInfo: UIWidgetRewardInfo
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface ScenarioHeaderTimerWidgetVisualizationInfo {
    shownState: WidgetShownState
    timerMin: number
    timerMax: number
    timerValue: number
    headerText: string
    timerTooltip: string
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface SpacerVisualizationInfo {
    shownState: WidgetShownState
    widgetWidth: number
    widgetHeight: number
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface SpellDisplayVisualizationInfo {
    spellInfo: UIWidgetSpellInfo
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface StackedResourceTrackerWidgetVisualizationInfo {
    shownState: WidgetShownState
    resources: undefined[]
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface StatusBarWidgetVisualizationInfo {
    shownState: WidgetShownState
    barMin: number
    barMax: number
    barValue: number
    text: string
    tooltip: string
    barValueTextType: StatusBarValueTextType
    overrideBarText: string
    overrideBarTextShownType: StatusBarOverrideBarTextShownType
    colorTint: StatusBarColorTintValue
    partitionValues: number[]
    tooltipLoc: UIWidgetTooltipLocation
    fillMotionType: UIWidgetMotionType
    barTextEnabledState: WidgetEnabledState
    barTextFontType: UIWidgetFontType
    barTextSizeType: UIWidgetTextSizeType
    textEnabledState: WidgetEnabledState
    textFontType: UIWidgetFontType
    textSizeType: UIWidgetTextSizeType
    glowAnimType: WidgetGlowAnimType
    showGlowState: WidgetShowGlowState
    fillMinOpacity: WidgetOpacityType
    fillMaxOpacity: WidgetOpacityType
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface TextColumnRowEntryInfo {
    text: string
    enabledState: WidgetEnabledState
    hAlign: WidgetTextHorizontalAlignmentType
    columnWidth: number
  }

  interface TextColumnRowVisualizationInfo {
    shownState: WidgetShownState
    entries: undefined[]
    textSizeType: UIWidgetTextSizeType
    fontType: UIWidgetFontType
    tooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    bottomPadding: number
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface TextWithStateWidgetVisualizationInfo {
    shownState: WidgetShownState
    enabledState: WidgetEnabledState
    text: string
    tooltip: string
    textSizeType: UIWidgetTextSizeType
    fontType: UIWidgetFontType
    bottomPadding: number
    tooltipLoc: UIWidgetTooltipLocation
    hAlign: WidgetTextHorizontalAlignmentType
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface TextWithSubtextWidgetVisualizationInfo {
    shownState: WidgetShownState
    enabledState: WidgetEnabledState
    text: string
    widgetWidth: number
    tooltip: string
    textSizeType: UIWidgetTextSizeType
    fontType: UIWidgetFontType
    tooltipLoc: UIWidgetTooltipLocation
    hAlign: WidgetTextHorizontalAlignmentType
    subText: string
    subTextSizeType: UIWidgetTextSizeType
    subTextFontType: UIWidgetFontType
    subTextHAlign: WidgetTextHorizontalAlignmentType
    subTextEnabledState: WidgetEnabledState
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
    spacing: number
  }

  interface TextureAndTextEntryInfo {
    text: string
    tooltip: string
  }

  interface TextureAndTextRowVisualizationInfo {
    shownState: WidgetShownState
    entries: undefined[]
    textSizeType: UIWidgetTextureAndTextSizeType
    groupAlignment: UIWidgetHorizontalDirection
    fixedWidth: number | undefined
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface TextureAndTextVisualizationInfo {
    shownState: WidgetShownState
    text: string
    tooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    textSizeType: UIWidgetTextureAndTextSizeType
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface TextureWithAnimationVisualizationInfo {
    shownState: WidgetShownState
    tooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface TugOfWarWidgetVisualizationInfo {
    shownState: WidgetShownState
    minValue: number
    maxValue: number
    currentValue: number
    neutralZoneCenter: number
    neutralZoneSize: number
    leftIconInfo: UIWidgetIconInfo
    rightIconInfo: UIWidgetIconInfo
    glowAnimType: WidgetGlowAnimType
    tooltip: string
    tooltipLoc: UIWidgetTooltipLocation
    neutralFillStyle: TugOfWarStyleValue
    markerArrowShownState: TugOfWarMarkerArrowShownState
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface UIWidgetCurrencyInfo {
    iconFileID: number
    leadingText: string
    text: string
    tooltip: string
    isCurrencyMaxed: boolean
    textFontType: UIWidgetFontType
    textSizeType: UIWidgetTextSizeType
    textEnabledState: WidgetEnabledState
    iconSizeType: WidgetIconSizeType
    updateAnimType: UIWidgetUpdateAnimType
  }

  interface UIWidgetIconInfo {
    sourceType: WidgetIconSourceType
    sourceID: number
    sizeType: WidgetIconSizeType
    tooltip: string
    tooltipLoc: UIWidgetTooltipLocation
  }

  interface UIWidgetInfo {
    widgetID: number
    widgetSetID: number
    widgetType: UIWidgetVisualizationType
    unitToken: string | undefined
  }

  interface UIWidgetItemInfo {
    itemID: number
    stackCount: number | undefined
    overrideItemName: string | undefined
    infoText: string | undefined
    overrideTooltip: string | undefined
    textDisplayStyle: ItemDisplayTextDisplayStyle
    tooltipEnabled: boolean
    iconSizeType: WidgetIconSizeType
    infoTextEnabledState: WidgetEnabledState
    showAsEarned: boolean
    itemNameTextFontType: UIWidgetFontType
    itemNameTextSizeType: UIWidgetTextSizeType
    infoTextFontType: UIWidgetFontType
    infoTextSizeType: UIWidgetTextSizeType
    itemNameCustomColor: WidgetEnabledState
    itemNameCustomColorOverrideState: UIWidgetOverrideState
  }

  interface UIWidgetRewardInfo {
    shownState: UIWidgetRewardShownState
    earnedTooltip: string
    unearnedTooltip: string
  }

  interface UIWidgetSetInfo {
    layoutDirection: UIWidgetSetLayoutDirection
    verticalPadding: number
  }

  interface UIWidgetSpellInfo {
    spellID: number
    shownState: WidgetShownState
    enabledState: WidgetEnabledState
    tooltip: string
    text: string
    stackDisplay: number
    iconSizeType: WidgetIconSizeType
    iconDisplayType: SpellDisplayIconDisplayType
    textShownState: SpellDisplayTextShownStateType
    borderColor: SpellDisplayBorderColor
    textFontType: UIWidgetFontType
    textSizeType: UIWidgetTextSizeType
    hAlignType: WidgetTextHorizontalAlignmentType
    tint: SpellDisplayTint
    showGlowState: WidgetShowGlowState
  }

  interface UIWidgetStateIconInfo {
    iconState: IconState
    state1Tooltip: string
    state2Tooltip: string
  }

  interface UIWidgetTextTooltipPair {
    text: string
    tooltip: string
  }

  interface UnitPowerBarWidgetVisualizationInfo {
    shownState: WidgetShownState
    barMin: number
    barMax: number
    barValue: number
    tooltip: string
    barValueTextType: StatusBarValueTextType
    overrideBarText: string
    overrideBarTextShownType: StatusBarOverrideBarTextShownType
    tooltipLoc: UIWidgetTooltipLocation
    fillMotionType: UIWidgetMotionType
    flashBlendModeType: UIWidgetBlendModeType
    sparkBlendModeType: UIWidgetBlendModeType
    flashMomentType: WidgetUnitPowerBarFlashMomentType
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface ZoneControlVisualizationInfo {
    shownState: WidgetShownState
    mode: ZoneControlMode
    leadingEdgeType: ZoneControlLeadingEdgeType
    dangerFlashType: ZoneControlDangerFlashType
    zoneEntries: undefined[]
    tooltipLoc: UIWidgetTooltipLocation
    widgetSizeSetting: number
    textureKit: string
    frameTextureKit: string
    hasTimer: boolean
    orderIndex: number
    widgetTag: string
    inAnimType: WidgetAnimationType
    outAnimType: WidgetAnimationType
    widgetScale: UIWidgetScale
    layoutDirection: UIWidgetLayoutDirection
    modelSceneLayer: UIWidgetModelSceneLayer
    scriptedAnimationEffectID: number
  }

  interface ZoneEntry {
    state: ZoneControlState
    activeState: ZoneControlActiveState
    fillType: ZoneControlFillType
    min: number
    max: number
    current: number
    capturePoint: number
    tooltip: string
  }

  interface AddPrivateAuraAnchorArgs {
    unitToken: string
    auraIndex: number
    parent: unknown
    showCountdownFrame: boolean
    showCountdownNumbers: boolean
    iconInfo: PrivateAuraIconInfo | undefined
    durationAnchor: AnchorBinding | undefined
  }

  interface PrivateAuraIconInfo {
    iconAnchor: AnchorBinding
    iconWidth: number
    iconHeight: number
  }

  interface UnitAuraUpdateInfo {
    isFullUpdate: boolean
    removedAuraInstanceIDs: number[] | undefined
    addedAuras: AuraData[] | undefined
    updatedAuraInstanceIDs: number[] | undefined
  }

  interface UnitPrivateAuraAnchorInfo {
    anchorID: number
    unitToken: string
    auraIndex: number
    showCountdownFrame: boolean
    showCountdownNumbers: boolean
    iconWidth: number | undefined
    iconHeight: number | undefined
  }

  interface UnitPrivateAuraAppliedSoundInfo {
    unitToken: string
    spellID: number
    soundFileName: string | undefined
    soundFileID: number | undefined
    outputChannel: string | undefined
  }

  interface CorruptionEffectInfo {
    name: string
    description: string
    minCorruption: number
  }

  interface UnitCastingInfoResult {
    name: string
    displayName: string
    textureID: number
    startTimeMs: number
    endTimeMs: number
    isTradeskill: boolean
    castID: string
    notInterruptible: boolean
    castingSpellID: number
  }

  interface UnitChannelInfoResult {
    name: string
    displayName: string
    textureID: number
    startTimeMs: number
    endTimeMs: number
    isTradeskill: boolean
    notInterruptible: boolean
    spellID: number
    isEmpowered: boolean
    numEmpowerStages: number
  }

  interface UnitPowerBarInfo {
    ID: number
    barType: number
    minPower: number
    startInset: number
    endInset: number
    smooth: boolean
    hideFromOthers: boolean
    showOnRaid: boolean
    opaqueSpark: boolean
    opaqueFlash: boolean
    anchorTop: boolean
    forcePercentage: boolean
    sparkUnderFrame: boolean
    flashAtMinPower: boolean
    fractionalCounter: boolean
    animateNumbers: boolean
  }

  interface GxAdapterInfoDetails {
    name: string
    isLowPower: boolean
    isExternal: boolean
  }

  interface VignetteInfo {
    vignetteGUID: string
    objectGUID: string
    name: string
    isDead: boolean
    onWorldMap: boolean
    zoneInfiniteAOI: boolean
    onMinimap: boolean
    isUnique: boolean
    inFogOfWar: boolean
    atlasName: string
    hasTooltip: boolean
    vignetteID: number
    type: VignetteType
    rewardQuestID: number
    tooltipWidgetSet: number | undefined
    iconWidgetSet: number | undefined
    addPaddingAboveTooltipWidgets: boolean | undefined
  }

  interface VoiceAudioDevice {
    deviceID: string
    displayName: string
    isActive: boolean
    isSystemDefault: boolean
    isCommsDefault: boolean
  }

  interface VoiceChatChannel {
    name: string
    channelID: number
    channelType: ChatChannelType
    clubId: string
    streamId: string
    volume: number
    isActive: boolean
    isMuted: boolean
    isTransmitting: boolean
    isTranscribing: boolean
    members: undefined[]
  }

  interface VoiceChatMember {
    energy: number
    memberID: number
    isActive: boolean
    isSpeaking: boolean
    isMutedForAll: boolean
    isSilenced: boolean
  }

  interface VoiceChatProcess {
    name: string
    channels: undefined[]
  }

  interface VoiceTtsVoiceType {
    voiceID: number
    name: string
  }

  interface CampaignChapterInfo {
    name: string
    description: string
    rewardQuestID: number
  }

  interface CampaignFailureReason {
    text: string
    questID: number | undefined
    mapID: number | undefined
  }

  interface CampaignInfo {
    name: string
    description: string
    uiTextureKit: string
    isWarCampaign: boolean
    usesNormalQuestIcons: boolean
    isContainerCampaign: boolean
    sortAsNormalQuest: boolean
  }

  interface ConquestWeeklyProgress {
    progress: number
    maxProgress: number
    displayType: ConquestProgressBarDisplayType
    unlocksCompleted: number
    maxUnlocks: number
    sampleItemHyperlink: string
  }

  interface WeeklyRewardActivityEncounterInfo {
    encounterID: number
    bestDifficulty: number
    uiOrder: number
    instanceID: number
  }

  interface WeeklyRewardActivityInfo {
    type: WeeklyRewardChestThresholdType
    index: number
    threshold: number
    progress: number
    id: number
    activityTierID: number
    level: number
    claimID: number | undefined
    raidString: string | undefined
    rewards: undefined[]
  }

  interface WeeklyRewardActivityRewardInfo {
    type: CachedRewardType
    id: number
    quantity: number
    itemDBID: string | undefined
  }

  interface WorldLootObjectInfo {
    inventoryType: InventoryType
    atMaxQuality: boolean
    isUpgrade: boolean
  }

  interface XMLTemplateInfo {
    type: string
    width: number
    height: number
    keyValues: undefined[]
    inherits: string | undefined
    sourceLocation: string
  }

  interface XMLTemplateKeyValue {
    key: string
    keyType: string
    type: string
    value: string
  }

  interface XMLTemplateListInfo {
    name: string
    type: string
  }

  interface ZoneAbilityInfo {
    zoneAbilityID: number
    uiPriority: number
    spellID: number
    textureKit: string
    tutorialText: string | undefined
  }
}

export {}
