/* eslint-disable @typescript-eslint/no-duplicate-enum-values */
/* eslint-disable @typescript-eslint/ban-types */
/** @noSelfInFile **/

declare global {
  function CanInspect(token: UnitToken, showError?: boolean): boolean
  function GetSpecializationRoleByID(
    specId: number
  ): 'DAMAGER' | 'TANK' | 'HEALER' | undefined
  function IsPlayerSpell(spellId: number): boolean
  function GetSpellCooldown(
    spellId: number
  ): LuaMultiReturn<[number, number, number, number]>
  function GetShapeshiftFormID(): number
  function UnitHasIncomingResurrection(token: string): boolean
  function CreateFrame<T extends FrameType>(
    type: T,
    name?: string,
    parent?: FrameGeneric<T>,
    template?: string,
    id?: number
  ): FrameGeneric<T>

  namespace C_AccountInfo {
    function GetIDFromBattleNetAccountGUID(battleNetAccountGUID: string): number

    function IsGUIDBattleNetAccountType(guid: string): boolean

    function IsGUIDRelatedToLocalAccount(guid: string): boolean
  }

  namespace C_AchievementInfo {
    function AreGuildAchievementsEnabled(): boolean

    function GetRewardItemID(achievementID: number): number | undefined

    function GetSupercedingAchievements(achievementID: number): number[]

    function IsGuildAchievement(achievementId: number): boolean

    function IsValidAchievement(achievementId: number): boolean

    function SetPortraitTexture(textureObject: Texture): void
  }

  namespace C_ActionBar {
    function EnableActionRangeCheck(actionID: number, enable: boolean): void

    function FindFlyoutActionButtons(flyoutID: number): number[]

    function FindPetActionButtons(petActionID: number): number[]

    function FindSpellActionButtons(spellID: number): number[]

    function GetBonusBarIndexForSlot(slotID: number): number | undefined

    function GetItemActionOnEquipSpellID(actionID: number): number | undefined

    function GetPetActionPetBarIndices(petActionID: number): number[]

    function GetProfessionQuality(actionID: number): number | undefined

    function GetSpell(actionID: number): number

    function HasFlyoutActionButtons(flyoutID: number): boolean

    function HasPetActionButtons(petActionID: number): boolean

    function HasPetActionPetBarIndices(petActionID: number): boolean

    function HasSpellActionButtons(spellID: number): boolean

    function IsAutoCastPetAction(slotID: number): boolean

    function IsEnabledAutoCastPetAction(slotID: number): boolean

    function IsHarmfulAction(actionID: number, useNeutral: boolean): boolean

    function IsHelpfulAction(actionID: number, useNeutral: boolean): boolean

    function IsOnBarOrSpecialBar(spellID: number): boolean

    function PutActionInSlot(slotID: number): void

    function ShouldOverrideBarShowHealthBar(): boolean

    function ShouldOverrideBarShowManaBar(): boolean

    function ToggleAutoCastPetAction(slotID: number): void
  }

  namespace C_AddOns {
    function DisableAddOn(name: string | number, character: string): void

    function DisableAllAddOns(character: string | undefined): void

    function DoesAddOnExist(name: string | number): boolean

    function EnableAddOn(name: string | number, character: string): void

    function EnableAllAddOns(character: string | undefined): void

    function GetAddOnDependencies(name: string | number): string

    function GetAddOnEnableState(
      name: string | number,
      character: string
    ): AddOnEnableState

    function GetAddOnInfo(
      name: string | number
    ): LuaMultiReturn<
      [
        name: string,
        title: string,
        notes: string,
        loadable: boolean,
        reason: string,
        security: string,
        updateAvailable: boolean
      ]
    >

    function GetAddOnMetadata(name: string | number, variable: string): string

    function GetAddOnOptionalDependencies(name: string | number): string

    function GetNumAddOns(): number

    function GetScriptsDisallowedForBeta(): boolean

    function IsAddOnLoadOnDemand(name: string | number): boolean

    function IsAddOnLoadable(
      name: string | number,
      character: string,
      demandLoaded: boolean
    ): LuaMultiReturn<[loadable: boolean, reason: string]>

    function IsAddOnLoaded(
      name: string | number
    ): LuaMultiReturn<[loadedOrLoading: boolean, loaded: boolean]>

    function IsAddonVersionCheckEnabled(): boolean

    function LoadAddOn(
      name: string | number
    ): LuaMultiReturn<[loaded: boolean | undefined, value: string | undefined]>

    function ResetAddOns(): void

    function ResetDisabledAddOns(): void

    function SaveAddOns(): void

    function SetAddonVersionCheck(enabled: boolean): void
  }

  namespace C_AdventureMap {
    function GetAdventureMapTextureKit(): string
  }

  namespace C_AlliedRaces {
    function GetAllRacialAbilitiesFromID(raceID: number): undefined[]

    function GetRaceInfoByID(raceID: number): AlliedRaceInfo
  }

  namespace C_AnimaDiversion {
    function CloseUI(): void

    function GetAnimaDiversionNodes(): undefined[]

    function GetOriginPosition(): Vector2DMixin | undefined

    function GetReinforceProgress(): number

    function GetTextureKit(): string

    function OpenAnimaDiversionUI(): void

    function SelectAnimaNode(talentID: number, temporary: boolean): void
  }

  namespace C_ArdenwealdGardening {
    function GetGardenData(): ArdenwealdGardenData

    function IsGardenAccessible(): boolean
  }

  namespace C_AreaPoiInfo {
    function GetAreaPOIForMap(uiMapID: number): number[]

    function GetAreaPOIInfo(uiMapID: number, areaPoiID: number): AreaPOIInfo

    function GetAreaPOISecondsLeft(areaPoiID: number): number

    function GetDelvesForMap(uiMapID: number): number[]

    function GetDragonridingRacesForMap(uiMapID: number): number[]

    function GetEventsForMap(uiMapID: number): number[]

    function GetQuestHubsForMap(uiMapID: number): number[]

    function IsAreaPOITimed(
      areaPoiID: number
    ): LuaMultiReturn<[isTimed: boolean, hideTimerInTooltip: boolean | undefined]>
  }

  function AcceptArenaTeam(): void

  function ArenaTeamDisband(index: number): void

  function ArenaTeamInviteByName(index: number, target: string): void

  function ArenaTeamLeave(index: number): void

  function ArenaTeamSetLeaderByName(index: number, target: string): void

  function ArenaTeamUninviteByName(index: number, target: string): void

  function DeclineArenaTeam(): void

  namespace C_ArtifactUI {
    function AddPower(powerID: number): boolean

    function ApplyCursorRelicToSlot(relicSlotIndex: number): void

    function CanApplyArtifactRelic(relicItemID: number, onlyUnlocked: boolean): boolean

    function CanApplyCursorRelicToSlot(relicSlotIndex: number): boolean

    function CanApplyRelicItemIDToEquippedArtifactSlot(
      relicItemID: number,
      relicSlotIndex: number
    ): boolean

    function CanApplyRelicItemIDToSlot(
      relicItemID: number,
      relicSlotIndex: number
    ): boolean

    function CheckRespecNPC(): boolean

    function Clear(): void

    function ClearForgeCamera(): void

    function ConfirmRespec(): void

    function DoesEquippedArtifactHaveAnyRelicsSlotted(): boolean

    function GetAppearanceInfo(
      appearanceSetIndex: number,
      appearanceIndex: number
    ): LuaMultiReturn<
      [
        artifactAppearanceID: number,
        appearanceName: string,
        displayIndex: number,
        unlocked: boolean,
        failureDescription: string | undefined,
        uiCameraID: number,
        altHandCameraID: number | undefined,
        swatchColorR: number,
        swatchColorG: number,
        swatchColorB: number,
        modelOpacity: number,
        modelSaturation: number,
        obtainable: boolean
      ]
    >

    function GetAppearanceInfoByID(
      artifactAppearanceID: number
    ): LuaMultiReturn<
      [
        artifactAppearanceSetID: number,
        artifactAppearanceID: number,
        appearanceName: string,
        displayIndex: number,
        unlocked: boolean,
        failureDescription: string | undefined,
        uiCameraID: number,
        altHandCameraID: number | undefined,
        swatchColorR: number,
        swatchColorG: number,
        swatchColorB: number,
        modelOpacity: number,
        modelSaturation: number,
        obtainable: boolean
      ]
    >

    function GetAppearanceSetInfo(
      appearanceSetIndex: number
    ): LuaMultiReturn<
      [
        artifactAppearanceSetID: number,
        appearanceSetName: string,
        appearanceSetDescription: string,
        numAppearances: number
      ]
    >

    function GetArtifactArtInfo(): ArtifactArtInfo

    function GetArtifactInfo(): LuaMultiReturn<
      [
        itemID: number,
        altItemID: number | undefined,
        name: string,
        icon: number,
        xp: number,
        pointsSpent: number,
        quality: number,
        artifactAppearanceID: number,
        appearanceModID: number,
        itemAppearanceID: number | undefined,
        altItemAppearanceID: number | undefined,
        altOnTop: boolean,
        tier: string
      ]
    >

    function GetArtifactItemID(): number

    function GetArtifactTier(): string | undefined

    function GetArtifactXPRewardTargetInfo(
      artifactCategoryID: number
    ): LuaMultiReturn<[name: string, icon: number]>

    function GetCostForPointAtRank(rank: number, tier: string): number

    function GetEquippedArtifactArtInfo(): ArtifactArtInfo

    function GetEquippedArtifactInfo(): LuaMultiReturn<
      [
        itemID: number,
        altItemID: number | undefined,
        name: string,
        icon: number,
        xp: number,
        pointsSpent: number,
        quality: number,
        artifactAppearanceID: number,
        appearanceModID: number,
        itemAppearanceID: number | undefined,
        altItemAppearanceID: number | undefined,
        altOnTop: boolean,
        tier: string
      ]
    >

    function GetEquippedArtifactItemID(): number

    function GetEquippedArtifactNumRelicSlots(onlyUnlocked: boolean): number

    function GetEquippedArtifactRelicInfo(
      relicSlotIndex: number
    ): LuaMultiReturn<[name: string, icon: number, slotTypeName: string, link: string]>

    function GetEquippedRelicLockedReason(relicSlotIndex: number): string | undefined

    function GetForgeRotation(): LuaMultiReturn<
      [forgeRotationX: number, forgeRotationY: number, forgeRotationZ: number]
    >

    function GetItemLevelIncreaseProvidedByRelic(itemLinkOrID: string | number): number

    function GetMetaPowerInfo(): LuaMultiReturn<
      [spellID: number, powerCost: number, currentRank: number]
    >

    function GetNumAppearanceSets(): number

    function GetNumObtainedArtifacts(): number

    function GetNumRelicSlots(onlyUnlocked: boolean): number

    function GetPointsRemaining(): number

    function GetPowerHyperlink(powerID: number): string

    function GetPowerInfo(powerID: number): ArtifactPowerInfo

    function GetPowerLinks(powerID: number): number[]

    function GetPowers(): number[]

    function GetPowersAffectedByRelic(relicSlotIndex: number): number

    function GetPowersAffectedByRelicItemLink(relicItemInfo: string | number): number

    function GetPreviewAppearance(): number | undefined

    function GetRelicInfo(
      relicSlotIndex: number
    ): LuaMultiReturn<[name: string, icon: number, slotTypeName: string, link: string]>

    function GetRelicInfoByItemID(
      itemID: number
    ): LuaMultiReturn<[name: string, icon: number, slotTypeName: string, link: string]>

    function GetRelicLockedReason(relicSlotIndex: number): string | undefined

    function GetRelicSlotType(relicSlotIndex: number): string

    function GetRespecArtifactArtInfo(): ArtifactArtInfo

    function GetRespecArtifactInfo(): LuaMultiReturn<
      [
        itemID: number,
        altItemID: number | undefined,
        name: string,
        icon: number,
        xp: number,
        pointsSpent: number,
        quality: number,
        artifactAppearanceID: number,
        appearanceModID: number,
        itemAppearanceID: number | undefined,
        altItemAppearanceID: number | undefined,
        altOnTop: boolean,
        tier: string
      ]
    >

    function GetRespecCost(): number

    function GetTotalPowerCost(
      startingTrait: number,
      numTraits: number,
      artifactTier: string
    ): number

    function GetTotalPurchasedRanks(): number

    function IsArtifactDisabled(): boolean

    function IsArtifactItem(itemLocation: ItemLocationMixin): boolean

    function IsAtForge(): boolean

    function IsEquippedArtifactDisabled(): boolean

    function IsEquippedArtifactMaxed(): boolean

    function IsMaxedByRulesOrEffect(): boolean

    function IsPowerKnown(powerID: number): boolean

    function IsViewedArtifactEquipped(): boolean

    function SetAppearance(artifactAppearanceID: number): void

    function SetForgeCamera(): void

    function SetForgeRotation(
      forgeRotationX: number,
      forgeRotationY: number,
      forgeRotationZ: number
    ): void

    function SetPreviewAppearance(artifactAppearanceID: number): void

    function ShouldSuppressForgeRotation(): boolean
  }

  namespace C_AuctionHouse {
    function CalculateCommodityDeposit(
      itemID: number,
      duration: number,
      quantity: number
    ): number | undefined

    function CalculateItemDeposit(
      item: ItemLocationMixin,
      duration: number,
      quantity: number
    ): number | undefined

    function CanCancelAuction(ownedAuctionID: number): boolean

    function CancelAuction(ownedAuctionID: number): void

    function CancelCommoditiesPurchase(): void

    function CancelSell(): void

    function CloseAuctionHouse(): void

    function ConfirmCommoditiesPurchase(itemID: number, quantity: number): void

    function ConfirmPostCommodity(
      item: ItemLocationMixin,
      duration: number,
      quantity: number,
      unitPrice: number
    ): void

    function ConfirmPostItem(
      item: ItemLocationMixin,
      duration: number,
      quantity: number,
      bid: number | undefined,
      buyout: number | undefined
    ): void

    function FavoritesAreAvailable(): boolean

    function GetAuctionInfoByID(auctionID: number): AuctionInfo | undefined

    function GetAuctionItemSubClasses(classID: number): number[]

    function GetAvailablePostCount(item: ItemLocationMixin): number

    function GetBidInfo(bidIndex: number): BidInfo | undefined

    function GetBidType(bidTypeIndex: number): ItemKey | undefined

    function GetBids(): undefined[]

    function GetBrowseResults(): undefined[]

    function GetCancelCost(ownedAuctionID: number): number

    function GetCommoditySearchResultInfo(
      itemID: number,
      commoditySearchResultIndex: number
    ): CommoditySearchResultInfo | undefined

    function GetCommoditySearchResultsQuantity(itemID: number): number

    function GetExtraBrowseInfo(itemKey: ItemKey): number

    function GetFilterGroups(): undefined[]

    function GetItemCommodityStatus(item: ItemLocationMixin): ItemCommodityStatus

    function GetItemKeyFromItem(item: ItemLocationMixin): ItemKey

    function GetItemKeyInfo(
      itemKey: ItemKey,
      restrictQualityToFilter: boolean
    ): ItemKeyInfo | undefined

    function GetItemKeyRequiredLevel(itemKey: ItemKey): number

    function GetItemSearchResultInfo(
      itemKey: ItemKey,
      itemSearchResultIndex: number
    ): ItemSearchResultInfo | undefined

    function GetItemSearchResultsQuantity(itemKey: ItemKey): number

    function GetMaxBidItemBid(): number | undefined

    function GetMaxBidItemBuyout(): number | undefined

    function GetMaxCommoditySearchResultPrice(itemID: number): number | undefined

    function GetMaxItemSearchResultBid(itemKey: ItemKey): number | undefined

    function GetMaxItemSearchResultBuyout(itemKey: ItemKey): number | undefined

    function GetMaxOwnedAuctionBid(): number | undefined

    function GetMaxOwnedAuctionBuyout(): number | undefined

    function GetNumBidTypes(): number

    function GetNumBids(): number

    function GetNumCommoditySearchResults(itemID: number): number

    function GetNumItemSearchResults(itemKey: ItemKey): number

    function GetNumOwnedAuctionTypes(): number

    function GetNumOwnedAuctions(): number

    function GetNumReplicateItems(): number

    function GetOwnedAuctionInfo(ownedAuctionIndex: number): OwnedAuctionInfo | undefined

    function GetOwnedAuctionType(ownedAuctionTypeIndex: number): ItemKey | undefined

    function GetOwnedAuctions(): undefined[]

    function GetQuoteDurationRemaining(): number

    function GetReplicateItemBattlePetInfo(
      index: number
    ): LuaMultiReturn<[creatureID: number, displayID: number]>

    function GetReplicateItemInfo(
      index: number
    ): LuaMultiReturn<
      [
        name: string | undefined,
        texture: number | undefined,
        count: number,
        qualityID: number,
        usable: boolean | undefined,
        level: number,
        levelType: string | undefined,
        minBid: number,
        minIncrement: number,
        buyoutPrice: number,
        bidAmount: number,
        highBidder: string | undefined,
        bidderFullName: string | undefined,
        owner: string | undefined,
        ownerFullName: string | undefined,
        saleStatus: number,
        itemID: number,
        hasAllInfo: boolean | undefined
      ]
    >

    function GetReplicateItemLink(index: number): string | undefined

    function GetReplicateItemTimeLeft(index: number): number

    function GetTimeLeftBandInfo(
      timeLeftBand: AuctionHouseTimeLeftBand
    ): LuaMultiReturn<[timeLeftMinSeconds: number, timeLeftMaxSeconds: number]>

    function HasFavorites(): boolean

    function HasFullBidResults(): boolean

    function HasFullBrowseResults(): boolean

    function HasFullCommoditySearchResults(itemID: number): boolean

    function HasFullItemSearchResults(itemKey: ItemKey): boolean

    function HasFullOwnedAuctionResults(): boolean

    function HasMaxFavorites(): boolean

    function HasSearchResults(itemKey: ItemKey): boolean

    function IsFavoriteItem(itemKey: ItemKey): boolean

    function IsSellItemValid(item: ItemLocationMixin, displayError: boolean): boolean

    function IsThrottledMessageSystemReady(): boolean

    function MakeItemKey(
      itemID: number,
      itemLevel: number,
      itemSuffix: number,
      battlePetSpeciesID: number
    ): ItemKey

    function PlaceBid(auctionID: number, bidAmount: number): void

    function PostCommodity(
      item: ItemLocationMixin,
      duration: number,
      quantity: number,
      unitPrice: number
    ): boolean

    function PostItem(
      item: ItemLocationMixin,
      duration: number,
      quantity: number,
      bid: number | undefined,
      buyout: number | undefined
    ): boolean

    function QueryBids(sorts: undefined[], auctionIDs: number[]): void

    function QueryOwnedAuctions(sorts: undefined[]): void

    function RefreshCommoditySearchResults(itemID: number): void

    function RefreshItemSearchResults(
      itemKey: ItemKey,
      minLevelFilter: number | undefined,
      maxLevelFilter: number | undefined
    ): void

    function ReplicateItems(): void

    function RequestFavorites(): void

    function RequestMoreBrowseResults(): void

    function RequestMoreCommoditySearchResults(itemID: number): boolean

    function RequestMoreItemSearchResults(itemKey: ItemKey): boolean

    function RequestOwnedAuctionBidderInfo(auctionID: number): string

    function SearchForFavorites(sorts: undefined[]): void

    function SearchForItemKeys(itemKeys: undefined[], sorts: undefined[]): void

    function SendBrowseQuery(query: AuctionHouseBrowseQuery): void

    function SendSearchQuery(
      itemKey: ItemKey,
      sorts: undefined[],
      separateOwnerItems: boolean,
      minLevelFilter: number,
      maxLevelFilter: number
    ): void

    function SendSellSearchQuery(
      itemKey: ItemKey,
      sorts: undefined[],
      separateOwnerItems: boolean
    ): void

    function SetFavoriteItem(itemKey: ItemKey, setFavorite: boolean): void

    function StartCommoditiesPurchase(itemID: number, quantity: number): void
  }

  namespace C_AzeriteEmpoweredItem {
    function CanSelectPower(
      azeriteEmpoweredItemLocation: ItemLocationMixin,
      powerID: number
    ): boolean

    function ConfirmAzeriteEmpoweredItemRespec(
      azeriteEmpoweredItemLocation: ItemLocationMixin
    ): void

    function GetAllTierInfo(azeriteEmpoweredItemLocation: ItemLocationMixin): undefined[]

    function GetAllTierInfoByItemID(
      itemInfo: string | number,
      classID: number | undefined
    ): undefined[]

    function GetAzeriteEmpoweredItemRespecCost(): number

    function GetPowerInfo(powerID: number): AzeriteEmpoweredItemPowerInfo

    function GetPowerText(
      azeriteEmpoweredItemLocation: ItemLocationMixin,
      powerID: number,
      level: AzeritePowerLevel
    ): AzeriteEmpoweredItemPowerText

    function GetSpecsForPower(powerID: number): undefined[]

    function HasAnyUnselectedPowers(
      azeriteEmpoweredItemLocation: ItemLocationMixin
    ): boolean

    function HasBeenViewed(azeriteEmpoweredItemLocation: ItemLocationMixin): boolean

    function IsAzeriteEmpoweredItem(itemLocation: ItemLocationMixin): boolean

    function IsAzeriteEmpoweredItemByID(itemInfo: string | number): boolean

    function IsAzeritePreviewSourceDisplayable(
      itemInfo: string | number,
      classID: number | undefined
    ): boolean

    function IsHeartOfAzerothEquipped(): boolean

    function IsPowerAvailableForSpec(powerID: number, specID: number): boolean

    function IsPowerSelected(
      azeriteEmpoweredItemLocation: ItemLocationMixin,
      powerID: number
    ): boolean

    function SelectPower(
      azeriteEmpoweredItemLocation: ItemLocationMixin,
      powerID: number
    ): boolean

    function SetHasBeenViewed(azeriteEmpoweredItemLocation: ItemLocationMixin): void
  }

  namespace C_AzeriteEssence {
    function ActivateEssence(essenceID: number, milestoneID: number): void

    function CanActivateEssence(essenceID: number, milestoneID: number): boolean

    function CanDeactivateEssence(milestoneID: number): boolean

    function CanOpenUI(): boolean

    function ClearPendingActivationEssence(): void

    function CloseForge(): void

    function GetEssenceHyperlink(essenceID: number, rank: number): string

    function GetEssenceInfo(essenceID: number): AzeriteEssenceInfo

    function GetEssences(): undefined[]

    function GetMilestoneEssence(milestoneID: number): number

    function GetMilestoneInfo(milestoneID: number): AzeriteMilestoneInfo

    function GetMilestoneSpell(milestoneID: number): number

    function GetMilestones(): undefined[]

    function GetNumUnlockedEssences(): number

    function GetNumUsableEssences(): number

    function GetPendingActivationEssence(): number

    function HasNeverActivatedAnyEssences(): boolean

    function HasPendingActivationEssence(): boolean

    function IsAtForge(): boolean

    function SetPendingActivationEssence(essenceID: number): void

    function UnlockMilestone(milestoneID: number): void
  }

  namespace C_AzeriteItem {
    function FindActiveAzeriteItem(): ItemLocationMixin

    function GetAzeriteItemXPInfo(
      azeriteItemLocation: ItemLocationMixin
    ): LuaMultiReturn<[xp: number, totalLevelXP: number]>

    function GetPowerLevel(azeriteItemLocation: ItemLocationMixin): number

    function GetUnlimitedPowerLevel(azeriteItemLocation: ItemLocationMixin): number

    function HasActiveAzeriteItem(): boolean

    function IsAzeriteItem(itemLocation: ItemLocationMixin): boolean

    function IsAzeriteItemAtMaxLevel(): boolean

    function IsAzeriteItemByID(itemInfo: string | number): boolean

    function IsAzeriteItemEnabled(azeriteItemLocation: ItemLocationMixin): boolean

    function IsUnlimitedLevelingUnlocked(): boolean
  }

  namespace C_Bank {
    function AutoDepositItemsIntoBank(bankType: BankType): void

    function CanDepositMoney(bankType: BankType): boolean

    function CanPurchaseBankTab(bankType: BankType): boolean

    function CanUseBank(bankType: BankType): boolean

    function CanViewBank(bankType: BankType): boolean

    function CanWithdrawMoney(bankType: BankType): boolean

    function CloseBankFrame(): void

    function DepositMoney(bankType: BankType, amount: number): void

    function FetchDepositedMoney(bankType: BankType): number

    function FetchNextPurchasableBankTabCost(bankType: BankType): number | undefined

    function FetchNumPurchasedBankTabs(bankType: BankType): number

    function FetchPurchasedBankTabData(bankType: BankType): undefined[]

    function FetchPurchasedBankTabIDs(bankType: BankType): undefined[]

    function HasMaxBankTabs(bankType: BankType): boolean

    function IsItemAllowedInBankType(
      bankType: BankType,
      itemLocation: ItemLocationMixin
    ): boolean

    function PurchaseBankTab(bankType: BankType): void

    function UpdateBankTabSettings(
      bankType: BankType,
      tabID: BagIndex,
      tabName: string,
      tabIcon: string,
      depositFlags: BagSlotFlags
    ): void

    function WithdrawMoney(bankType: BankType, amount: number): void
  }

  namespace C_BarberShop {
    function ApplyCustomizationChoices(): boolean

    function Cancel(): void

    function ClearPreviewChoices(clearSavedChoices: boolean): void

    function GetAvailableCustomizations(): undefined[]

    function GetCurrentCameraZoom(): number

    function GetCurrentCharacterData(): PlayerInfoCharacterData

    function GetCurrentCost(): number

    function GetCustomizationScope(): number

    function GetViewingChrModel(): number | undefined

    function HasAnyChanges(): boolean

    function IsViewingAlteredForm(): boolean

    function MarkCustomizationChoiceAsSeen(choiceID: number): void

    function MarkCustomizationOptionAsSeen(optionID: number): void

    function PreviewCustomizationChoice(optionID: number, choiceID: number): void

    function RandomizeCustomizationChoices(): void

    function ResetCameraRotation(): void

    function ResetCustomizationChoices(): void

    function RotateCamera(diffDegrees: number): void

    function SaveSeenChoices(): void

    function SetCameraDistanceOffset(offset: number): void

    function SetCameraZoomLevel(
      zoomLevel: number,
      keepCustomZoom: boolean | undefined
    ): void

    function SetCustomizationChoice(optionID: number, choiceID: number): void

    function SetModelDressState(dressedState: boolean): void

    function SetSelectedSex(sex: number): void

    function SetViewingAlteredForm(isViewingAlteredForm: boolean): void

    function SetViewingChrModel(chrModelID: number | undefined): void

    function SetViewingShapeshiftForm(shapeshiftFormID: number | undefined): void

    function ZoomCamera(zoomAmount: number): void
  }

  namespace C_BarberShopInternal {
    function SetQAMode(qaModeEnabled: boolean): void
  }

  namespace C_BattleNet {
    function GetAccountInfoByGUID(guid: string): BNetAccountInfo | undefined

    function GetAccountInfoByID(
      id: number,
      wowAccountGUID: string | undefined
    ): BNetAccountInfo | undefined

    function GetFriendAccountInfo(
      friendIndex: number,
      wowAccountGUID: string | undefined
    ): BNetAccountInfo | undefined

    function GetFriendGameAccountInfo(
      friendIndex: number,
      accountIndex: number
    ): BNetGameAccountInfo | undefined

    function GetFriendNumGameAccounts(friendIndex: number): number

    function GetGameAccountInfoByGUID(guid: string): BNetGameAccountInfo | undefined

    function GetGameAccountInfoByID(id: number): BNetGameAccountInfo | undefined
  }

  namespace C_BehavioralMessaging {
    function SendNotificationReceipt(
      dbId: string,
      openTimeSeconds: number,
      readTimeSeconds: number
    ): void
  }

  function GetBuildInfo(): LuaMultiReturn<
    [
      buildVersion: string,
      buildNumber: string,
      buildDate: string,
      interfaceVersion: number,
      localizedVersion: string,
      buildInfo: string
    ]
  >

  function Is64BitClient(): boolean

  function IsBetaBuild(): boolean

  function IsDebugBuild(): boolean

  function IsLinuxClient(): boolean

  function IsMacClient(): boolean

  function IsPublicBuild(): boolean

  function IsTestBuild(): boolean

  function IsWindowsClient(): boolean

  function SupportsClipCursor(): boolean

  namespace C_CVar {
    function GetCVar(name: string): string | undefined

    function GetCVarBitfield(name: string, index: number): boolean | undefined

    function GetCVarBool(name: string): boolean | undefined

    function GetCVarDefault(name: string): string | undefined

    function GetCVarInfo(
      name: string
    ): LuaMultiReturn<
      [
        value: string,
        defaultValue: string,
        isStoredServerAccount: boolean,
        isStoredServerCharacter: boolean,
        isLockedFromUser: boolean,
        isSecure: boolean,
        isReadOnly: boolean
      ]
    >

    function RegisterCVar(name: string, value: string | undefined): void

    function ResetTestCVars(): void

    function SetCVar(name: string, value: string | undefined): boolean

    function SetCVarBitfield(name: string, index: number, value: boolean): boolean
  }

  namespace C_Calendar {
    function AddEvent(): void

    function AreNamesReady(): boolean

    function CanAddEvent(): boolean

    function CanSendInvite(): boolean

    function CloseEvent(): void

    function ContextMenuEventCanComplain(
      offsetMonths: number,
      monthDay: number,
      eventIndex: number
    ): boolean

    function ContextMenuEventCanEdit(
      offsetMonths: number,
      monthDay: number,
      eventIndex: number
    ): boolean

    function ContextMenuEventCanRemove(
      offsetMonths: number,
      monthDay: number,
      eventIndex: number
    ): boolean

    function ContextMenuEventClipboard(): boolean

    function ContextMenuEventCopy(): void

    function ContextMenuEventGetCalendarType(): string | undefined

    function ContextMenuEventPaste(offsetMonths: number, monthDay: number): void

    function ContextMenuEventRemove(): void

    function ContextMenuEventSignUp(): void

    function ContextMenuGetEventIndex(): CalendarEventIndexInfo

    function ContextMenuInviteAvailable(): void

    function ContextMenuInviteDecline(): void

    function ContextMenuInviteRemove(): void

    function ContextMenuInviteTentative(): void

    function ContextMenuSelectEvent(
      offsetMonths: number,
      monthDay: number,
      eventIndex: number
    ): void

    function CreateCommunitySignUpEvent(): void

    function CreateGuildAnnouncementEvent(): void

    function CreateGuildSignUpEvent(): void

    function CreatePlayerEvent(): void

    function EventAvailable(): void

    function EventCanEdit(): boolean

    function EventClearAutoApprove(): void

    function EventClearLocked(): void

    function EventClearModerator(inviteIndex: number): void

    function EventDecline(): void

    function EventGetCalendarType(): string | undefined

    function EventGetClubId(): string | undefined

    function EventGetInvite(eventIndex: number): CalendarEventInviteInfo

    function EventGetInviteResponseTime(eventIndex: number): CalendarTime

    function EventGetInviteSortCriterion(): LuaMultiReturn<
      [criterion: string, reverse: boolean]
    >

    function EventGetSelectedInvite(): number | undefined

    function EventGetStatusOptions(eventIndex: number): undefined[]

    function EventGetTextures(eventType: CalendarEventType): undefined[]

    function EventGetTypes(): string[]

    function EventGetTypesDisplayOrdered(): undefined[]

    function EventHasPendingInvite(): boolean

    function EventHaveSettingsChanged(): boolean

    function EventInvite(name: string): void

    function EventRemoveInvite(inviteIndex: number): void

    function EventRemoveInviteByGuid(guid: string): void

    function EventSelectInvite(inviteIndex: number): void

    function EventSetAutoApprove(): void

    function EventSetClubId(clubId: string | undefined): void

    function EventSetDate(month: number, monthDay: number, year: number): void

    function EventSetDescription(description: string): void

    function EventSetInviteStatus(eventIndex: number, status: CalendarStatus): void

    function EventSetLocked(): void

    function EventSetModerator(inviteIndex: number): void

    function EventSetTextureID(textureIndex: number): void

    function EventSetTime(hour: number, minute: number): void

    function EventSetTitle(title: string): void

    function EventSetType(typeIndex: CalendarEventType): void

    function EventSignUp(): void

    function EventSortInvites(criterion: string, reverse: boolean): void

    function EventTentative(): void

    function GetClubCalendarEvents(
      clubId: string,
      startTime: CalendarTime,
      endTime: CalendarTime
    ): undefined[]

    function GetDayEvent(
      monthOffset: number,
      monthDay: number,
      index: number
    ): CalendarDayEvent

    function GetDefaultGuildFilter(): CalendarGuildFilterInfo

    function GetEventIndex(): CalendarEventIndexInfo

    function GetEventIndexInfo(
      eventID: string,
      monthOffset: number | undefined,
      monthDay: number | undefined
    ): CalendarEventIndexInfo | undefined

    function GetEventInfo(): CalendarEventInfo

    function GetFirstPendingInvite(
      offsetMonths: number,
      monthDay: number
    ): number | undefined

    function GetGuildEventInfo(index: number): CalendarGuildEventInfo

    function GetGuildEventSelectionInfo(index: number): CalendarEventIndexInfo

    function GetHolidayInfo(
      monthOffset: number,
      monthDay: number,
      index: number
    ): CalendarHolidayInfo

    function GetMaxCreateDate(): CalendarTime

    function GetMinDate(): CalendarTime

    function GetMonthInfo(offsetMonths: number): CalendarMonthInfo

    function GetNextClubId(): string | undefined

    function GetNumDayEvents(offsetMonths: number, monthDay: number): number

    function GetNumGuildEvents(): number

    function GetNumInvites(): number

    function GetNumPendingInvites(): number

    function GetRaidInfo(
      offsetMonths: number,
      monthDay: number,
      eventIndex: number
    ): CalendarRaidInfo

    function IsActionPending(): boolean

    function IsEventOpen(): boolean

    function MassInviteCommunity(
      clubId: string,
      minLevel: number,
      maxLevel: number,
      maxRankOrder: number | undefined
    ): void

    function MassInviteGuild(
      minLevel: number,
      maxLevel: number,
      maxRankOrder: number
    ): void

    function OpenCalendar(): void

    function OpenEvent(offsetMonths: number, monthDay: number, index: number): boolean

    function RemoveEvent(): void

    function SetAbsMonth(month: number, year: number): void

    function SetMonth(offsetMonths: number): void

    function SetNextClubId(clubId: string | undefined): void

    function UpdateEvent(): void
  }

  function GetCameraFOVDefaults(): LuaMultiReturn<
    [
      fieldOfViewDegreesDefault: number,
      fieldOfViewDegreesPlayerMin: number,
      fieldOfViewDegreesPlayerMax: number
    ]
  >

  function GetUICameraInfo(
    uiCameraID: number
  ): LuaMultiReturn<
    [
      posX: number,
      posY: number,
      posZ: number,
      lookAtX: number,
      lookAtY: number,
      lookAtZ: number,
      animID: number,
      animVariation: number,
      animFrame: number,
      useModelCenter: boolean
    ]
  >

  namespace C_ChallengeMode {
    function CanUseKeystoneInCurrentMap(itemLocation: ItemLocationMixin): boolean

    function ClearKeystone(): void

    function CloseKeystoneFrame(): void

    function GetActiveChallengeMapID(): number | undefined

    function GetActiveKeystoneInfo(): LuaMultiReturn<
      [
        activeKeystoneLevel: number,
        activeAffixIDs: number[],
        wasActiveKeystoneCharged: boolean
      ]
    >

    function GetAffixInfo(
      affixID: number
    ): LuaMultiReturn<[name: string, description: string, filedataid: number]>

    function GetCompletionInfo(): LuaMultiReturn<
      [
        mapChallengeModeID: number,
        level: number,
        time: number,
        onTime: boolean,
        keystoneUpgradeLevels: number,
        practiceRun: boolean,
        oldOverallDungeonScore: number | undefined,
        newOverallDungeonScore: number | undefined,
        IsMapRecord: boolean,
        IsAffixRecord: boolean,
        PrimaryAffix: number,
        isEligibleForScore: boolean,
        members: undefined[]
      ]
    >

    function GetDeathCount(): LuaMultiReturn<[numDeaths: number, timeLost: number]>

    function GetDungeonScoreRarityColor(dungeonScore: number): ColorMixin

    function GetGuildLeaders(): undefined[]

    function GetKeystoneLevelRarityColor(level: number): ColorMixin

    function GetMapScoreInfo(): undefined[]

    function GetMapTable(): number[]

    function GetMapUIInfo(
      mapChallengeModeID: number
    ): LuaMultiReturn<
      [
        name: string,
        id: number,
        timeLimit: number,
        texture: number | undefined,
        backgroundTexture: number
      ]
    >

    function GetOverallDungeonScore(): number

    function GetPowerLevelDamageHealthMod(
      powerLevel: number
    ): LuaMultiReturn<[damageMod: number, healthMod: number]>

    function GetSlottedKeystoneInfo(): LuaMultiReturn<
      [mapChallengeModeID: number, affixIDs: number[], keystoneLevel: number]
    >

    function GetSpecificDungeonOverallScoreRarityColor(
      specificDungeonOverallScore: number
    ): ColorMixin

    function GetSpecificDungeonScoreRarityColor(specificDungeonScore: number): ColorMixin

    function HasSlottedKeystone(): boolean

    function IsChallengeModeActive(): boolean

    function RemoveKeystone(): boolean

    function RequestLeaders(mapChallengeModeID: number): void

    function Reset(): void

    function SlotKeystone(): void

    function StartChallengeMode(): boolean
  }

  namespace C_ChatBubbles {
    function GetAllChatBubbles(includeForbidden: boolean): undefined[]
  }

  namespace C_ChatInfo {
    function CanPlayerSpeakLanguage(languageId: number): boolean

    function GetChannelInfoFromIdentifier(
      channelIdentifier: string
    ): ChatChannelInfo | undefined

    function GetChannelRosterInfo(
      channelIndex: number,
      rosterIndex: number
    ): LuaMultiReturn<[name: string, owner: boolean, moderator: boolean, guid: string]>

    function GetChannelRuleset(channelIndex: number): ChatChannelRuleset

    function GetChannelRulesetForChannelID(channelID: number): ChatChannelRuleset

    function GetChannelShortcut(channelIndex: number): string

    function GetChannelShortcutForChannelID(channelID: number): string

    function GetChatLineSenderGUID(chatLine: number): string

    function GetChatLineSenderName(chatLine: number): string

    function GetChatLineText(chatLine: number): string

    function GetChatTypeName(typeID: number): string | undefined

    function GetClubStreamIDs(clubID: string): string[]

    function GetColorForChatType(chatType: string): ColorMixin | undefined

    function GetGeneralChannelID(): number

    function GetGeneralChannelLocalID(): number | undefined

    function GetMentorChannelID(): number

    function GetNumActiveChannels(): number

    function GetNumReservedChatWindows(): number

    function GetRegisteredAddonMessagePrefixes(): string[]

    function IsAddonMessagePrefixRegistered(prefix: string): boolean

    function IsChannelRegional(channelIndex: number): boolean

    function IsChannelRegionalForChannelID(channelID: number): boolean

    function IsChatLineCensored(chatLine: number): boolean

    function IsPartyChannelType(channelType: ChatChannelType): boolean

    function IsRegionalServiceAvailable(): boolean

    function IsTimerunningPlayer(playerGUID: string): boolean

    function IsValidChatLine(chatLine: number | undefined): boolean

    function IsValidCombatFilterName(name: string): boolean

    function RegisterAddonMessagePrefix(prefix: string): RegisterAddonMessagePrefixResult

    function ReplaceIconAndGroupExpressions(
      input: string,
      noIconReplacement: boolean | undefined,
      noGroupReplacement: boolean | undefined
    ): string

    function RequestCanLocalWhisperTarget(whisperTarget: string): void

    function ResetDefaultZoneChannels(): void

    function SendAddonMessage(
      prefix: string,
      message: string,
      chatType: string | undefined,
      target: string | undefined
    ): SendAddonMessageResult

    function SendAddonMessageLogged(
      prefix: string,
      message: string,
      chatType: string | undefined,
      target: string | undefined
    ): SendAddonMessageResult | undefined

    function SwapChatChannelsByChannelIndex(
      firstChannelIndex: number,
      secondChannelIndex: number
    ): void

    function UncensorChatLine(chatLine: number): void
  }

  namespace C_ChromieTime {
    function CloseUI(): void

    function GetChromieTimeExpansionOption(
      expansionRecID: number
    ): ChromieTimeExpansionInfo | undefined

    function GetChromieTimeExpansionOptions(): undefined[]

    function SelectChromieTimeOption(chromieTimeExpansionInfoId: number): void
  }

  function CinematicFinished(
    movieType: CinematicType,
    userCanceled: boolean,
    didError: boolean
  ): void

  function CinematicStarted(
    movieType: CinematicType,
    movieID: number,
    canCancel: boolean
  ): void

  function InCinematic(): boolean

  function MouseOverrideCinematicDisable(doOverride: boolean): void

  function OpeningCinematic(): void

  function StopCinematic(): void

  namespace C_ClassColor {
    function GetClassColor(className: string): ColorMixin
  }

  namespace C_ClassTalents {
    function CanChangeTalents(): LuaMultiReturn<
      [canChange: boolean, canAdd: boolean, changeError: string | undefined]
    >

    function CanCreateNewConfig(): boolean

    function CanEditTalents(): LuaMultiReturn<[canEdit: boolean, changeError: string]>

    function CommitConfig(savedConfigID: number | undefined): boolean

    function DeleteConfig(configID: number): boolean

    function GetActiveConfigID(): number | undefined

    function GetActiveHeroTalentSpec(): number | undefined

    function GetConfigIDsBySpecID(specID: number | undefined): number[]

    function GetHasStarterBuild(): boolean

    function GetHeroTalentSpecsForClassSpec(
      configID: number | undefined,
      classSpecID: number | undefined
    ): LuaMultiReturn<
      [subTreeIDs: number[] | undefined, requiredPlayerLevel: number | undefined]
    >

    function GetLastSelectedSavedConfigID(specID: number): number | undefined

    function GetNextStarterBuildPurchase(): LuaMultiReturn<
      [nodeID: number | undefined, entryID: number | undefined]
    >

    function GetStarterBuildActive(): boolean

    function GetTraitTreeForSpec(specID: number): number | undefined

    function HasUnspentHeroTalentPoints(): LuaMultiReturn<
      [hasUnspentPoints: boolean, numHeroPoints: number]
    >

    function HasUnspentTalentPoints(): LuaMultiReturn<
      [hasUnspentPoints: boolean, numClassPoints: number, numSpecPoints: number]
    >

    function ImportLoadout(
      configID: number,
      entries: undefined[],
      name: string
    ): LuaMultiReturn<[success: boolean, importError: string]>

    function InitializeViewLoadout(specID: number, level: number): void

    function IsConfigPopulated(configID: number): boolean

    function LoadConfig(
      configID: number,
      autoApply: boolean
    ): LuaMultiReturn<
      [
        result: LoadConfigResult,
        changeError: string | undefined,
        newLearnedNodeIDs: number[]
      ]
    >

    function RenameConfig(configID: number, name: string): boolean

    function RequestNewConfig(name: string): boolean

    function SaveConfig(configID: number): boolean

    function SetStarterBuildActive(active: boolean): LoadConfigResult

    function SetUsesSharedActionBars(configID: number, usesShared: boolean): void

    function UpdateLastSelectedSavedConfigID(
      specID: number,
      configID: number | undefined
    ): void

    function ViewLoadout(entries: undefined[]): boolean
  }

  namespace C_ClickBindings {
    function CanSpellBeClickBound(spellID: number): boolean

    function ExecuteBinding(targetToken: string, button: string, modifiers: number): void

    function GetBindingType(button: string, modifiers: number): ClickBindingType

    function GetEffectiveInteractionButton(button: string, modifiers: number): string

    function GetProfileInfo(): undefined[]

    function GetStringFromModifiers(modifiers: number): string

    function GetTutorialShown(): boolean

    function MakeModifiers(): number

    function ResetCurrentProfile(): void

    function SetProfileByInfo(infoVec: undefined[]): void

    function SetTutorialShown(): void
  }

  function FlashClientIcon(): void

  function GetBillingTimeRested(): number

  function GetFileIDFromPath(filePath: string): number

  function GetFramerate(): number

  function ReportBug(description: string): void

  function ReportSuggestion(description: string): void

  function RestartGx(): void

  function Screenshot(): void

  function UpdateWindow(): void

  namespace C_Club {
    function AcceptInvitation(clubId: string): void

    function AddClubStreamChatChannel(clubId: string, streamId: string): void

    function AdvanceStreamViewMarker(clubId: string, streamId: string): void

    function AssignMemberRole(
      clubId: string,
      memberId: number,
      roleId: ClubRoleIdentifier
    ): void

    function CanResolvePlayerLocationFromClubMessageData(
      clubId: string,
      streamId: string,
      epoch: number,
      position: number
    ): boolean

    function ClearAutoAdvanceStreamViewMarker(): void

    function ClearClubPresenceSubscription(): void

    function CompareBattleNetDisplayName(
      clubId: string,
      lhsMemberId: number,
      rhsMemberId: number
    ): number

    function CreateClub(
      name: string,
      shortName: string | undefined,
      description: string,
      clubType: ClubType,
      avatarId: number,
      isCrossFaction: boolean | undefined
    ): void

    function CreateStream(
      clubId: string,
      name: string,
      subject: string,
      leadersAndModeratorsOnly: boolean
    ): void

    function CreateTicket(
      clubId: string,
      allowedRedeemCount: number | undefined,
      duration: number | undefined,
      defaultStreamId: string | undefined,
      isCrossFaction: boolean | undefined
    ): void

    function DeclineInvitation(clubId: string): void

    function DestroyClub(clubId: string): void

    function DestroyMessage(
      clubId: string,
      streamId: string,
      messageId: ClubMessageIdentifier
    ): void

    function DestroyStream(clubId: string, streamId: string): void

    function DestroyTicket(clubId: string, ticketId: string): void

    function DoesAnyCommunityHaveUnreadMessages(): boolean

    function DoesCommunityHaveMembersOfTheOppositeFaction(clubId: string): boolean

    function EditClub(
      clubId: string,
      name: string | undefined,
      shortName: string | undefined,
      description: string | undefined,
      avatarId: number | undefined,
      broadcast: string | undefined,
      crossFaction: boolean | undefined
    ): void

    function EditMessage(
      clubId: string,
      streamId: string,
      messageId: ClubMessageIdentifier,
      message: string
    ): void

    function EditStream(
      clubId: string,
      streamId: string,
      name: string | undefined,
      subject: string | undefined,
      leadersAndModeratorsOnly: boolean | undefined
    ): void

    function Flush(): void

    function FocusCommunityStreams(): void

    function FocusStream(clubId: string, streamId: string): boolean

    function GetAssignableRoles(clubId: string, memberId: number): undefined[]

    function GetAvatarIdList(clubType: ClubType): number[] | undefined

    function GetClubCapacity(): number

    function GetClubInfo(clubId: string): ClubInfo | undefined

    function GetClubLimits(clubType: ClubType): ClubLimits

    function GetClubMembers(clubId: string, streamId: string | undefined): number[]

    function GetClubPrivileges(clubId: string): ClubPrivilegeInfo

    function GetClubStreamNotificationSettings(clubId: string): undefined[]

    function GetCommunityNameResultText(result: ValidateNameResult): string | undefined

    function GetGuildClubId(): string | undefined

    function GetInfoFromLastCommunityChatLine(): LuaMultiReturn<
      [messageInfo: ClubMessageInfo, clubId: string, streamId: string, clubType: ClubType]
    >

    function GetInvitationCandidates(
      filter: string | undefined,
      maxResults: number | undefined,
      cursorPosition: number | undefined,
      allowFullMatch: boolean | undefined,
      clubId: string
    ): undefined[]

    function GetInvitationInfo(clubId: string): ClubSelfInvitationInfo | undefined

    function GetInvitationsForClub(clubId: string): undefined[]

    function GetInvitationsForSelf(): undefined[]

    function GetLastTicketResponse(
      ticket: string
    ): LuaMultiReturn<
      [error: ClubErrorType, info: ClubInfo | undefined, showError: boolean]
    >

    function GetMemberInfo(clubId: string, memberId: number): ClubMemberInfo | undefined

    function GetMemberInfoForSelf(clubId: string): ClubMemberInfo | undefined

    function GetMessageInfo(
      clubId: string,
      streamId: string,
      messageId: ClubMessageIdentifier
    ): ClubMessageInfo | undefined

    function GetMessageRanges(clubId: string, streamId: string): undefined[]

    function GetMessagesBefore(
      clubId: string,
      streamId: string,
      newest: ClubMessageIdentifier,
      count: number
    ): undefined[]

    function GetMessagesInRange(
      clubId: string,
      streamId: string,
      oldest: ClubMessageIdentifier,
      newest: ClubMessageIdentifier
    ): undefined[]

    function GetStreamInfo(clubId: string, streamId: string): ClubStreamInfo | undefined

    function GetStreamViewMarker(clubId: string, streamId: string): number | undefined

    function GetStreams(clubId: string): undefined[]

    function GetSubscribedClubs(): undefined[]

    function GetTickets(clubId: string): undefined[]

    function IsAccountMuted(clubId: string): boolean

    function IsBeginningOfStream(
      clubId: string,
      streamId: string,
      messageId: ClubMessageIdentifier
    ): boolean

    function IsEnabled(): boolean

    function IsRestricted(): ClubRestrictionReason

    function IsSubscribedToStream(clubId: string, streamId: string): boolean

    function KickMember(clubId: string, memberId: number): void

    function LeaveClub(clubId: string): void

    function RedeemTicket(ticketId: string): void

    function RequestInvitationsForClub(clubId: string): void

    function RequestMoreMessagesBefore(
      clubId: string,
      streamId: string,
      messageId: ClubMessageIdentifier | undefined,
      count: number | undefined
    ): boolean

    function RequestTicket(ticketId: string): void

    function RequestTickets(clubId: string): void

    function RevokeInvitation(clubId: string, memberId: number): void

    function SendBattleTagFriendRequest(guildClubId: string, memberId: number): void

    function SendCharacterInvitation(clubId: string, character: string): void

    function SendInvitation(clubId: string, memberId: number): void

    function SendMessage(clubId: string, streamId: string, message: string): void

    function SetAutoAdvanceStreamViewMarker(clubId: string, streamId: string): void

    function SetAvatarTexture(
      texture: Texture,
      avatarId: number,
      clubType: ClubType
    ): void

    function SetClubMemberNote(clubId: string, memberId: number, note: string): void

    function SetClubPresenceSubscription(clubId: string): void

    function SetClubStreamNotificationSettings(
      clubId: string,
      settings: undefined[]
    ): void

    function SetCommunityID(communityID: number): void

    function SetFavorite(clubId: string, isFavorite: boolean): void

    function SetSocialQueueingEnabled(clubId: string, enabled: boolean): void

    function ShouldAllowClubType(clubType: ClubType): boolean

    function UnfocusAllStreams(unsubscribe: boolean): void

    function UnfocusStream(clubId: string, streamId: string): void

    function ValidateText(
      clubType: ClubType,
      text: string,
      clubFieldType: ClubFieldType
    ): ValidateNameResult
  }

  namespace C_ClubFinder {
    function ApplicantAcceptClubInvite(clubFinderGUID: string): void

    function ApplicantDeclineClubInvite(clubFinderGUID: string): void

    function CancelMembershipRequest(clubFinderGUID: string): void

    function CheckAllPlayerApplicantSettings(): void

    function ClearAllFinderCache(): void

    function ClearClubApplicantsCache(): void

    function ClearClubFinderPostingsCache(): void

    function DoesPlayerBelongToClubFromClubGUID(clubFinderGUID: string): boolean

    function GetClubFinderDisableReason(): ClubFinderDisableReason | undefined

    function GetClubRecruitmentSettings(): ClubSettingsInfo

    function GetClubTypeFromFinderGUID(clubFinderGUID: string): ClubFinderRequestType

    function GetFocusIndexFromFlag(flags: number): number

    function GetPlayerApplicantLocaleFlags(): number

    function GetPlayerApplicantSettings(): ClubSettingsInfo

    function GetPlayerClubApplicationStatus(
      clubFinderGUID: string
    ): PlayerClubRequestStatus

    function GetPlayerSettingsFocusFlagsSelectedCount(): number

    function GetPostingIDFromClubFinderGUID(clubFinderGUID: string): number | undefined

    function GetRecruitingClubInfoFromClubID(
      clubId: string
    ): RecruitingClubInfo | undefined

    function GetRecruitingClubInfoFromFinderGUID(
      clubFinderGUID: string
    ): RecruitingClubInfo

    function GetStatusOfPostingFromClubId(postingID: string): undefined[]

    function GetTotalMatchingCommunityListSize(): number

    function GetTotalMatchingGuildListSize(): number

    function HasAlreadyAppliedToLinkedPosting(clubFinderGUID: string): boolean

    function HasPostingBeenDelisted(postingID: string): boolean

    function IsCommunityFinderEnabled(): boolean

    function IsEnabled(): boolean

    function IsListingEnabledFromFlags(flags: number): boolean

    function IsPostingBanned(postingID: string): boolean

    function LookupClubPostingFromClubFinderGUID(
      clubFinderGUID: string,
      isLinkedPosting: boolean
    ): void

    function PlayerGetClubInvitationList(): undefined[]

    function PlayerRequestPendingClubsList(type: ClubFinderRequestType): void

    function PlayerReturnPendingCommunitiesList(): undefined[]

    function PlayerReturnPendingGuildsList(): undefined[]

    function PostClub(
      clubId: string,
      itemLevelRequirement: number,
      name: string,
      description: string,
      avatarId: number,
      specs: number[],
      type: ClubFinderRequestType,
      crossFaction: boolean
    ): boolean

    function RequestApplicantList(type: ClubFinderRequestType): void

    function RequestClubsList(
      guildListRequested: boolean,
      searchString: string,
      specIDs: number[]
    ): void

    function RequestMembershipToClub(
      clubFinderGUID: string,
      comment: string,
      specIDs: number[]
    ): void

    function RequestNextCommunityPage(startingIndex: number, pageSize: number): void

    function RequestNextGuildPage(startingIndex: number, pageSize: number): void

    function RequestPostingInformationFromClubId(clubId: string): boolean

    function RequestSubscribedClubPostingIDs(): void

    function ResetClubPostingMapCache(): void

    function RespondToApplicant(
      clubFinderGUID: string,
      playerGUID: string,
      shouldAccept: boolean,
      requestType: ClubFinderRequestType,
      playerName: string,
      forceAccept: boolean,
      reported: boolean | undefined
    ): void

    function ReturnClubApplicantList(clubId: string): undefined[]

    function ReturnMatchingCommunityList(): undefined[]

    function ReturnMatchingGuildList(): undefined[]

    function ReturnPendingClubApplicantList(clubId: string): undefined[]

    function SendChatWhisper(
      clubFinderGUID: string,
      playerGUID: string,
      applicantType: ClubFinderRequestType,
      name: string
    ): void

    function SetAllRecruitmentSettings(value: number): void

    function SetPlayerApplicantLocaleFlags(localeFlags: number): void

    function SetPlayerApplicantSettings(index: number, checked: boolean): void

    function SetRecruitmentLocale(locale: number): void

    function SetRecruitmentSettings(index: number, checked: boolean): void

    function ShouldShowClubFinder(): boolean
  }

  namespace C_Commentator {
    function AddPlayerOverrideName(playerName: string, overrideName: string): void

    function AddTrackedDefensiveAuras(spellIDs: number[]): void

    function AddTrackedOffensiveAuras(spellIDs: number[]): void

    function AreTeamsSwapped(): boolean

    function AssignPlayerToTeam(playerName: string, teamName: string): void

    function AssignPlayersToTeam(playerName: string[], teamName: string): void

    function AssignPlayersToTeamInCurrentInstance(
      teamIndex: number,
      teamName: string
    ): void

    function CanUseCommentatorCheats(): boolean

    function ClearCameraTarget(): void

    function ClearFollowTarget(): void

    function ClearLookAtTarget(lookAtIndex: number | undefined): void

    function EnterInstance(): void

    function ExitInstance(): void

    function FindSpectatedUnit(
      unitToken: UnitToken
    ): LuaMultiReturn<[playerIndex: number, teamIndex: number, isPet: boolean]>

    function FindTeamNameInCurrentInstance(teamIndex: number): string | undefined

    function FindTeamNameInDirectory(playerNames: string[]): string | undefined

    function FlushCommentatorHistory(): void

    function FollowPlayer(
      factionIndex: number,
      playerIndex: number,
      forceInstantTransition: boolean | undefined
    ): void

    function FollowUnit(token: string): void

    function ForceFollowTransition(): void

    function GetAdditionalCameraWeight(): LuaMultiReturn<
      [teamIndex: number, playerIndex: number]
    >

    function GetAdditionalCameraWeightByToken(unitToken: UnitToken): number

    function GetAllPlayerOverrideNames(): undefined[]

    function GetCamera(): LuaMultiReturn<
      [
        xPos: number,
        yPos: number,
        zPos: number,
        yaw: number,
        pitch: number,
        roll: number,
        fov: number
      ]
    >

    function GetCameraCollision(): boolean

    function GetCameraPosition(): LuaMultiReturn<
      [xPos: number, yPos: number, zPos: number]
    >

    function GetCommentatorHistory(): CommentatorHistory

    function GetCurrentMapID(): number | undefined

    function GetDampeningPercent(): number

    function GetDistanceBeforeForcedHorizontalConvergence(): number

    function GetDurationToForceHorizontalConvergence(): number

    function GetExcludeDistance(): number

    function GetHardlockWeight(): number

    function GetHorizontalAngleThresholdToSmooth(): number

    function GetIndirectSpellID(trackedSpellID: number): number

    function GetInstanceInfo(
      mapIndex: number,
      instanceIndex: number
    ): LuaMultiReturn<
      [
        mapID: number,
        mapName: string | undefined,
        status: number,
        instanceIDLow: number,
        instanceIDHigh: number
      ]
    >

    function GetLookAtLerpAmount(): number

    function GetMapInfo(
      mapIndex: number
    ): LuaMultiReturn<
      [teamSize: number, minLevel: number, maxLevel: number, numInstances: number]
    >

    function GetMatchDuration(): number

    function GetMaxNumPlayersPerTeam(): number

    function GetMaxNumTeams(): number

    function GetMode(): number

    function GetMsToHoldForHorizontalMovement(): number

    function GetMsToHoldForVerticalMovement(): number

    function GetMsToSmoothHorizontalChange(): number

    function GetMsToSmoothVerticalChange(): number

    function GetNumMaps(): number

    function GetNumPlayers(factionIndex: number): number

    function GetOrCreateSeries(teamName1: string, teamName2: string): CommentatorSeries

    function GetPlayerAuraInfo(
      teamIndex: number,
      playerIndex: number,
      spellID: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: boolean]>

    function GetPlayerAuraInfoByUnit(
      token: UnitToken,
      spellID: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: boolean]>

    function GetPlayerCooldownInfo(
      teamIndex: number,
      playerIndex: number,
      spellID: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: boolean]>

    function GetPlayerCooldownInfoByUnit(
      unitToken: UnitToken,
      spellID: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: boolean]>

    function GetPlayerCrowdControlInfo(
      teamIndex: number,
      playerIndex: number
    ): LuaMultiReturn<[spellID: number, expiration: number, duration: number]>

    function GetPlayerCrowdControlInfoByUnit(
      token: UnitToken
    ): LuaMultiReturn<[spellID: number, expiration: number, duration: number]>

    function GetPlayerData(
      teamIndex: number,
      playerIndex: number
    ): CommentatorPlayerData | undefined

    function GetPlayerFlagInfo(teamIndex: number, playerIndex: number): boolean

    function GetPlayerFlagInfoByUnit(unitToken: UnitToken): boolean

    function GetPlayerItemCooldownInfo(
      teamIndex: number,
      playerIndex: number,
      itemID: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: boolean]>

    function GetPlayerItemCooldownInfoByUnit(
      unitToken: UnitToken,
      itemID: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: boolean]>

    function GetPlayerOverrideName(originalName: string): string

    function GetPlayerSpellCharges(
      teamIndex: number,
      playerIndex: number,
      spellID: number
    ): LuaMultiReturn<
      [charges: number, maxCharges: number, startTime: number, duration: number]
    >

    function GetPlayerSpellChargesByUnit(
      unitToken: UnitToken,
      spellID: number
    ): LuaMultiReturn<
      [charges: number, maxCharges: number, startTime: number, duration: number]
    >

    function GetPositionLerpAmount(): number

    function GetSmoothFollowTransitioning(): boolean

    function GetSoftlockWeight(): number

    function GetSpeedFactor(): number

    function GetStartLocation(mapID: number): Vector3DMixin

    function GetTeamColor(teamIndex: number): ColorMixin

    function GetTeamColorByUnit(unitToken: UnitToken): ColorMixin

    function GetTimeLeftInMatch(): number | undefined

    function GetTrackedSpellID(indirectSpellID: number): number

    function GetTrackedSpells(
      teamIndex: number,
      playerIndex: number,
      category: TrackedSpellCategory
    ): number[] | undefined

    function GetTrackedSpellsByUnit(
      unitToken: UnitToken,
      category: TrackedSpellCategory
    ): number[] | undefined

    function GetUnitData(unitToken: UnitToken): CommentatorUnitData

    function GetWargameInfo(
      listID: number
    ): LuaMultiReturn<
      [name: string, minPlayers: number, maxPlayers: number, isArena: boolean]
    >

    function HasTrackedAuras(
      token: UnitToken
    ): LuaMultiReturn<[hasOffensiveAura: boolean, hasDefensiveAura: boolean]>

    function IsSmartCameraLocked(): boolean

    function IsSpectating(): boolean

    function IsTrackedDefensiveAura(spellID: number): boolean

    function IsTrackedOffensiveAura(spellID: number): boolean

    function IsTrackedSpell(
      teamIndex: number,
      playerIndex: number,
      spellID: number,
      category: TrackedSpellCategory
    ): boolean

    function IsTrackedSpellByUnit(
      unitToken: UnitToken,
      spellID: number,
      category: TrackedSpellCategory
    ): boolean

    function IsUsingSmartCamera(): boolean

    function LookAtPlayer(
      factionIndex: number,
      playerIndex: number,
      lookAtIndex: number | undefined
    ): void

    function RemoveAllOverrideNames(): void

    function RemovePlayerOverrideName(originalPlayerName: string): void

    function RequestPlayerCooldownInfo(teamIndex: number, playerIndex: number): void

    function ResetFoVTarget(): void

    function ResetSeriesScores(teamName1: string, teamName2: string): void

    function ResetSettings(): void

    function ResetTrackedAuras(): void

    function SetAdditionalCameraWeight(
      teamIndex: number,
      playerIndex: number,
      weight: number
    ): void

    function SetAdditionalCameraWeightByToken(unitToken: UnitToken, weight: number): void

    function SetBlocklistedAuras(spellIDs: number[]): void

    function SetBlocklistedCooldowns(specID: number, spellIDs: number[]): void

    function SetBlocklistedItemCooldowns(itemIDs: number[]): void

    function SetCamera(
      xPos: number,
      yPos: number,
      zPos: number,
      yaw: number,
      pitch: number,
      roll: number,
      fov: number
    ): void

    function SetCameraCollision(collide: boolean): void

    function SetCameraPosition(
      xPos: number,
      yPos: number,
      zPos: number,
      snapToLocation: boolean
    ): void

    function SetCheatsEnabled(enableCheats: boolean): void

    function SetCommentatorHistory(history: CommentatorHistory): void

    function SetDistanceBeforeForcedHorizontalConvergence(distance: number): void

    function SetDurationToForceHorizontalConvergence(ms: number): void

    function SetExcludeDistance(excludeDistance: number): void

    function SetFollowCameraSpeeds(elasticSpeed: number, minSpeed: number): void

    function SetHardlockWeight(weight: number): void

    function SetHorizontalAngleThresholdToSmooth(angle: number): void

    function SetLookAtLerpAmount(amount: number): void

    function SetMapAndInstanceIndex(mapIndex: number, instanceIndex: number): void

    function SetMouseDisabled(disabled: boolean): void

    function SetMoveSpeed(newSpeed: number): void

    function SetMsToHoldForHorizontalMovement(ms: number): void

    function SetMsToHoldForVerticalMovement(ms: number): void

    function SetMsToSmoothHorizontalChange(ms: number): void

    function SetMsToSmoothVerticalChange(ms: number): void

    function SetPositionLerpAmount(amount: number): void

    function SetRequestedDebuffCooldowns(specID: number, spellIDs: number[]): void

    function SetRequestedDefensiveCooldowns(specID: number, spellIDs: number[]): void

    function SetRequestedItemCooldowns(itemIDs: number[]): void

    function SetRequestedOffensiveCooldowns(specID: number, spellIDs: number[]): void

    function SetSeriesScore(
      teamName1: string,
      teamName2: string,
      scoringTeamName: string,
      score: number
    ): void

    function SetSeriesScores(
      teamName1: string,
      teamName2: string,
      score1: number,
      score2: number
    ): void

    function SetSmartCameraLocked(locked: boolean): void

    function SetSmoothFollowTransitioning(enabled: boolean): void

    function SetSoftlockWeight(weight: number): void

    function SetSpeedFactor(factor: number): void

    function SetTargetHeightOffset(offset: number): void

    function SetUseSmartCamera(useSmartCamera: boolean): void

    function SnapCameraLookAtPoint(): void

    function StartWargame(
      listID: number,
      teamSize: number,
      tournamentRules: boolean,
      teamOneCaptain: string,
      teamTwoCaptain: string
    ): void

    function SwapTeamSides(): void

    function ToggleCheats(): void

    function UpdateMapInfo(targetPlayer: string | undefined): void

    function UpdatePlayerInfo(): void

    function ZoomIn(): void

    function ZoomIn_Position(zoomAmount: number | undefined): void

    function ZoomOut(): void

    function ZoomOut_Position(zoomAmount: number | undefined): void
  }

  namespace C_ConfigurationWarnings {
    function GetConfigurationWarningSeen(
      configurationWarning: ConfigurationWarning
    ): boolean

    function GetConfigurationWarningString(
      configurationWarning: ConfigurationWarning
    ): string

    function GetConfigurationWarnings(includeSeenWarnings: boolean): undefined[]

    function SetConfigurationWarningSeen(configurationWarning: ConfigurationWarning): void
  }

  function CancelLogout(): void

  function ForceLogout(): void

  function ForceQuit(): void

  function GetNetIpTypes(): string

  function GetNetStats(): LuaMultiReturn<
    [inValue: number, out: number, latencyList: number]
  >

  function GetRealmID(): number

  function GetRealmName(): string

  function IsOnTournamentRealm(): boolean

  function Logout(): void

  function Quit(): void

  function SelectedRealmName(): string

  function CalculateStringEditDistance(firstString: string, secondString: string): number

  function ConsoleAddMessage(message: string): void

  function ConsoleExec(command: string, addToHistory: boolean): boolean

  function ConsoleGetAllCommands(): undefined[]

  function ConsoleGetColorFromType(colorType: ConsoleColorType): ColorMixin

  function ConsoleGetFontHeight(): number

  function ConsoleIsActive(): boolean

  function ConsolePrintAllMatchingCommands(partialCommandText: string): void

  function ConsoleSetFontHeight(fontHeightInPixels: number): void

  function SetConsoleKey(keystring: string): void

  namespace C_ConsoleScriptCollection {
    function GetCollectionDataByID(
      collectionID: number
    ): ConsoleScriptCollectionData | undefined

    function GetCollectionDataByTag(
      collectionTag: string
    ): ConsoleScriptCollectionData | undefined

    function GetElements(collectionID: number): undefined[]

    function GetScriptData(consoleScriptID: number): ConsoleScriptData
  }

  namespace C_Container {
    function ContainerIDToInventoryID(containerID: BagIndex): number

    function ContainerRefundItemPurchase(
      containerIndex: BagIndex,
      slotIndex: number,
      isEquipped: boolean
    ): void

    function GetBackpackAutosortDisabled(): boolean

    function GetBackpackSellJunkDisabled(): boolean

    function GetBagName(bagIndex: BagIndex): string

    function GetBagSlotFlag(bagIndex: BagIndex, flag: BagSlotFlags): boolean

    function GetBankAutosortDisabled(): boolean

    function GetContainerFreeSlots(containerIndex: BagIndex): number[]

    function GetContainerItemCooldown(
      containerIndex: BagIndex,
      slotIndex: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: number]>

    function GetContainerItemDurability(
      containerIndex: BagIndex,
      slotIndex: number
    ): LuaMultiReturn<[durability: number, maxDurability: number]>

    function GetContainerItemEquipmentSetInfo(
      containerIndex: BagIndex,
      slotIndex: number
    ): LuaMultiReturn<[inSet: boolean, setList: string]>

    function GetContainerItemID(containerIndex: BagIndex, slotIndex: number): number

    function GetContainerItemInfo(
      containerIndex: BagIndex,
      slotIndex: number
    ): ContainerItemInfo

    function GetContainerItemLink(containerIndex: BagIndex, slotIndex: number): string

    function GetContainerItemPurchaseCurrency(
      containerIndex: BagIndex,
      slotIndex: number,
      itemIndex: number,
      isEquipped: boolean
    ): ItemPurchaseCurrency

    function GetContainerItemPurchaseInfo(
      containerIndex: BagIndex,
      slotIndex: number,
      isEquipped: boolean
    ): ItemPurchaseInfo

    function GetContainerItemPurchaseItem(
      containerIndex: BagIndex,
      slotIndex: number,
      itemIndex: number,
      isEquipped: boolean
    ): ItemPurchaseItem

    function GetContainerItemQuestInfo(
      containerIndex: BagIndex,
      slotIndex: number
    ): ItemQuestInfo

    function GetContainerNumFreeSlots(
      bagIndex: BagIndex
    ): LuaMultiReturn<[numFreeSlots: number, bagFamily: number | undefined]>

    function GetContainerNumSlots(containerIndex: BagIndex): number

    function GetInsertItemsLeftToRight(): boolean

    function GetItemCooldown(
      itemID: number
    ): LuaMultiReturn<[startTime: number, duration: number, enable: number]>

    function GetMaxArenaCurrency(): number

    function GetSortBagsRightToLeft(): boolean

    function IsBattlePayItem(containerIndex: BagIndex, slotIndex: number): boolean

    function IsContainerFiltered(containerIndex: BagIndex): boolean

    function PickupContainerItem(containerIndex: BagIndex, slotIndex: number): void

    function PlayerHasHearthstone(): number | undefined

    function SetBackpackAutosortDisabled(disable: boolean): void

    function SetBackpackSellJunkDisabled(disable: boolean): void

    function SetBagPortraitTexture(texture: Texture, bagIndex: BagIndex): void

    function SetBagSlotFlag(bagIndex: BagIndex, flag: BagSlotFlags, isSet: boolean): void

    function SetBankAutosortDisabled(disable: boolean): void

    function SetInsertItemsLeftToRight(enable: boolean): void

    function SetItemSearch(searchString: string): void

    function SetSortBagsRightToLeft(enable: boolean): void

    function ShowContainerSellCursor(containerIndex: BagIndex, slotIndex: number): void

    function SocketContainerItem(containerIndex: BagIndex, slotIndex: number): boolean

    function SortAccountBankBags(): void

    function SortBags(): void

    function SortBankBags(): void

    function SortReagentBankBags(): void

    function SplitContainerItem(
      containerIndex: BagIndex,
      slotIndex: number,
      amount: number
    ): void

    function UseContainerItem(
      containerIndex: BagIndex,
      slotIndex: number,
      unitToken: UnitToken | undefined,
      bankType: BankType | undefined,
      reagentBankOpen: boolean
    ): void

    function UseHearthstone(): boolean
  }

  namespace C_ContentTracking {
    function GetBestMapForTrackable(
      trackableType: ContentTrackingType,
      trackableID: number,
      ignoreWaypoint: boolean
    ): LuaMultiReturn<[result: ContentTrackingResult, mapID: number | undefined]>

    function GetCollectableSourceTrackingEnabled(): boolean

    function GetCollectableSourceTypes(): undefined[]

    function GetCurrentTrackingTarget(
      type: ContentTrackingType,
      id: number
    ): LuaMultiReturn<[targetType: ContentTrackingTargetType, targetID: number]>

    function GetEncounterTrackingInfo(journalEncounterID: number): EncounterTrackingInfo

    function GetNextWaypointForTrackable(
      trackableType: ContentTrackingType,
      trackableID: number,
      uiMapID: number
    ): LuaMultiReturn<
      [result: ContentTrackingResult, mapInfo: ContentTrackingMapInfo | undefined]
    >

    function GetObjectiveText(
      targetType: ContentTrackingTargetType,
      targetID: number,
      includeHyperlinks: boolean
    ): string

    function GetTitle(trackableType: ContentTrackingType, trackableID: number): string

    function GetTrackablesOnMap(
      trackableType: ContentTrackingType,
      uiMapID: number
    ): LuaMultiReturn<[result: ContentTrackingResult, trackableMapInfos: undefined[]]>

    function GetTrackedIDs(trackableType: ContentTrackingType): number[]

    function GetVendorTrackingInfo(collectableEntryID: number): VendorTrackingInfo

    function GetWaypointText(
      trackableType: ContentTrackingType,
      trackableID: number
    ): string

    function IsNavigable(
      trackableType: ContentTrackingType,
      trackableID: number
    ): LuaMultiReturn<[result: ContentTrackingResult, isNavigable: boolean]>

    function IsTrackable(type: ContentTrackingType, id: number): boolean

    function IsTracking(type: ContentTrackingType, id: number): boolean

    function StartTracking(
      type: ContentTrackingType,
      id: number
    ): ContentTrackingError | undefined

    function StopTracking(
      type: ContentTrackingType,
      id: number,
      stopType: ContentTrackingStopType
    ): void

    function ToggleTracking(
      type: ContentTrackingType,
      id: number,
      stopType: ContentTrackingStopType
    ): ContentTrackingError | undefined
  }

  namespace C_ContributionCollector {
    function Close(): void

    function Contribute(contributionID: number): void

    function GetActive(): number

    function GetAtlases(contributionID: number): string[]

    function GetBuffs(contributionID: number): number

    function GetContributionAppearance(
      contributionID: number,
      contributionState: ContributionState
    ): ContributionAppearance | undefined

    function GetContributionCollectorsForMap(uiMapID: number): undefined[]

    function GetContributionResult(contributionID: number): ContributionResult

    function GetDescription(contributionID: number): string

    function GetManagedContributionsForCreatureID(creatureID: number): number

    function GetName(contributionID: number): string

    function GetOrderIndex(contributionID: number): number

    function GetRequiredContributionCurrency(
      contributionID: number
    ): LuaMultiReturn<[currencyID: number, currencyAmount: number]>

    function GetRequiredContributionItem(
      contributionID: number
    ): LuaMultiReturn<[itemID: number, itemCount: number]>

    function GetRewardQuestID(contributionID: number): number

    function GetState(
      contributionID: number
    ): LuaMultiReturn<
      [
        contributionState: ContributionState,
        contributionPercentageComplete: number,
        timeOfNextStateChange: number | undefined,
        startTime: number
      ]
    >

    function HasPendingContribution(contributionID: number): boolean

    function IsAwaitingRewardQuestData(contributionID: number): boolean
  }

  namespace C_CovenantCallings {
    function AreCallingsUnlocked(): boolean

    function RequestCallings(): void
  }

  namespace C_CovenantPreview {
    function CloseFromUI(): void

    function GetCovenantInfoForPlayerChoiceResponseID(
      playerChoiceResponseID: number
    ): CovenantPreviewInfo
  }

  namespace C_CovenantSanctumUI {
    function CanAccessReservoir(): boolean

    function CanDepositAnima(): boolean

    function DepositAnima(): void

    function EndInteraction(): void

    function GetAnimaInfo(): LuaMultiReturn<
      [currencyID: number, maxDisplayableValue: number]
    >

    function GetCurrentTalentTreeID(): number | undefined

    function GetFeatures(): undefined[]

    function GetRenownLevel(): number

    function GetRenownLevels(covenantID: number): undefined[]

    function GetRenownRewardsForLevel(
      covenantID: number,
      renownLevel: number
    ): undefined[]

    function GetSanctumType(): GarrTalentFeatureSubtype | undefined

    function GetSoulCurrencies(): number[]

    function HasMaximumRenown(): boolean

    function IsPlayerInRenownCatchUpMode(): boolean

    function IsWeeklyRenownCapped(): boolean

    function RequestCatchUpState(): void
  }

  namespace C_Covenants {
    function GetActiveCovenantID(): number

    function GetCovenantData(covenantID: number): CovenantData | undefined

    function GetCovenantIDs(): number[]
  }

  namespace C_CraftingOrders {
    function AreOrderNotesDisabled(): boolean

    function CalculateCraftingOrderPostingFee(
      skillLineAbilityID: number,
      orderType: CraftingOrderType,
      orderDuration: CraftingOrderDuration
    ): number

    function CanOrderSkillAbility(skillLineAbilityID: number): boolean

    function CancelOrder(orderID: number): void

    function ClaimOrder(orderID: number, profession: Profession): void

    function CloseCrafterCraftingOrders(): void

    function CloseCustomerCraftingOrders(): void

    function FulfillOrder(
      orderID: number,
      crafterNote: string,
      profession: Profession
    ): void

    function GetClaimedOrder(): CraftingOrderInfo | undefined

    function GetCrafterBuckets(): undefined[]

    function GetCrafterOrders(): undefined[]

    function GetCraftingOrderTime(): number

    function GetCustomerCategories(): undefined[]

    function GetCustomerOptions(
      params: CraftingOrderCustomerSearchParams
    ): CraftingOrderCustomerSearchResults

    function GetCustomerOrders(): undefined[]

    function GetDefaultOrdersSkillLine(): number | undefined

    function GetMyOrders(): undefined[]

    function GetNumFavoriteCustomerOptions(): number

    function GetOrderClaimInfo(profession: Profession): CraftingOrderClaimsRemainingInfo

    function GetPersonalOrdersInfo(): undefined[]

    function HasFavoriteCustomerOptions(): boolean

    function IsCustomerOptionFavorited(recipeID: number): boolean

    function ListMyOrders(request: CraftingOrderRequestMyOrdersInfo): void

    function OpenCrafterCraftingOrders(): void

    function OpenCustomerCraftingOrders(): void

    function OrderCanBeRecrafted(orderID: number): boolean

    function ParseCustomerOptions(): void

    function PlaceNewOrder(orderInfo: NewCraftingOrderInfo): void

    function RejectOrder(
      orderID: number,
      crafterNote: string,
      profession: Profession
    ): void

    function ReleaseOrder(orderID: number, profession: Profession): void

    function RequestCrafterOrders(request: CraftingOrderRequestInfo): void

    function RequestCustomerOrders(request: CraftingOrderRequestInfo): void

    function SetCustomerOptionFavorited(recipeID: number, favorited: boolean): void

    function ShouldShowCraftingOrderTab(): boolean

    function SkillLineHasOrders(skillLineID: number): boolean

    function UpdateIgnoreList(): void
  }

  namespace C_CreatureInfo {
    function GetClassInfo(classID: number): ClassInfo | undefined

    function GetFactionInfo(raceID: number): FactionInfo | undefined

    function GetRaceInfo(raceID: number): RaceInfo | undefined
  }

  namespace C_CurrencyInfo {
    function CanTransferCurrency(
      currencyID: number
    ): LuaMultiReturn<
      [
        canTransferCurrency: boolean,
        failureReason: AccountCurrencyTransferResult | undefined
      ]
    >

    function DoesWarModeBonusApply(
      currencyID: number
    ): LuaMultiReturn<
      [warModeApplies: boolean | undefined, limitOncePerTooltip: boolean | undefined]
    >

    function ExpandCurrencyList(index: number, expand: boolean): void

    function FetchCurrencyDataFromAccountCharacters(currencyID: number): undefined[]

    function FetchCurrencyTransferTransactions(): undefined[]

    function GetAzeriteCurrencyID(): number

    function GetBackpackCurrencyInfo(index: number): BackpackCurrencyInfo

    function GetBasicCurrencyInfo(
      currencyType: number,
      quantity: number | undefined
    ): CurrencyDisplayInfo

    function GetCoinIcon(amount: number): number

    function GetCoinText(amount: number, separator: string): string

    function GetCoinTextureString(amount: number, fontHeight: number): string

    function GetCostToTransferCurrency(
      currencyID: number,
      quantity: number
    ): number | undefined

    function GetCurrencyContainerInfo(
      currencyType: number,
      quantity: number
    ): CurrencyDisplayInfo

    function GetCurrencyDescription(type: number): string

    function GetCurrencyIDFromLink(currencyLink: string): number

    function GetCurrencyInfo(type: number): CurrencyInfo

    function GetCurrencyInfoFromLink(link: string): CurrencyInfo

    function GetCurrencyLink(type: number, amount: number | undefined): string

    function GetCurrencyListInfo(index: number): CurrencyInfo

    function GetCurrencyListLink(index: number): string

    function GetCurrencyListSize(): number

    function GetDragonIslesSuppliesCurrencyID(): number

    function GetFactionGrantedByCurrency(currencyID: number): number | undefined

    function GetMaxTransferableAmountFromQuantity(
      currencyID: number,
      requestedQuantity: number
    ): number | undefined

    function GetWarResourcesCurrencyID(): number

    function IsAccountCharacterCurrencyDataReady(): boolean

    function IsAccountTransferableCurrency(currencyID: number): boolean

    function IsAccountWideCurrency(currencyID: number): boolean

    function IsCurrencyContainer(currencyID: number, quantity: number): boolean

    function IsCurrencyTransferTransactionDataReady(): boolean

    function PickupCurrency(type: number): void

    function PlayerHasMaxQuantity(currencyID: number): boolean

    function PlayerHasMaxWeeklyQuantity(currencyID: number): boolean

    function RequestCurrencyDataForAccountCharacters(): void

    function RequestCurrencyFromAccountCharacter(
      sourceCharacterGUID: string,
      currencyID: number,
      quantity: number
    ): void

    function SetCurrencyBackpack(index: number, backpack: boolean): void

    function SetCurrencyUnused(index: number, unused: boolean): void
  }

  namespace C_Cursor {
    function GetCursorItem(): ItemLocationMixin
  }

  namespace C_DateAndTime {
    function AdjustTimeByDays(date: CalendarTime, days: number): CalendarTime

    function AdjustTimeByMinutes(date: CalendarTime, minutes: number): CalendarTime

    function AdjustTimeByMonths(date: CalendarTime, months: number): CalendarTime

    function CompareCalendarTime(
      lhsCalendarTime: CalendarTime,
      rhsCalendarTime: CalendarTime
    ): number

    function GetCalendarTimeFromEpoch(epoch: number): CalendarTime

    function GetCurrentCalendarTime(): CalendarTime

    function GetSecondsUntilDailyReset(): number

    function GetSecondsUntilWeeklyReset(): number

    function GetServerTimeLocal(): number

    function GetWeeklyResetStartTime(): number
  }

  namespace C_DeathInfo {
    function GetCorpseMapPosition(uiMapID: number): Vector2DMixin | undefined

    function GetDeathReleasePosition(uiMapID: number): Vector2DMixin | undefined

    function GetGraveyardsForMap(uiMapID: number): undefined[]

    function GetSelfResurrectOptions(): undefined[]

    function UseSelfResurrectOption(optionType: SelfResurrectOptionType, id: number): void
  }

  function GetDebugAnimationStats(
    unitGUID: UnitToken | undefined
  ): LuaMultiReturn<
    [
      upperBodyAnim: string,
      lowerBodyAnim: string,
      mountAnim: string,
      upperBodyPrimaryAnim: string,
      upperBodyPrimaryAnimVariation: number,
      upperBodySecondaryAnim: string,
      upperBodySecondaryAnimVariation: number,
      lowerBodyPrimaryAnim: string,
      lowerBodyPrimaryAnimVariation: number,
      lowerBodySecondaryAnim: string,
      lowerBodySecondaryAnimVariation: number,
      animKitID: number | undefined,
      mountAnimKitID: number | undefined
    ]
  >

  function GetDebugPerf(): string

  function GetDebugSpellEffects(): string

  function GetDebugStats(): string

  function GetDebugTargetCustomizationInfo(): string

  function GetDebugUnitInfo(unitGUID: string): void

  function ToggleAnimKitDisplay(): void

  function ToggleCollision(): void

  function ToggleCollisionDisplay(): void

  function ToggleDebugAIDisplay(): void

  function ToggleGravity(): void

  function TogglePlayerBounds(): void

  function TogglePortals(): void

  function ToggleTris(): void

  namespace C_DelvesUI {
    function GetCreatureDisplayInfoForCompanion(companionID: number | undefined): number

    function GetCurioNodeForCompanion(
      companionID: number | undefined,
      curioType: CurioType
    ): number

    function GetCurioRarityByTraitCondAccountElementID(
      traitCondAccountElementID: number
    ): CurioRarity

    function GetCurrentDelvesSeasonNumber(): number

    function GetDelvesAffixSpellsForSeason(): number[]

    function GetDelvesFactionForSeason(): number

    function GetDelvesMinRequiredLevel(): number | undefined

    function GetFactionForCompanion(companionID: number | undefined): number

    function GetModelSceneForCompanion(companionID: number | undefined): number

    function GetRoleNodeForCompanion(companionID: number | undefined): number

    function GetRoleSubtreeForCompanion(
      companionID: number | undefined,
      roleType: CompanionRoleType
    ): number

    function GetTraitTreeForCompanion(companionID: number | undefined): number

    function GetUnseenCuriosBySlotType(
      slotType: CompanionConfigSlotTypes,
      ownedCurioNodeIDs: number[]
    ): number[]

    function HasActiveDelve(mapID: number | undefined): boolean

    function IsEligibleForActiveDelveRewards(unit: UnitToken): boolean

    function SaveSeenCuriosBySlotType(
      slotType: CompanionConfigSlotTypes,
      ownedCurioNodeIDs: number[]
    ): void
  }

  namespace C_EditMode {
    function ConvertLayoutInfoToString(layoutInfo: EditModeLayoutInfo): string

    function ConvertStringToLayoutInfo(layoutInfoAsString: string): EditModeLayoutInfo

    function GetAccountSettings(): undefined[]

    function GetLayouts(): EditModeLayouts

    function OnEditModeExit(): void

    function OnLayoutAdded(
      addedLayoutIndex: number,
      activateNewLayout: boolean,
      isLayoutImported: boolean
    ): void

    function OnLayoutDeleted(deletedLayoutIndex: number): void

    function SaveLayouts(saveInfo: EditModeLayouts): void

    function SetAccountSetting(setting: EditModeAccountSetting, value: number): void

    function SetActiveLayout(activeLayout: number): void
  }

  namespace C_EncounterJournal {
    function GetDungeonEntrancesForMap(uiMapID: number): undefined[]

    function GetEncounterJournalLink(
      linkType: JournalLinkTypes,
      ID: number,
      displayText: string,
      difficultyID: number
    ): string

    function GetEncountersOnMap(uiMapID: number): undefined[]

    function GetInstanceForGameMap(mapID: number): number | undefined

    function GetLootInfo(id: number): EncounterJournalItemInfo

    function GetLootInfoByIndex(
      index: number,
      encounterIndex: number | undefined
    ): EncounterJournalItemInfo

    function GetSectionIconFlags(sectionID: number): number[] | undefined

    function GetSectionInfo(sectionID: number): EncounterJournalSectionInfo

    function GetSlotFilter(): ItemSlotFilterType

    function InitalizeSelectedTier(): void

    function InstanceHasLoot(instanceID: number | undefined): boolean

    function IsEncounterComplete(journalEncounterID: number): boolean

    function OnClose(): void

    function OnOpen(): void

    function ResetSlotFilter(): void

    function SetPreviewMythicPlusLevel(level: number): void

    function SetPreviewPvpTier(tier: number): void

    function SetSlotFilter(filterSlot: ItemSlotFilterType): void

    function SetTab(tabIdx: number): void
  }

  namespace C_EquipmentSet {
    function AssignSpecToEquipmentSet(equipmentSetID: number, specIndex: number): void

    function CanUseEquipmentSets(): boolean

    function ClearIgnoredSlotsForSave(): void

    function CreateEquipmentSet(equipmentSetName: string, icon: string | undefined): void

    function DeleteEquipmentSet(equipmentSetID: number): void

    function EquipmentSetContainsLockedItems(equipmentSetID: number): boolean

    function GetEquipmentSetAssignedSpec(equipmentSetID: number): number

    function GetEquipmentSetForSpec(specIndex: number): number

    function GetEquipmentSetID(equipmentSetName: string): number

    function GetEquipmentSetIDs(): number[]

    function GetEquipmentSetInfo(
      equipmentSetID: number
    ): LuaMultiReturn<
      [
        name: string,
        iconFileID: number,
        setID: number,
        isEquipped: boolean,
        numItems: number,
        numEquipped: number,
        numInInventory: number,
        numLost: number,
        numIgnored: number
      ]
    >

    function GetIgnoredSlots(equipmentSetID: number): boolean[]

    function GetItemIDs(equipmentSetID: number): number[]

    function GetItemLocations(equipmentSetID: number): number[]

    function GetNumEquipmentSets(): number

    function IgnoreSlotForSave(slot: number): void

    function IsSlotIgnoredForSave(slot: number): boolean

    function ModifyEquipmentSet(
      equipmentSetID: number,
      newName: string,
      newIcon: string | undefined
    ): void

    function PickupEquipmentSet(equipmentSetID: number): void

    function SaveEquipmentSet(equipmentSetID: number, icon: string | undefined): void

    function UnassignEquipmentSetSpec(equipmentSetID: number): void

    function UnignoreSlotForSave(slot: number): void

    function UseEquipmentSet(equipmentSetID: number): boolean
  }

  namespace C_EventUtils {
    function IsEventValid(eventName: string): boolean

    function NotifySettingsLoaded(): void
  }

  function CanUpgradeExpansion(): boolean

  function DoesCurrentLocaleSellExpansionLevels(): boolean

  function GetAccountExpansionLevel(): number

  function GetClientDisplayExpansionLevel(): number

  function GetCurrentRegionName(): string

  function GetExpansionDisplayInfo(
    expansionLevel: number
  ): ExpansionDisplayInfo | undefined

  function GetExpansionForLevel(playerLevel: number): number

  function GetExpansionLevel(): number

  function GetExpansionTrialInfo(): LuaMultiReturn<
    [isExpansionTrialAccount: boolean, expansionTrialRemainingSeconds: number | undefined]
  >

  function GetMaxLevelForExpansionLevel(expansionLevel: number): number

  function GetMaxLevelForLatestExpansion(): number

  function GetMaxLevelForPlayerExpansion(): number

  function GetMaximumExpansionLevel(): number

  function GetMinimumExpansionLevel(): number

  function GetNumExpansions(): number

  function GetServerExpansionLevel(): number

  function IsDemonHunterAvailable(): boolean

  function IsExpansionTrial(): boolean

  function IsTrialAccount(): boolean

  function IsVeteranTrialAccount(): boolean

  function SendSubscriptionInterstitialResponse(
    response: SubscriptionInterstitialResponseType
  ): void

  function ClassicExpansionAtLeast(expansionLevel: number): boolean

  function GetClassicExpansionLevel(): number

  namespace C_ExpansionTrial {
    function OnTrialLevelUpDialogClicked(): void

    function OnTrialLevelUpDialogShown(): void
  }

  namespace C_FogOfWar {
    function GetFogOfWarForMap(uiMapID: number): number | undefined

    function GetFogOfWarInfo(fogOfWarID: number): FogOfWarInfo | undefined
  }

  function GetFontInfo(fontObject: FontInfo): FontScriptInfo | undefined

  function GetFonts(): string[]

  function CreateWindow(popupStyle: boolean): unknown | undefined

  function GetCallstackHeight(): number

  function GetCurrentEventID(): number | undefined

  function GetErrorCallstackHeight(): number | undefined

  function GetEventTime(
    eventProfileIndex: number
  ): LuaMultiReturn<
    [
      totalElapsedTime: number,
      numExecutedHandlers: number,
      slowestHandlerName: string,
      slowestHandlerTime: number
    ]
  >

  function RunScript(text: string): void

  function SetErrorCallstackHeight(height: number | undefined): void

  namespace C_FriendList {
    function AddFriend(name: string, notes: string | undefined): void

    function AddIgnore(name: string): boolean

    function AddOrDelIgnore(name: string): void

    function AddOrRemoveFriend(name: string, notes: string): void

    function DelIgnore(name: string): boolean

    function DelIgnoreByIndex(index: number): void

    function GetFriendInfo(name: string): FriendInfo

    function GetFriendInfoByIndex(index: number): FriendInfo

    function GetIgnoreName(index: number): string | undefined

    function GetNumFriends(): number

    function GetNumIgnores(): number

    function GetNumOnlineFriends(): number

    function GetNumWhoResults(): LuaMultiReturn<[numWhos: number, totalNumWhos: number]>

    function GetSelectedFriend(): number | undefined

    function GetSelectedIgnore(): number | undefined

    function GetWhoInfo(index: number): WhoInfo

    function IsFriend(guid: string): boolean

    function IsIgnored(token: string): boolean

    function IsIgnoredByGuid(guid: string): boolean

    function IsOnIgnoredList(token: string): boolean

    function RemoveFriend(name: string): boolean

    function RemoveFriendByIndex(index: number): void

    function SendWho(filter: string, origin: number | undefined): void

    function SetFriendNotes(name: string, notes: string): boolean

    function SetFriendNotesByIndex(index: number, notes: string): void

    function SetSelectedFriend(index: number): void

    function SetSelectedIgnore(index: number): void

    function SetWhoToUi(whoToUi: boolean): void

    function ShowFriends(): void

    function SortWho(sorting: string): void
  }

  function ClearCursor(): void

  function ClearCursorHoveredItem(): void

  function CursorHasItem(): boolean

  function CursorHasMacro(): boolean

  function CursorHasMoney(): boolean

  function CursorHasSpell(): boolean

  function DeleteCursorItem(): void

  function DropCursorMoney(): void

  function EquipCursorItem(slot: number): void

  function GetCursorInfo(): void

  function GetCursorMoney(): number

  function PickupPlayerMoney(amount: number): void

  function ResetCursor(): void

  function SellCursorItem(): void

  function SetCursor(name: string | undefined): boolean

  function SetCursorHoveredItem(item: ItemLocationMixin): void

  function SetCursorHoveredItemTradeItem(enabled: boolean): void

  function SetCursorVirtualItem(itemInfo: string | number, cursorType: UICursorType): void

  namespace C_GameEnvironmentManager {
    function GetCurrentEventRealmQueues(): EventRealmQueues

    function GetCurrentGameEnvironment(): GameEnvironment

    function RequestGameEnvironment(gameEnvironment: GameEnvironment): void
  }

  function GetGameMessageInfo(
    gameErrorIndex: number
  ): LuaMultiReturn<
    [errorName: string, soundKitID: number | undefined, voiceID: number | undefined]
  >

  function NotWhileDeadError(): void

  namespace C_GameModeManager {
    function GetCurrentGameMode(): string
  }

  namespace C_GamePad {
    function AddSDLMapping(platform: ClientPlatformType, mapping: string): boolean

    function ApplyConfigs(): void

    function AxisIndexToConfigName(axisIndex: number): string | undefined

    function ButtonBindingToIndex(bindingName: string): number | undefined

    function ButtonIndexToBinding(buttonIndex: number): string | undefined

    function ButtonIndexToConfigName(buttonIndex: number): string | undefined

    function ClearLedColor(): void

    function DeleteConfig(configID: GamePadConfigID): void

    function GetActiveDeviceID(): number

    function GetAllConfigIDs(): undefined[]

    function GetAllDeviceIDs(): number[]

    function GetCombinedDeviceID(): number

    function GetConfig(configID: GamePadConfigID): GamePadConfig | undefined

    function GetDeviceMappedState(
      deviceID: number | undefined
    ): GamePadMappedState | undefined

    function GetDeviceRawState(deviceID: number): GamePadRawState | undefined

    function GetLedColor(): ColorMixin

    function GetPowerLevel(deviceID: number | undefined): GamePadPowerLevel

    function IsEnabled(): boolean

    function SetConfig(config: GamePadConfig): void

    function SetLedColor(color: ColorMixin): void

    function SetVibration(vibrationType: string, intensity: number): void

    function StickIndexToConfigName(stickIndex: number): string | undefined

    function StopVibration(): void
  }

  namespace C_GameRules {
    function GetGameRuleAsFloat(gameRule: number, decimalPlaces: number): number

    function IsGameRuleActive(gameRule: number): boolean
  }

  function SetInWorldUIVisibility(visible: boolean): void

  function SetUIVisibility(visible: boolean): void

  namespace C_Garrison {
    function AddFollowerToMission(
      missionID: number,
      followerID: number,
      boardIndex: number | undefined
    ): boolean

    function GetAutoCombatDamageClassValues(): undefined[]

    function GetAutoMissionBoardState(missionID: number): undefined[]

    function GetAutoMissionEnvironmentEffect(
      missionID: number
    ): AutoMissionEnvironmentEffect | undefined

    function GetAutoMissionTargetingInfo(
      missionID: number,
      followerID: number,
      casterBoardIndex: number
    ): undefined[]

    function GetAutoMissionTargetingInfoForSpell(
      missionID: number,
      autoCombatSpellID: number,
      casterBoardIndex: number
    ): undefined[]

    function GetAutoTroops(followerType: number): undefined[]

    function GetCombatLogSpellInfo(
      autoCombatSpellID: number
    ): AutoCombatSpellInfo | undefined

    function GetCurrentCypherEquipmentLevel(): number

    function GetCurrentGarrTalentTreeFriendshipFactionID(): number | undefined

    function GetCurrentGarrTalentTreeID(): number | undefined

    function GetCyphersToNextEquipmentLevel(): number | undefined

    function GetFollowerAutoCombatSpells(
      garrFollowerID: number,
      followerLevel: number
    ): LuaMultiReturn<
      [
        autoCombatSpells: undefined[],
        autoCombatAutoAttack: AutoCombatSpellInfo | undefined
      ]
    >

    function GetFollowerAutoCombatStats(
      garrFollowerID: number
    ): FollowerAutoCombatStatsInfo | undefined

    function GetFollowerMissionCompleteInfo(
      followerID: number
    ): FollowerMissionCompleteInfo

    function GetGarrisonPlotsInstancesForMap(uiMapID: number): undefined[]

    function GetGarrisonTalentTreeCurrencyTypes(
      garrTalentTreeID: number
    ): number | undefined

    function GetGarrisonTalentTreeType(garrTalentTreeID: number): number

    function GetMaxCypherEquipmentLevel(): number

    function GetMissionCompleteEncounters(missionID: number): undefined[]

    function GetMissionDeploymentInfo(missionID: number): MissionDeploymentInfo

    function GetMissionEncounterIconInfo(missionID: number): MissionEncounterIconInfo

    function GetTalentInfo(talentID: number): GarrisonTalentInfo

    function GetTalentPointsSpentInTalentTree(garrTalentTreeID: number): number

    function GetTalentTreeIDsByClassID(garrType: number, classID: number): number[]

    function GetTalentTreeInfo(treeID: number): GarrisonTalentTreeInfo

    function GetTalentTreeResetInfo(
      garrTalentTreeID: number
    ): LuaMultiReturn<[goldCost: number, currencyCosts: undefined[]]>

    function GetTalentTreeTalentPointResearchInfo(
      garrTalentID: number,
      researchRank: number,
      garrTalentTreeID: number,
      talentPointIndex: number,
      isRespec: number
    ): LuaMultiReturn<
      [goldCost: number, currencyCosts: undefined[], durationSecs: number]
    >

    function GetTalentUnlockWorldQuest(talentID: number): number

    function HasAdventures(): boolean

    function IsAtGarrisonMissionNPC(): boolean

    function IsEnvironmentCountered(missionID: number): boolean

    function IsFollowerOnCompletedMission(followerID: number): boolean

    function IsTalentConditionMet(
      talentID: number
    ): LuaMultiReturn<[isMet: boolean, failureString: string | undefined]>

    function RegenerateCombatLog(missionID: number): boolean

    function RemoveFollowerFromMission(
      missionID: number,
      followerID: number,
      boardIndex: number | undefined
    ): void

    function RushHealAllFollowers(followerType: number): void

    function RushHealFollower(garrFollowerID: number): void

    function SetAutoCombatSpellFastForward(state: boolean): void
  }

  function IsOnGlueScreen(): boolean

  namespace C_GossipInfo {
    function CloseGossip(): void

    function ForceGossip(): boolean

    function GetActiveDelveGossip(): GossipOptionUIInfo

    function GetActiveQuests(): undefined[]

    function GetAvailableQuests(): undefined[]

    function GetCompletedOptionDescriptionString(): string | undefined

    function GetCustomGossipDescriptionString(): string | undefined

    function GetFriendshipReputation(
      friendshipFactionID: number
    ): FriendshipReputationInfo

    function GetFriendshipReputationRanks(
      friendshipFactionID: number
    ): FriendshipReputationRankInfo

    function GetGossipDelveMapID(): number

    function GetNumActiveQuests(): number

    function GetNumAvailableQuests(): number

    function GetOptionUIWidgetSetsAndTypesByOptionID(
      gossipOptionID: number
    ): undefined[] | undefined

    function GetOptions(): undefined[]

    function GetPoiForUiMapID(uiMapID: number): number | undefined

    function GetPoiInfo(uiMapID: number, gossipPoiID: number): GossipPoiInfo | undefined

    function GetText(): string

    function RefreshOptions(): void

    function SelectActiveQuest(optionID: number): void

    function SelectAvailableQuest(optionID: number): void

    function SelectOption(
      optionID: number,
      text: string | undefined,
      confirmed: boolean | undefined
    ): void

    function SelectOptionByIndex(
      optionID: number,
      text: string | undefined,
      confirmed: boolean | undefined
    ): void
  }

  namespace C_GuildBank {
    function IsGuildBankEnabled(): boolean
  }

  namespace C_GuildInfo {
    function AreGuildEventsEnabled(): boolean

    function CanEditOfficerNote(): boolean

    function CanSpeakInGuildChat(): boolean

    function CanViewOfficerNote(): boolean

    function Demote(name: string): void

    function Disband(): void

    function GetGuildNewsInfo(index: number): GuildNewsInfo

    function GetGuildRankOrder(guid: string): number

    function GetGuildTabardInfo(unit: UnitToken | undefined): GuildTabardInfo | undefined

    function GuildControlGetRankFlags(rankOrder: number): boolean[]

    function GuildRoster(): void

    function Invite(name: string): void

    function IsEncounterGuildNewsEnabled(): boolean

    function IsGuildOfficer(): boolean

    function IsGuildRankAssignmentAllowed(guid: string, rankOrder: number): boolean

    function IsGuildReputationEnabled(): boolean

    function Leave(): void

    function MemberExistsByName(name: string): boolean

    function Promote(name: string): void

    function QueryGuildMemberRecipes(guildMemberGUID: string, skillLineID: number): void

    function QueryGuildMembersForRecipe(
      skillLineID: number,
      recipeSpellID: number,
      recipeLevel: number | undefined
    ): number

    function RemoveFromGuild(guid: string): void

    function SetGuildRankOrder(guid: string, rankOrder: number): void

    function SetLeader(name: string): void

    function SetMOTD(motd: string): void

    function SetNote(guid: string, note: string, isPublic: boolean): void

    function Uninvite(name: string): void
  }

  namespace C_HeirloomInfo {
    function AreAllCollectionFiltersChecked(): boolean

    function AreAllSourceFiltersChecked(): boolean

    function IsHeirloomSourceValid(source: number): boolean

    function IsUsingDefaultFilters(): boolean

    function SetAllCollectionFilters(checked: boolean): void

    function SetAllSourceFilters(checked: boolean): void

    function SetDefaultFilters(): void
  }

  namespace C_ImmersiveInteraction {
    function HasImmersiveInteraction(): boolean
  }

  namespace C_Navigation {
    function GetDistance(): number

    function GetFrame(): unknown | undefined

    function GetNearestPartyMemberToken(): string

    function GetTargetState(): NavigationState

    function HasValidScreenPosition(): boolean

    function WasClampedToScreen(): boolean
  }

  namespace C_IncomingSummon {
    function HasIncomingSummon(unit: UnitToken): boolean

    function IncomingSummonStatus(unit: UnitToken): SummonStatus
  }

  function GetCursorDelta(): LuaMultiReturn<[deltaX: number, deltaY: number]>

  function GetCursorPosition(): LuaMultiReturn<[posX: number, posY: number]>

  function GetMouseButtonClicked(): string

  function GetMouseButtonName(button: unknown): string

  function GetMouseFoci(): unknown[]

  function IsAltKeyDown(): boolean

  function IsControlKeyDown(): boolean

  function IsKeyDown(
    keyOrMouseName: string,
    excludeBindingState: boolean
  ): boolean | undefined

  function IsLeftAltKeyDown(): boolean

  function IsLeftControlKeyDown(): boolean

  function IsLeftMetaKeyDown(): boolean

  function IsLeftShiftKeyDown(): boolean

  function IsMetaKeyDown(): boolean

  function IsModifierKeyDown(): boolean

  function IsMouseButtonDown(button: unknown | undefined): boolean

  function IsRightAltKeyDown(): boolean

  function IsRightControlKeyDown(): boolean

  function IsRightMetaKeyDown(): boolean

  function IsRightShiftKeyDown(): boolean

  function IsShiftKeyDown(): boolean

  function IsUsingGamepad(): boolean

  function IsUsingMouse(): boolean

  function CanChangePlayerDifficulty(): LuaMultiReturn<
    [canChange: boolean, notOnCooldown: boolean]
  >

  function CanMapChangeDifficulty(mapID: number | undefined): boolean

  function CanShowResetInstances(): boolean

  function GetDifficultyInfo(
    difficultyID: number
  ): LuaMultiReturn<
    [
      name: string,
      instanceType: string,
      isHeroic: boolean,
      isChallengeMode: boolean,
      displayHeroic: boolean,
      displayMythic: boolean,
      toggleDifficultyID: number | undefined,
      isLFR: boolean,
      minPlayers: number | undefined,
      maxPlayers: number | undefined
    ]
  >

  function GetDungeonDifficultyID(): number

  function GetInstanceBootTimeRemaining(): number

  function GetInstanceInfo(): LuaMultiReturn<
    [
      name: string,
      instanceType: string,
      difficultyID: number,
      difficultyName: string,
      maxPlayers: number,
      dynamicDifficulty: number,
      isDynamic: boolean | undefined,
      instanceID: number,
      instanceGroupSize: number,
      lfgDungeonID: number | undefined
    ]
  >

  function GetInstanceLockTimeRemaining(): LuaMultiReturn<
    [
      timeLeft: number,
      extending: boolean,
      encountersTotal: number,
      encountersCompleted: number
    ]
  >

  function GetInstanceLockTimeRemainingEncounter(
    encounterIndex: number
  ): LuaMultiReturn<
    [encounterName: string, texture: string, isKilled: boolean, ineligible: boolean]
  >

  function GetLegacyRaidDifficultyID(): number | undefined

  function GetRaidDifficultyID(): number | undefined

  function IsInInstance(): LuaMultiReturn<[isInInstance: boolean, instanceType: string]>

  function IsLegacyDifficulty(difficultyID: number): boolean | undefined

  function ResetInstances(): void

  function SetDungeonDifficultyID(difficultyID: number): void

  function SetLegacyRaidDifficultyID(difficultyID: number, force: boolean): void

  function SetRaidDifficultyID(difficultyID: number, force: boolean): void

  namespace C_InterfaceFileManifest {
    function GetInterfaceArtFiles(): string[]
  }

  namespace C_InvasionInfo {
    function AreInvasionsAvailable(): boolean

    function GetInvasionForUiMapID(uiMapID: number): number | undefined

    function GetInvasionInfo(invasionID: number): InvasionMapInfo

    function GetInvasionTimeLeft(invasionID: number): number | undefined
  }

  namespace C_IslandsQueue {
    function CloseIslandsQueueScreen(): void

    function GetIslandDifficultyInfo(): undefined[]

    function GetIslandsMaxGroupSize(): number

    function GetIslandsWeeklyQuestID(): number | undefined

    function QueueForIsland(difficultyID: number): void

    function RequestPreloadRewardData(questId: number): void
  }

  namespace C_Item {
    function ActionBindsItem(): void

    function BindEnchant(): void

    function CanItemTransmogAppearance(
      itemLoc: ItemLocationMixin
    ): LuaMultiReturn<[canTransmog: boolean, errorCode: number]>

    function CanScrapItem(itemLoc: ItemLocationMixin): boolean

    function CanViewItemPowers(itemLoc: ItemLocationMixin): boolean

    function ConfirmBindOnUse(): void

    function ConfirmNoRefundOnUse(): void

    function ConfirmOnUse(): void

    function DoesItemContainSpec(
      itemInfo: string | number,
      classID: number,
      specID: number
    ): boolean

    function DoesItemExist(emptiableItemLocation: ItemLocationMixin): boolean

    function DoesItemExistByID(itemInfo: string | number): boolean

    function DoesItemMatchBonusTreeReplacement(itemLoc: ItemLocationMixin): boolean

    function DoesItemMatchTargetEnchantingSpell(itemLoc: ItemLocationMixin): boolean

    function DoesItemMatchTrackJump(itemLoc: ItemLocationMixin): boolean

    function DropItemOnUnit(unitGUID: UnitToken): void

    function EndBoundTradeable(type: string): void

    function EndRefund(type: number): void

    function EquipItemByName(itemInfo: string | number, dstSlot: number | undefined): void

    function GetAppliedItemTransmogInfo(
      itemLoc: ItemLocationMixin
    ): ItemTransmogInfo | undefined

    function GetBaseItemTransmogInfo(
      itemLoc: ItemLocationMixin
    ): ItemTransmogInfo | undefined

    function GetCurrentItemLevel(itemLocation: ItemLocationMixin): number | undefined

    function GetCurrentItemTransmogInfo(
      itemLoc: ItemLocationMixin
    ): ItemTransmogInfo | undefined

    function GetDelvePreviewItemLink(itemID: number, context: number): string | undefined

    function GetDetailedItemLevelInfo(
      itemInfo: string | number
    ): LuaMultiReturn<
      [actualItemLevel: number, previewLevel: boolean, sparseItemLevel: number]
    >

    function GetFirstTriggeredSpellForItem(
      itemID: number,
      itemQuality: number
    ): number | undefined

    function GetItemChildInfo(
      itemInfo: string | number,
      slotID: number | undefined
    ): number[]

    function GetItemClassInfo(itemClassID: number): string

    function GetItemConversionOutputIcon(itemLoc: ItemLocationMixin): number | undefined

    function GetItemCooldown(
      itemInfo: string | number
    ): LuaMultiReturn<
      [startTimeSeconds: number, durationSeconds: number, enableCooldownTimer: boolean]
    >

    function GetItemCount(
      itemInfo: string | number,
      includeBank: boolean,
      includeUses: boolean,
      includeReagentBank: boolean
    ): number

    function GetItemCreationContext(
      itemInfo: string | number
    ): LuaMultiReturn<[itemID: number, creationContext: string]>

    function GetItemFamily(itemInfo: string | number): number | undefined

    function GetItemGUID(itemLocation: ItemLocationMixin): string

    function GetItemGem(
      hyperlink: string,
      index: number
    ): LuaMultiReturn<[gemName: string, gemLink: string]>

    function GetItemGemID(itemInfo: string | number, index: number): number

    function GetItemID(itemLocation: ItemLocationMixin): number

    function GetItemIDByGUID(itemGUID: string): number | undefined

    function GetItemIDForItemInfo(itemInfo: string | number): number

    function GetItemIcon(itemLocation: ItemLocationMixin): number | undefined

    function GetItemIconByID(itemInfo: string | number): number | undefined

    function GetItemInfo(
      itemInfo: string | number
    ): LuaMultiReturn<
      [
        itemName: string,
        itemLink: string,
        itemQuality: ItemQuality,
        itemLevel: number,
        itemMinLevel: number,
        itemType: string,
        itemSubType: string,
        itemStackCount: number,
        itemEquipLoc: string,
        itemTexture: number,
        sellPrice: number,
        classID: number,
        subclassID: number,
        bindType: number,
        expansionID: number,
        setID: number | undefined,
        isCraftingReagent: boolean
      ]
    >

    function GetItemInfoInstant(
      itemInfo: string | number
    ): LuaMultiReturn<
      [
        itemID: number,
        itemType: string,
        itemSubType: string,
        itemEquipLoc: string,
        icon: number,
        classID: number,
        subClassID: number
      ]
    >

    function GetItemInventorySlotInfo(inventorySlot: InventoryType): string

    function GetItemInventorySlotKey(inventorySlot: InventoryType): string

    function GetItemInventoryType(
      itemLocation: ItemLocationMixin
    ): InventoryType | undefined

    function GetItemInventoryTypeByID(
      itemInfo: string | number
    ): InventoryType | undefined

    function GetItemLearnTransmogSet(itemInfo: string | number): number | undefined

    function GetItemLink(itemLocation: ItemLocationMixin): string | undefined

    function GetItemLinkByGUID(itemGUID: string): string | undefined

    function GetItemLocation(itemGUID: string): ItemLocationMixin | undefined

    function GetItemMaxStackSize(itemLocation: ItemLocationMixin): number | undefined

    function GetItemMaxStackSizeByID(itemInfo: string | number): number | undefined

    function GetItemName(itemLocation: ItemLocationMixin): string | undefined

    function GetItemNameByID(itemInfo: string | number): string | undefined

    function GetItemNumAddedSockets(itemInfo: string | number): number

    function GetItemNumSockets(itemInfo: string | number): number

    function GetItemQuality(itemLocation: ItemLocationMixin): ItemQuality | undefined

    function GetItemQualityByID(itemInfo: string | number): ItemQuality | undefined

    function GetItemQualityColor(
      quality: number
    ): LuaMultiReturn<
      [colorRGBR: number, colorRGBG: number, colorRGBB: number, qualityString: string]
    >

    function GetItemSetInfo(setID: number): string

    function GetItemSpecInfo(itemInfo: string | number): number[]

    function GetItemSpell(
      itemInfo: string | number
    ): LuaMultiReturn<[spellName: string, spellID: number]>

    function GetItemStatDelta(itemLink1: string, itemLink2: string): {}

    function GetItemStats(itemLink: string): {}

    function GetItemSubClassInfo(
      itemClassID: number,
      itemSubClassID: number
    ): LuaMultiReturn<[subClassName: string, subClassUsesInvType: boolean]>

    function GetItemUniqueness(
      itemInfo: string | number
    ): LuaMultiReturn<[limitCategory: number, limitMax: number]>

    function GetItemUniquenessByID(
      itemInfo: string | number
    ): LuaMultiReturn<
      [
        isUnique: boolean,
        limitCategoryName: string | undefined,
        limitCategoryCount: number | undefined,
        limitCategoryID: number | undefined
      ]
    >

    function GetLimitedCurrencyItemInfo(
      itemInfo: string | number
    ): LuaMultiReturn<
      [
        name: string,
        icon: number,
        quantity: number,
        maxQuantity: number,
        totalEarned: number
      ]
    >

    function GetSetBonusesForSpecializationByItemID(
      specID: number,
      itemID: number
    ): number[]

    function GetStackCount(itemLocation: ItemLocationMixin): number

    function IsAnimaItemByID(itemInfo: string | number): boolean

    function IsArtifactPowerItem(itemInfo: string | number): boolean

    function IsBound(itemLocation: ItemLocationMixin): boolean

    function IsBoundToAccountUntilEquip(itemLocation: ItemLocationMixin): boolean

    function IsConsumableItem(itemInfo: string | number): boolean

    function IsCorruptedItem(itemInfo: string | number): boolean | undefined

    function IsCosmeticItem(itemInfo: string | number): boolean | undefined

    function IsCurioItem(itemInfo: string | number): boolean | undefined

    function IsCurrentItem(itemInfo: string | number): boolean

    function IsDressableItemByID(itemInfo: string | number): boolean

    function IsEquippableItem(itemInfo: string | number): boolean

    function IsEquippedItem(itemInfo: string | number): boolean

    function IsEquippedItemType(type: string): boolean

    function IsHarmfulItem(itemInfo: string | number): boolean

    function IsHelpfulItem(itemInfo: string | number): boolean

    function IsItemConduit(itemLoc: ItemLocationMixin): boolean

    function IsItemConvertibleAndValidForPlayer(itemLoc: ItemLocationMixin): boolean

    function IsItemCorrupted(itemLoc: ItemLocationMixin): boolean

    function IsItemCorruptionRelated(itemLoc: ItemLocationMixin): boolean

    function IsItemCorruptionResistant(itemLoc: ItemLocationMixin): boolean

    function IsItemDataCached(itemLocation: ItemLocationMixin): boolean

    function IsItemDataCachedByID(itemInfo: string | number): boolean

    function IsItemGUIDInInventory(itemGUID: string): boolean

    function IsItemInRange(
      itemInfo: string | number,
      targetToken: string
    ): boolean | undefined

    function IsItemKeystoneByID(itemInfo: string | number): boolean

    function IsItemSpecificToPlayerClass(itemInfo: string | number): boolean

    function IsLocked(itemLocation: ItemLocationMixin): boolean

    function IsUsableItem(
      itemInfo: string | number
    ): LuaMultiReturn<[usable: boolean, noMana: boolean]>

    function ItemHasRange(itemInfo: string | number): boolean

    function LockItem(itemLocation: ItemLocationMixin): void

    function LockItemByGUID(itemGUID: string): void

    function PickupItem(itemInfo: string | number): void

    function ReplaceEnchant(): void

    function ReplaceTradeEnchant(): void

    function ReplaceTradeskillEnchant(): void

    function RequestLoadItemData(itemLocation: ItemLocationMixin): void

    function RequestLoadItemDataByID(itemInfo: string | number): void

    function UnlockItem(itemLocation: ItemLocationMixin): void

    function UnlockItemByGUID(itemGUID: string): void

    function UseItemByName(itemInfo: string | number, target: string | undefined): void
  }

  namespace C_ItemInteraction {
    function ClearPendingItem(): void

    function CloseUI(): void

    function GetChargeInfo(): ItemInteractionChargeInfo

    function GetItemConversionCurrencyCost(
      item: ItemLocationMixin
    ): ConversionCurrencyCost

    function GetItemInteractionInfo(): ItemInteractionFrameInfo | undefined

    function GetItemInteractionSpellId(): number

    function InitializeFrame(): void

    function PerformItemInteraction(): void

    function Reset(): void

    function SetPendingItem(item: ItemLocationMixin | undefined): boolean
  }

  namespace C_ItemSocketInfo {
    function CompleteSocketing(): void
  }

  namespace C_ItemUpgrade {
    function CanUpgradeItem(baseItem: ItemLocationMixin): boolean

    function ClearItemUpgrade(): void

    function CloseItemUpgrade(): void

    function GetHighWatermarkForItem(
      itemInfo: string | number
    ): LuaMultiReturn<[characterHighWatermark: number, accountHighWatermark: number]>

    function GetHighWatermarkForSlot(
      itemRedundancySlot: number
    ): LuaMultiReturn<[characterHighWatermark: number, accountHighWatermark: number]>

    function GetHighWatermarkSlotForItem(itemInfo: string | number): number

    function GetItemHyperlink(): string

    function GetItemUpgradeCurrentLevel(): LuaMultiReturn<
      [itemLevel: number, isPvpItemLevel: boolean]
    >

    function GetItemUpgradeEffect(
      effectIndex: number,
      numUpgradeLevels: number | undefined
    ): LuaMultiReturn<[outBaseEffect: string, outUpgradedEffect: string]>

    function GetItemUpgradeItemInfo(): ItemUpgradeItemInfo

    function GetItemUpgradePvpItemLevelDeltaValues(
      numUpgradeLevels: number
    ): LuaMultiReturn<[currentPvPItemLevel: number, upgradedPvPItemLevel: number]>

    function GetNumItemUpgradeEffects(): number

    function IsItemBound(): boolean

    function SetItemUpgradeFromCursorItem(): void

    function SetItemUpgradeFromLocation(itemToSet: ItemLocationMixin): void

    function UpgradeItem(numUpgrades: number): void
  }

  namespace C_KeyBindings {
    function GetBindingIndex(action: string): number | undefined

    function GetCustomBindingType(bindingIndex: number): CustomBindingType | undefined
  }

  namespace C_LFGInfo {
    function CanPlayerUseGroupFinder(): LuaMultiReturn<
      [canUse: boolean, failureReason: string]
    >

    function CanPlayerUseLFD(): LuaMultiReturn<[canUse: boolean, failureReason: string]>

    function CanPlayerUseLFR(): LuaMultiReturn<[canUse: boolean, failureReason: string]>

    function CanPlayerUsePVP(): LuaMultiReturn<[canUse: boolean, failureReason: string]>

    function CanPlayerUsePremadeGroup(): LuaMultiReturn<
      [canUse: boolean, failureReason: string]
    >

    function CanPlayerUseScenarioFinder(): LuaMultiReturn<
      [canUse: boolean, failureReason: string]
    >

    function ConfirmLfgExpandSearch(): void

    function GetAllEntriesForCategory(category: number): number[]

    function GetDungeonInfo(lfgDungeonID: number): LFGDungeonInfo

    function GetLFDLockStates(): undefined[]

    function GetRoleCheckDifficultyDetails(): LuaMultiReturn<
      [maxLevel: number | undefined, isLevelReduced: boolean]
    >

    function HideNameFromUI(dungeonID: number): boolean

    function IsGroupFinderEnabled(): boolean

    function IsInLFGFollowerDungeon(): boolean

    function IsLFDEnabled(): boolean

    function IsLFGFollowerDungeon(dungeonID: number): boolean

    function IsLFREnabled(): boolean

    function IsPremadeGroupEnabled(): boolean
  }

  namespace C_LFGList {
    function CanActiveEntryUseAutoAccept(): boolean

    function CanCreateQuestGroup(questID: number): boolean

    function CanCreateScenarioGroup(scenarioID: number): boolean

    function ClearApplicationTextFields(): void

    function ClearCreationTextFields(): void

    function ClearSearchTextFields(): void

    function CopyActiveEntryInfoToCreationFields(): void

    function CreateScenarioListing(
      activityID: number,
      itemLevel: number,
      autoAccept: boolean,
      privateGroup: boolean,
      scenarioID: number
    ): boolean

    function DoesEntryTitleMatchPrebuiltTitle(
      activityID: number,
      groupID: number,
      playstyle: LFGEntryPlaystyle | undefined
    ): boolean

    function GetActiveEntryInfo(): LfgEntryData

    function GetActivityFullName(
      activityID: number,
      questID: number | undefined,
      showWarmode: boolean | undefined
    ): string

    function GetActivityGroupInfo(
      groupID: number
    ): LuaMultiReturn<[name: string, orderIndex: number]>

    function GetActivityInfoTable(
      activityID: number,
      questID: number | undefined,
      showWarmode: boolean | undefined
    ): GroupFinderActivityInfo

    function GetAdvancedFilter(): AdvancedFilterOptions

    function GetApplicantBestDungeonScore(
      localID: number,
      applicantIndex: number
    ): BestDungeonScoreMapInfo

    function GetApplicantDungeonScoreForListing(
      localID: number,
      applicantIndex: number,
      activityID: number
    ): BestDungeonScoreMapInfo

    function GetApplicantInfo(applicantID: number): LfgApplicantData

    function GetApplicantPvpRatingInfoForListing(
      localID: number,
      applicantIndex: number,
      activityID: number
    ): PvpRatingInfo

    function GetFilteredSearchResults(): LuaMultiReturn<
      [totalResultsFound: number, filteredResults: number[]]
    >

    function GetKeystoneForActivity(activityID: number): number

    function GetLfgCategoryInfo(categoryID: number): LfgCategoryData

    function GetOwnedKeystoneActivityAndGroupAndLevel(
      getTimewalking: boolean
    ): LuaMultiReturn<[activityID: number, groupID: number, keystoneLevel: number]>

    function GetPlaystyleString(
      playstyle: LFGEntryPlaystyle,
      activityInfo: GroupFinderActivityInfo
    ): string

    function GetSearchResultInfo(searchResultID: number): LfgSearchResultData

    function GetSearchResults(): LuaMultiReturn<
      [totalResultsFound: number, results: number[]]
    >

    function HasActiveEntryInfo(): boolean

    function HasSearchResultInfo(searchResultID: number): boolean

    function IsPlayerAuthenticatedForLFG(activityID: number | undefined): boolean

    function SaveAdvancedFilter(options: AdvancedFilterOptions): void

    function Search(
      categoryID: number,
      filter: number,
      preferredFilters: number,
      languageFilter: WowLocale | undefined,
      searchCrossFactionListings: boolean | undefined,
      advancedFilter: AdvancedFilterOptions | undefined
    ): void

    function SetEntryTitle(
      activityID: number,
      groupID: number,
      playstyle: LFGEntryPlaystyle | undefined
    ): void

    function SetSearchToActivity(activityID: number): void

    function SetSearchToQuestID(questID: number): void

    function SetSearchToScenarioID(scenarioID: number): void

    function ValidateRequiredDungeonScore(dungeonScore: number): boolean

    function ValidateRequiredPvpRatingForActivity(
      activityID: number,
      rating: number
    ): boolean
  }

  namespace C_LegendaryCrafting {
    function CloseRuneforgeInteraction(): void

    function CraftRuneforgeLegendary(
      description: RuneforgeLegendaryCraftDescription
    ): void

    function GetRuneforgeItemPreviewInfo(
      baseItem: ItemLocationMixin,
      runeforgePowerID: number | undefined,
      modifiers: number[] | undefined
    ): RuneforgeItemPreviewInfo | undefined

    function GetRuneforgeLegendaryComponentInfo(
      runeforgeLegendary: ItemLocationMixin
    ): RuneforgeLegendaryComponentInfo

    function GetRuneforgeLegendaryCost(baseItem: ItemLocationMixin): undefined[]

    function GetRuneforgeLegendaryCraftSpellID(): number

    function GetRuneforgeLegendaryCurrencies(): number[]

    function GetRuneforgeLegendaryUpgradeCost(
      runeforgeLegendary: ItemLocationMixin,
      upgradeItem: ItemLocationMixin
    ): undefined[]

    function GetRuneforgeModifierInfo(
      baseItem: ItemLocationMixin,
      powerID: number | undefined,
      addedModifierIndex: number,
      modifiers: number[]
    ): LuaMultiReturn<[name: string, description: string[]]>

    function GetRuneforgeModifiers(): number[]

    function GetRuneforgePowerInfo(runeforgePowerID: number): RuneforgePower

    function GetRuneforgePowerSlots(runeforgePowerID: number): string[]

    function GetRuneforgePowers(
      baseItem: ItemLocationMixin | undefined,
      filter: RuneforgePowerFilter | undefined
    ): LuaMultiReturn<
      [primaryRuneforgePowerIDs: number[], otherRuneforgePowerIDs: number[]]
    >

    function GetRuneforgePowersByClassSpecAndCovenant(
      classID: number | undefined,
      specID: number | undefined,
      covenantID: number | undefined,
      filter: RuneforgePowerFilter | undefined
    ): number[]

    function IsRuneforgeLegendary(item: ItemLocationMixin): boolean

    function IsRuneforgeLegendaryMaxLevel(runeforgeLegendary: ItemLocationMixin): boolean

    function IsUpgradeItemValidForRuneforgeLegendary(
      runeforgeLegendary: ItemLocationMixin,
      upgradeItem: ItemLocationMixin
    ): boolean

    function IsValidRuneforgeBaseItem(baseItem: ItemLocationMixin): boolean

    function MakeRuneforgeCraftDescription(
      baseItem: ItemLocationMixin,
      runeforgePowerID: number,
      modifiers: number[]
    ): RuneforgeLegendaryCraftDescription

    function UpgradeRuneforgeLegendary(
      runeforgeLegendary: ItemLocationMixin,
      upgradeItem: ItemLocationMixin
    ): void
  }

  namespace C_LevelLink {
    function IsActionLocked(actionID: number): boolean

    function IsSpellLocked(spellID: number): boolean
  }

  namespace C_LevelSquish {
    function ConvertFollowerLevel(level: number, maxFollowerLevel: number): number

    function ConvertPlayerLevel(level: number): number
  }

  namespace C_LiveEvent {
    function OnLiveEventBannerClicked(timerunningSeasonID: number): void

    function OnLiveEventPopupClicked(timerunningSeasonID: number): void
  }

  function GetAvailableLocaleInfo(ignoreLocaleRestrictions: boolean): undefined[]

  function GetAvailableLocales(ignoreLocaleRestrictions: boolean): string

  function GetCurrentRegion(): number

  function GetLocale(): string

  function GetOSLocale(): string

  function BreakUpLargeNumbers(largeNumber: number, natural: boolean): string

  function CaseAccentInsensitiveParse(name: string): string

  function DeclineName(
    name: string,
    gender: number | undefined,
    declensionSet: number
  ): string

  function GetNumDeclensionSets(name: string, gender: number | undefined): number

  function IsEuropeanNumbers(): boolean

  function LocalizedClassList(isFemale: boolean): {}

  function SetEuropeanNumbers(enabled: boolean): void

  namespace C_Loot {
    function GetLootRollDuration(rollID: number): number | undefined

    function IsLegacyLootModeEnabled(): boolean
  }

  namespace C_LootHistory {
    function GetAllEncounterInfos(): undefined[]

    function GetInfoForEncounter(encounterID: number): EncounterLootInfo | undefined

    function GetLootHistoryTime(): number

    function GetSortedDropsForEncounter(encounterID: number): undefined[] | undefined

    function GetSortedInfoForDrop(
      encounterID: number,
      lootListID: number
    ): EncounterLootDropInfo | undefined
  }

  namespace C_LootJournal {
    function GetItemSetItems(setID: number): undefined[]

    function GetItemSets(
      classID: number | undefined,
      specID: number | undefined
    ): undefined[]
  }

  namespace C_LoreText {
    function RequestLoreTextForCampaignID(campaignID: number): void
  }

  namespace C_LossOfControl {
    function GetActiveLossOfControlData(index: number): LossOfControlData | undefined

    function GetActiveLossOfControlDataByUnit(
      unitToken: UnitToken,
      index: number
    ): LossOfControlData | undefined

    function GetActiveLossOfControlDataCount(): number

    function GetActiveLossOfControlDataCountByUnit(unitToken: UnitToken): number
  }

  namespace C_MacOptions {
    function AreOSShortcutsDisabled(): LuaMultiReturn<
      [osShortcutsDisabledCVar: boolean | undefined, osShortcutsDisabled: boolean]
    >

    function GetGameBundleName(): string

    function HasNewStyleInputMonitoring(): boolean

    function IsInputMonitoringEnabled(): boolean

    function IsMicrophoneEnabled(): boolean

    function IsUniversalAccessEnabled(): boolean

    function OpenInputMonitoring(): void

    function OpenMicrophoneRequestDialogue(): void

    function OpenUniversalAccess(): void

    function SetOSShortcutsDisabled(disable: boolean): void
  }

  namespace C_Mail {
    function CanCheckInbox(): LuaMultiReturn<
      [canCheckInbox: boolean, secondsUntilAllowed: number]
    >

    function GetCraftingOrderMailInfo(
      inboxIndex: number
    ): CraftingOrderMailInfo | undefined

    function HasInboxMoney(inboxIndex: number): boolean

    function IsCommandPending(): boolean

    function SetOpeningAll(openingAll: boolean): void
  }

  namespace C_MajorFactions {
    function GetCovenantIDForMajorFaction(majorFactionID: number): number

    function GetCurrentRenownLevel(majorFactionID: number): number

    function GetMajorFactionData(majorFactionID: number): MajorFactionData | undefined

    function GetMajorFactionIDs(expansionID: number | undefined): number[]

    function GetMajorFactionRenownInfo(
      majorFactionID: number
    ): MajorFactionRenownInfo | undefined

    function GetRenownLevels(majorFactionID: number): undefined[]

    function GetRenownNPCFactionID(): number

    function GetRenownRewardsForLevel(
      majorFactionID: number,
      renownLevel: number
    ): undefined[]

    function HasMaximumRenown(majorFactionID: number): boolean

    function IsWeeklyRenownCapped(majorFactionID: number): boolean
  }

  namespace C_Map {
    function CanSetUserWaypointOnMap(uiMapID: number): boolean

    function ClearUserWaypoint(): void

    function CloseWorldMapInteraction(): void

    function GetAreaInfo(areaID: number): string

    function GetBestMapForUnit(unitToken: UnitToken): number | undefined

    function GetBountySetMaps(bountySetID: number): number[]

    function GetFallbackWorldMapID(): number

    function GetMapArtBackgroundAtlas(uiMapID: number): string

    function GetMapArtHelpTextPosition(uiMapID: number): MapCanvasPosition

    function GetMapArtID(uiMapID: number): number

    function GetMapArtLayerTextures(uiMapID: number, layerIndex: number): number[]

    function GetMapArtLayers(uiMapID: number): undefined[]

    function GetMapBannersForMap(uiMapID: number): undefined[]

    function GetMapChildrenInfo(
      uiMapID: number,
      mapType: UIMapType | undefined,
      allDescendants: boolean | undefined
    ): undefined[]

    function GetMapDisplayInfo(uiMapID: number): boolean

    function GetMapGroupID(uiMapID: number): number

    function GetMapGroupMembersInfo(uiMapGroupID: number): undefined[]

    function GetMapHighlightInfoAtPosition(
      uiMapID: number,
      x: number,
      y: number
    ): LuaMultiReturn<
      [
        fileDataID: number,
        atlasID: string,
        texturePercentageX: number,
        texturePercentageY: number,
        textureX: number,
        textureY: number,
        scrollChildX: number,
        scrollChildY: number
      ]
    >

    function GetMapHighlightPulseInfo(
      uiMapID: number
    ): LuaMultiReturn<
      [
        fileDataID: number,
        atlasID: string,
        texturePercentageX: number,
        texturePercentageY: number,
        textureX: number,
        textureY: number,
        scrollChildX: number,
        scrollChildY: number
      ]
    >

    function GetMapInfo(uiMapID: number): UiMapDetails

    function GetMapInfoAtPosition(
      uiMapID: number,
      x: number,
      y: number,
      ignoreZoneMapPositionData: boolean | undefined
    ): UiMapDetails

    function GetMapLevels(
      uiMapID: number
    ): LuaMultiReturn<
      [
        playerMinLevel: number,
        playerMaxLevel: number,
        petMinLevel: number,
        petMaxLevel: number
      ]
    >

    function GetMapLinksForMap(uiMapID: number): undefined[]

    function GetMapPosFromWorldPos(
      continentID: number,
      worldPosition: Vector2DMixin,
      overrideUiMapID: number | undefined
    ): LuaMultiReturn<[uiMapID: number, mapPosition: Vector2DMixin]>

    function GetMapRectOnMap(
      uiMapID: number,
      topUiMapID: number
    ): LuaMultiReturn<[minX: number, maxX: number, minY: number, maxY: number]>

    function GetMapWorldSize(
      uiMapID: number
    ): LuaMultiReturn<[width: number, height: number]>

    function GetPlayerMapPosition(
      uiMapID: number,
      unitToken: UnitToken
    ): Vector2DMixin | undefined

    function GetUserWaypoint(): UiMapPoint

    function GetUserWaypointFromHyperlink(hyperlink: string): UiMapPoint

    function GetUserWaypointHyperlink(): string

    function GetUserWaypointPositionForMap(uiMapID: number): Vector2DMixin

    function GetWorldPosFromMapPos(
      uiMapID: number,
      mapPosition: Vector2DMixin
    ): LuaMultiReturn<[continentID: number, worldPosition: Vector2DMixin]>

    function HasUserWaypoint(): boolean

    function IsCityMap(uiMapID: number): boolean

    function IsMapValidForNavBarDropdown(uiMapID: number): boolean

    function MapHasArt(uiMapID: number): boolean

    function RequestPreloadMap(uiMapID: number): void

    function SetUserWaypoint(point: UiMapPoint): void
  }

  namespace C_MapExplorationInfo {
    function GetExploredAreaIDsAtPosition(
      uiMapID: number,
      normalizedPosition: Vector2DMixin
    ): number[] | undefined

    function GetExploredMapTextures(uiMapID: number): undefined[]
  }

  namespace C_MerchantFrame {
    function GetBuybackItemID(buybackSlotIndex: number): number

    function GetNumJunkItems(): number

    function IsMerchantItemRefundable(index: number): boolean

    function IsSellAllJunkEnabled(): boolean

    function SellAllJunkItems(): void
  }

  namespace C_Minimap {
    function CanTrackBattlePets(): boolean

    function ClearAllTracking(): void

    function GetDefaultTrackingValue(filterType: MinimapTrackingFilter): boolean

    function GetDrawGroundTextures(): boolean

    function GetNumQuestPOIWorldEffects(): number

    function GetNumTrackingTypes(): number

    function GetObjectIconTextureCoords(
      index: number | undefined
    ): LuaMultiReturn<
      [
        textureCoordsX: number,
        textureCoordsY: number,
        textureCoordsZ: number,
        textureCoordsW: number
      ]
    >

    function GetPOITextureCoords(
      index: number | undefined
    ): LuaMultiReturn<
      [
        textureCoordsX: number,
        textureCoordsY: number,
        textureCoordsZ: number,
        textureCoordsW: number
      ]
    >

    function GetTrackingFilter(spellIndex: number): MinimapScriptTrackingFilter

    function GetTrackingInfo(spellIndex: number): MinimapScriptTrackingInfo | undefined

    function GetUiMapID(): number | undefined

    function GetViewRadius(): number

    function IsFilteredOut(filterType: MinimapTrackingFilter): boolean

    function IsRotateMinimapIgnored(): boolean

    function IsTrackingAccountCompletedQuests(): boolean

    function IsTrackingBattlePets(): boolean

    function IsTrackingHiddenQuests(): boolean

    function SetDrawGroundTextures(draw: boolean): void

    function SetIgnoreRotateMinimap(ignore: boolean): void

    function SetTracking(index: number, on: boolean): void

    function ShouldUseHybridMinimap(): boolean
  }

  function GetMirrorTimerInfo(
    timerIndex: number
  ): LuaMultiReturn<
    [
      name: string,
      startValue: number,
      maxValue: number,
      scale: number,
      paused: number,
      label: string,
      spellID: number
    ]
  >

  function GetMirrorTimerProgress(timerName: string): number | undefined

  namespace C_MountJournal {
    function ApplyMountEquipment(itemLocation: ItemLocationMixin): boolean

    function AreMountEquipmentEffectsSuppressed(): boolean

    function ClearFanfare(mountID: number): void

    function ClearRecentFanfares(): void

    function Dismiss(): void

    function GetAllCreatureDisplayIDsForMountID(mountID: number): number[]

    function GetAppliedMountEquipmentID(): number | undefined

    function GetCollectedDragonridingMounts(): number[]

    function GetCollectedFilterSetting(filterIndex: number): boolean

    function GetDisplayedMountAllCreatureDisplayInfo(mountIndex: number): undefined[]

    function GetDisplayedMountID(displayIndex: number): number

    function GetDisplayedMountInfo(
      displayIndex: number
    ): LuaMultiReturn<
      [
        name: string,
        spellID: number,
        icon: number,
        isActive: boolean,
        isUsable: boolean,
        sourceType: number,
        isFavorite: boolean,
        isFactionSpecific: boolean,
        faction: number | undefined,
        shouldHideOnChar: boolean,
        isCollected: boolean,
        mountID: number,
        isSteadyFlight: boolean
      ]
    >

    function GetDisplayedMountInfoExtra(
      mountIndex: number
    ): LuaMultiReturn<
      [
        creatureDisplayInfoID: number | undefined,
        description: string,
        source: string,
        isSelfMount: boolean,
        mountTypeID: number,
        uiModelSceneID: number,
        animID: number,
        spellVisualKitID: number,
        disablePlayerMountPreview: boolean
      ]
    >

    function GetDynamicFlightModeSpellID(): number

    function GetIsFavorite(
      mountIndex: number
    ): LuaMultiReturn<[isFavorite: boolean, canSetFavorite: boolean]>

    function GetMountAllCreatureDisplayInfoByID(mountID: number): undefined[]

    function GetMountEquipmentUnlockLevel(): number

    function GetMountFromItem(itemID: number): number | undefined

    function GetMountFromSpell(spellID: number): number | undefined

    function GetMountIDs(): number[]

    function GetMountInfoByID(
      mountID: number
    ): LuaMultiReturn<
      [
        name: string,
        spellID: number,
        icon: number,
        isActive: boolean,
        isUsable: boolean,
        sourceType: number,
        isFavorite: boolean,
        isFactionSpecific: boolean,
        faction: number | undefined,
        shouldHideOnChar: boolean,
        isCollected: boolean,
        mountID: number,
        isSteadyFlight: boolean
      ]
    >

    function GetMountInfoExtraByID(
      mountID: number
    ): LuaMultiReturn<
      [
        creatureDisplayInfoID: number | undefined,
        description: string,
        source: string,
        isSelfMount: boolean,
        mountTypeID: number,
        uiModelSceneID: number,
        animID: number,
        spellVisualKitID: number,
        disablePlayerMountPreview: boolean
      ]
    >

    function GetMountLink(spellID: number): string | undefined

    function GetMountUsabilityByID(
      mountID: number,
      checkIndoors: boolean
    ): LuaMultiReturn<[isUsable: boolean, useError: string | undefined]>

    function GetNumDisplayedMounts(): number

    function GetNumMounts(): number

    function GetNumMountsNeedingFanfare(): number

    function IsDragonridingUnlocked(): boolean

    function IsItemMountEquipment(itemLocation: ItemLocationMixin): boolean

    function IsMountEquipmentApplied(): boolean

    function IsSourceChecked(filterIndex: number): boolean

    function IsTypeChecked(filterIndex: number): boolean

    function IsUsingDefaultFilters(): boolean

    function IsValidSourceFilter(filterIndex: number): boolean

    function IsValidTypeFilter(filterIndex: number): boolean

    function NeedsFanfare(mountID: number): boolean

    function Pickup(displayIndex: number): void

    function PickupDynamicFlightMode(): void

    function SetAllSourceFilters(isChecked: boolean): void

    function SetAllTypeFilters(isChecked: boolean): void

    function SetCollectedFilterSetting(filterIndex: number, isChecked: boolean): void

    function SetDefaultFilters(): void

    function SetIsFavorite(mountIndex: number, isFavorite: boolean): void

    function SetSearch(searchValue: string): void

    function SetSourceFilter(filterIndex: number, isChecked: boolean): void

    function SetTypeFilter(filterIndex: number, isChecked: boolean): void

    function SummonByID(mountID: number): void

    function SwapDynamicFlightMode(): void
  }

  function CancelPreloadingMovie(movieId: number): void

  function GetMovieDownloadProgress(
    movieId: number
  ): LuaMultiReturn<[inProgress: boolean, downloaded: number, total: number]>

  function IsMovieLocal(movieId: number): boolean

  function IsMoviePlayable(movieId: number): boolean

  function IsMovieReadable(movieId: number): boolean

  function PreloadMovie(movieId: number): void

  namespace C_MythicPlus {
    function GetCurrentAffixes(): undefined[]

    function GetCurrentSeason(): number

    function GetCurrentSeasonValues(): LuaMultiReturn<
      [displaySeasonID: number, milestoneSeasonID: number, rewardSeasonID: number]
    >

    function GetCurrentUIDisplaySeason(): number | undefined

    function GetEndOfRunGearSequenceLevel(keystoneLevel: number): number | undefined

    function GetLastWeeklyBestInformation(): LuaMultiReturn<
      [challengeMapId: number, level: number]
    >

    function GetOwnedKeystoneChallengeMapID(): number

    function GetOwnedKeystoneLevel(): number

    function GetOwnedKeystoneMapID(): number

    function GetRewardLevelForDifficultyLevel(
      difficultyLevel: number
    ): LuaMultiReturn<[weeklyRewardLevel: number, endOfRunRewardLevel: number]>

    function GetRewardLevelFromKeystoneLevel(keystoneLevel: number): number | undefined

    function GetRunHistory(
      includePreviousWeeks: boolean,
      includeIncompleteRuns: boolean
    ): undefined[]

    function GetSeasonBestAffixScoreInfoForMap(
      mapChallengeModeID: number
    ): LuaMultiReturn<[affixScores: undefined[], bestOverAllScore: number]>

    function GetSeasonBestForMap(
      mapChallengeModeID: number
    ): LuaMultiReturn<
      [
        intimeInfo: MapSeasonBestInfo | undefined,
        overtimeInfo: MapSeasonBestInfo | undefined
      ]
    >

    function GetSeasonBestMythicRatingFromThisExpansion(): LuaMultiReturn<
      [bestSeasonScore: number, bestSeason: number]
    >

    function GetWeeklyBestForMap(
      mapChallengeModeID: number
    ): LuaMultiReturn<
      [
        durationSec: number,
        level: number,
        completionDate: MythicPlusDate,
        affixIDs: number[],
        members: undefined[],
        dungeonScore: number
      ]
    >

    function GetWeeklyChestRewardLevel(): LuaMultiReturn<
      [
        currentWeekBestLevel: number,
        weeklyRewardLevel: number,
        nextDifficultyWeeklyRewardLevel: number,
        nextBestLevel: number
      ]
    >

    function IsMythicPlusActive(): boolean

    function IsWeeklyRewardAvailable(): boolean

    function RequestCurrentAffixes(): void

    function RequestMapInfo(): void

    function RequestRewards(): void
  }

  namespace C_NewItems {
    function ClearAll(): void

    function IsNewItem(containerIndex: BagIndex, slotIndex: number): boolean

    function RemoveNewItem(containerIndex: BagIndex, slotIndex: number): void
  }

  function CopyToClipboard(text: string, removeMarkup: boolean): number

  function GetTimePreciseSec(): number

  namespace C_PaperDollInfo {
    function CanAutoEquipCursorItem(): boolean

    function CanCursorCanGoInSlot(slotIndex: number): boolean

    function GetArmorEffectiveness(armor: number, attackerLevel: number): number

    function GetArmorEffectivenessAgainstTarget(armor: number): number | undefined

    function GetInspectAzeriteItemEmpoweredChoices(
      unit: UnitToken,
      equipmentSlotIndex: number
    ): number[]

    function GetInspectGuildInfo(
      unitString: string
    ): LuaMultiReturn<
      [
        achievementPoints: number,
        numMembers: number,
        guildName: string,
        realmName: string
      ]
    >

    function GetInspectItemLevel(unit: UnitToken): number

    function GetInspectRatedBGBlitzData(): InspectPVPData

    function GetInspectRatedSoloShuffleData(): InspectPVPData

    function GetMinItemLevel(): number | undefined

    function GetStaggerPercentage(
      unit: UnitToken
    ): LuaMultiReturn<[stagger: number, staggerAgainstTarget: number | undefined]>

    function OffhandHasShield(): boolean

    function OffhandHasWeapon(): boolean
  }

  function GetSecondsUntilParentalControlsKick(): number | undefined

  namespace C_PartyInfo {
    function AllowedToDoPartyConversion(toRaid: boolean): boolean

    function CanFormCrossFactionParties(): boolean

    function CanInvite(): boolean

    function ConfirmConvertToRaid(): void

    function ConfirmInviteTravelPass(targetName: string, targetGUID: string): void

    function ConfirmInviteUnit(targetName: string): void

    function ConfirmLeaveParty(category: number | undefined): void

    function ConfirmRequestInviteFromUnit(
      targetName: string,
      tank: boolean | undefined,
      healer: boolean | undefined,
      dps: boolean | undefined
    ): void

    function ConvertToParty(): void

    function ConvertToRaid(): void

    function DelveTeleportOut(): void

    function DoCountdown(seconds: number): boolean

    function GetActiveCategories(): number[]

    function GetInviteConfirmationInvalidQueues(inviteGUID: string): undefined[]

    function GetInviteReferralInfo(
      inviteGUID: string
    ): LuaMultiReturn<
      [
        outReferredByGuid: string,
        outReferredByName: string,
        outRelationType: PartyRequestJoinRelation,
        outIsQuickJoin: boolean,
        outClubId: string
      ]
    >

    function GetMinItemLevel(
      avgItemLevelCategory: AvgItemLevelCategories
    ): LuaMultiReturn<[minItemLevel: number, playerNameWithLowestItemLevel: string]>

    function GetMinLevel(category: number | undefined): number

    function GetRestrictPings(): RestrictPingsTo

    function InviteUnit(targetName: string): void

    function IsCrossFactionParty(category: number | undefined): boolean

    function IsDelveComplete(): boolean

    function IsDelveInProgress(): boolean

    function IsPartyFull(category: number | undefined): boolean

    function IsPartyInJailersTower(): boolean

    function IsPartyWalkIn(): boolean

    function LeaveParty(category: number | undefined): void

    function RequestInviteFromUnit(
      targetName: string,
      tank: boolean | undefined,
      healer: boolean | undefined,
      dps: boolean | undefined
    ): void

    function SetRestrictPings(restrictTo: RestrictPingsTo): void
  }

  namespace C_PartyPose {
    function ExtraAction(partyPoseID: number): void

    function GetPartyPoseInfoByID(mapID: number): PartyPoseInfo

    function GetPartyPoseInfoByMapID(mapID: number): PartyPoseInfo

    function HasExtraAction(partyPoseID: number): boolean
  }

  function GetAddOnCPUUsage(name: string | number): number

  function GetAddOnMemoryUsage(name: string | number): number

  function GetFrameCPUUsage(
    frame: unknown,
    includeChildren: boolean
  ): LuaMultiReturn<[call_time: number, call_count: number]>

  function ResetCPUUsage(): void

  function UpdateAddOnCPUUsage(): void

  function UpdateAddOnMemoryUsage(): void

  namespace C_PerksActivities {
    function AddTrackedPerksActivity(perksActivityID: number): void

    function ClearPerksActivitiesPendingCompletion(): void

    function GetAllPerksActivityTags(): PerksActivityTags

    function GetPerksActivitiesInfo(): PerksActivitiesInfo

    function GetPerksActivitiesPendingCompletion(): PerksActivitiesPending

    function GetPerksActivityChatLink(perksActivityID: number): string

    function GetPerksActivityInfo(perksActivityID: number): PerksActivityInfo | undefined

    function GetPerksUIThemePrefix(): string

    function GetTrackedPerksActivities(): PerksActivitiesTracked

    function RemoveTrackedPerksActivity(perksActivityID: number): void
  }

  namespace C_PerksProgram {
    function ClearFrozenPerksVendorItem(): void

    function CloseInteraction(): void

    function GetAvailableCategoryIDs(): number[]

    function GetAvailableVendorItemIDs(): number[]

    function GetCategoryInfo(categoryID: number): PerksVendorCategoryInfo

    function GetCurrencyAmount(): number

    function GetDraggedPerksVendorItem(): number

    function GetFrozenPerksVendorItemInfo(): PerksVendorItemInfo

    function GetPendingChestRewards(): undefined[]

    function GetPerksProgramItemDisplayInfo(id: number): PerksProgramItemDisplayInfo

    function GetTimeRemaining(vendorItemID: number): number

    function GetVendorItemInfo(vendorItemID: number): PerksVendorItemInfo

    function GetVendorItemInfoRefundTimeLeft(vendorItemID: number): number

    function IsAttackAnimToggleEnabled(): boolean

    function IsFrozenPerksVendorItem(perksVendorItemID: number): boolean

    function IsMountSpecialAnimToggleEnabled(): boolean

    function ItemSelectedTelemetry(perksVendorItemID: number): void

    function PickupPerksVendorItem(perksVendorItemID: number): void

    function RequestPendingChestRewards(): void

    function RequestPurchase(perksVendorItemID: number): void

    function RequestRefund(perksVendorItemID: number): void

    function ResetHeldItemDragAndDrop(): void

    function SetFrozenPerksVendorItem(): void
  }

  namespace C_PetBattles {
    function GetBreedQuality(
      petOwner: BattlePetOwner,
      slot: number
    ): BattlePetBreedQuality

    function GetIcon(petOwner: BattlePetOwner, slot: number): number

    function GetName(
      petOwner: BattlePetOwner,
      slot: number
    ): LuaMultiReturn<[customName: string, speciesName: string]>

    function IsPlayerNPC(): boolean

    function IsWildBattle(): boolean
  }

  namespace C_PetInfo {
    function GetPetTamersForMap(uiMapID: number): undefined[]

    function GetSpellForPetAction(actionID: number): number | undefined

    function IsPetActionPassive(actionID: number): boolean

    function PetAbandon(petNumber: number | undefined): void

    function PetRename(
      name: string,
      petNumber: number | undefined,
      declensions: string[] | undefined
    ): void
  }

  namespace C_PetJournal {
    function ClearHoveredBattlePet(): void

    function GetDisplayIDByIndex(speciesID: number, index: number): number | undefined

    function GetDisplayProbabilityByIndex(
      speciesID: number,
      index: number
    ): number | undefined

    function GetNumDisplays(speciesID: number): number | undefined

    function GetNumPetsInJournal(
      creatureID: number
    ): LuaMultiReturn<[maxAllowed: number, numPets: number]>

    function GetPetAbilityInfo(
      abilityID: number
    ): LuaMultiReturn<[name: string, icon: number, petType: number]>

    function GetPetAbilityListTable(speciesID: number): undefined[]

    function GetPetInfoTableByPetID(petID: string): PetJournalPetInfo

    function GetPetLoadOutInfo(
      slot: number
    ): LuaMultiReturn<
      [
        petID: string | undefined,
        ability1ID: number,
        ability2ID: number,
        ability3ID: number,
        locked: boolean
      ]
    >

    function GetPetSummonInfo(
      battlePetGUID: string
    ): LuaMultiReturn<[isSummonable: boolean, error: PetJournalError, errorText: string]>

    function HasFavoritePets(): boolean

    function IsUsingDefaultFilters(): boolean

    function PetIsSummonable(battlePetGUID: string): boolean

    function PetUsesRandomDisplay(speciesID: number): boolean | undefined

    function SetDefaultFilters(): void

    function SetHoveredBattlePet(battlePetGUID: string): void

    function SpellTargetBattlePet(battlePetGUID: string): void
  }

  namespace C_Ping {
    function GetContextualPingTypeForUnit(targetUnit: string | undefined): PingSubjectType

    function GetCooldownInfo(): PingCooldownInfo

    function GetDefaultPingOptions(): undefined[]

    function GetTextureKitForType(type: PingSubjectType): string

    function SendMacroPing(
      type: PingSubjectType | undefined,
      targetToken: string | undefined
    ): void

    function TogglePingListener(down: boolean): void
  }

  namespace C_PingSecure {
    function ClearPendingPingInfo(): void

    function CreateFrame(): void

    function DisplayError(error: string): void

    function GetTargetPingReceiver(mousePosX: number, mousePosY: number): unknown

    function GetTargetWorldPing(mousePosX: number, mousePosY: number): boolean

    function GetTargetWorldPingAndSend(): ContextualWorldPingResult

    function SendPing(type: PingSubjectType, target: string | undefined): PingResult

    function SetPendingPingOffScreenCallback(cb: () => void): void

    function SetPingCooldownStartedCallback(cb: PingCooldownStartedCallback): void

    function SetPingPinFrameAddedCallback(cb: PingPinFrameAddedCallback): void

    function SetPingPinFrameRemovedCallback(cb: PingPinFrameRemovedCallback): void

    function SetPingPinFrameScreenClampStateUpdatedCallback(
      cb: PingPinFrameScreenClampStateUpdatedCallback
    ): void

    function SetPingRadialWheelCreatedCallback(cb: PingRadialWheelCreatedCallback): void

    function SetSendMacroPingCallback(cb: SendMacroPingCallback): void

    function SetTogglePingListenerCallback(cb: TogglePingListenerCallback): void
  }

  namespace C_PlayerChoice {
    function GetCurrentPlayerChoiceInfo(): PlayerChoiceInfo

    function GetNumRerolls(): number

    function GetRemainingTime(): number | undefined

    function IsWaitingForPlayerChoiceResponse(): boolean

    function OnUIClosed(): void

    function RequestRerollPlayerChoice(): void

    function SendPlayerChoiceResponse(responseID: number): void
  }

  namespace C_PlayerInfo {
    function CanPlayerEnterChromieTime(): boolean

    function CanPlayerUseAreaLoot(): boolean

    function CanPlayerUseMountEquipment(): LuaMultiReturn<
      [canUseMountEquipment: boolean, failureReason: string]
    >

    function CanUseItem(itemID: number): boolean

    function GetAlternateFormInfo(): LuaMultiReturn<
      [hasAlternateForm: boolean, inAlternateForm: boolean]
    >

    function GetContentDifficultyCreatureForPlayer(
      unitToken: UnitToken
    ): RelativeContentDifficulty

    function GetContentDifficultyQuestForPlayer(
      questID: number
    ): RelativeContentDifficulty

    function GetDisplayID(): number

    function GetGlidingInfo(): LuaMultiReturn<
      [isGliding: boolean, canGlide: boolean, forwardSpeed: number]
    >

    function GetInstancesUnlockedAtLevel(level: number, isRaid: boolean): number[]

    function GetNativeDisplayID(): number

    function GetPetStableCreatureDisplayInfoID(index: number): number

    function GetPlayerCharacterData(): PlayerInfoCharacterData

    function GetPlayerMythicPlusRatingSummary(
      playerToken: UnitToken
    ): MythicPlusRatingSummary

    function HasAccountInventoryLock(): boolean

    function HasVisibleInvSlot(slot: number): boolean

    function IsDisplayRaceNative(): boolean

    function IsExpansionLandingPageUnlockedForPlayer(expansionID: number): boolean

    function IsMirrorImage(): boolean

    function IsPlayerEligibleForNPE(): LuaMultiReturn<
      [isEligible: boolean, failureReason: string]
    >

    function IsPlayerEligibleForNPEv2(): LuaMultiReturn<
      [isEligible: boolean, failureReason: string]
    >

    function IsPlayerInChromieTime(): boolean

    function IsPlayerNPERestricted(): boolean

    function IsSelfFoundActive(): boolean

    function IsTradingPostAvailable(): boolean

    function IsTravelersLogAvailable(): boolean
  }

  namespace C_PlayerInteractionManager {
    function ClearInteraction(type: PlayerInteractionType | undefined): void

    function ConfirmationInteraction(type: PlayerInteractionType | undefined): void

    function InteractUnit(
      unit: string,
      exactMatch: boolean,
      looseTargeting: boolean
    ): boolean

    function IsInteractingWithNpcOfType(type: PlayerInteractionType): boolean

    function IsReplacingUnit(): boolean

    function IsValidNPCInteraction(type: PlayerInteractionType): boolean

    function ReopenInteraction(): void
  }

  namespace C_PlayerInfo {
    function GUIDIsPlayer(guid: string): boolean

    function GetClass(
      playerLocation: PlayerLocationMixin
    ): LuaMultiReturn<
      [
        className: string | undefined,
        classFilename: string | undefined,
        classID: number | undefined
      ]
    >

    function GetName(playerLocation: PlayerLocationMixin): string | undefined

    function GetRace(playerLocation: PlayerLocationMixin): number | undefined

    function GetSex(playerLocation: PlayerLocationMixin): number | undefined

    function IsConnected(
      playerLocation: PlayerLocationMixin | undefined
    ): boolean | undefined

    function UnitIsSameServer(playerLocation: PlayerLocationMixin): boolean
  }

  namespace C_PlayerMentorship {
    function GetMentorLevelRequirement(): number | undefined

    function GetMentorRequirements(): LuaMultiReturn<
      [
        achievementIDs: number[],
        optionalAchievementIDs: number[],
        optionalCompleteAtLeastCount: number
      ]
    >

    function GetMentorshipStatus(
      playerLocation: PlayerLocationMixin
    ): PlayerMentorshipStatus

    function IsActivePlayerConsideredNewcomer(): boolean

    function IsMentorRestricted(): boolean
  }

  function AcceptAreaSpiritHeal(): void

  function AcceptGuild(): void

  function AcceptResurrect(): void

  function Ambiguate(fullName: string, context: string): string

  function AreAccountAchievementsHidden(): boolean

  function AutoEquipCursorItem(): void

  function BeginTrade(): void

  function CanDualWield(): boolean

  function CanInspect(targetGUID: UnitToken): boolean

  function CanLootUnit(
    targetUnit: string
  ): LuaMultiReturn<[hasLoot: boolean, canLoot: boolean]>

  function CancelAreaSpiritHeal(): void

  function CancelPendingEquip(index: number): void

  function CancelTrade(): void

  function CheckInteractDistance(unitGUID: UnitToken, distIndex: number): boolean

  function CheckTalentMasterDist(): boolean

  function ClearPendingBindConversionItem(): void

  function ConfirmTalentWipe(): void

  function ConvertItemToBindToAccount(): void

  function DeclineGuild(): void

  function DeclineResurrect(): void

  function Dismount(): void

  function EquipPendingItem(index: number): void

  function FollowUnit(name: string, exactMatch: boolean): void

  function GetAllowLowLevelRaid(): boolean

  function GetAreaSpiritHealerTime(): number

  function GetAttackPowerForStat(stat: number, value: number): number

  function GetAutoDeclineGuildInvites(): boolean

  function GetAvoidance(): number

  function GetBindLocation(): string

  function GetBlockChance(): number

  function GetCemeteryPreference(): number

  function GetCombatRating(ratingIndex: number): number | undefined

  function GetCombatRatingBonus(ratingIndex: number): number | undefined

  function GetCombatRatingBonusForCombatRatingValue(
    ratingIndex: number,
    value: number
  ): number | undefined

  function GetCorpseRecoveryDelay(): number

  function GetCorruption(): number

  function GetCorruptionResistance(): number

  function GetCritChance(): number

  function GetCritChanceProvidesParryEffect(): boolean

  function GetDodgeChance(): number

  function GetDodgeChanceFromAttribute(): number

  function GetExpertise(): LuaMultiReturn<
    [mainhandExpertise: number, offhandExpertise: number, rangedExpertise: number]
  >

  function GetHaste(): number

  function GetHitModifier(): number

  function GetJailersTowerLevel(): number

  function GetLifesteal(): number

  function GetLootSpecialization(): number

  function GetManaRegen(): LuaMultiReturn<
    [baseManaRegen: number, castingManaRegen: number]
  >

  function GetMastery(): number

  function GetMasteryEffect(): LuaMultiReturn<
    [masteryEffect: number, bonusCoefficient: number]
  >

  function GetMaxCombatRatingBonus(ratingIndex: number): number | undefined

  function GetMaxPlayerLevel(): number

  function GetMeleeHaste(): number

  function GetModResilienceDamageReduction(): number

  function GetMoney(): number

  function GetNormalizedRealmName(): string

  function GetOverrideAPBySpellPower(): number

  function GetOverrideSpellPowerByAP(): number

  function GetPVPDesired(): boolean

  function GetPVPGearStatRules(): boolean

  function GetPVPLifetimeStats(): LuaMultiReturn<
    [lifetimeHonorableKills: number, lifetimeMaxPVPRank: number]
  >

  function GetPVPSessionStats(): LuaMultiReturn<
    [honorableKills: number, dishonorableKills: number]
  >

  function GetPVPTimer(): number

  function GetPVPYesterdayStats(): LuaMultiReturn<
    [honorableKills: number, dishonorableKills: number]
  >

  function GetParryChance(): number

  function GetParryChanceFromAttribute(): number

  function GetPetMeleeHaste(): number

  function GetPetSpellBonusDamage(): number

  function GetPlayerFacing(): number | undefined

  function GetPlayerInfoByGUID(
    guid: string
  ): LuaMultiReturn<
    [
      localizedClass: string,
      englishClass: string,
      localizedRace: string,
      englishRace: string,
      sex: number,
      name: string,
      realmName: string
    ]
  >

  function GetPowerRegen(): LuaMultiReturn<
    [basePowerRegen: number, castingPowerRegen: number]
  >

  function GetPowerRegenForPowerType(
    powerType: number
  ): LuaMultiReturn<[basePowerRegen: number, castingPowerRegen: number]>

  function GetPvpPowerDamage(): number

  function GetPvpPowerHealing(): number

  function GetRangedCritChance(): number

  function GetRangedHaste(): number

  function GetReleaseTimeRemaining(): number

  function GetResSicknessDuration(): string | undefined

  function GetRestState(): LuaMultiReturn<
    [exhaustionID: number, name: string, factor: number]
  >

  function GetRestrictedAccountData(): LuaMultiReturn<
    [maxLevel: number, maxMoney: number, professionCap: number]
  >

  function GetRuneCooldown(
    runeIndex: number
  ): LuaMultiReturn<[startTime: number, duration: number, isRuneReady: boolean]>

  function GetRuneCount(runeIndex: number): number

  function GetSheathState(): number | undefined

  function GetShieldBlock(): number

  function GetSpeed(): number

  function GetSpellBonusDamage(school: number): number | undefined

  function GetSpellBonusHealing(): number

  function GetSpellCritChance(): number

  function GetSpellHitModifier(): number

  function GetSpellPenetration(): number

  function GetSturdiness(): number

  function GetTaxiBenchmarkMode(): boolean

  function GetVersatilityBonus(combatRating: number): number

  function GetXPExhaustion(): number | undefined

  function HasAPEffectsSpellPower(): boolean

  function HasDualWieldPenalty(): boolean

  function HasFullControl(): boolean

  function HasIgnoreDualWieldWeapon(): boolean

  function HasKey(): boolean

  function HasNoReleaseAura(): LuaMultiReturn<
    [
      hasCannotReleaseEffect: boolean,
      longestDuration: number,
      hasUntilCancelledDuration: boolean
    ]
  >

  function HasSPEffectsAttackPower(): boolean

  function InitiateTrade(guid: UnitToken): void

  function IsAccountSecured(): boolean

  function IsAdvancedFlyableArea(): boolean

  function IsCemeterySelectionAvailable(): boolean

  function IsCharacterNewlyBoosted(): boolean

  function IsDualWielding(): boolean

  function IsFlyableArea(): boolean

  function IsGuildLeader(): boolean

  function IsInGuild(): boolean

  function IsInJailersTower(): boolean

  function IsIndoors(): boolean

  function IsInsane(): boolean

  function IsItemPreferredArmorType(itemLocation: ItemLocationMixin): boolean

  function IsJailersTowerLayerTimeLocked(layerLevel: number): string

  function IsLoggedIn(): boolean

  function IsMounted(): boolean

  function IsOnGroundFloorInJailersTower(): boolean

  function IsOutOfBounds(): boolean

  function IsOutdoors(): boolean

  function IsPVPTimerRunning(): boolean

  function IsPlayerInWorld(): boolean

  function IsPlayerMoving(): boolean

  function IsRangedWeapon(): boolean

  function IsResting(): boolean

  function IsRestrictedAccount(): boolean

  function IsStealthed(): boolean

  function IsXPUserDisabled(): boolean

  function NoPlayTime(): boolean | undefined

  function NotifyInspect(targetGUID: UnitToken): void

  function PartialPlayTime(): boolean | undefined

  function PlayerCanTeleport(): boolean

  function PlayerEffectiveAttackPower(): LuaMultiReturn<
    [mainHandAttackPower: number, offHandAttackPower: number, rangedAttackPower: number]
  >

  function PlayerGetTimerunningSeasonID(): number | undefined

  function PortGraveyard(): void

  function RandomRoll(min: number, max: number): void

  function RepopMe(): void

  function RequestTimePlayed(): void

  function RespondInstanceLock(acceptLock: boolean): void

  function ResurrectGetOfferer(): string

  function ResurrectHasSickness(): boolean

  function ResurrectHasTimer(): boolean

  function RetrieveCorpse(): void

  function SetAllowLowLevelRaid(allow: boolean): void

  function SetAutoDeclineGuildInvites(allow: boolean): void

  function SetCemeteryPreference(cemetaryID: number): void

  function SetLootSpecialization(specializationID: number): void

  function SetTaxiBenchmarkMode(enable: boolean): void

  function ShouldShowIslandsWeeklyPOI(): boolean

  function ShouldShowSpecialSplashScreen(): boolean

  function ShowAccountAchievements(hide: boolean): void

  function ShowCloak(show: boolean): void

  function ShowHelm(show: boolean): void

  function ShowingCloak(): boolean

  function ShowingHelm(): boolean

  function SitStandOrDescendStart(): void

  function SplashFrameCanBeShown(): boolean

  function StartAttack(name: string, exactMatch: boolean): void

  function StopAttack(): void

  function Stuck(): void

  function TimeoutResurrect(): void

  function ToggleSelfHighlight(): boolean

  function ToggleSheath(): void

  function SetPortraitToTexture(texture: Texture, asset: string): void

  namespace C_ProfSpecs {
    function CanRefundPath(pathID: number, configID: number): boolean

    function CanUnlockTab(tabTreeID: number, configID: number): boolean

    function GetChildrenForPath(pathID: number): number[]

    function GetConfigIDForSkillLine(skillLineID: number): number

    function GetCurrencyInfoForSkillLine(skillLineID: number): SpecializationCurrencyInfo

    function GetDefaultSpecSkillLine(): number | undefined

    function GetDescriptionForPath(pathID: number): string

    function GetDescriptionForPerk(perkID: number): string

    function GetEntryIDForPerk(perkID: number): number

    function GetNewSpecReminderProfName(): string | undefined

    function GetPerksForPath(pathID: number): undefined[]

    function GetRootPathForTab(tabTreeID: number): number | undefined

    function GetSourceTextForPath(pathID: number, configID: number): string

    function GetSpecTabIDsForSkillLine(skillLineID: number): number[]

    function GetSpecTabInfo(): SpecializationTabInfo

    function GetSpendCurrencyForPath(pathID: number): number | undefined

    function GetSpendEntryForPath(pathID: number): number

    function GetStateForPath(pathID: number, configID: number): ProfessionsSpecPathState

    function GetStateForPerk(perkID: number, configID: number): ProfessionsSpecPerkState

    function GetStateForTab(tabTreeID: number, configID: number): ProfessionsSpecTabState

    function GetTabInfo(tabTreeID: number): ProfTabInfo | undefined

    function GetUnlockEntryForPath(pathID: number): number

    function GetUnlockRankForPerk(perkID: number): number | undefined

    function ShouldShowPointsReminder(): boolean

    function ShouldShowPointsReminderForSkillLine(skillLineID: number): boolean

    function ShouldShowSpecTab(): boolean

    function SkillLineHasSpecialization(skillLineID: number): boolean
  }

  namespace C_PvP {
    function ArePvpTalentsUnlocked(): boolean

    function CanDisplayDamage(): boolean

    function CanDisplayDeaths(): boolean

    function CanDisplayHealing(): boolean

    function CanDisplayHonorableKills(): boolean

    function CanDisplayKillingBlows(): boolean

    function CanPlayerUseRatedPVPUI(): LuaMultiReturn<
      [canUse: boolean, failureReason: string]
    >

    function CanToggleWarMode(toggle: boolean): boolean

    function CanToggleWarModeInArea(): boolean

    function DoesMatchOutcomeAffectRating(): boolean

    function GetActiveBrawlInfo(): PvpBrawlInfo | undefined

    function GetActiveMatchBracket(): number

    function GetActiveMatchDuration(): number

    function GetActiveMatchState(): PvPMatchState

    function GetActiveMatchWinner(): number

    function GetArenaCrowdControlInfo(
      playerToken: UnitToken
    ): LuaMultiReturn<[spellID: number, startTime: number, duration: number]>

    function GetArenaRewards(
      teamSize: number
    ): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined
      ]
    >

    function GetArenaSkirmishRewards(): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined
      ]
    >

    function GetAssignedSpecForBattlefieldQueue(queueID: number): number | undefined

    function GetAvailableBrawlInfo(): PvpBrawlInfo | undefined

    function GetBattlefieldFlagPosition(
      flagIndex: number,
      uiMapId: number
    ): LuaMultiReturn<
      [uiPosx: number | undefined, uiPosy: number | undefined, flagTexture: number]
    >

    function GetBattlefieldVehicleInfo(
      vehicleIndex: number,
      uiMapID: number
    ): BattlefieldVehicleInfo

    function GetBattlefieldVehicles(uiMapID: number): undefined[]

    function GetBrawlRewards(
      brawlType: BrawlType
    ): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined,
        hasWon: boolean
      ]
    >

    function GetBrawlSoloRBGMinItemLevel(): number

    function GetCustomVictoryStatID(): number

    function GetGlobalPvpScalingInfoForSpecID(specializationID: number): undefined[]

    function GetHonorRewardInfo(honorLevel: number): HonorRewardInfo | undefined

    function GetLevelUpBattlegrounds(level: number): undefined[]

    function GetMatchPVPStatColumn(pvpStatID: number): MatchPVPStatColumn | undefined

    function GetMatchPVPStatColumns(): undefined[]

    function GetNextHonorLevelForReward(honorLevel: number): number | undefined

    function GetOutdoorPvPWaitTime(uiMapID: number): number

    function GetPVPActiveMatchPersonalRatedInfo(): PVPPersonalRatedInfo | undefined

    function GetPVPActiveRatedMatchDeserterPenalty():
      | RatedMatchDeserterPenalty
      | undefined

    function GetPVPSeasonRewardAchievementID(): number

    function GetPersonalRatedBGBlitzSpecStats(): RatedBGBlitzSpecStats | undefined

    function GetPersonalRatedSoloShuffleSpecStats(): RatedSoloShuffleSpecStats | undefined

    function GetPostMatchCurrencyRewards(): undefined[]

    function GetPostMatchItemRewards(): undefined[]

    function GetPvpTalentsUnlockedLevel(): number

    function GetPvpTierID(tierEnum: number, bracketEnum: number): number | undefined

    function GetPvpTierInfo(tierID: number): PvpTierInfo | undefined

    function GetRandomBGInfo(): RandomBGInfo

    function GetRandomBGRewards(): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined
      ]
    >

    function GetRandomEpicBGInfo(): RandomBGInfo

    function GetRandomEpicBGRewards(): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined
      ]
    >

    function GetRatedBGRewards(): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined
      ]
    >

    function GetRatedSoloRBGMinItemLevel(): number

    function GetRatedSoloRBGRewards(): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined
      ]
    >

    function GetRatedSoloShuffleMinItemLevel(): number

    function GetRatedSoloShuffleRewards(): LuaMultiReturn<
      [
        honor: number,
        experience: number,
        itemRewards: undefined[] | undefined,
        currencyRewards: undefined[] | undefined,
        roleShortageBonus: RoleShortageReward | undefined
      ]
    >

    function GetRewardItemLevelsByTierEnum(
      pvpTierEnum: number
    ): LuaMultiReturn<[activityItemLevel: number, weeklyItemLevel: number]>

    function GetScoreInfo(offsetIndex: number): PVPScoreInfo | undefined

    function GetScoreInfoByPlayerGuid(guid: string): PVPScoreInfo | undefined

    function GetSeasonBestInfo(): LuaMultiReturn<
      [tierID: number, nextTierID: number | undefined]
    >

    function GetSkirmishInfo(pvpBracket: number): BattlemasterListInfo

    function GetSpecialEventBrawlInfo(): PvpBrawlInfo | undefined

    function GetTeamInfo(factionIndex: number): PVPTeamInfo | undefined

    function GetUIDisplaySeason(): number

    function GetWarModeRewardBonus(): number

    function GetWarModeRewardBonusDefault(): number

    function GetWeeklyChestInfo(): LuaMultiReturn<
      [
        rewardAchieved: boolean,
        lastWeekRewardAchieved: boolean,
        lastWeekRewardClaimed: boolean,
        pvpTierMaxFromWins: number
      ]
    >

    function GetZonePVPInfo(): LuaMultiReturn<
      [pvpType: string, isSubZonePvP: boolean, factionName: string | undefined]
    >

    function HasArenaSkirmishWinToday(): boolean

    function IsActiveBattlefield(): boolean

    function IsActiveMatchRegistered(): boolean

    function IsArena(): boolean

    function IsBattleground(): boolean

    function IsBattlegroundEnlistmentBonusActive(): LuaMultiReturn<
      [battlegroundActive: boolean, brawlActive: boolean]
    >

    function IsBrawlSoloRBG(): boolean

    function IsBrawlSoloShuffle(): boolean

    function IsInBrawl(): boolean

    function IsInRatedMatchWithDeserterPenalty(): boolean

    function IsMatchActive(): boolean

    function IsMatchComplete(): boolean

    function IsMatchConsideredArena(): boolean

    function IsMatchFactional(): boolean

    function IsPVPMap(): boolean

    function IsRatedArena(): boolean

    function IsRatedBattleground(): boolean

    function IsRatedMap(): boolean

    function IsRatedSoloRBG(): boolean

    function IsRatedSoloShuffle(): boolean

    function IsSoloRBG(): boolean

    function IsSoloShuffle(): boolean

    function IsSubZonePVPPOI(): boolean

    function IsWarModeActive(): boolean

    function IsWarModeDesired(): boolean

    function IsWarModeFeatureEnabled(): boolean

    function JoinBrawl(isSpecialBrawl: boolean): void

    function JoinRatedBGBlitz(): void

    function RequestCrowdControlSpell(playerToken: UnitToken): void

    function SetPVP(enablePVP: boolean): void

    function SetWarModeDesired(warModeDesired: boolean): void

    function StartSoloRBGWarGameByName(args: string): number

    function StartSpectatorSoloRBGWarGame(
      opaqueID1: number,
      opaqueID2: number,
      specifiedMap: string,
      tournamentRules: boolean
    ): number

    function TogglePVP(): void

    function ToggleWarMode(): void
  }

  namespace C_QuestHub {
    function IsQuestCurrentlyRelatedToHub(questID: number, areaPoiID: number): boolean
  }

  namespace C_QuestInfoSystem {
    function GetQuestClassification(
      questID: number | undefined
    ): QuestClassification | undefined

    function GetQuestRewardCurrencies(questID: number | undefined): undefined[]

    function GetQuestRewardSpellInfo(
      questID: number | undefined,
      spellID: number
    ): QuestRewardSpellInfo | undefined

    function GetQuestRewardSpells(questID: number | undefined): number[]

    function GetQuestShouldToastCompletion(questID: number | undefined): boolean

    function HasQuestRewardCurrencies(questID: number | undefined): boolean

    function HasQuestRewardSpells(questID: number | undefined): boolean
  }

  namespace C_QuestItemUse {
    function CanUseQuestItemOnObject(
      item: ItemLocationMixin,
      unit: UnitToken,
      checkRange: boolean | undefined
    ): boolean
  }

  namespace C_QuestLine {
    function GetAvailableQuestLines(uiMapID: number): undefined[]

    function GetForceVisibleQuests(uiMapID: number): number[]

    function GetQuestLineInfo(
      questID: number,
      uiMapID: number | undefined,
      displayableOnly: boolean
    ): QuestLineInfo | undefined

    function GetQuestLineQuests(questLineID: number): number[]

    function IsComplete(questLineID: number): boolean

    function QuestLineIgnoresAccountCompletedFiltering(
      uiMapID: number,
      questLineID: number
    ): boolean

    function RequestQuestLinesForMap(uiMapID: number): void
  }

  namespace C_QuestLog {
    function AbandonQuest(): void

    function AddQuestWatch(questID: number): boolean

    function AddWorldQuestWatch(
      questID: number,
      watchType: QuestWatchType | undefined
    ): boolean

    function CanAbandonQuest(questID: number): boolean

    function DoesQuestAwardReputationWithFaction(
      questID: number,
      factionID: number
    ): boolean

    function GetAbandonQuest(): number

    function GetAbandonQuestItems(): number[]

    function GetActiveThreatMaps(): number[]

    function GetAllCompletedQuestIDs(): number[]

    function GetBountiesForMapID(uiMapID: number): undefined[] | undefined

    function GetBountySetInfoForMapID(
      uiMapID: number
    ): LuaMultiReturn<
      [
        displayLocation: MapOverlayDisplayLocation,
        lockQuestID: number,
        bountySetID: number,
        isActivitySet: boolean
      ]
    >

    function GetDistanceSqToQuest(
      questID: number
    ): LuaMultiReturn<[distanceSq: number, onContinent: boolean]>

    function GetHeaderIndexForQuest(questID: number): number | undefined

    function GetInfo(questLogIndex: number): QuestInfo | undefined

    function GetLogIndexForQuestID(questID: number): number | undefined

    function GetMapForQuestPOIs(): number

    function GetMaxNumQuests(): number

    function GetMaxNumQuestsCanAccept(): number

    function GetNextWaypoint(
      questID: number
    ): LuaMultiReturn<[mapID: number, x: number, y: number]>

    function GetNextWaypointForMap(
      questID: number,
      uiMapID: number
    ): LuaMultiReturn<[x: number, y: number]>

    function GetNextWaypointText(questID: number): string

    function GetNumQuestLogEntries(): LuaMultiReturn<
      [numShownEntries: number, numQuests: number]
    >

    function GetNumQuestObjectives(questID: number): number

    function GetNumQuestWatches(): number

    function GetNumWorldQuestWatches(): number

    function GetQuestAdditionalHighlights(
      questID: number
    ): LuaMultiReturn<
      [
        uiMapID: number,
        worldQuests: boolean,
        worldQuestsElite: boolean,
        dungeons: boolean,
        treasures: boolean
      ]
    >

    function GetQuestDetailsTheme(questID: number): QuestTheme | undefined

    function GetQuestDifficultyLevel(questID: number): number

    function GetQuestIDForLogIndex(questLogIndex: number): number | undefined

    function GetQuestIDForQuestWatchIndex(questWatchIndex: number): number | undefined

    function GetQuestIDForWorldQuestWatchIndex(
      questWatchIndex: number
    ): number | undefined

    function GetQuestLogMajorFactionReputationRewards(questID: number): undefined[]

    function GetQuestLogPortraitGiver(
      questLogIndex: number | undefined
    ): LuaMultiReturn<
      [
        portraitGiver: number,
        portraitGiverText: string,
        portraitGiverName: string,
        portraitGiverMount: number,
        portraitGiverModelSceneID: number | undefined
      ]
    >

    function GetQuestObjectives(questID: number): undefined[]

    function GetQuestRewardCurrencies(questID: number): undefined[]

    function GetQuestRewardCurrencyInfo(
      questID: number,
      currencyIndex: number,
      isChoice: boolean
    ): QuestRewardCurrencyInfo | undefined

    function GetQuestTagInfo(questID: number): QuestTagInfo | undefined

    function GetQuestType(questID: number): number | undefined

    function GetQuestWatchType(questID: number): QuestWatchType | undefined

    function GetQuestsOnMap(uiMapID: number): undefined[]

    function GetRequiredMoney(questID: number | undefined): number

    function GetSelectedQuest(): number

    function GetSuggestedGroupSize(questID: number): number

    function GetTimeAllowed(
      questID: number
    ): LuaMultiReturn<[totalTime: number, elapsedTime: number]>

    function GetTitleForLogIndex(questLogIndex: number): string | undefined

    function GetTitleForQuestID(questID: number): string | undefined

    function GetZoneStoryInfo(
      uiMapID: number
    ): LuaMultiReturn<[achievementID: number, storyMapID: number]>

    function HasActiveThreats(): boolean

    function IsAccountQuest(questID: number): boolean

    function IsComplete(questID: number): boolean

    function IsFailed(questID: number): boolean

    function IsImportantQuest(questID: number): boolean

    function IsLegendaryQuest(questID: number): boolean

    function IsMetaQuest(questID: number): boolean

    function IsOnMap(
      questID: number
    ): LuaMultiReturn<[onMap: boolean, hasLocalPOI: boolean]>

    function IsOnQuest(questID: number): boolean

    function IsPushableQuest(questID: number): boolean

    function IsQuestBounty(questID: number): boolean

    function IsQuestCalling(questID: number): boolean

    function IsQuestCriteriaForBounty(questID: number, bountyQuestID: number): boolean

    function IsQuestDisabledForSession(questID: number): boolean

    function IsQuestFlaggedCompleted(questID: number): boolean

    function IsQuestFlaggedCompletedOnAccount(questID: number): boolean

    function IsQuestFromContentPush(questID: number): boolean

    function IsQuestInvasion(questID: number): boolean

    function IsQuestRepeatableType(questID: number): boolean

    function IsQuestReplayable(questID: number): boolean

    function IsQuestReplayedRecently(questID: number): boolean

    function IsQuestTask(questID: number): boolean

    function IsQuestTrivial(questID: number): boolean

    function IsRepeatableQuest(questID: number): boolean

    function IsThreatQuest(questID: number): boolean

    function IsUnitOnQuest(unit: UnitToken, questID: number): boolean

    function IsWorldQuest(questID: number): boolean

    function QuestCanHaveWarModeBonus(questID: number): boolean

    function QuestHasQuestSessionBonus(questID: number): boolean

    function QuestHasWarModeBonus(questID: number): boolean

    function QuestIgnoresAccountCompletedFiltering(questID: number): boolean

    function ReadyForTurnIn(questID: number): boolean | undefined

    function RemoveQuestWatch(questID: number): boolean

    function RemoveWorldQuestWatch(questID: number): boolean

    function RequestLoadQuestByID(questID: number): void

    function SetAbandonQuest(): void

    function SetMapForQuestPOIs(uiMapID: number): void

    function SetSelectedQuest(questID: number): void

    function ShouldDisplayTimeRemaining(questID: number): boolean

    function ShouldShowQuestRewards(questID: number): boolean

    function SortQuestWatches(): void

    function UnitIsRelatedToActiveQuest(unit: UnitToken): boolean

    function UpdateCampaignHeaders(): void
  }

  namespace C_QuestOffer {
    function GetHideRequiredItems(): boolean

    function GetQuestOfferMajorFactionReputationRewards(): undefined[]

    function GetQuestRequiredCurrencyInfo(
      questRewardIndex: number
    ): QuestRequiredCurrencyInfo | undefined

    function GetQuestRewardCurrencyInfo(
      questInfoType: string,
      questRewardIndex: number
    ): QuestRewardCurrencyInfo | undefined
  }

  namespace C_QuestSession {
    function CanStart(): boolean

    function CanStop(): boolean

    function Exists(): boolean

    function GetAvailableSessionCommand(): QuestSessionCommand

    function GetPendingCommand(): QuestSessionCommand

    function GetProposedMaxLevelForSession(): number

    function GetSessionBeginDetails(): QuestSessionPlayerDetails | undefined

    function GetSuperTrackedQuest(): number | undefined

    function HasJoined(): boolean

    function HasPendingCommand(): boolean

    function RequestSessionStart(): void

    function RequestSessionStop(): void

    function SendSessionBeginResponse(beginSession: boolean): void

    function SetQuestIsSuperTracked(questID: number, superTrack: boolean): void
  }

  namespace C_TaskQuest {
    function DoesMapShowTaskQuestObjectives(uiMapID: number): boolean

    function GetQuestIconUIWidgetSet(questID: number): number

    function GetQuestInfoByQuestID(
      questID: number
    ): LuaMultiReturn<
      [
        questTitle: string,
        factionID: number | undefined,
        capped: boolean | undefined,
        displayAsObjective: boolean | undefined
      ]
    >

    function GetQuestLocation(
      questID: number,
      uiMapID: number
    ): LuaMultiReturn<[locationX: number, locationY: number]>

    function GetQuestProgressBarInfo(questID: number): number

    function GetQuestTimeLeftMinutes(questID: number): number

    function GetQuestTimeLeftSeconds(questID: number): number

    function GetQuestTooltipUIWidgetSet(questID: number): number

    function GetQuestZoneID(questID: number): number

    function GetQuestsForPlayerByMapID(uiMapID: number): undefined[]

    function GetThreatQuests(): number[]

    function IsActive(questID: number): boolean

    function RequestPreloadRewardData(questID: number): void
  }

  namespace C_RaidLocks {
    function IsEncounterComplete(
      mapID: number,
      encounterID: number,
      difficultyID: number | undefined
    ): boolean
  }

  namespace C_RecruitAFriend {
    function CanSummonFriend(guid: string): boolean

    function ClaimActivityReward(activityID: number, acceptanceID: string): boolean

    function ClaimNextReward(
      rafVersion: RecruitAFriendRewardsVersion | undefined
    ): boolean

    function GenerateRecruitmentLink(): boolean

    function GetRAFInfo(): RafInfo

    function GetRAFSystemInfo(): RafSystemInfo

    function GetRecruitActivityRequirementsText(
      activityID: number,
      acceptanceID: string
    ): string[]

    function GetRecruitInfo(): LuaMultiReturn<[active: boolean, faction: number]>

    function GetSummonFriendCooldown(): LuaMultiReturn<
      [startTimeSeconds: number, durationSeconds: number, enableCooldownTimer: boolean]
    >

    function IsEnabled(): boolean

    function IsRecruitAFriendLinked(guid: string): boolean

    function IsRecruitingEnabled(): boolean

    function RemoveRAFRecruit(wowAccountGUID: string): boolean

    function RequestUpdatedRecruitmentInfo(): boolean

    function SummonFriend(target: string, name: string): void
  }

  namespace C_ReportSystem {
    function CanReportPlayer(playerLocation: PlayerLocationMixin): boolean

    function CanReportPlayerForLanguage(playerLocation: PlayerLocationMixin): boolean

    function GetMajorCategoriesForReportType(reportType: ReportType): undefined[]

    function GetMajorCategoryString(majorCategory: ReportMajorCategory): string

    function GetMinorCategoriesForReportTypeAndMajorCategory(
      reportType: ReportType,
      majorCategory: ReportMajorCategory
    ): undefined[]

    function GetMinorCategoryString(minorCategory: ReportMinorCategory): string

    function ReportServerLag(): void

    function ReportStuckInCombat(): void

    function SendReport(
      reportInfo: ReportInfoMixin,
      playerLocation: PlayerLocationMixin | undefined
    ): void
  }

  namespace C_Reputation {
    function AreLegacyReputationsShown(): boolean

    function CollapseAllFactionHeaders(): void

    function CollapseFactionHeader(factionSortIndex: number): void

    function ExpandAllFactionHeaders(): void

    function ExpandFactionHeader(factionSortIndex: number): void

    function GetFactionDataByID(factionID: number): FactionData | undefined

    function GetFactionDataByIndex(factionSortIndex: number): FactionData | undefined

    function GetFactionParagonInfo(
      factionID: number
    ): LuaMultiReturn<
      [
        currentValue: number,
        threshold: number,
        rewardQuestID: number,
        hasRewardPending: boolean,
        tooLowLevelForParagon: boolean
      ]
    >

    function GetGuildFactionData(): FactionData | undefined

    function GetGuildRepExpirationTime(): number | undefined

    function GetNumFactions(): number

    function GetReputationSortType(): ReputationSortType

    function GetSelectedFaction(): number

    function GetWatchedFactionData(): FactionData | undefined

    function IsAccountWideReputation(factionID: number): boolean

    function IsFactionActive(factionSortIndex: number): boolean

    function IsFactionParagon(factionID: number): boolean

    function IsMajorFaction(factionID: number): boolean

    function RequestFactionParagonPreloadRewardData(factionID: number): void

    function SetFactionActive(factionSortIndex: number, setActive: boolean): void

    function SetLegacyReputationsShown(showLegacyReputations: boolean): void

    function SetReputationSortType(sortType: ReputationSortType): void

    function SetSelectedFaction(factionSortIndex: number): void

    function SetWatchedFactionByID(factionID: number): void

    function SetWatchedFactionByIndex(factionSortIndex: number): void

    function ToggleFactionAtWar(factionSortIndex: number): void
  }

  namespace C_ResearchInfo {
    function GetDigSitesForMap(uiMapID: number): undefined[]
  }

  function InCombatLockdown(): boolean

  namespace C_ReturningPlayerUI {
    function AcceptPrompt(): void

    function DeclinePrompt(): void
  }

  namespace C_ScenarioInfo {
    function GetCriteriaInfo(criteriaIndex: number): ScenarioCriteriaInfo

    function GetCriteriaInfoByStep(
      stepID: number,
      criteriaIndex: number
    ): ScenarioCriteriaInfo

    function GetJailersTowerTypeString(runType: JailersTowerType): string | undefined

    function GetScenarioInfo(): ScenarioInformation

    function GetScenarioStepInfo(scenarioStepID: number | undefined): ScenarioStepInfo
  }

  namespace C_ScrappingMachineUI {
    function CloseScrappingMachine(): void

    function DropPendingScrapItemFromCursor(index: number): void

    function GetCurrentPendingScrapItemLocationByIndex(index: number): ItemLocationMixin

    function GetScrapSpellID(): number

    function GetScrappingMachineName(): string

    function HasScrappableItems(): boolean

    function RemoveAllScrapItems(): void

    function RemoveCurrentScrappingItem(): void

    function RemoveItemToScrap(index: number): void

    function ScrapItems(): void

    function ValidateScrappingList(): void
  }

  function GetDefaultScale(): number

  function GetPhysicalScreenSize(): LuaMultiReturn<[sizeX: number, sizeY: number]>

  function GetScreenDPIScale(): number

  function GetScreenHeight(): number

  function GetScreenWidth(): number

  namespace C_ScriptedAnimations {
    function GetAllScriptedAnimationEffects(): undefined[]
  }

  namespace C_SeasonInfo {
    function GetCurrentDisplaySeasonExpansion(): number | undefined

    function GetCurrentDisplaySeasonID(): number
  }

  namespace C_Traits {
    function CanPurchaseRank(
      configID: number,
      nodeID: number,
      nodeEntryID: number
    ): boolean

    function CanRefundRank(configID: number, nodeID: number): boolean

    function CascadeRepurchaseRanks(
      configID: number,
      nodeID: number,
      entryID: number | undefined
    ): boolean

    function ClearCascadeRepurchaseHistory(configID: number): void

    function CloseTraitSystemInteraction(): void

    function CommitConfig(configID: number): boolean

    function ConfigHasStagedChanges(configID: number): boolean

    function GenerateImportString(configID: number): string

    function GenerateInspectImportString(target: string): string

    function GetConditionInfo(configID: number, condID: number): TraitCondInfo

    function GetConfigIDBySystemID(systemID: number): number

    function GetConfigIDByTreeID(treeID: number): number

    function GetConfigInfo(configID: number): TraitConfigInfo

    function GetConfigsByType(configType: TraitConfigType): number[]

    function GetDefinitionInfo(definitionID: number): TraitDefinitionInfo

    function GetEntryInfo(configID: number, entryID: number): TraitEntryInfo

    function GetLoadoutSerializationVersion(): number

    function GetNodeCost(configID: number, nodeID: number): undefined[]

    function GetNodeInfo(configID: number, nodeID: number): TraitNodeInfo

    function GetStagedChanges(
      configID: number
    ): LuaMultiReturn<
      [
        nodeIDsWithPurchases: number[],
        nodeIDsWithRefunds: number[],
        nodeIDsWithSelectionSwaps: number[]
      ]
    >

    function GetStagedChangesCost(configID: number): undefined[]

    function GetSubTreeInfo(configID: number, subTreeID: number): TraitSubTreeInfo

    function GetSystemIDByTreeID(treeID: number): number

    function GetTraitCurrencyInfo(
      traitCurrencyID: number
    ): LuaMultiReturn<
      [
        flags: number,
        type: number,
        currencyTypesID: number | undefined,
        icon: number | undefined
      ]
    >

    function GetTraitDescription(entryID: number, rank: number): string

    function GetTraitSystemFlags(configID: number): number

    function GetTraitSystemWidgetSetID(configID: number): number

    function GetTreeCurrencyInfo(
      configID: number,
      treeID: number,
      excludeStagedChanges: boolean
    ): undefined[]

    function GetTreeHash(treeID: number): number[]

    function GetTreeInfo(configID: number, treeID: number): TraitTreeInfo

    function GetTreeNodes(treeID: number): number[]

    function HasValidInspectData(): boolean

    function IsReadyForCommit(): boolean

    function PurchaseRank(configID: number, nodeID: number): boolean

    function RefundAllRanks(configID: number, nodeID: number): boolean

    function RefundRank(
      configID: number,
      nodeID: number,
      clearEdges: boolean | undefined
    ): boolean

    function ResetTree(configID: number, treeID: number): boolean

    function ResetTreeByCurrency(
      configID: number,
      treeID: number,
      traitCurrencyID: number
    ): boolean

    function RollbackConfig(configID: number): boolean

    function SetSelection(
      configID: number,
      nodeID: number,
      nodeEntryID: number | undefined,
      clearEdges: boolean | undefined
    ): boolean

    function StageConfig(configID: number): boolean

    function TalentTestUnlearnSpells(): void
  }

  function AreDangerousScriptsAllowed(): boolean

  function SetAllowDangerousScripts(allowed: boolean): void

  namespace C_Social {
    function GetLastAchievement(): LuaMultiReturn<
      [
        achievementID: number,
        achievementName: string,
        achievementDesc: string,
        iconFileID: number
      ]
    >

    function GetLastItem(): LuaMultiReturn<
      [
        itemID: number,
        itemName: string,
        iconFileID: number,
        itemQuality: number,
        itemLevel: number,
        itemLinkString: string
      ]
    >

    function GetLastScreenshotIndex(): number

    function GetMaxTweetLength(): number

    function GetScreenshotInfoByIndex(
      index: number
    ): LuaMultiReturn<[screenWidth: number, screenHeight: number]>

    function GetTweetLength(tweetText: string): number

    function IsSocialEnabled(): boolean

    function TwitterCheckStatus(): void

    function TwitterConnect(): void

    function TwitterDisconnect(): void

    function TwitterGetMSTillCanPost(): number

    function TwitterPostMessage(message: string): void
  }

  namespace C_SocialQueue {
    function GetAllGroups(
      allowNonJoinable: boolean,
      allowNonQueuedGroups: boolean
    ): string[]

    function GetConfig(): SocialQueueConfig

    function GetGroupForPlayer(
      playerGUID: string
    ): LuaMultiReturn<[groupGUID: string, isSoloQueueParty: boolean]>

    function GetGroupInfo(
      groupGUID: string
    ): LuaMultiReturn<
      [
        canJoin: boolean,
        numQueues: number,
        needTank: boolean,
        needHealer: boolean,
        needDamage: boolean,
        isSoloQueueParty: boolean,
        questSessionActive: boolean,
        leaderGUID: string
      ]
    >

    function GetGroupMembers(groupGUID: string): undefined[]

    function GetGroupQueues(groupGUID: string): undefined[]

    function RequestToJoin(
      groupGUID: string,
      applyAsTank: boolean,
      applyAsHealer: boolean,
      applyAsDamage: boolean
    ): boolean

    function SignalToastDisplayed(groupGUID: string, priority: number): void
  }

  namespace C_SocialRestrictions {
    function AcknowledgeRegionalChatDisabled(): void

    function IsChatDisabled(): boolean

    function IsMuted(): boolean

    function IsSilenced(): boolean

    function IsSquelched(): boolean

    function SetChatDisabled(disabled: boolean): void
  }

  namespace C_Soulbinds {
    function ActivateSoulbind(soulbindID: number): void

    function CanActivateSoulbind(
      soulbindID: number
    ): LuaMultiReturn<[result: boolean, errorDescription: string | undefined]>

    function CanModifySoulbind(): boolean

    function CanResetConduitsInSoulbind(
      soulbindID: number
    ): LuaMultiReturn<[result: boolean, errorDescription: string | undefined]>

    function CanSwitchActiveSoulbindTreeBranch(): boolean

    function CloseUI(): void

    function CommitPendingConduitsInSoulbind(soulbindID: number): void

    function FindNodeIDActuallyInstalled(soulbindID: number, conduitID: number): number

    function FindNodeIDAppearingInstalled(soulbindID: number, conduitID: number): number

    function FindNodeIDPendingInstall(soulbindID: number, conduitID: number): number

    function FindNodeIDPendingUninstall(soulbindID: number, conduitID: number): number

    function GetActiveSoulbindID(): number

    function GetConduitCollection(conduitType: SoulbindConduitType): undefined[]

    function GetConduitCollectionCount(): number

    function GetConduitCollectionData(
      conduitID: number
    ): ConduitCollectionData | undefined

    function GetConduitCollectionDataAtCursor(): ConduitCollectionData | undefined

    function GetConduitCollectionDataByVirtualID(
      virtualID: number
    ): ConduitCollectionData | undefined

    function GetConduitDisplayed(nodeID: number): number

    function GetConduitHyperlink(conduitID: number, rank: number): string

    function GetConduitIDPendingInstall(nodeID: number): number

    function GetConduitQuality(conduitID: number, rank: number): number

    function GetConduitRank(conduitID: number): number

    function GetConduitSpellID(conduitID: number, conduitRank: number): number

    function GetInstalledConduitID(nodeID: number): number

    function GetNode(nodeID: number): SoulbindNode

    function GetSoulbindData(soulbindID: number): SoulbindData

    function GetSpecsAssignedToSoulbind(soulbindID: number): number[]

    function GetTree(treeID: number): SoulbindTree

    function HasAnyInstalledConduitInSoulbind(soulbindID: number): boolean

    function HasAnyPendingConduits(): boolean

    function HasPendingConduitsInSoulbind(soulbindID: number): boolean

    function IsConduitInstalled(nodeID: number): boolean

    function IsConduitInstalledInSoulbind(soulbindID: number, conduitID: number): boolean

    function IsItemConduitByItemInfo(itemInfo: string | number): boolean

    function IsNodePendingModify(nodeID: number): boolean

    function IsUnselectedConduitPendingInSoulbind(soulbindID: number): boolean

    function ModifyNode(
      nodeID: number,
      conduitID: number,
      type: SoulbindConduitTransactionType
    ): void

    function SelectNode(nodeID: number): void

    function UnmodifyNode(nodeID: number): void
  }

  namespace C_Sound {
    function GetSoundScaledVolume(soundHandle: number): number

    function IsPlaying(soundHandle: number): boolean

    function PlayItemSound(
      soundType: ItemSoundType,
      itemLocation: ItemLocationMixin
    ): void

    function PlayVocalErrorSound(vocalErrorSoundID: number): void
  }

  namespace C_SpecializationInfo {
    function CanPlayerUsePVPTalentUI(): LuaMultiReturn<
      [canUse: boolean, failureReason: string]
    >

    function CanPlayerUseTalentSpecUI(): LuaMultiReturn<
      [canUse: boolean, failureReason: string]
    >

    function CanPlayerUseTalentUI(): LuaMultiReturn<
      [canUse: boolean, failureReason: string]
    >

    function GetAllSelectedPvpTalentIDs(): number[]

    function GetClassIDFromSpecID(specID: number): number | undefined

    function GetInspectSelectedPvpTalent(
      inspectedUnit: UnitToken,
      talentIndex: number
    ): number | undefined

    function GetPvpTalentAlertStatus(): LuaMultiReturn<
      [hasUnspentSlot: boolean, hasNewTalent: boolean]
    >

    function GetPvpTalentInfo(talentID: number): PvpTalentInfo | undefined

    function GetPvpTalentSlotInfo(talentIndex: number): PvpTalentSlotInfo | undefined

    function GetPvpTalentSlotUnlockLevel(talentIndex: number): number | undefined

    function GetPvpTalentUnlockLevel(talentID: number): number | undefined

    function GetSpecIDs(specSetID: number): number[]

    function GetSpellsDisplay(specializationID: number): number[]

    function IsInitialized(): boolean

    function IsPvpTalentLocked(talentID: number): boolean

    function MatchesCurrentSpecSet(specSetID: number): boolean

    function SetPvpTalentLocked(talentID: number, locked: boolean): void
  }

  function GetNumSpecializationsForClassID(specID: number): number

  function GetSpecializationInfoForClassID(
    classID: number,
    index: number,
    gender: number | undefined
  ): LuaMultiReturn<
    [
      id: number,
      name: string,
      description: string,
      icon: number,
      role: string,
      recommended: boolean,
      allowedForBoost: boolean,
      masterySpell1: number | undefined,
      masterySpell2: number | undefined
    ]
  >

  function GetSpecializationInfoForSpecID(
    specID: number,
    gender: number | undefined
  ): LuaMultiReturn<
    [
      id: number,
      name: string,
      description: string,
      icon: number,
      role: string,
      recommended: boolean,
      allowedForBoost: boolean,
      masterySpell1: number | undefined,
      masterySpell2: number | undefined
    ]
  >

  function GetSpecializationNameForSpecID(
    specID: number,
    gender: number | undefined
  ): string | undefined

  namespace C_SpellBook {
    function CastSpellBookItem(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank,
      targetSelf: boolean
    ): void

    function ContainsAnyDisenchantSpell(): boolean

    function FindSpellBookSlotForSpell(
      spellIdentifier: number,
      includeHidden: boolean,
      includeFlyouts: boolean,
      includeFutureSpells: boolean,
      includeOffSpec: boolean
    ): LuaMultiReturn<
      [spellBookItemSlotIndex: number, spellBookItemSpellBank: SpellBookSpellBank]
    >

    function GetCurrentLevelSpells(level: number): number[]

    function GetNumSpellBookSkillLines(): number

    function GetSkillLineIndexByID(skillLineID: number): number | undefined

    function GetSpellBookItemAutoCast(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): LuaMultiReturn<[autoCastAllowed: boolean, autoCastEnabled: boolean]>

    function GetSpellBookItemCastCount(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): number

    function GetSpellBookItemCharges(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): SpellChargeInfo

    function GetSpellBookItemCooldown(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): SpellCooldownInfo

    function GetSpellBookItemDescription(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): string

    function GetSpellBookItemInfo(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): SpellBookItemInfo

    function GetSpellBookItemLevelLearned(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): number

    function GetSpellBookItemLink(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank,
      glyphID: number | undefined
    ): string

    function GetSpellBookItemLossOfControlCooldown(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): LuaMultiReturn<[startTime: number, duration: number]>

    function GetSpellBookItemName(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): LuaMultiReturn<[name: string, subName: string]>

    function GetSpellBookItemPowerCost(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): undefined[]

    function GetSpellBookItemSkillLineIndex(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): number | undefined

    function GetSpellBookItemTexture(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): number

    function GetSpellBookItemTradeSkillLink(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): string

    function GetSpellBookItemType(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): LuaMultiReturn<
      [itemType: SpellBookItemType, actionID: number, spellID: number | undefined]
    >

    function GetSpellBookSkillLineInfo(skillLineIndex: number): SpellBookSkillLineInfo

    function GetTrackedNameplateCooldownSpells(): number[]

    function HasPetSpells(): LuaMultiReturn<[numPetSpells: number, petNameToken: string]>

    function IsAutoAttackSpellBookItem(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsClassTalentSpellBookItem(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsPvPTalentSpellBookItem(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsRangedAutoAttackSpellBookItem(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsSpellBookItemHarmful(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsSpellBookItemHelpful(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsSpellBookItemInRange(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank,
      targetUnit: UnitToken | undefined
    ): boolean | undefined

    function IsSpellBookItemOffSpec(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsSpellBookItemPassive(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function IsSpellBookItemUsable(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): LuaMultiReturn<[isUsable: boolean, insufficientPower: boolean]>

    function PickupSpellBookItem(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): void

    function SetSpellBookItemAutoCastEnabled(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank,
      enabled: boolean
    ): void

    function SpellBookItemHasRange(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): boolean

    function ToggleSpellBookItemAutoCast(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): void
  }

  namespace C_Spell {
    function DoesSpellExist(spellIdentifier: number): boolean

    function GetDeadlyDebuffInfo(spellIdentifier: number): DeadlyDebuffInfo

    function GetMawPowerBorderAtlasBySpellID(spellID: number): string

    function GetMawPowerLinkBySpellID(spellID: number): string

    function GetOverrideSpell(
      spellIdentifier: number,
      spec: number,
      onlyKnown: boolean,
      ignoreOverrideSpellID: number
    ): number

    function GetSchoolString(schoolMask: number): string

    function GetSpellAutoCast(
      spellIdentifier: number
    ): LuaMultiReturn<[autoCastAllowed: boolean, autoCastEnabled: boolean]>

    function GetSpellCastCount(spellIdentifier: number): number

    function GetSpellCharges(spellIdentifier: number): SpellChargeInfo

    function GetSpellCooldown(spellIdentifier: number): SpellCooldownInfo

    function GetSpellDescription(spellIdentifier: number): string

    function GetSpellIDForSpellIdentifier(spellIdentifier: number): number

    function GetSpellInfo(spellIdentifier: number): SpellInfo

    function GetSpellLevelLearned(spellIdentifier: number): number

    function GetSpellLink(spellIdentifier: number, glyphID: number | undefined): string

    function GetSpellLossOfControlCooldown(
      spellIdentifier: number
    ): LuaMultiReturn<[startTime: number, duration: number]>

    function GetSpellName(spellIdentifier: number): string

    function GetSpellPowerCost(spellIdentifier: number): undefined[]

    function GetSpellQueueWindow(): number

    function GetSpellSkillLineAbilityRank(spellIdentifier: number): number

    function GetSpellSubtext(spellIdentifier: number): string

    function GetSpellTexture(
      spellIdentifier: number
    ): LuaMultiReturn<[iconID: number, originalIconID: number]>

    function GetSpellTradeSkillLink(spellIdentifier: number): string

    function IsAutoAttackSpell(spellIdentifier: number): boolean

    function IsAutoRepeatSpell(spellIdentifier: number): boolean

    function IsClassTalentSpell(spellIdentifier: number): boolean

    function IsCurrentSpell(spellIdentifier: number): boolean

    function IsPressHoldReleaseSpell(spellIdentifier: number): boolean

    function IsPvPTalentSpell(spellIdentifier: number): boolean

    function IsRangedAutoAttackSpell(spellIdentifier: number): boolean

    function IsSpellDataCached(spellIdentifier: number): boolean

    function IsSpellDisabled(spellIdentifier: number): boolean

    function IsSpellHarmful(spellIdentifier: number): boolean

    function IsSpellHelpful(spellIdentifier: number): boolean

    function IsSpellInRange(
      spellIdentifier: number,
      targetUnit: UnitToken | undefined
    ): boolean | undefined

    function IsSpellPassive(spellIdentifier: number): boolean

    function IsSpellUsable(
      spellIdentifier: number
    ): LuaMultiReturn<[isUsable: boolean, insufficientPower: boolean]>

    function PickupSpell(spellIdentifier: number): void

    function RequestLoadSpellData(spellIdentifier: number): void

    function SetSpellAutoCastEnabled(spellIdentifier: number, enabled: boolean): void

    function SpellHasRange(spellIdentifier: number): boolean

    function TargetSpellIsEnchanting(): boolean

    function TargetSpellJumpsUpgradeTrack(): boolean

    function TargetSpellReplacesBonusTree(): boolean

    function ToggleSpellAutoCast(spellIdentifier: number): void
  }

  namespace C_SplashScreen {
    function AcknowledgeSplash(): void

    function CanViewSplashScreen(): boolean

    function RequestLatestSplashScreen(fromGameMenu: boolean): void
  }

  namespace C_StableInfo {
    function ClosePetStables(): void

    function GetActivePetList(): undefined[]

    function GetNumActivePets(): number

    function GetNumStablePets(): number

    function GetStablePetFoodTypes(index: number): string[]

    function GetStablePetInfo(index: number): PetInfo | undefined

    function GetStabledPetList(): undefined[]

    function IsAtStableMaster(): boolean

    function IsPetFavorite(slot: number): boolean

    function PickupStablePet(index: number): void

    function SetPetFavorite(slot: number, isFavorite: boolean): void

    function SetPetSlot(index: number, slot: number): void
  }

  namespace C_StorePublic {
    function DoesGroupHavePurchaseableProducts(groupID: number): boolean

    function IsDisabledByParentalControls(): boolean

    function IsEnabled(): boolean
  }

  function GetAvailableBandwidth(): number

  function GetBackgroundLoadingStatus(): number

  function GetDownloadedPercentage(): number

  function GetFileStreamingStatus(): number

  function StripHyperlinks(
    text: string,
    maintainColor: boolean,
    maintainBrackets: boolean,
    stripNewlines: boolean,
    maintainAtlases: boolean
  ): string

  namespace C_SummonInfo {
    function CancelSummon(): void

    function ConfirmSummon(): void

    function GetSummonConfirmAreaName(): string

    function GetSummonConfirmSummoner(): string | undefined

    function GetSummonConfirmTimeLeft(): number

    function GetSummonReason(): number

    function IsSummonSkippingStartExperience(): boolean
  }

  namespace C_SuperTrack {
    function ClearAllSuperTracked(): void

    function ClearSuperTrackedContent(): void

    function ClearSuperTrackedMapPin(): void

    function GetHighestPrioritySuperTrackingType(): SuperTrackingType | undefined

    function GetSuperTrackedContent(): LuaMultiReturn<
      [trackableType: ContentTrackingType, trackableID: number]
    >

    function GetSuperTrackedMapPin(): LuaMultiReturn<
      [type: SuperTrackingMapPinType, typeID: number]
    >

    function GetSuperTrackedQuestID(): number | undefined

    function GetSuperTrackedVignette(): string | undefined

    function IsSuperTrackingAnything(): boolean

    function IsSuperTrackingContent(): boolean

    function IsSuperTrackingCorpse(): boolean

    function IsSuperTrackingMapPin(): boolean

    function IsSuperTrackingQuest(): boolean

    function IsSuperTrackingUserWaypoint(): boolean

    function SetSuperTrackedContent(
      trackableType: ContentTrackingType,
      trackableID: number
    ): void

    function SetSuperTrackedMapPin(type: SuperTrackingMapPinType, typeID: number): void

    function SetSuperTrackedQuestID(questID: number): void

    function SetSuperTrackedUserWaypoint(superTracked: boolean): void

    function SetSuperTrackedVignette(vignetteGUID: string): void
  }

  namespace C_System {
    function GetFrameStack(): unknown[]
  }

  function GetGameTime(): LuaMultiReturn<[hour: number, minute: number]>

  function GetLocalGameTime(): LuaMultiReturn<[hour: number, minute: number]>

  function GetServerTime(): number

  function GetSessionTime(): number

  function GetTickTime(): number

  function GetTime(): number

  function IsUsingFixedTimeStep(): boolean

  namespace C_TTSSettings {
    function GetChannelEnabled(channelInfo: ChatChannelInfo): boolean

    function GetCharacterSettingsSaved(): boolean

    function GetChatTypeEnabled(chatName: string): boolean

    function GetSetting(setting: TtsBoolSetting): boolean

    function GetSpeechRate(): number

    function GetSpeechVolume(): number

    function GetVoiceOptionID(voiceType: TtsVoiceType): number

    function GetVoiceOptionName(voiceType: TtsVoiceType): string

    function MarkCharacterSettingsSaved(): void

    function SetChannelEnabled(channelInfo: ChatChannelInfo, newVal: boolean): void

    function SetChannelKeyEnabled(channelKey: string, newVal: boolean): void

    function SetChatTypeEnabled(chatName: string, newVal: boolean): void

    function SetDefaultSettings(): void

    function SetSetting(setting: TtsBoolSetting, newVal: boolean): void

    function SetSpeechRate(newVal: number): void

    function SetSpeechVolume(newVal: number): void

    function SetVoiceOption(voiceType: TtsVoiceType, voiceID: number): void

    function SetVoiceOptionName(voiceType: TtsVoiceType, voiceName: string): void

    function ShouldOverrideMessage(language: number, messageText: string): boolean
  }

  function AssistUnit(name: string, exactMatch: boolean): void

  function AttackTarget(): void

  function ClearFocus(): void

  function ClearTarget(): boolean

  function FocusUnit(name: string): void

  function IsTargetLoose(): boolean

  function TargetDirectionEnemy(facing: number, coneAngle: number | undefined): void

  function TargetDirectionFinished(): void

  function TargetDirectionFriend(facing: number, coneAngle: number | undefined): void

  function TargetLastEnemy(): void

  function TargetLastFriend(): void

  function TargetLastTarget(): void

  function TargetNearest(reverse: boolean): void

  function TargetNearestEnemy(reverse: boolean): void

  function TargetNearestEnemyPlayer(reverse: boolean): void

  function TargetNearestFriend(reverse: boolean): void

  function TargetNearestFriendPlayer(reverse: boolean): void

  function TargetNearestPartyMember(reverse: boolean): void

  function TargetNearestRaidMember(reverse: boolean): void

  function TargetPriorityHighlightEnd(): void

  function TargetPriorityHighlightStart(useStartDelay: boolean): void

  function TargetToggle(): void

  function TargetUnit(name: string, exactMatch: boolean): void

  namespace C_TaxiMap {
    function GetAllTaxiNodes(uiMapID: number): undefined[]

    function GetTaxiNodesForMap(uiMapID: number): undefined[]

    function ShouldMapShowTaxiNodes(uiMapID: number): boolean
  }

  namespace C_Texture {
    function ClearTitleIconTexture(texture: Texture): void

    function GetAtlasElementID(atlas: string): number

    function GetAtlasID(atlas: string): number

    function GetAtlasInfo(atlas: string): AtlasInfo

    function GetCraftingReagentQualityChatIcon(quality: number): string

    function GetFilenameFromFileDataID(fileDataID: number): string

    function GetTitleIconTexture(
      titleID: string,
      version: TitleIconVersion,
      callback: GetTitleIconTextureCallback
    ): void

    function IsTitleIconTextureReady(titleID: string, version: TitleIconVersion): boolean

    function SetTitleIconTexture(
      texture: Texture,
      titleID: string,
      version: TitleIconVersion
    ): void
  }

  function GetThreatStatusColor(
    gameErrorIndex: number
  ): LuaMultiReturn<[colorR: number, colorG: number, colorB: number]>

  function IsThreatWarningEnabled(): boolean

  function GetCurrentTitle(): number

  function GetNumTitles(): number

  function GetTitleName(
    titleMaskID: number
  ): LuaMultiReturn<[titleString: string, playerTitle: boolean]>

  function IsTitleKnown(titleMaskID: number): boolean

  function SetCurrentTitle(titleMaskID: number): void

  namespace C_TooltipComparison {
    function GetItemComparisonDelta(
      comparisonItem: TooltipComparisonItem,
      equippedItem: TooltipComparisonItem,
      pairedItem: TooltipComparisonItem | undefined,
      addPairedStats: boolean | undefined
    ): string[]

    function GetItemComparisonInfo(
      comparisonItem: TooltipComparisonItem
    ): TooltipItemComparisonInfo
  }

  namespace C_TooltipInfo {
    function GetAchievementByID(achievementID: number): TooltipData

    function GetAction(actionID: number): TooltipData

    function GetArtifactItem(): TooltipData

    function GetArtifactPowerByID(powerID: number): TooltipData

    function GetAzeriteEssence(essenceID: number, rank: number | undefined): TooltipData

    function GetAzeriteEssenceSlot(slot: AzeriteEssenceSlot): TooltipData

    function GetAzeritePower(
      itemID: number,
      itemLevel: number,
      powerID: number,
      owningItemLink: string | undefined
    ): TooltipData

    function GetBackpackToken(index: number): TooltipData

    function GetBagItem(bagIndex: BagIndex, slotIndex: number): TooltipData

    function GetBagItemChild(
      bagIndex: BagIndex,
      slotIndex: number,
      equipSlotIndex: number
    ): TooltipData

    function GetBuybackItem(index: number): TooltipData

    function GetCompanionPet(petGUID: string): TooltipData

    function GetConduit(conduitID: number, conduitRank: number): TooltipData

    function GetCurrencyByID(currencyID: number, amount: number | undefined): TooltipData

    function GetCurrencyToken(tokenIndex: number): TooltipData

    function GetEnhancedConduit(conduitID: number, rank: number): TooltipData

    function GetEquipmentSet(setID: number): TooltipData

    function GetExistingSocketGem(
      index: number,
      toDestroy: boolean | undefined
    ): TooltipData

    function GetGuildBankItem(tab: number, slot: number): TooltipData

    function GetHeirloomByItemID(itemID: number): TooltipData

    function GetHyperlink(
      hyperlink: string,
      optionalArg1: number | undefined,
      optionalArg2: number | undefined,
      hideVendorPrice: boolean | undefined
    ): TooltipData

    function GetInboxItem(
      messageIndex: number,
      attachmentIndex: number | undefined
    ): TooltipData

    function GetInstanceLockEncountersComplete(index: number): TooltipData

    function GetInventoryItem(
      unit: UnitToken,
      slot: number,
      hideUselessStats: boolean | undefined
    ): TooltipData

    function GetInventoryItemByID(itemID: number): TooltipData

    function GetItemByGUID(guid: string): TooltipData

    function GetItemByID(itemID: number, quality: number | undefined): TooltipData

    function GetItemByItemModifiedAppearanceID(
      itemModifiedAppearanceID: number
    ): TooltipData

    function GetItemInteractionItem(): TooltipData

    function GetItemKey(
      itemID: number,
      itemLevel: number,
      itemSuffix: number,
      requiredLevel: number | undefined
    ): TooltipData

    function GetLFGDungeonReward(dungeonID: number, lootIndex: number): TooltipData

    function GetLFGDungeonShortageReward(
      dungeonID: number,
      shortageSeverity: number,
      lootIndex: number
    ): TooltipData

    function GetLootCurrency(slot: number): TooltipData

    function GetLootItem(slot: number): TooltipData

    function GetLootRollItem(id: number): TooltipData

    function GetMerchantCostItem(slot: number, costIndex: number): TooltipData

    function GetMerchantItem(slot: number): TooltipData

    function GetMinimapMouseover(): TooltipData

    function GetMountBySpellID(
      spellID: number,
      checkIndoors: boolean | undefined
    ): TooltipData

    function GetOwnedItemByID(itemID: number): TooltipData

    function GetPetAction(slot: number): TooltipData

    function GetPossession(slot: number): TooltipData

    function GetPvpBrawl(isSpecial: boolean | undefined): TooltipData

    function GetPvpTalent(
      talentID: number,
      isInspect: boolean | undefined,
      groupIndex: number | undefined,
      talentIndex: number | undefined
    ): TooltipData

    function GetQuestCurrency(type: string, currencyIndex: number): TooltipData

    function GetQuestItem(
      type: string,
      itemIndex: number,
      allowCollectionText: boolean | undefined
    ): TooltipData

    function GetQuestLogCurrency(
      type: string,
      currencyIndex: number,
      questID: number | undefined
    ): TooltipData

    function GetQuestLogItem(
      type: string,
      itemIndex: number,
      questID: number | undefined,
      allowCollectionText: boolean | undefined
    ): TooltipData

    function GetQuestLogSpecialItem(questIndex: number): TooltipData

    function GetQuestPartyProgress(
      questID: number,
      omitTitle: boolean | undefined,
      ignoreActivePlayer: boolean | undefined
    ): TooltipData

    function GetRecipeRankInfo(recipeID: number, rank: number): TooltipData

    function GetRecipeReagentItem(
      recipeSpellID: number,
      dataSlotIndex: number
    ): TooltipData

    function GetRecipeResultItem(
      recipeID: number,
      craftingReagents: undefined[] | undefined,
      recraftItemGUID: string | undefined,
      recipeLevel: number | undefined,
      overrideQualityID: number | undefined
    ): TooltipData

    function GetRecipeResultItemForOrder(
      recipeID: number,
      craftingReagents: undefined[] | undefined,
      orderID: number | undefined,
      recipeLevel: number | undefined,
      overrideQualityID: number | undefined
    ): TooltipData

    function GetRuneforgeResultItem(
      itemGUID: string,
      itemLevel: number,
      powerID: number | undefined,
      modifiers: number[] | undefined
    ): TooltipData

    function GetSendMailItem(attachmentIndex: number | undefined): TooltipData

    function GetShapeshift(slot: number): TooltipData

    function GetSlottedKeystone(): TooltipData

    function GetSocketGem(index: number): TooltipData

    function GetSocketedItem(): TooltipData

    function GetSocketedRelic(slotIndex: number): TooltipData

    function GetSpellBookItem(
      spellBookItemSlotIndex: number,
      spellBookItemSpellBank: SpellBookSpellBank
    ): TooltipData

    function GetSpellByID(
      spellID: number,
      isPet: boolean | undefined,
      showSubtext: boolean | undefined,
      dontOverride: boolean | undefined,
      difficultyID: number | undefined,
      isLink: boolean | undefined
    ): TooltipData

    function GetTalent(
      talentID: number,
      isInspect: boolean | undefined,
      groupIndex: number | undefined
    ): TooltipData

    function GetTotem(slot: number): TooltipData

    function GetToyByItemID(itemID: number): TooltipData

    function GetTradePlayerItem(slot: number): TooltipData

    function GetTradeTargetItem(slot: number): TooltipData

    function GetTrainerService(serviceIndex: number): TooltipData

    function GetTraitEntry(entryID: number, rank: number | undefined): TooltipData

    function GetTransmogrifyItem(transmogLocation: TransmogLocationMixin): TooltipData

    function GetUnit(unit: UnitToken, hideStatus: boolean | undefined): TooltipData

    function GetUnitAura(
      unitToken: UnitToken,
      index: number,
      filter: string | undefined
    ): TooltipData

    function GetUnitBuff(
      unitToken: UnitToken,
      index: number,
      filter: string | undefined
    ): TooltipData

    function GetUnitBuffByAuraInstanceID(
      unitTokenString: string,
      auraInstanceID: number,
      filter: string | undefined
    ): TooltipData

    function GetUnitDebuff(
      unitToken: UnitToken,
      index: number,
      filter: string | undefined
    ): TooltipData

    function GetUnitDebuffByAuraInstanceID(
      unitTokenString: string,
      auraInstanceID: number,
      filter: string | undefined
    ): TooltipData

    function GetUpgradeItem(): TooltipData

    function GetVoidDepositItem(slot: number): TooltipData

    function GetVoidItem(tab: number, slot: number): TooltipData

    function GetVoidWithdrawalItem(slot: number): TooltipData

    function GetWeeklyReward(itemDBID: string): TooltipData

    function GetWorldCursor(): TooltipData

    function GetWorldLootObject(unitTokenString: string): TooltipData
  }

  function DestroyTotem(slot: number): void

  function GetTotemCannotDismiss(slot: number): boolean | undefined

  function GetTotemInfo(
    slot: number
  ): LuaMultiReturn<
    [
      haveTotem: boolean,
      totemName: string,
      startTime: number,
      duration: number,
      icon: number
    ]
  >

  function GetTotemTimeLeft(slot: number): number | undefined

  function TargetTotem(slot: number): void

  namespace C_ToyBoxInfo {
    function ClearFanfare(itemID: number): void

    function IsToySourceValid(source: number): boolean

    function IsUsingDefaultFilters(): boolean

    function NeedsFanfare(itemID: number): boolean

    function SetDefaultFilters(): void
  }

  namespace C_TradeSkillUI {
    function CanStoreEnchantInItem(itemGUID: string): boolean

    function CloseTradeSkill(): void

    function CraftEnchant(
      recipeSpellID: number,
      numCasts: number,
      craftingReagents: undefined[] | undefined,
      itemTarget: ItemLocationMixin | undefined,
      applyConcentration: boolean | undefined
    ): void

    function CraftRecipe(
      recipeSpellID: number,
      numCasts: number,
      craftingReagents: undefined[] | undefined,
      recipeLevel: number | undefined,
      orderID: number | undefined,
      applyConcentration: boolean | undefined
    ): void

    function CraftSalvage(
      recipeSpellID: number,
      numCasts: number,
      itemTarget: ItemLocationMixin,
      craftingReagents: undefined[] | undefined,
      applyConcentration: boolean | undefined
    ): void

    function DoesRecraftingRecipeAcceptItem(
      itemLocation: ItemLocationMixin,
      recipeID: number
    ): boolean

    function GetAllProfessionTradeSkillLines(): number[]

    function GetBaseProfessionInfo(): ProfessionInfo

    function GetChildProfessionInfo(): ProfessionInfo

    function GetChildProfessionInfos(): undefined[]

    function GetConcentrationCurrencyID(skillLineID: number): number

    function GetCraftableCount(
      recipeSpellID: number,
      recipeLevel: number | undefined
    ): number

    function GetCraftingOperationInfo(
      recipeID: number,
      craftingReagents: undefined[],
      allocationItemGUID: string | undefined,
      applyConcentration: boolean
    ): CraftingOperationInfo | undefined

    function GetCraftingOperationInfoForOrder(
      recipeID: number,
      craftingReagents: undefined[],
      orderID: number,
      applyConcentration: boolean
    ): CraftingOperationInfo | undefined

    function GetCraftingReagentBonusText(
      recipeSpellID: number,
      craftingReagentIndex: number,
      craftingReagents: undefined[],
      allocationItemGUID: string | undefined
    ): string[]

    function GetCraftingTargetItems(itemIDs: number[]): undefined[]

    function GetEnchantItems(recipeID: number): string[]

    function GetFactionSpecificOutputItem(recipeSpellID: number): number | undefined

    function GetGatheringOperationInfo(
      recipeID: number
    ): GatheringOperationInfo | undefined

    function GetHideUnownedFlags(
      recipeID: number
    ): LuaMultiReturn<[cannotModifyHideUnowned: boolean, alwaysShowUnowned: boolean]>

    function GetItemCraftedQualityByItemInfo(
      itemInfo: string | number
    ): number | undefined

    function GetItemReagentQualityByItemInfo(
      itemInfo: string | number
    ): number | undefined

    function GetItemSlotModifications(itemGUID: string): undefined[]

    function GetItemSlotModificationsForOrder(orderID: number): undefined[]

    function GetOriginalCraftRecipeID(
      itemGUID: string
    ): LuaMultiReturn<
      [recipeID: number | undefined, skillLineAbilityID: number | undefined]
    >

    function GetProfessionByInventorySlot(slot: number): Profession | undefined

    function GetProfessionChildSkillLineID(): number

    function GetProfessionForCursorItem(): Profession | undefined

    function GetProfessionInfoByRecipeID(recipeID: number): ProfessionInfo

    function GetProfessionInfoBySkillLineID(skillLineID: number): ProfessionInfo

    function GetProfessionInventorySlots(): undefined[]

    function GetProfessionNameForSkillLineAbility(skillLineAbilityID: number): string

    function GetProfessionSkillLineID(profession: Profession): number

    function GetProfessionSlots(profession: Profession): number[]

    function GetProfessionSpells(
      professionID: number,
      skillLineID: number | undefined
    ): number[]

    function GetQualitiesForRecipe(recipeID: number): number[] | undefined

    function GetReagentDifficultyText(
      craftingReagentIndex: number,
      craftingReagents: undefined[]
    ): string

    function GetReagentRequirementItemIDs(itemID: number): number[]

    function GetReagentSlotStatus(
      mcrSlotID: number,
      recipeSpellID: number,
      skillLineAbilityID: number
    ): LuaMultiReturn<[locked: boolean, lockedReason: string]>

    function GetRecipeDescription(
      recipeID: number,
      craftingReagents: undefined[],
      allocationItemGUID: string | undefined
    ): string

    function GetRecipeFixedReagentItemLink(
      recipeID: number,
      dataSlotIndex: number
    ): string

    function GetRecipeInfo(
      recipeSpellID: number,
      recipeLevel: number | undefined
    ): TradeSkillRecipeInfo | undefined

    function GetRecipeInfoForSkillLineAbility(
      skillLineAbilityID: number,
      recipeLevel: number | undefined
    ): TradeSkillRecipeInfo | undefined

    function GetRecipeOutputItemData(
      recipeSpellID: number,
      reagents: undefined[] | undefined,
      allocationItemGUID: string | undefined,
      overrideQualityID: number | undefined,
      recraftOrderID: number | undefined
    ): CraftingRecipeOutputInfo

    function GetRecipeQualityItemIDs(recipeSpellID: number): number[] | undefined

    function GetRecipeQualityReagentItemLink(
      recipeID: number,
      dataSlotIndex: number,
      qualityIndex: number
    ): string

    function GetRecipeRequirements(recipeID: number): undefined[]

    function GetRecipeSchematic(
      recipeSpellID: number,
      isRecraft: boolean,
      recipeLevel: number | undefined
    ): CraftingRecipeSchematic

    function GetRecipesTracked(isRecraft: boolean): number[]

    function GetRecraftItems(recipeID: number | undefined): string[]

    function GetRecraftRemovalWarnings(
      itemGUID: string,
      replacedItemIDs: number[]
    ): string[]

    function GetRemainingRecasts(): number

    function GetSalvagableItemIDs(recipeID: number): number[]

    function GetShowLearned(): boolean

    function GetShowUnlearned(): boolean

    function GetSkillLineForGear(itemInfo: string | number): number | undefined

    function GetSourceTypeFilter(): number

    function GetTradeSkillDisplayName(skillLineID: number): string

    function HasFavoriteOrderRecipes(): boolean

    function IsEnchantTargetValid(
      recipeID: number,
      itemGUID: string,
      craftingReagents: undefined[] | undefined
    ): boolean

    function IsGuildTradeSkillsEnabled(): boolean

    function IsNPCCrafting(): boolean

    function IsNearProfessionSpellFocus(profession: Profession): boolean

    function IsOriginalCraftRecipeLearned(itemGUID: string): boolean

    function IsRecipeFirstCraft(recipeID: number): boolean

    function IsRecipeInBaseSkillLine(recipeID: number): boolean

    function IsRecipeInSkillLine(recipeID: number, skillLineID: number): boolean

    function IsRecipeProfessionLearned(recipeID: number): boolean

    function IsRecipeTracked(recipeID: number, isRecraft: boolean): boolean

    function IsRecraftItemEquipped(recraftItemGUID: string): boolean

    function IsRecraftReagentValid(itemGUID: string, itemID: number): boolean

    function IsRuneforging(): boolean

    function OpenRecipe(recipeID: number): void

    function OpenTradeSkill(skillLineID: number): boolean

    function RecraftLimitCategoryValid(reagentItemID: number): boolean

    function RecraftRecipe(
      itemGUID: string,
      craftingReagents: undefined[] | undefined,
      removedModifications: undefined[] | undefined,
      applyConcentration: boolean | undefined
    ): boolean

    function RecraftRecipeForOrder(
      orderID: number,
      itemGUID: string,
      craftingReagents: undefined[] | undefined,
      removedModifications: undefined[] | undefined,
      applyConcentration: boolean | undefined
    ): boolean

    function SetOnlyShowAvailableForOrders(flag: boolean): void

    function SetProfessionChildSkillLineID(skillLineID: number): void

    function SetRecipeTracked(
      recipeID: number,
      tracked: boolean,
      isRecraft: boolean
    ): void

    function SetShowLearned(flag: boolean): void

    function SetShowUnlearned(flag: boolean): void

    function SetSourceTypeFilter(sourceTypeFilter: number): void
  }

  namespace C_Transmog {
    function ApplyAllPending(currentSpecOnly: boolean): boolean

    function CanHaveSecondaryAppearanceForSlotID(slotID: number): boolean

    function CanTransmogItem(
      itemInfo: string | number
    ): LuaMultiReturn<
      [
        canBeTransmogged: boolean,
        selfFailureReason: string | undefined,
        canTransmogOthers: boolean,
        othersFailureReason: string | undefined
      ]
    >

    function CanTransmogItemWithItem(
      targetItemInfo: string | number,
      sourceItemInfo: string | number
    ): LuaMultiReturn<[canTransmog: boolean, failureReason: string | undefined]>

    function ClearAllPending(): void

    function ClearPending(transmogLocation: TransmogLocationMixin): void

    function Close(): void

    function ExtractTransmogIDList(input: string): number[]

    function GetAllSetAppearancesByID(setID: number): undefined[] | undefined

    function GetApplyCost(): number | undefined

    function GetApplyWarnings(): undefined[]

    function GetBaseCategory(transmogID: number): TransmogCollectionType

    function GetCreatureDisplayIDForSource(
      itemModifiedAppearanceID: number
    ): number | undefined

    function GetItemIDForSource(itemModifiedAppearanceID: number): number | undefined

    function GetPending(transmogLocation: TransmogLocationMixin): TransmogLocationMixin

    function GetSlotEffectiveCategory(
      transmogLocation: TransmogLocationMixin
    ): TransmogCollectionType

    function GetSlotForInventoryType(inventoryType: number): number

    function GetSlotInfo(
      transmogLocation: TransmogLocationMixin
    ): LuaMultiReturn<
      [
        isTransmogrified: boolean,
        hasPending: boolean,
        isPendingCollected: boolean,
        canTransmogrify: boolean,
        cannotTransmogrifyReason: number,
        hasUndo: boolean,
        isHideVisual: boolean,
        texture: number | undefined
      ]
    >

    function GetSlotUseError(
      transmogLocation: TransmogLocationMixin
    ): LuaMultiReturn<[errorCode: number, errorString: string]>

    function GetSlotVisualInfo(
      transmogLocation: TransmogLocationMixin
    ): LuaMultiReturn<
      [
        baseSourceID: number,
        baseVisualID: number,
        appliedSourceID: number,
        appliedVisualID: number,
        pendingSourceID: number,
        pendingVisualID: number,
        hasUndo: boolean,
        isHideVisual: boolean,
        itemSubclass: number
      ]
    >

    function IsAtTransmogNPC(): boolean

    function IsSlotBeingCollapsed(transmogLocation: TransmogLocationMixin): boolean

    function LoadOutfit(outfitID: number): void

    function SetPending(
      transmogLocation: TransmogLocationMixin,
      pendingInfo: TransmogLocationMixin
    ): void
  }

  namespace C_TransmogCollection {
    function AccountCanCollectSource(
      sourceID: number
    ): LuaMultiReturn<[hasItemData: boolean, canCollect: boolean]>

    function AreAllCollectionTypeFiltersChecked(): boolean

    function AreAllSourceTypeFiltersChecked(): boolean

    function CanAppearanceBeDisplayedOnPlayer(itemAppearanceID: number): boolean

    function CanAppearanceHaveIllusion(appearanceID: number): boolean

    function ClearNewAppearance(visualID: number): void

    function ClearSearch(searchType: TransmogSearchType): boolean

    function DeleteOutfit(outfitID: number): void

    function EndSearch(): void

    function GetAllAppearanceSources(itemAppearanceID: number): number[]

    function GetAllFactionsShown(): boolean

    function GetAllRacesShown(): boolean

    function GetAppearanceCameraID(
      itemAppearanceID: number,
      variation: TransmogCameraVariation | undefined
    ): number

    function GetAppearanceCameraIDBySource(
      itemModifiedAppearanceID: number,
      variation: TransmogCameraVariation | undefined
    ): number

    function GetAppearanceInfoBySource(
      itemModifiedAppearanceID: number
    ): TransmogAppearanceInfoBySourceData

    function GetAppearanceSourceDrops(itemModifiedAppearanceID: number): undefined[]

    function GetAppearanceSourceInfo(
      itemModifiedAppearanceID: number
    ): LuaMultiReturn<
      [
        category: TransmogCollectionType,
        itemAppearanceID: number,
        canHaveIllusion: boolean,
        icon: number,
        isCollected: boolean,
        itemLink: string,
        transmoglink: string,
        sourceType: number | undefined,
        itemSubClass: number
      ]
    >

    function GetAppearanceSources(
      appearanceID: number,
      categoryType: TransmogCollectionType | undefined,
      transmogLocation: TransmogLocationMixin | undefined
    ): undefined[]

    function GetArtifactAppearanceStrings(
      appearanceID: number
    ): LuaMultiReturn<[name: string, hyperlink: string]>

    function GetCategoryAppearances(
      category: TransmogCollectionType,
      transmogLocation: TransmogLocationMixin | undefined
    ): undefined[]

    function GetCategoryCollectedCount(category: TransmogCollectionType): number

    function GetCategoryForItem(itemModifiedAppearanceID: number): TransmogCollectionType

    function GetCategoryInfo(
      category: TransmogCollectionType
    ): LuaMultiReturn<
      [
        name: string,
        isWeapon: boolean,
        canHaveIllusions: boolean,
        canMainHand: boolean,
        canOffHand: boolean
      ]
    >

    function GetCategoryTotal(category: TransmogCollectionType): number

    function GetClassFilter(): number

    function GetCollectedShown(): boolean

    function GetFallbackWeaponAppearance(): number | undefined

    function GetFilteredCategoryCollectedCount(category: TransmogCollectionType): number

    function GetFilteredCategoryTotal(category: TransmogCollectionType): number

    function GetIllusionInfo(illusionID: number): TransmogIllusionInfo

    function GetIllusionStrings(
      illusionID: number
    ): LuaMultiReturn<[name: string, hyperlink: string, sourceText: string | undefined]>

    function GetIllusions(): undefined[]

    function GetInspectItemTransmogInfoList(): ItemTransmogInfo[]

    function GetIsAppearanceFavorite(itemAppearanceID: number): boolean

    function GetItemInfo(
      itemInfo: string | number
    ): LuaMultiReturn<[itemAppearanceID: number, itemModifiedAppearanceID: number]>

    function GetItemTransmogInfoListFromOutfitHyperlink(
      hyperlink: string
    ): ItemTransmogInfo[]

    function GetLatestAppearance(): LuaMultiReturn<
      [visualID: number, category: TransmogCollectionType]
    >

    function GetNumMaxOutfits(): number

    function GetNumTransmogSources(): number

    function GetOutfitHyperlinkFromItemTransmogInfoList(
      itemTransmogInfoList: ItemTransmogInfo[]
    ): string

    function GetOutfitInfo(outfitID: number): LuaMultiReturn<[name: string, icon: number]>

    function GetOutfitItemTransmogInfoList(outfitID: number): ItemTransmogInfo[]

    function GetOutfits(): number[]

    function GetPairedArtifactAppearance(itemModifiedAppearanceID: number): number

    function GetSourceIcon(itemModifiedAppearanceID: number): number

    function GetSourceInfo(sourceID: number): AppearanceSourceInfo

    function GetSourceItemID(itemModifiedAppearanceID: number): number

    function GetSourceRequiredHoliday(itemModifiedAppearanceID: number): string

    function GetUncollectedShown(): boolean

    function GetValidAppearanceSourcesForClass(
      appearanceID: number,
      classID: number,
      categoryType: TransmogCollectionType | undefined,
      transmogLocation: TransmogLocationMixin | undefined
    ): undefined[]

    function HasFavorites(): boolean

    function IsAppearanceHiddenVisual(appearanceID: number): boolean

    function IsCategoryValidForItem(
      category: TransmogCollectionType,
      itemInfo: string | number
    ): boolean

    function IsNewAppearance(visualID: number): boolean

    function IsSearchDBLoading(): boolean

    function IsSearchInProgress(searchType: TransmogSearchType): boolean

    function IsSourceTypeFilterChecked(index: number): boolean

    function IsUsingDefaultFilters(): boolean

    function ModifyOutfit(
      outfitID: number,
      itemTransmogInfoList: ItemTransmogInfo[]
    ): void

    function NewOutfit(
      name: string,
      icon: number,
      itemTransmogInfoList: ItemTransmogInfo[]
    ): number | undefined

    function PlayerCanCollectSource(
      sourceID: number
    ): LuaMultiReturn<[hasItemData: boolean, canCollect: boolean]>

    function PlayerHasTransmog(itemID: number, itemAppearanceModID: number): boolean

    function PlayerHasTransmogByItemInfo(itemInfo: string | number): boolean

    function PlayerHasTransmogItemModifiedAppearance(
      itemModifiedAppearanceID: number
    ): boolean

    function PlayerKnowsSource(sourceID: number): boolean

    function RenameOutfit(outfitID: number, name: string): void

    function SearchProgress(searchType: TransmogSearchType): number

    function SearchSize(searchType: TransmogSearchType): number

    function SetAllCollectionTypeFilters(checked: boolean): void

    function SetAllFactionsShown(shown: boolean): void

    function SetAllRacesShown(shown: boolean): void

    function SetAllSourceTypeFilters(checked: boolean): void

    function SetClassFilter(classID: number): void

    function SetCollectedShown(shown: boolean): void

    function SetDefaultFilters(): void

    function SetIsAppearanceFavorite(itemAppearanceID: number, isFavorite: boolean): void

    function SetSearch(searchType: TransmogSearchType, searchText: string): boolean

    function SetSearchAndFilterCategory(category: TransmogCollectionType): void

    function SetSourceTypeFilter(index: number, checked: boolean): void

    function SetUncollectedShown(shown: boolean): void

    function UpdateUsableAppearances(): void
  }

  namespace C_TransmogSets {
    function ClearLatestSource(): void

    function ClearNewSource(sourceID: number): void

    function ClearSetNewSourcesForSlot(transmogSetID: number, slot: number): void

    function GetAllSets(): undefined[]

    function GetAllSourceIDs(transmogSetID: number): number[]

    function GetBaseSetID(transmogSetID: number): number

    function GetBaseSets(): undefined[]

    function GetBaseSetsFilter(index: number): boolean

    function GetCameraIDs(): LuaMultiReturn<
      [detailsCameraID: number | undefined, vendorCameraID: number | undefined]
    >

    function GetFilteredBaseSetsCounts(): LuaMultiReturn<
      [numCollected: number, numTotal: number]
    >

    function GetFullBaseSetsCounts(): LuaMultiReturn<
      [numCollected: number, numTotal: number]
    >

    function GetIsFavorite(
      transmogSetID: number
    ): LuaMultiReturn<[isFavorite: boolean, isGroupFavorite: boolean]>

    function GetLatestSource(): number

    function GetSetInfo(transmogSetID: number): TransmogSetInfo

    function GetSetNewSources(transmogSetID: number): number[]

    function GetSetPrimaryAppearances(transmogSetID: number): undefined[]

    function GetSetsContainingSourceID(sourceID: number): number[]

    function GetSourceIDsForSlot(transmogSetID: number, slot: number): number[]

    function GetSourcesForSlot(transmogSetID: number, slot: number): undefined[]

    function GetTransmogSetsClassFilter(): number

    function GetUsableSets(): undefined[]

    function GetValidBaseSetsCountsForCharacter(): LuaMultiReturn<
      [numCollected: number, numTotal: number]
    >

    function GetVariantSets(transmogSetID: number): undefined[]

    function HasUsableSets(): boolean

    function IsBaseSetCollected(transmogSetID: number): boolean

    function IsNewSource(sourceID: number): boolean

    function IsSetVisible(transmogSetID: number): boolean

    function IsUsingDefaultBaseSetsFilters(): boolean

    function SetBaseSetsFilter(index: number, isChecked: boolean): void

    function SetDefaultBaseSetsFilters(): void

    function SetHasNewSources(transmogSetID: number): boolean

    function SetHasNewSourcesForSlot(transmogSetID: number, slot: number): boolean

    function SetIsFavorite(transmogSetID: number, isFavorite: boolean): void

    function SetTransmogSetsClassFilter(classID: number): void
  }

  namespace C_Tutorial {
    function AbandonTutorialArea(): void

    function ReturnToTutorialArea(): void
  }

  namespace C_UIColor {
    function GetColors(): undefined[]
  }

  namespace C_EventToastManager {
    function GetLevelUpDisplayToastsFromLevel(level: number): undefined[]

    function GetNextToastToDisplay(): EventToastInfo

    function RemoveCurrentToast(): void
  }

  namespace C_FrameManager {
    function GetFrameVisibilityState(frameType: UIFrameType): boolean
  }

  namespace C_GenericWidgetDisplay {
    function Acknowledge(): void

    function Close(): void
  }

  namespace C_Macro {
    function RunMacroText(text: string, button: string): void

    function SetMacroExecuteLineCallback(cb: MacroExecuteLineCallback): void
  }

  namespace C_UI {
    function DoesAnyDisplayHaveNotch(): boolean

    function GetTopLeftNotchSafeRegion(): LuaMultiReturn<
      [left: number, right: number, top: number, bottom: number]
    >

    function GetTopRightNotchSafeRegion(): LuaMultiReturn<
      [left: number, right: number, top: number, bottom: number]
    >

    function GetUIParent(): unknown

    function GetWorldFrame(): unknown

    function Reload(): void

    function ShouldUIParentAvoidNotch(): boolean
  }

  namespace C_ModelInfo {
    function AddActiveModelScene(modelSceneFrame: ModelScene, modelSceneID: number): void

    function AddActiveModelSceneActor(
      modelSceneFrameActor: ModelSceneActor,
      modelSceneActorID: number
    ): void

    function ClearActiveModelScene(modelSceneFrame: ModelScene): void

    function ClearActiveModelSceneActor(modelSceneFrameActor: ModelSceneActor): void

    function GetModelSceneActorDisplayInfoByID(
      modelActorDisplayID: number
    ): UIModelSceneActorDisplayInfo

    function GetModelSceneActorInfoByID(modelActorID: number): UIModelSceneActorInfo

    function GetModelSceneCameraInfoByID(
      modelSceneCameraID: number
    ): UIModelSceneCameraInfo

    function GetModelSceneInfoByID(
      modelSceneID: number
    ): LuaMultiReturn<
      [
        modelSceneType: ModelSceneType,
        modelCameraIDs: number[],
        modelActorsIDs: number[],
        flags: number
      ]
    >
  }

  namespace C_ModifiedInstance {
    function GetModifiedInstanceInfoFromMapID(mapID: number): ModifiedInstanceInfo
  }

  namespace C_SystemVisibilityManager {
    function IsSystemVisible(system: UISystemType): boolean
  }

  namespace C_UIWidgetManager {
    function GetAllWidgetsBySetID(setID: number): undefined[]

    function GetBelowMinimapWidgetSetID(): number

    function GetBulletTextListWidgetVisualizationInfo(
      widgetID: number
    ): BulletTextListWidgetVisualizationInfo | undefined

    function GetCaptureBarWidgetVisualizationInfo(
      widgetID: number
    ): CaptureBarWidgetVisualizationInfo | undefined

    function GetCaptureZoneVisualizationInfo(
      widgetID: number
    ): CaptureZoneVisualizationInfo | undefined

    function GetDiscreteProgressStepsVisualizationInfo(
      widgetID: number
    ): DiscreteProgressStepsVisualizationInfo | undefined

    function GetDoubleIconAndTextWidgetVisualizationInfo(
      widgetID: number
    ): DoubleIconAndTextWidgetVisualizationInfo | undefined

    function GetDoubleStateIconRowVisualizationInfo(
      widgetID: number
    ): DoubleStateIconRowVisualizationInfo | undefined

    function GetDoubleStatusBarWidgetVisualizationInfo(
      widgetID: number
    ): DoubleStatusBarWidgetVisualizationInfo | undefined

    function GetFillUpFramesWidgetVisualizationInfo(
      widgetID: number
    ): FillUpFramesWidgetVisualizationInfo | undefined

    function GetHorizontalCurrenciesWidgetVisualizationInfo(
      widgetID: number
    ): HorizontalCurrenciesWidgetVisualizationInfo | undefined

    function GetIconAndTextWidgetVisualizationInfo(
      widgetID: number
    ): IconAndTextWidgetVisualizationInfo | undefined

    function GetIconTextAndBackgroundWidgetVisualizationInfo(
      widgetID: number
    ): IconTextAndBackgroundWidgetVisualizationInfo | undefined

    function GetIconTextAndCurrenciesWidgetVisualizationInfo(
      widgetID: number
    ): IconTextAndCurrenciesWidgetVisualizationInfo | undefined

    function GetItemDisplayVisualizationInfo(
      widgetID: number
    ): ItemDisplayVisualizationInfo | undefined

    function GetMapPinAnimationWidgetVisualizationInfo(
      widgetID: number
    ): MapPinAnimationWidgetVisualizationInfo | undefined

    function GetObjectiveTrackerWidgetSetID(): number

    function GetPowerBarWidgetSetID(): number

    function GetScenarioHeaderCurrenciesAndBackgroundWidgetVisualizationInfo(
      widgetID: number
    ): ScenarioHeaderCurrenciesAndBackgroundWidgetVisualizationInfo | undefined

    function GetScenarioHeaderDelvesWidgetVisualizationInfo(
      widgetID: number
    ): ScenarioHeaderDelvesWidgetVisualizationInfo | undefined

    function GetScenarioHeaderTimerWidgetVisualizationInfo(
      widgetID: number
    ): ScenarioHeaderTimerWidgetVisualizationInfo | undefined

    function GetSpacerVisualizationInfo(
      widgetID: number
    ): SpacerVisualizationInfo | undefined

    function GetSpellDisplayVisualizationInfo(
      widgetID: number
    ): SpellDisplayVisualizationInfo | undefined

    function GetStackedResourceTrackerWidgetVisualizationInfo(
      widgetID: number
    ): StackedResourceTrackerWidgetVisualizationInfo | undefined

    function GetStatusBarWidgetVisualizationInfo(
      widgetID: number
    ): StatusBarWidgetVisualizationInfo | undefined

    function GetTextColumnRowVisualizationInfo(
      widgetID: number
    ): TextColumnRowVisualizationInfo | undefined

    function GetTextWithStateWidgetVisualizationInfo(
      widgetID: number
    ): TextWithStateWidgetVisualizationInfo | undefined

    function GetTextWithSubtextWidgetVisualizationInfo(
      widgetID: number
    ): TextWithSubtextWidgetVisualizationInfo | undefined

    function GetTextureAndTextRowVisualizationInfo(
      widgetID: number
    ): TextureAndTextRowVisualizationInfo | undefined

    function GetTextureAndTextVisualizationInfo(
      widgetID: number
    ): TextureAndTextVisualizationInfo | undefined

    function GetTextureWithAnimationVisualizationInfo(
      widgetID: number
    ): TextureWithAnimationVisualizationInfo | undefined

    function GetTopCenterWidgetSetID(): number

    function GetTugOfWarWidgetVisualizationInfo(
      widgetID: number
    ): TugOfWarWidgetVisualizationInfo | undefined

    function GetUnitPowerBarWidgetVisualizationInfo(
      widgetID: number
    ): UnitPowerBarWidgetVisualizationInfo | undefined

    function GetWidgetSetInfo(widgetSetID: number): UIWidgetSetInfo

    function GetZoneControlVisualizationInfo(
      widgetID: number
    ): ZoneControlVisualizationInfo | undefined

    function RegisterUnitForWidgetUpdates(unitToken: string, isGuid: boolean): void

    function SetProcessingUnit(unit: UnitToken | undefined): void

    function SetProcessingUnitGuid(unit: string | undefined): void

    function UnregisterUnitForWidgetUpdates(unitToken: string, isGuid: boolean): void
  }

  function LaunchURL(url: string): void

  function LoadURLIndex(index: number, param: number | undefined): void

  namespace C_UnitAuras {
    function AddPrivateAuraAnchor(args: AddPrivateAuraAnchorArgs): number | undefined

    function AddPrivateAuraAppliedSound(
      sound: UnitPrivateAuraAppliedSoundInfo
    ): number | undefined

    function AuraIsPrivate(spellID: number): boolean

    function GetAuraDataByAuraInstanceID(
      unitToken: string,
      auraInstanceID: number
    ): AuraData | undefined

    function GetAuraDataByIndex(
      unitToken: string,
      index: number,
      filter: string | undefined
    ): AuraData | undefined

    function GetAuraDataBySlot(unitToken: string, slot: number): AuraData | undefined

    function GetAuraDataBySpellName(
      unitToken: string,
      spellName: string,
      filter: string | undefined
    ): AuraData | undefined

    function GetAuraSlots(
      unitToken: UnitToken,
      filter: string | undefined,
      maxSlots: number | undefined,
      continuationToken: number | undefined
    ): LuaMultiReturn<[outContinuationToken: number | undefined, slots: number]>

    function GetBuffDataByIndex(
      unitToken: string,
      index: number,
      filter: string | undefined
    ): AuraData | undefined

    function GetCooldownAuraBySpellID(spellID: number): number | undefined

    function GetDebuffDataByIndex(
      unitToken: string,
      index: number,
      filter: string | undefined
    ): AuraData | undefined

    function GetPlayerAuraBySpellID(spellID: number): AuraData | undefined

    function IsAuraFilteredOutByInstanceID(
      unitToken: string,
      auraInstanceID: number,
      filterFlags: string
    ): boolean

    function RemovePrivateAuraAnchor(anchorID: number): void

    function RemovePrivateAuraAppliedSound(privateAuraSoundID: number): void

    function SetPrivateWarningTextAnchor(
      parent: unknown,
      anchor: AnchorBinding | undefined
    ): void

    function WantsAlteredForm(unitToken: string): boolean
  }

  function CanEjectPassengerFromSeat(virtualSeatIndex: number): boolean

  function CanShowSetRoleButton(): boolean

  function CanSwitchVehicleSeat(): boolean

  function ClosestGameObjectPosition(
    gameObjectID: number
  ): LuaMultiReturn<[xPos: number, yPos: number, distance: number]>

  function ClosestUnitPosition(
    creatureID: number
  ): LuaMultiReturn<[xPos: number, yPos: number, distance: number]>

  function EjectPassengerFromSeat(virtualSeatIndex: number): void

  function GetComboPoints(unit: UnitToken, target: UnitToken): number

  function GetNegativeCorruptionEffectInfo(): undefined[]

  function GetUnitChargedPowerPoints(unit: UnitToken): number[]

  function GetUnitEmpowerHoldAtMaxTime(unit: UnitToken): number

  function GetUnitEmpowerMinHoldTime(unit: UnitToken): number

  function GetUnitEmpowerStageDuration(unit: UnitToken, index: number): number

  function GetUnitHealthModifier(unit: UnitToken): number

  function GetUnitMaxHealthModifier(unit: UnitToken): number

  function GetUnitPowerBarInfo(unitToken: UnitToken): UnitPowerBarInfo

  function GetUnitPowerBarInfoByID(barID: number): UnitPowerBarInfo

  function GetUnitPowerBarStrings(
    unitToken: UnitToken
  ): LuaMultiReturn<
    [name: string | undefined, tooltip: string | undefined, cost: string | undefined]
  >

  function GetUnitPowerBarStringsByID(
    barID: number
  ): LuaMultiReturn<
    [name: string | undefined, tooltip: string | undefined, cost: string | undefined]
  >

  function GetUnitPowerBarTextureInfo(
    unitToken: UnitToken,
    textureIndex: number,
    timerIndex: number | undefined
  ): LuaMultiReturn<
    [texture: number, colorR: number, colorG: number, colorB: number, colorA: number]
  >

  function GetUnitPowerBarTextureInfoByID(
    barID: number,
    textureIndex: number
  ): LuaMultiReturn<
    [texture: number, colorR: number, colorG: number, colorB: number, colorA: number]
  >

  function GetUnitPowerModifier(unit: UnitToken): number

  function GetUnitSpeed(
    unit: UnitToken
  ): LuaMultiReturn<
    [currentSpeed: number, runSpeed: number, flightSpeed: number, swimSpeed: number]
  >

  function GetUnitTotalModifiedMaxHealthPercent(unit: UnitToken): number

  function GetVehicleUIIndicator(
    vehicleIndicatorID: number
  ): LuaMultiReturn<[backgroundTextureID: number, numSeatIndicators: number]>

  function GetVehicleUIIndicatorSeat(
    vehicleIndicatorID: number,
    indicatorSeatIndex: number
  ): LuaMultiReturn<[virtualSeatIndex: number, xPos: number, yPos: number]>

  function InitiateRolePoll(): boolean

  function IsFalling(unit: UnitToken | undefined): boolean

  function IsFlying(unit: UnitToken | undefined): boolean

  function IsPlayerInGuildFromGUID(playerGUID: string): boolean

  function IsSubmerged(unit: UnitToken | undefined): boolean

  function IsSwimming(unit: UnitToken | undefined): boolean

  function IsUnitModelReadyForUI(unitToken: UnitToken): boolean

  function PlayerIsPVPInactive(unit: UnitToken): boolean

  function PlayerVehicleHasComboPoints(): boolean

  function ReportPlayerIsPVPAFK(unit: UnitToken): void

  function ResistancePercent(resistance: number, casterLevel: number): number

  function SetPortraitTexture(
    textureObject: Texture,
    unitToken: UnitToken,
    disableMasking: boolean
  ): void

  function SetPortraitTextureFromCreatureDisplayID(
    textureObject: Texture,
    creatureDisplayID: number
  ): void

  function SetUnitCursorTexture(
    textureObject: Texture,
    unit: UnitToken,
    style: CursorStyle | undefined,
    includeLowPriority: boolean | undefined
  ): boolean

  function ShowBossFrameWhenUninteractable(unit: UnitToken): boolean

  function UnitAffectingCombat(unit: UnitToken): boolean

  function UnitAlliedRaceInfo(
    unit: UnitToken
  ): LuaMultiReturn<[isAlliedRace: boolean, hasHeritageArmorUnlocked: boolean]>

  function UnitArmor(
    unit: UnitToken
  ): LuaMultiReturn<[base: number, effective: number, real: number, bonus: number]>

  function UnitAttackPower(
    unit: UnitToken
  ): LuaMultiReturn<[attackPower: number, posBuff: number, negBuff: number]>

  function UnitAttackSpeed(
    unit: UnitToken
  ): LuaMultiReturn<[attackSpeed: number, offhandAttackSpeed: number | undefined]>

  function UnitBattlePetLevel(unit: UnitToken): number | undefined

  function UnitBattlePetSpeciesID(unit: UnitToken): number | undefined

  function UnitBattlePetType(unit: UnitToken): number | undefined

  function UnitCanAssist(unit: UnitToken, target: UnitToken): boolean

  function UnitCanAttack(unit: UnitToken, target: UnitToken): boolean

  function UnitCanCooperate(unit: UnitToken, target: UnitToken): boolean

  function UnitCanPetBattle(unit: UnitToken, target: UnitToken): boolean

  function UnitCastingInfo(
    unit: UnitToken
  ): LuaMultiReturn<
    [
      name: string,
      displayName: string,
      textureID: number,
      startTimeMs: number,
      endTimeMs: number,
      isTradeskill: boolean,
      castID: string,
      notInterruptible: boolean,
      castingSpellID: number
    ]
  >

  function UnitChannelInfo(
    unitToken: string
  ): LuaMultiReturn<
    [
      name: string,
      displayName: string,
      textureID: number,
      startTimeMs: number,
      endTimeMs: number,
      isTradeskill: boolean,
      notInterruptible: boolean,
      spellID: number,
      isEmpowered: boolean,
      numEmpowerStages: number
    ]
  >

  function UnitChromieTimeID(unit: UnitToken): number

  function UnitClass(
    unit: UnitToken
  ): LuaMultiReturn<[className: string, classFilename: string, classID: number]>

  function UnitClassBase(
    unit: UnitToken
  ): LuaMultiReturn<[classFilename: string, classID: number]>

  function UnitClassification(unit: UnitToken): string

  function UnitControllingVehicle(unit: UnitToken): boolean

  function UnitCreatureFamily(unit: UnitToken): string

  function UnitCreatureType(unit: UnitToken): string

  function UnitDamage(
    unit: UnitToken
  ): LuaMultiReturn<
    [
      minDamage: number,
      maxDamage: number,
      offhandMinDamage: number,
      offhandMaxDamage: number,
      posBuff: number,
      negBuff: number,
      percent: number
    ]
  >

  function UnitDetailedThreatSituation(
    unit: UnitToken,
    mobGUID: UnitToken
  ): LuaMultiReturn<
    [
      isTanking: boolean,
      status: number,
      scaledPercentage: number,
      rawPercentage: number,
      rawThreat: number
    ]
  >

  function UnitDistanceSquared(
    unit: UnitToken
  ): LuaMultiReturn<[distance: number, checkedDistance: boolean]>

  function UnitEffectiveLevel(name: string): number

  function UnitExists(unit: UnitToken): boolean

  function UnitFactionGroup(
    unitName: string,
    checkDisplayRace: boolean
  ): LuaMultiReturn<[factionGroupTag: string, localized: string]>

  function UnitFullName(
    unit: string
  ): LuaMultiReturn<[unitName: string, unitServer: string]>

  function UnitGUID(unit: UnitToken): string | undefined

  function UnitGetIncomingHeals(
    unit: UnitToken,
    healerGUID: UnitToken | undefined
  ): number | undefined

  function UnitGetTotalAbsorbs(unit: UnitToken): number

  function UnitGetTotalHealAbsorbs(unit: UnitToken): number

  function UnitGroupRolesAssigned(unit: UnitToken): string

  function UnitGroupRolesAssignedEnum(unit: UnitToken): number

  function UnitHPPerStamina(unit: UnitToken): number

  function UnitHasRelicSlot(unit: UnitToken): boolean

  function UnitHasVehiclePlayerFrameUI(unit: UnitToken): boolean

  function UnitHasVehicleUI(unit: UnitToken): boolean

  function UnitHealthMax(unit: UnitToken): number

  function UnitHealth(unit: UnitToken, usePredicted: boolean): number

  function UnitHonor(unit: UnitToken): number

  function UnitHonorLevel(unit: UnitToken): number

  function UnitHonorMax(unit: UnitToken): number

  function UnitInAnyGroup(unit: UnitToken, partyIndex: number | undefined): boolean

  function UnitInBattleground(
    unit: UnitToken,
    partyIndex: number | undefined
  ): number | undefined

  function UnitInParty(unit: UnitToken, partyIndex: number | undefined): boolean

  function UnitInPartyIsAI(unit: UnitToken): boolean

  function UnitInPartyShard(unit: UnitToken): boolean

  function UnitInRaid(unit: UnitToken, partyIndex: number | undefined): number | undefined

  function UnitInRange(
    unit: UnitToken
  ): LuaMultiReturn<[inRange: boolean, checkedRange: boolean]>

  function UnitInSubgroup(unit: UnitToken, partyIndex: number | undefined): boolean

  function UnitInVehicle(unit: UnitToken): boolean

  function UnitInVehicleControlSeat(unit: UnitToken): boolean

  function UnitInVehicleHidesPetFrame(unit: UnitToken): boolean

  function UnitIsAFK(unit: UnitToken): boolean

  function UnitIsBattlePet(unit: UnitToken): boolean | undefined

  function UnitIsBattlePetCompanion(unit: UnitToken): boolean

  function UnitIsBossMob(unit: UnitToken): boolean

  function UnitIsCharmed(unit: UnitToken): boolean

  function UnitIsConnected(unit: UnitToken): boolean

  function UnitIsControlling(unit: UnitToken): boolean

  function UnitIsCorpse(unit: UnitToken): boolean

  function UnitIsDND(unit: UnitToken): boolean

  function UnitIsDead(unit: UnitToken): boolean

  function UnitIsDeadOrGhost(unit: UnitToken): boolean

  function UnitIsEnemy(unit: UnitToken, target: UnitToken): boolean

  function UnitIsFeignDeath(unit: UnitToken): boolean

  function UnitIsFriend(unit: UnitToken, target: UnitToken): boolean

  function UnitIsGameObject(unit: UnitToken): boolean

  function UnitIsGhost(unit: UnitToken): boolean

  function UnitIsInMyGuild(unit: string): boolean

  function UnitIsInteractable(unit: UnitToken): boolean

  function UnitIsMercenary(name: string): boolean

  function UnitIsOtherPlayersBattlePet(unit: UnitToken): boolean

  function UnitIsOtherPlayersPet(unit: UnitToken): boolean

  function UnitIsOwnerOrControllerOfUnit(
    controllingUnit: UnitToken,
    controlledUnit: UnitToken
  ): boolean

  function UnitIsPVP(unit: UnitToken): boolean

  function UnitIsPVPFreeForAll(unit: UnitToken): boolean

  function UnitIsPVPSanctuary(unit: UnitToken): boolean

  function UnitIsPlayer(unit: UnitToken, partyIndex: number | undefined): boolean

  function UnitIsPossessed(unit: UnitToken): boolean

  function UnitIsQuestBoss(unit: UnitToken): boolean

  function UnitIsRaidOfficer(unit: UnitToken): boolean

  function UnitIsSameServer(unitName: string): boolean

  function UnitIsTapDenied(unit: UnitToken): boolean

  function UnitIsTrivial(unit: UnitToken): boolean

  function UnitIsUnconscious(unit: UnitToken): boolean

  function UnitIsUnit(unitName1: string, unitName2: string): boolean

  function UnitIsVisible(unit: UnitToken): boolean

  function UnitIsWildBattlePet(unit: UnitToken): boolean

  function UnitLevel(name: string): number

  function UnitName(unit: string): LuaMultiReturn<[unitName: string, unitServer: string]>

  function UnitNameUnmodified(
    unit: string
  ): LuaMultiReturn<[unitName: string, unitServer: string]>

  function UnitNameplateShowsWidgetsOnly(unit: UnitToken): boolean

  function UnitNumPowerBarTimers(unit: UnitToken): number

  function UnitOnTaxi(unit: UnitToken): boolean

  function UnitPVPName(unit: UnitToken): string

  function UnitPartialPower(
    unitToken: UnitToken,
    powerType: PowerType | undefined,
    unmodified: boolean
  ): number

  function UnitPercentHealthFromGUID(unitGUID: string): number | undefined

  function UnitPhaseReason(unit: UnitToken): PhaseReason | undefined

  function UnitPlayerControlled(unit: UnitToken): boolean

  function UnitPlayerOrPetInParty(
    unit: UnitToken,
    partyIndex: number | undefined
  ): boolean

  function UnitPlayerOrPetInRaid(unit: UnitToken, partyIndex: number | undefined): boolean

  function UnitPosition(
    unit: UnitToken
  ): LuaMultiReturn<
    [positionX: number, positionY: number, positionZ: number, mapID: number]
  >

  function UnitPower(
    unitToken: UnitToken,
    powerType: PowerType | undefined,
    unmodified: boolean
  ): number

  function UnitPowerBarID(unitToken: UnitToken): number

  function UnitPowerBarTimerInfo(
    unit: UnitToken,
    index: number
  ): LuaMultiReturn<[duration: number, expiration: number, barID: number, auraID: number]>

  function UnitPowerDisplayMod(powerType: PowerType): number

  function UnitPowerMax(
    unitToken: UnitToken,
    powerType: PowerType | undefined,
    unmodified: boolean
  ): number

  function UnitPowerType(
    unit: UnitToken,
    index: number
  ): LuaMultiReturn<
    [
      powerType: PowerType,
      powerTypeToken: string,
      rgbX: number,
      rgbY: number,
      rgbZ: number
    ]
  >

  function UnitPvpClassification(unit: UnitToken): PvPUnitClassification | undefined

  function UnitQuestTrivialLevelRange(unit: UnitToken): number

  function UnitQuestTrivialLevelRangeScaling(unit: UnitToken): number

  function UnitRace(
    name: string
  ): LuaMultiReturn<[localizedRaceName: string, englishRaceName: string, raceID: number]>

  function UnitRangedAttackPower(
    unit: UnitToken
  ): LuaMultiReturn<[attackPower: number, posBuff: number, negBuff: number]>

  function UnitRangedDamage(
    unit: UnitToken
  ): LuaMultiReturn<
    [
      speed: number,
      minDamage: number,
      maxDamage: number,
      posBuff: number,
      negBuff: number,
      percent: number
    ]
  >

  function UnitReaction(unit: UnitToken, target: UnitToken): number | undefined

  function UnitRealmRelationship(unit: UnitToken): number | undefined

  function UnitSelectionColor(
    unit: UnitToken,
    useExtendedColors: boolean
  ): LuaMultiReturn<[resultR: number, resultG: number, resultB: number, resultA: number]>

  function UnitSelectionType(unit: UnitToken, useExtendedColors: boolean): number

  function UnitSetRole(unit: UnitToken, roleStr: string | undefined): boolean

  function UnitSetRoleEnum(unit: UnitToken, role: LFGRole | undefined): boolean

  function UnitSex(unit: UnitToken): number | undefined

  function UnitShouldDisplayName(unit: UnitToken): boolean

  function UnitSpellHaste(unit: UnitToken): number

  function UnitStagger(unit: UnitToken): number

  function UnitStat(
    unit: UnitToken,
    index: number
  ): LuaMultiReturn<
    [
      currentStat: number,
      effectiveStat: number,
      statPositiveBuff: number,
      statNegativeBuff: number
    ]
  >

  function UnitSwitchToVehicleSeat(unit: UnitToken, virtualSeatIndex: number): void

  function UnitTargetsVehicleInRaidUI(unit: UnitToken): boolean

  function UnitThreatPercentageOfLead(
    unit: UnitToken,
    mobGUID: UnitToken
  ): number | undefined

  function UnitThreatSituation(
    unit: UnitToken,
    mobGUID: UnitToken | undefined
  ): number | undefined

  function UnitTokenFromGUID(unitGUID: string): string | undefined

  function UnitTreatAsPlayerForDisplay(unit: UnitToken): boolean

  function UnitTrialBankedLevels(
    unit: UnitToken
  ): LuaMultiReturn<
    [bankedLevels: number, xpIntoCurrentLevel: number, xpForNextLevel: number]
  >

  function UnitTrialXP(unit: UnitToken): number

  function UnitUsingVehicle(unit: UnitToken): boolean

  function UnitVehicleSeatCount(unit: UnitToken): number

  function UnitVehicleSeatInfo(
    unit: UnitToken,
    virtualSeatIndex: number
  ): LuaMultiReturn<
    [
      controlType: string,
      occupantName: string,
      serverName: string,
      ejectable: boolean,
      canSwitchSeats: boolean
    ]
  >

  function UnitVehicleSkin(unit: UnitToken): number

  function UnitWeaponAttackPower(
    unit: UnitToken
  ): LuaMultiReturn<
    [
      mainHandWeaponAttackPower: number,
      offHandWeaponAttackPower: number,
      rangedWeaponAttackPower: number
    ]
  >

  function UnitWidgetSet(unit: UnitToken): number

  function UnitXP(unit: UnitToken): number

  function UnitXPMax(unit: UnitToken): number

  function WorldLootObjectExists(unit: UnitToken): boolean

  namespace C_UserFeedback {
    function SubmitBug(bugInfo: string, suppressNotification: boolean): boolean

    function SubmitSuggestion(suggestion: string): boolean
  }

  namespace C_VideoOptions {
    function GetCurrentGameWindowSize(): Vector2DMixin

    function GetDefaultGameWindowSize(monitor: number): Vector2DMixin

    function GetGameWindowSizes(monitor: number, fullscreen: boolean): Vector2DMixin[]

    function GetGxAdapterInfo(): undefined[]

    function SetGameWindowSize(x: number, y: number): void
  }

  namespace C_VignetteInfo {
    function FindBestUniqueVignette(vignetteGUIDs: string[]): number | undefined

    function GetVignetteInfo(vignetteGUID: string): VignetteInfo | undefined

    function GetVignettePosition(
      vignetteGUID: string,
      uiMapID: number
    ): LuaMultiReturn<
      [vignettePosition: Vector2DMixin, vignetteFacing: number | undefined]
    >

    function GetVignettes(): string[]
  }

  namespace C_VoiceChat {
    function ActivateChannel(channelID: number): void

    function ActivateChannelTranscription(channelID: number): void

    function BeginLocalCapture(listenToLocalUser: boolean): void

    function CanPlayerUseVoiceChat(): boolean

    function CreateChannel(channelDisplayName: string): VoiceChatStatusCode

    function DeactivateChannel(channelID: number): void

    function DeactivateChannelTranscription(channelID: number): void

    function EndLocalCapture(): void

    function GetActiveChannelID(): number | undefined

    function GetActiveChannelType(): ChatChannelType | undefined

    function GetAvailableInputDevices(): undefined[] | undefined

    function GetAvailableOutputDevices(): undefined[] | undefined

    function GetChannel(channelID: number): VoiceChatChannel | undefined

    function GetChannelForChannelType(
      channelType: ChatChannelType
    ): VoiceChatChannel | undefined

    function GetChannelForCommunityStream(
      clubId: string,
      streamId: string
    ): VoiceChatChannel | undefined

    function GetCommunicationMode(): CommunicationMode | undefined

    function GetCurrentVoiceChatConnectionStatusCode(): VoiceChatStatusCode | undefined

    function GetInputVolume(): number | undefined

    function GetJoinClubVoiceChannelError(
      clubId: string
    ): VoiceChannelErrorReason | undefined

    function GetLocalPlayerActiveChannelMemberInfo(): VoiceChatMember | undefined

    function GetLocalPlayerMemberID(channelID: number): number | undefined

    function GetMasterVolumeScale(): number

    function GetMemberGUID(memberID: number, channelID: number): string

    function GetMemberID(channelID: number, memberGUID: string): number | undefined

    function GetMemberInfo(
      memberID: number,
      channelID: number
    ): VoiceChatMember | undefined

    function GetMemberName(memberID: number, channelID: number): string | undefined

    function GetMemberVolume(playerLocation: PlayerLocationMixin): number | undefined

    function GetOutputVolume(): number | undefined

    function GetPTTButtonPressedState(): boolean | undefined

    function GetProcesses(): undefined[]

    function GetPushToTalkBinding(): string[] | undefined

    function GetRemoteTtsVoices(): undefined[]

    function GetTtsVoices(): undefined[]

    function GetVADSensitivity(): number | undefined

    function IsChannelJoinPending(
      channelType: ChatChannelType,
      clubId: string | undefined,
      streamId: string | undefined
    ): boolean

    function IsDeafened(): boolean | undefined

    function IsEnabled(): boolean

    function IsLoggedIn(): boolean

    function IsMemberLocalPlayer(memberID: number, channelID: number): boolean

    function IsMemberMuted(playerLocation: PlayerLocationMixin): boolean | undefined

    function IsMemberMutedForAll(memberID: number, channelID: number): boolean | undefined

    function IsMemberSilenced(memberID: number, channelID: number): boolean | undefined

    function IsMuted(): boolean | undefined

    function IsParentalDisabled(): boolean

    function IsParentalMuted(): boolean

    function IsPlayerUsingVoice(playerLocation: PlayerLocationMixin): boolean

    function IsSilenced(): boolean | undefined

    function IsSpeakForMeActive(): boolean

    function IsSpeakForMeAllowed(): boolean

    function IsTranscribing(): boolean

    function IsTranscriptionAllowed(): boolean

    function IsVoiceChatConnected(): boolean

    function LeaveChannel(channelID: number): void

    function Login(): VoiceChatStatusCode

    function Logout(): VoiceChatStatusCode

    function MarkChannelsDiscovered(): void

    function RequestJoinAndActivateCommunityStreamChannel(
      clubId: string,
      streamId: string
    ): void

    function RequestJoinChannelByChannelType(
      channelType: ChatChannelType,
      autoActivate: boolean | undefined
    ): void

    function SetCommunicationMode(communicationMode: CommunicationMode): void

    function SetDeafened(isDeafened: boolean): void

    function SetInputDevice(deviceID: string): void

    function SetInputVolume(volume: number): void

    function SetMasterVolumeScale(scale: number): void

    function SetMemberMuted(playerLocation: PlayerLocationMixin, muted: boolean): void

    function SetMemberVolume(playerLocation: PlayerLocationMixin, volume: number): void

    function SetMuted(isMuted: boolean): void

    function SetOutputDevice(deviceID: string): void

    function SetOutputVolume(volume: number): void

    function SetPortraitTexture(
      textureObject: Texture,
      memberID: number,
      channelID: number
    ): void

    function SetPushToTalkBinding(keys: string[]): void

    function SetVADSensitivity(sensitivity: number): void

    function ShouldDiscoverChannels(): boolean

    function SpeakRemoteTextSample(text: string): void

    function SpeakText(
      voiceID: number,
      text: string,
      destination: VoiceTtsDestination,
      rate: number,
      volume: number
    ): void

    function StopSpeakingText(): void

    function ToggleDeafened(): void

    function ToggleMemberMuted(playerLocation: PlayerLocationMixin): void

    function ToggleMuted(): void
  }

  namespace C_CampaignInfo {
    function GetAvailableCampaigns(): number[]

    function GetCampaignChapterInfo(
      campaignChapterID: number
    ): CampaignChapterInfo | undefined

    function GetCampaignID(questID: number): number

    function GetCampaignInfo(campaignID: number): CampaignInfo | undefined

    function GetChapterIDs(campaignID: number): number[] | undefined

    function GetCurrentChapterID(campaignID: number): number | undefined

    function GetFailureReason(campaignID: number): CampaignFailureReason | undefined

    function GetState(campaignID: number): CampaignState

    function IsCampaignQuest(questID: number): boolean

    function SortAsNormalQuest(campaignID: number): boolean
  }

  namespace C_WeeklyRewards {
    function AreRewardsForCurrentRewardPeriod(): boolean

    function CanClaimRewards(): boolean

    function ClaimReward(id: number): void

    function CloseInteraction(): void

    function GetActivities(type: WeeklyRewardChestThresholdType | undefined): undefined[]

    function GetActivityEncounterInfo(
      type: WeeklyRewardChestThresholdType,
      index: number
    ): undefined[]

    function GetConquestWeeklyProgress(): ConquestWeeklyProgress

    function GetDifficultyIDForActivityTier(activityTierID: number): number

    function GetExampleRewardItemHyperlinks(
      id: number
    ): LuaMultiReturn<[hyperlink: string, upgradeHyperlink: string]>

    function GetItemHyperlink(itemDBID: string): string

    function GetNextActivitiesIncrease(
      activityTierID: number,
      level: number
    ): LuaMultiReturn<
      [
        hasSeasonData: boolean,
        nextActivityTierID: number | undefined,
        nextLevel: number | undefined,
        itemLevel: number | undefined
      ]
    >

    function GetNextMythicPlusIncrease(
      mythicPlusLevel: number
    ): LuaMultiReturn<
      [
        hasSeasonData: boolean,
        nextMythicPlusLevel: number | undefined,
        itemLevel: number | undefined
      ]
    >

    function GetNumCompletedDungeonRuns(): LuaMultiReturn<
      [numHeroic: number, numMythic: number, numMythicPlus: number]
    >

    function HasAvailableRewards(): boolean

    function HasGeneratedRewards(): boolean

    function HasInteraction(): boolean

    function IsWeeklyChestRetired(): boolean

    function OnUIInteract(): void

    function ShouldShowFinalRetirementMessage(): boolean

    function ShouldShowRetirementMessage(): boolean
  }

  namespace C_WorldLootObject {
    function GetCurrentWorldLootObjectSwapInventoryType(): InventoryType

    function GetWorldLootObjectInfo(unitToken: UnitToken): WorldLootObjectInfo

    function IsWorldLootObject(unitToken: UnitToken): boolean

    function IsWorldLootObjectInRange(unitToken: UnitToken): boolean

    function OnWorldLootObjectClick(unitToken: UnitToken): void
  }

  namespace C_WowTokenUI {
    function StartTokenSell(tokenGUID: string): void
  }

  namespace C_XMLUtil {
    function GetTemplateInfo(name: string): XMLTemplateInfo

    function GetTemplates(): undefined[]
  }

  namespace C_ZoneAbility {
    function GetActiveAbilities(): undefined[]

    function GetZoneAbilityIcon(zoneAbilitySpellID: number): number | undefined
  }

  function GetAreaText(): string

  function GetMinimapZoneText(): string

  function GetRealZoneText(mapID: number | undefined): string

  function GetSubZoneText(): string

  function GetZoneText(): string
}

export {}
